CREATE TABLE `wp__wsd_plugin_alerts` (  `alertId` int(10) unsigned NOT NULL AUTO_INCREMENT,  `alertType` tinyint(4) NOT NULL DEFAULT '0',  `alertSeverity` int(11) NOT NULL DEFAULT '0',  `alertActionName` varchar(255) NOT NULL,  `alertTitle` varchar(255) NOT NULL,  `alertDescription` text NOT NULL,  `alertSolution` text NOT NULL,  `alertDate` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `alertFirstSeen` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  PRIMARY KEY (`alertId`),  UNIQUE KEY `alertId_UNIQUE` (`alertId`)) ENGINE=MyISAM AUTO_INCREMENT=29 DEFAULT CHARSET=utf8;
INSERT INTO `wp__wsd_plugin_alerts` VALUES('1', '0', '3', 'fix_wp_version_hidden', 'WordPress version is displayed for all users', '<p>Displaying your WordPress version on frontend and in the backend\'s footer to all visitors\r\n                        and users of your website is a security risk because if a hacker knows which version of WordPress a website is running, it can make it easier for him to target a known WordPress security issue.</p>', '<p>This plugin can automatically hide your WordPress version from frontend, backend and rss feeds if the option <strong>\"Hide WordPress version for all users but administrators\"</strong> is checked on the plugin\'s settings page.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('2', '0', '3', 'fix_wp_generators_frontend', 'WordPress meta tags are displayed on frontend to all users', '<p>By default, WordPress creates a few meta tags, among which is the currently installed version, that give a hacker the knowledge about your WordPress installation. At the moment, these meta tags are available for anyone to see, which is a potentially security risk.</p>', '<p>This plugin can automatically hide your WordPress\'s default meta tags if the option <strong>\"Remove various meta tags generators from the blog\'s head tag for non-administrators\"</strong> is checked on the plugin\'s settings page.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('3', '0', '0', 'fix_wp_rsd_frontend', 'WordPress Really Simple Discovery tag is displayed on frontend to all users', '<p>By default, WordPress creates the <strong>rsd meta tag</strong> to allow bloggers to consume services like Flickr using the <a href=\"http://en.wikipedia.org/wiki/XML-RPC\" target=\"_blank\">XML-RPC</a> protocol.\r\n                            If you don\'t use such services it is recommended to hide this meta tag.</p>', '<p>This plugin can automatically hide the rsd meta tag if the option <strong>\"Remove Really Simple Discovery meta tags from front-end\"</strong> is checked on the plugin\'s settings page.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('4', '0', '2', 'fix_wp_wlw_frontend', 'WordPress Windows Live Writer tag is displayed on frontend for all users', '<p>By default, WordPress creates the wlw meta tag to allow bloggers to publish their articles using the <strong>\"Windows Live Writer\"</strong> application.\r\n                        It is recommended to hide this meta tag from all visitors. If the option <strong>\"Remove Windows Live Writer meta tags from front-end\"</strong> is checked on the plugin\'s settings page, this meta tag\r\n                        will still be available for administrator users to use the <strong>\"Windows Live Writer\"</strong> application to publish their blog posts.</p>', '<p>This plugin can automatically hide the wlw meta tag if the option <strong>\"Remove Windows Live Writer meta tags from front-end\"\"</strong> is checked on the plugin\'s settings page.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('5', '0', '3', 'fix_wp_error_reporting', 'The check for PHP and database error reporting is disabled', '<p>By default, WordPress hides database errors, but there are times when a plugin might enable them thus it is very important to have this type of errors turned off\r\n                            so if there is an error during a connection to the database the user will not get access to the error message generated during that request.</p>\r\n                            <p>As regarding the PHP errors, with the <strong>display_error</strong> PHP configuration directive enabled, untrusted sources can see detailed web application environment\r\n                            error messages which include sensitive information that can be used to craft further attacks.</p>\r\n                            <p>Attackers will do anything to collect information in order to design their attack in a more sophisticated way to eventually hack your website or web application, and causing\r\n                            errors to display is a common starting point. Website errors can always occur, but they should be suppressed from being displayed back to the public.</p>\r\n                            <p>Therefore we highly recommend you to have the <strong>\"Disable error reporting (php + db) for all but administrators\"</strong> option checked on the plugin\'s settings page to ensure PHP and\r\n                            database errors will be hidden from all users. For more information, please check the following <a href=\"http://www.acunetix.com/blog/web-security-zone/articles/php-security-directive-your-website-is-showing-php-errors/\" target=\"_blank\">article</a>.</p>', '<p>This plugin can do this automatically if the option <strong>\"Disable error reporting (php + db) for all but administrators\"</strong> is checked on the plugin\'s settings page.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('6', '0', '3', 'fix_wp_core_update_notif', 'Core update notifications are displayed to all users', '<p>These notifications are displayed at the top of the screen by the WordPress platform whenever the website was updated or needs an update.</p>\r\n                    <p>These notifications should only be viewed by the website\'s administrators and not visible to any other users registered with that website.</p>', '<p>This plugin can automatically hide these notifications if the option <strong>\"Remove core update notifications from back-end for all but administrators\"</strong> is checked on the plugin\'s settings page.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('7', '0', '2', 'fix_wp_plugins_update_notif', 'Plugins update notifications are displayed to all users', '<p>These notifications are displayed at the top of the screen by the WordPress platform whenever the blog administrator\r\n                        needs to be informed about an available update for a plugin.</p>\r\n                    <p>These notifications should only be viewed by the website\'s administrators and not visible to any other users registered with that website.</p>', '<p>This plugin can automatically hide these notifications if the option <strong>\"Remove plug-ins update notifications from back-end\"</strong> is checked on the plugin\'s settings page.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('8', '0', '0', 'fix_wp_themes_update_notif', 'Themes update notifications are displayed to all users.', '<p>These notifications are displayed at the top of the screen by the WordPress platform whenever the blog administrator\r\n                        needs to be informed about an available update for a theme.</p>\r\n                    <p>These notifications should only be viewed by the website\'s administrators and not visible to any other users registered with that website.</p>', '<p>This plugin can automatically hide these notifications if the option <strong>\"Remove themes update notifications from back-end\"</strong> is checked on the plugin\'s settings page.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('9', '0', '2', 'fix_wp_login_errors', 'WordPress login errors are displayed.', '<p>Every time a failed login is encountered, the WordPress platform generates an error message that is displayed to the user.\r\n                        This is a potential security risk because it let\'s the user know of his mistake (be it a wrong user name or password) thus making your\r\n                        WordPress website more vulnerable to attacks.</p>\r\n                    <p>We strongly recommend you to hide these login error messages from all users to ensure a better security of your blog.</p>', '<p>This plugin can automatically hide these notifications if the option <strong>\"Remove login error notifications from front-end\"</strong> is checked on the plugin\'s settings page.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('10', '0', '2', 'fix_wp_admin_notices', 'WordPress admin notifications are displayed to all users.', '<p>These notifications are displayed at the top of the screen by the WordPress platform whenever the blog administrator\r\n                       needs to be informed about an event that has occurred inside WordPress, it could be about an available update for the\r\n                       WordPress platform, a plugin or a theme that was updated or needs an update or to be configured, etc.</p>\r\n                    <p>These notifications should only be viewed by the website\'s administrators and not visible to any other users registered with that website.</p>', '<p>This plugin can automatically hide these notifications if the option <strong>\"Hide admin notifications for non admins\"</strong> is checked on the plugin\'s settings page.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('11', '0', '2', 'fix_wp_dir_listing', 'Directory listing check is disabled. This option should be enabled.', '<p>A directory listing provides an attacker with the complete index of all the resources located inside of the directory.\r\n                    The specific risks and consequences vary depending on which files are listed and accessible.\r\n                    Therefore, it is important to protect your directories by having an empty index.php or index.htm file inside them.</p>', '<p>This plugin can automatically create an empty <strong>index.php</strong> file in the following directories: wp-content, wp-content/plugins, wp-content/themes and wp-content/uploads if\r\n                    the option <strong>\"Try to create the index.php file in the wp-content, wp-content/plugins, wp-content/themes and wp-content/uploads directories to prevent directory listing\"</strong> is checked on the plugin\'s settings page.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('12', '0', '3', 'fix_remove_wp_version_links', 'WordPress version is displayed in links for all users', '<p>By default, WordPress will display the current version in links to javascript scripts or stylesheets.\r\n                    Therefore, if anyone has access to this information it might be a security risk because if a hacker knows which version of WordPress a website is running,\r\n                    it can make it easier for him to target a known WordPress security issue.</p>', '<p>This plugin can automatically hide the WordPress version from links if the option <strong>\"Remove the version parameter from urls\"</strong> is checked on the plugin\'s settings page.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('13', '0', '2', 'fix_empty_root_readme_file', 'Clearing the content of the <strong>\"readme.html\"</strong> file from the <strong>\"root\"</strong> directory is disabled.', '<p>A default WordPress installation contains a readme.html file. This file is a simple html file that does not contain executable content that can be exploited by hackers or malicious users.\r\n                        Still, this file can provide hackers the version of your WordPress installation, therefore it is important to either delete this file or make it inaccessible for your visitors.</p>', '<p>This plugin can automatically delete its content (assuming the file exists) if the option <strong>\"Empty the content of the readme.html file from the root directory\"</strong> is checked on the plugin\'s settings page.\r\n                    You can also delete this file manually by connecting to your website through an FTP connection.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('14', '0', '3', 'check_table_prefix', 'The default WordPress database prefix (<strong>wp_</strong>) is used', '<p>The majority of reported WordPress database security attacks were performed by exploiting SQL Injection vulnerabilities.\r\n                        By renaming the WordPress database table prefixes you are securing your WordPress blog and website from zero day SQL injections attacks.</p>\r\n                    <p>Therefore by renaming the WordPress database table prefixes, you are automatically enforcing your WordPress database security against such dangerous attacks\r\n                        because the attacker would not be able to guess the table names.</p>\r\n                    <p>We recommend to use difficult to guess prefixes, like long random strings which include both letters and numbers.</p>', '<p>This plugin can automatically <a href=\"admin.php?page=wsd_database\">do this</a> for you, but if you want to do it manually then please read this <a href=\"http://www.websitedefender.com/wordpress-security/change-wordpress-database-prefix/\" target=\"_blank\">article</a> first.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('15', '0', '0', 'check_wp_current_version', 'You have the latest version of WordPress installed', '<p>The latest WordPress version is usually more stable and secure, and is only released to include new features or fix technical and WordPress security bugs;\r\n                            making it an important part of your website administration to keep up to date since some fixes might resolve security issues.<p>\r\n                        <p>Running an older WordPress version could put your blog security at risk, allowing a hacker to exploit known vulnerabilities for your specific version and take full control over your web server.</p>', '', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('16', '0', '0', 'check_index_wp_content', 'The <strong>\"index.php\"</strong> file was found in the <strong>\"/wp-content\"</strong> directory', '<p>A directory listing provides an attacker with the complete index of all the resources located inside of the directory. The specific risks and consequences vary depending on which files are listed and accessible.</p>\r\n                    <p>Therefore, it is important to protect your directories by having an empty index.php or index.htm file inside them.</p>', '', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('17', '0', '0', 'check_index_wp_plugins', 'The <strong>\"index.php\"</strong> file was found in the <strong>\"/wp-content/plugins\"</strong> directory', '<p>A directory listing provides an attacker with the complete index of all the resources located inside of the directory. The specific risks and consequences vary depending on which files are listed and accessible.</p>\r\n                    <p>Therefore, it is important to protect your directories by having an empty index.php or index.htm file inside them.</p>', '', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('18', '0', '0', 'check_index_wp_themes', 'The <strong>\"index.php\"</strong> file was found in the <strong>\"/wp-content/themes\"</strong> directory', '<p>A directory listing provides an attacker with the complete index of all the resources located inside of the directory. The specific risks and consequences vary depending on which files are listed and accessible.</p>\r\n                    <p>Therefore, it is important to protect your directories by having an empty index.php or index.htm file inside them.</p>', '', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('19', '0', '2', 'check_index_wp_uploads', 'The <strong>\"index.php\"</strong> file was not found in the <strong>\"/wp-content/uploads\"</strong> directory', '<p>A directory listing provides an attacker with the complete index of all the resources located inside of the directory. The specific risks and consequences vary depending on which files are listed and accessible.</p>\r\n                        <p>Therefore, it is important to protect your directories by having an empty index.php or index.htm file inside them.</p>', '<p>This plugin can automatically create an empty <strong>\"index.php\"</strong> file in the following directories: wp-content, wp-content/plugins, wp-content/themes and wp-content/uploads if the\r\n                        option <strong>\"Try to create the index.php file in the wp-content, wp-content/plugins, wp-content/themes and wp-content/uploads directories to prevent directory listing\"</strong> is checked on the plugin\'s settings page.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('20', '0', '2', 'check_htaccess_wp_admin', 'The <strong>\".htaccess\"</strong> file was not found in the <strong>\"wp-admin\"</strong> directory', '<p>An .htaccess file is a configuration file which provides the ability to specify configuration settings for a specific directory in a website.\r\n                    The .htaccess file can include one or more configuration settings which apply only for the directory in which the .htaccess file has been placed.\r\n                    So while web servers have their own main configuration settings file, the .htaccess file can be used to override their main configuration settings.</p>', '<p>Please refer to this <a href=\"http://www.acunetix.com/blog/web-security-zone/articles/what-is-an-htaccess-file/\" target=\"_blank\">article</a> for more information on how to create an .htaccess file.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('21', '0', '2', 'check_readme_wp_root', 'The <strong>readme.html</strong> file was found in the root directory', '<p>A default WordPress installation contains a readme.html file.\r\n                                This file is a simple html file that does not contain executable content that can be exploited by hackers or malicious users.\r\n                                Still, this file can provide hackers the version of your WordPress installation, therefore it is important to either delete this file or make it inaccessible for your visitors.</p>', '<p>This plugin can automatically delete its content if the option <strong>\"Empty the content of the readme.html file from the root directory.\"</strong> is checked on the plugin\'s settings page.\r\n                                You can also delete this file manually by connecting to your website through an FTP connection.</p>', '2014-06-09 21:12:52', '2013-11-11 15:51:41');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('22', '0', '3', 'check_username_admin ', 'The default user <strong>\"admin\"</strong> was found', '<p>One well known and dangerous WordPress security vulnerability is User Enumeration, in which a malicious user is able to enumerate\r\n                            a valid WordPress user account to launch a brute force attack against it.</p>\r\n                            <p>In order to help deter this type of attack, you should change your default <a href=\"http://www.acunetix.com/blog/web-security-zone/articles/default-wordpress-administrator-account/\" target=\"_blank\">WordPress administrator</a>\r\n                            username to something more difficult to guess.</p>', '<p>Do not make the following change unless you are comfortable working with PHPMyAdmin and MySQL. If not, ask someone who is familiar with WordPress and MySQL to assist you. </p>\r\n                            <p>Also, it is of utmost importance to backup your whole blog - including the database - before making any of the changes described below.</p>\r\n                            <p>To change your WordPress default admin username, navigate to your web host\'s MySQL administration tool (probably PHPMyAdmin) and browse to your WordPress database.\r\n                            Locate the users table, in which you will find a user_login column. One of the rows will contain admin in the field.\r\n                            Change this to a complex and hard-to-guess name, which ideally consists of alpha-numeric characters.</p>\r\n                            <p><strong>IMPORTANT:</strong> Even if the username is hard to guess, you will still need a very strong password.</p>', '2014-06-09 17:19:35', '2013-11-11 15:51:42');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('23', '1', '2', 'watch_admin_password_update', 'Administrator (admin) password updated', '<p>This alert is generated every time an administrator\'s password is updated.</p>', '', '2013-11-11 15:59:19', '2013-11-11 15:59:19');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('24', '1', '2', 'watch_admin_password_update', 'Administrator (admin) password updated', '<p>This alert is generated every time an administrator\'s password is updated.</p>', '', '2013-11-11 16:02:05', '2013-11-11 15:59:19');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('25', '1', '2', 'watch_admin_password_update', 'Administrator (admin) password updated', '<p>This alert is generated every time an administrator\'s password is updated.</p>', '', '2013-11-11 16:04:11', '2013-11-11 15:59:19');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('26', '1', '2', 'watch_admin_password_update', 'Administrator (admin) password updated', '<p>This alert is generated every time an administrator\'s password is updated.</p>', '', '2013-11-11 16:06:24', '2013-11-11 15:59:19');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('27', '1', '2', 'watch_admin_password_update', 'Administrator (admin) password updated', '<p>This alert is generated every time an administrator\'s password is updated.</p>', '', '2013-11-11 16:08:30', '2013-11-11 15:59:19');
INSERT INTO `wp__wsd_plugin_alerts` VALUES('28', '1', '2', 'watch_admin_password_update', 'Administrator (admin) password updated', '<p>This alert is generated every time an administrator\'s password is updated.</p>', '', '2013-11-11 16:10:25', '2013-11-11 15:59:19');
CREATE TABLE `wp__wsd_plugin_live_traffic` (  `entryId` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `entryTime` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `entryIp` text,  `entryReferrer` text,  `entryUA` text,  `entryRequestedUrl` text,  PRIMARY KEY (`entryId`)) ENGINE=MyISAM AUTO_INCREMENT=53940 DEFAULT CHARSET=utf8;
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53604', '2014-06-09 20:33:39', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53603', '2014-06-09 20:33:35', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53602', '2014-06-09 20:33:32', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53601', '2014-06-09 20:33:27', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53599', '2014-06-09 20:33:19', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53598', '2014-06-09 20:33:14', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53596', '2014-06-09 20:33:06', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53594', '2014-06-09 20:32:56', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53592', '2014-06-09 20:32:42', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53590', '2014-06-09 20:32:35', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53588', '2014-06-09 20:32:26', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53587', '2014-06-09 20:32:21', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53586', '2014-06-09 20:32:17', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53584', '2014-06-09 20:32:09', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53583', '2014-06-09 20:32:06', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53582', '2014-06-09 20:31:59', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53581', '2014-06-09 20:31:55', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53386', '2014-06-09 17:23:15', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-admin/admin.php?page=pluginbuddy_slideshow-settings', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-content/plugins/slideshow/js/swiftpopup.js?ver=3.9.1');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53387', '2014-06-09 17:23:19', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-admin/admin.php?page=pluginbuddy_slideshow-settings&amp;edit=0', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-content/plugins/slideshow/js/swiftpopup.js?ver=3.9.1');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53580', '2014-06-09 20:31:50', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53579', '2014-06-09 20:31:46', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53385', '2014-06-09 17:23:11', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-admin/admin.php?page=pluginbuddy_slideshow-settings', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-content/plugins/slideshow/js/swiftpopup.js?ver=3.9.1');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53408', '2014-06-09 20:20:04', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53380', '2014-06-09 08:08:13', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-login.php?redirect_to=http%3A%2F%2Fwww.plrblogs.com%2Frestorevision%2Fwp-admin%2Fplugins.php%3Factivate%3Dtrue%26plugin_status%3Dall%26paged%3D1%26s%3D&amp;reauth=1', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-login.php');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53382', '2014-06-09 17:19:50', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/Put%20your%20300x250%20Banner%20URL%20here');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53383', '2014-06-09 17:19:53', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53384', '2014-06-09 17:23:07', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-admin/admin.php?page=pluginbuddy_slideshow-settings', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-content/plugins/slideshow/js/swiftpopup.js?ver=3.9.1');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53578', '2014-06-09 20:31:43', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53577', '2014-06-09 20:31:40', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53576', '2014-06-09 20:31:34', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53575', '2014-06-09 20:31:31', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53574', '2014-06-09 20:31:24', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53573', '2014-06-09 20:31:21', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53572', '2014-06-09 20:31:18', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53571', '2014-06-09 20:31:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53568', '2014-06-09 20:30:59', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53567', '2014-06-09 20:30:55', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53566', '2014-06-09 20:30:51', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53564', '2014-06-09 20:30:43', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53563', '2014-06-09 20:30:40', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53562', '2014-06-09 20:30:35', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53561', '2014-06-09 20:30:32', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53560', '2014-06-09 20:30:28', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53559', '2014-06-09 20:30:23', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53558', '2014-06-09 20:30:18', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53557', '2014-06-09 20:30:16', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53556', '2014-06-09 20:30:09', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53555', '2014-06-09 20:30:06', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53554', '2014-06-09 20:30:00', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53552', '2014-06-09 20:29:52', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53550', '2014-06-09 20:29:44', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53549', '2014-06-09 20:29:36', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53548', '2014-06-09 20:29:31', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53547', '2014-06-09 20:29:27', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53546', '2014-06-09 20:29:23', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53545', '2014-06-09 20:29:18', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53544', '2014-06-09 20:29:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53543', '2014-06-09 20:29:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53540', '2014-06-09 20:28:56', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53538', '2014-06-09 20:28:47', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53537', '2014-06-09 20:28:43', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53535', '2014-06-09 20:28:35', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53534', '2014-06-09 20:28:31', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53532', '2014-06-09 20:28:23', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53531', '2014-06-09 20:28:19', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53530', '2014-06-09 20:28:15', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53529', '2014-06-09 20:28:10', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53528', '2014-06-09 20:28:05', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53526', '2014-06-09 20:27:56', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53525', '2014-06-09 20:27:52', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53524', '2014-06-09 20:27:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53522', '2014-06-09 20:27:40', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53521', '2014-06-09 20:27:35', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53519', '2014-06-09 20:27:26', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53518', '2014-06-09 20:27:21', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53516', '2014-06-09 20:27:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53515', '2014-06-09 20:27:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53513', '2014-06-09 20:26:59', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53512', '2014-06-09 20:26:55', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53511', '2014-06-09 20:26:50', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53510', '2014-06-09 20:26:46', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53509', '2014-06-09 20:26:42', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53508', '2014-06-09 20:26:38', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53507', '2014-06-09 20:26:34', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53506', '2014-06-09 20:26:28', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53504', '2014-06-09 20:26:20', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53503', '2014-06-09 20:26:15', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53502', '2014-06-09 20:26:11', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53501', '2014-06-09 20:26:07', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53499', '2014-06-09 20:25:57', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53498', '2014-06-09 20:25:54', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53497', '2014-06-09 20:25:49', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53406', '2014-06-09 20:19:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/restore-your-vision-videos', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53405', '2014-06-09 20:19:05', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/restore-your-vision-videos');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53401', '2014-06-09 20:18:40', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53400', '2014-06-09 20:18:39', '70.39.246.37', '', 'Mozilla/5.0 Moreover/5.1 (+http://www.moreover.com; webmaster@moreover.com)', 'http://www.plrblogs.com/restorevision/feed');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53398', '2014-06-09 20:18:38', '70.39.246.37', '', 'Mozilla/5.0 Moreover/5.1 (+http://www.moreover.com; webmaster@moreover.com)', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53495', '2014-06-09 20:25:41', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53494', '2014-06-09 20:25:39', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53493', '2014-06-09 20:25:33', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53491', '2014-06-09 20:25:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53490', '2014-06-09 20:25:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53488', '2014-06-09 20:25:04', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53486', '2014-06-09 20:24:53', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53485', '2014-06-09 20:24:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53484', '2014-06-09 20:24:45', '66.249.65.211', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/sitemap-pt-post-2014-06.xml');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53482', '2014-06-09 20:24:39', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53480', '2014-06-09 20:24:30', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53479', '2014-06-09 20:24:30', '66.249.65.185', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/sitemap-pt-post-2014-06.xml');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53478', '2014-06-09 20:24:25', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53477', '2014-06-09 20:24:21', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53476', '2014-06-09 20:24:17', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53475', '2014-06-09 20:24:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53474', '2014-06-09 20:24:09', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53473', '2014-06-09 20:24:03', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53471', '2014-06-09 20:23:54', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53470', '2014-06-09 20:23:52', '66.249.65.185', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/sitemap-pt-post-2014-06.xml');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53469', '2014-06-09 20:23:51', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53468', '2014-06-09 20:23:46', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53467', '2014-06-09 20:23:42', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53465', '2014-06-09 20:23:33', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53464', '2014-06-09 20:23:30', '66.249.65.211', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/sitemap-pt-post-2014-06.xml');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53463', '2014-06-09 20:23:29', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53462', '2014-06-09 20:23:25', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53461', '2014-06-09 20:23:23', '66.249.65.185', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/sitemap-pt-post-2014-06.xml');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53460', '2014-06-09 20:23:22', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53459', '2014-06-09 20:23:16', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53458', '2014-06-09 20:23:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53457', '2014-06-09 20:23:10', '66.249.65.185', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/sitemap-pt-post-2014-06.xml');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53456', '2014-06-09 20:23:09', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53454', '2014-06-09 20:23:00', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53453', '2014-06-09 20:22:56', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53452', '2014-06-09 20:22:51', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53451', '2014-06-09 20:22:47', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53449', '2014-06-09 20:22:39', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53448', '2014-06-09 20:22:35', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53447', '2014-06-09 20:22:30', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53446', '2014-06-09 20:22:25', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53445', '2014-06-09 20:22:20', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53443', '2014-06-09 20:22:10', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53442', '2014-06-09 20:22:06', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53441', '2014-06-09 20:22:03', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53440', '2014-06-09 20:21:58', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53439', '2014-06-09 20:21:54', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53437', '2014-06-09 20:21:46', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53436', '2014-06-09 20:21:42', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53435', '2014-06-09 20:21:39', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53434', '2014-06-09 20:21:34', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53432', '2014-06-09 20:21:29', '66.249.65.211', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/sitemap-pt-post-2014-06.xml');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53431', '2014-06-09 20:21:28', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53429', '2014-06-09 20:21:20', '49.128.54.28', '', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.1; WOW64; Trident/5.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E)', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53428', '2014-06-09 20:21:17', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53427', '2014-06-09 20:21:13', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53426', '2014-06-09 20:21:11', '66.249.65.198', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/sitemap-pt-post-2014-06.xml');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53424', '2014-06-09 20:21:05', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53422', '2014-06-09 20:20:57', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53421', '2014-06-09 20:20:53', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53420', '2014-06-09 20:20:49', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53419', '2014-06-09 20:20:47', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53417', '2014-06-09 20:20:40', '66.249.65.198', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/sitemap-pt-post-2014-06.xml');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53416', '2014-06-09 20:20:38', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53415', '2014-06-09 20:20:33', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53414', '2014-06-09 20:20:29', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53413', '2014-06-09 20:20:25', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53412', '2014-06-09 20:20:21', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53411', '2014-06-09 20:20:17', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53409', '2014-06-09 20:20:10', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53396', '2014-06-09 17:31:50', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53394', '2014-06-09 17:31:22', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/restore-your-vision-videos');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53393', '2014-06-09 17:31:19', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53390', '2014-06-09 17:29:36', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53389', '2014-06-09 17:29:34', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53376', '2014-06-09 01:24:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/importbuddy.php?step=7', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/importbuddy.php?ezimg=bullet_error.png');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53939', '2014-06-09 21:12:41', '2.216.124.230', '', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53938', '2014-06-09 21:12:33', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wptwin.php', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wptwin.php');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53937', '2014-06-09 21:04:44', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wptwin.php', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wptwin.php');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53936', '2014-06-09 21:02:22', '23.22.131.24', '', 'viralvideochart.unrulymedia.com vvcscanner@unrulymedia.com', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53935', '2014-06-09 21:00:36', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wptwin.php', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wptwin.php');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53934', '2014-06-09 20:59:52', '2.216.124.230', '', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wptwin.php');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53933', '2014-06-09 20:59:31', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53932', '2014-06-09 20:59:26', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-admin/admin.php?page=pluginbuddy_slideshow-settings&amp;edit=0', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-content/plugins/slideshow/js/swiftpopup.js?ver=3.9.1');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53931', '2014-06-09 20:58:47', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-admin/admin.php?page=pluginbuddy_slideshow-settings&amp;edit=0', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-content/plugins/slideshow/js/swiftpopup.js?ver=3.9.1');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53928', '2014-06-09 20:57:39', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-admin/admin.php?page=pluginbuddy_slideshow-settings&amp;edit=0', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-content/plugins/slideshow/js/swiftpopup.js?ver=3.9.1');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53927', '2014-06-09 20:57:22', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53926', '2014-06-09 20:57:22', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-admin/admin.php?page=pluginbuddy_slideshow-settings&amp;edit=0', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-content/plugins/slideshow/js/swiftpopup.js?ver=3.9.1');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53925', '2014-06-09 20:57:21', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53924', '2014-06-09 20:57:17', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53923', '2014-06-09 20:57:16', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-admin/admin.php?page=pluginbuddy_slideshow-settings&amp;edit=0', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-content/plugins/slideshow/js/swiftpopup.js?ver=3.9.1');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53922', '2014-06-09 20:57:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53921', '2014-06-09 20:57:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53920', '2014-06-09 20:57:04', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53919', '2014-06-09 20:57:04', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-admin/admin.php?page=pluginbuddy_slideshow-settings&amp;edit=0', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-content/plugins/slideshow/js/swiftpopup.js?ver=3.9.1');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53918', '2014-06-09 20:57:00', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53917', '2014-06-09 20:56:56', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53916', '2014-06-09 20:56:52', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53915', '2014-06-09 20:56:50', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-admin/admin.php?page=pluginbuddy_slideshow-settings&amp;edit=0', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-content/plugins/slideshow/js/swiftpopup.js?ver=3.9.1');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53914', '2014-06-09 20:56:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53903', '2014-06-09 20:56:05', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53902', '2014-06-09 20:56:01', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53901', '2014-06-09 20:55:57', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53900', '2014-06-09 20:55:53', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53899', '2014-06-09 20:55:49', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53898', '2014-06-09 20:55:44', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53897', '2014-06-09 20:55:41', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53896', '2014-06-09 20:53:59', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53892', '2014-06-09 20:53:43', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53890', '2014-06-09 20:53:38', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53882', '2014-06-09 20:53:13', '66.249.65.211', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53881', '2014-06-09 20:53:11', '66.249.65.198', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/feed');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53880', '2014-06-09 20:53:10', '66.249.65.198', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/sitemap-pt-post-2014-06.xml');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53879', '2014-06-09 20:53:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53878', '2014-06-09 20:53:04', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53877', '2014-06-09 20:53:04', '66.249.65.198', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/sitemap-pt-post-2014-06.xml');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53358', '2014-06-08 23:11:26', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53359', '2014-06-08 23:11:29', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53360', '2014-06-08 23:11:32', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53361', '2014-06-08 23:11:35', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53362', '2014-06-08 23:11:38', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53363', '2014-06-08 23:11:39', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53364', '2014-06-08 23:11:44', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53365', '2014-06-08 23:11:49', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53366', '2014-06-08 23:11:50', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53367', '2014-06-08 23:11:51', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53368', '2014-06-08 23:11:55', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53369', '2014-06-08 23:11:57', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53370', '2014-06-08 23:11:59', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53371', '2014-06-08 23:12:02', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53372', '2014-06-08 23:12:06', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53373', '2014-06-08 23:12:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53374', '2014-06-08 23:12:11', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53605', '2014-06-09 20:33:44', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53600', '2014-06-09 20:33:23', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53597', '2014-06-09 20:33:09', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53595', '2014-06-09 20:33:00', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53593', '2014-06-09 20:32:47', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53591', '2014-06-09 20:32:38', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53589', '2014-06-09 20:32:30', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53585', '2014-06-09 20:32:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53407', '2014-06-09 20:19:10', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53379', '2014-06-09 08:06:41', '2.216.124.230', '', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-login.php?redirect_to=http%3A%2F%2Fwww.plrblogs.com%2Frestorevision%2Fwp-admin%2Fplugins.php%3Factivate%3Dtrue%26plugin_status%3Dall%26paged%3D1%26s%3D&amp;reauth=1');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53570', '2014-06-09 20:31:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53569', '2014-06-09 20:31:03', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53565', '2014-06-09 20:30:47', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53553', '2014-06-09 20:29:55', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53551', '2014-06-09 20:29:46', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53381', '2014-06-09 17:19:46', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-admin/plugins.php?activate=true&amp;plugin_status=all&amp;paged=1&amp;s&amp;sucuriscan_lastlogin_message=1', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53542', '2014-06-09 20:29:04', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53541', '2014-06-09 20:29:00', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53539', '2014-06-09 20:28:51', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53536', '2014-06-09 20:28:39', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53533', '2014-06-09 20:28:27', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53527', '2014-06-09 20:28:00', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53523', '2014-06-09 20:27:44', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53520', '2014-06-09 20:27:30', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53517', '2014-06-09 20:27:16', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53514', '2014-06-09 20:27:03', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53505', '2014-06-09 20:26:25', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53500', '2014-06-09 20:26:02', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53496', '2014-06-09 20:25:45', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53404', '2014-06-09 20:19:05', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53403', '2014-06-09 20:18:48', '66.249.65.185', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/feed');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53402', '2014-06-09 20:18:47', '66.249.65.198', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53399', '2014-06-09 20:18:38', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53397', '2014-06-09 20:18:31', '66.249.65.198', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/sitemap-pt-post-2014-05.xml');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53492', '2014-06-09 20:25:29', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53489', '2014-06-09 20:25:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/restore-your-vision-videos', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53487', '2014-06-09 20:24:57', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53483', '2014-06-09 20:24:44', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53481', '2014-06-09 20:24:34', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53472', '2014-06-09 20:23:58', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53466', '2014-06-09 20:23:38', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53455', '2014-06-09 20:23:04', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53450', '2014-06-09 20:22:43', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53444', '2014-06-09 20:22:15', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53438', '2014-06-09 20:21:50', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53433', '2014-06-09 20:21:30', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53430', '2014-06-09 20:21:21', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53425', '2014-06-09 20:21:10', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53423', '2014-06-09 20:21:01', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53418', '2014-06-09 20:20:41', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53410', '2014-06-09 20:20:13', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53395', '2014-06-09 17:31:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/restore-your-vision-videos', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53392', '2014-06-09 17:31:18', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53391', '2014-06-09 17:31:16', '66.249.65.211', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/sitemap-pt-revision-2014-06.xml');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53388', '2014-06-09 17:23:37', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-admin/admin.php?page=pluginbuddy_slideshow-settings&amp;edit=0', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-content/plugins/slideshow/js/swiftpopup.js?ver=3.9.1');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53378', '2014-06-09 01:25:20', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-login.php', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-login.php');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53377', '2014-06-09 01:24:37', '2.216.124.230', '', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-login.php');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53375', '2014-06-09 01:24:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/importbuddy.php?step=7', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/importbuddy.php?ezimg=pluginbuddy.png');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53930', '2014-06-09 20:58:02', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-admin/admin.php?page=pluginbuddy_slideshow-settings&amp;edit=0', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-content/plugins/slideshow/js/swiftpopup.js?ver=3.9.1');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53929', '2014-06-09 20:57:52', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53913', '2014-06-09 20:56:45', '2.216.124.230', 'http://www.plrblogs.com/restorevision/wp-admin/admin.php?page=pluginbuddy_slideshow-settings', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/wp-content/plugins/slideshow/js/swiftpopup.js?ver=3.9.1');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53912', '2014-06-09 20:56:44', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53911', '2014-06-09 20:56:39', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53910', '2014-06-09 20:56:35', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53909', '2014-06-09 20:56:31', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53908', '2014-06-09 20:56:27', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53907', '2014-06-09 20:56:23', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53906', '2014-06-09 20:56:18', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53905', '2014-06-09 20:56:14', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53904', '2014-06-09 20:56:10', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53895', '2014-06-09 20:53:57', '2.216.124.230', 'http://www.plrblogs.com/restorevision/restore-your-vision-videos', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53894', '2014-06-09 20:53:53', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53893', '2014-06-09 20:53:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53891', '2014-06-09 20:53:43', '66.249.65.185', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/sitemap-pt-post-2014-06.xml');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53889', '2014-06-09 20:53:36', '66.249.65.211', '', 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)', 'http://www.plrblogs.com/restorevision/sitemap-pt-post-2014-06.xml');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53888', '2014-06-09 20:53:34', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53887', '2014-06-09 20:53:30', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53886', '2014-06-09 20:53:25', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53885', '2014-06-09 20:53:21', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53884', '2014-06-09 20:53:17', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53883', '2014-06-09 20:53:13', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53876', '2014-06-09 20:53:01', '70.39.246.37', '', 'Mozilla/5.0 Moreover/5.1 (+http://www.moreover.com; webmaster@moreover.com)', 'http://www.plrblogs.com/restorevision/feed');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53875', '2014-06-09 20:53:00', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53874', '2014-06-09 20:52:54', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53873', '2014-06-09 20:52:50', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53872', '2014-06-09 20:52:46', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53871', '2014-06-09 20:52:42', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53870', '2014-06-09 20:52:38', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53869', '2014-06-09 20:52:33', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53868', '2014-06-09 20:52:28', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53867', '2014-06-09 20:52:24', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53866', '2014-06-09 20:52:20', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53865', '2014-06-09 20:52:16', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53864', '2014-06-09 20:52:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53863', '2014-06-09 20:52:07', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53862', '2014-06-09 20:52:03', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53861', '2014-06-09 20:51:59', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53860', '2014-06-09 20:51:55', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53859', '2014-06-09 20:51:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53858', '2014-06-09 20:51:45', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53606', '2014-06-09 20:33:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53607', '2014-06-09 20:33:53', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53608', '2014-06-09 20:33:58', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53609', '2014-06-09 20:34:03', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53610', '2014-06-09 20:34:07', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53611', '2014-06-09 20:34:11', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53612', '2014-06-09 20:34:16', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53613', '2014-06-09 20:34:21', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53614', '2014-06-09 20:34:27', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53615', '2014-06-09 20:34:30', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53616', '2014-06-09 20:34:35', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53617', '2014-06-09 20:34:39', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53618', '2014-06-09 20:34:43', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53619', '2014-06-09 20:34:47', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53620', '2014-06-09 20:34:51', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53621', '2014-06-09 20:34:56', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53622', '2014-06-09 20:35:05', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53623', '2014-06-09 20:35:13', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53624', '2014-06-09 20:35:14', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53625', '2014-06-09 20:35:18', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53626', '2014-06-09 20:35:23', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53627', '2014-06-09 20:35:28', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53628', '2014-06-09 20:35:34', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53629', '2014-06-09 20:35:36', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53630', '2014-06-09 20:35:40', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53631', '2014-06-09 20:35:45', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53632', '2014-06-09 20:35:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53633', '2014-06-09 20:35:53', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53634', '2014-06-09 20:35:58', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53635', '2014-06-09 20:36:03', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53636', '2014-06-09 20:36:07', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53637', '2014-06-09 20:36:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53638', '2014-06-09 20:36:16', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53639', '2014-06-09 20:36:22', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53640', '2014-06-09 20:36:25', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53641', '2014-06-09 20:36:30', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53642', '2014-06-09 20:36:35', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53643', '2014-06-09 20:36:39', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53644', '2014-06-09 20:36:44', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53645', '2014-06-09 20:36:49', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53646', '2014-06-09 20:36:53', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53647', '2014-06-09 20:36:58', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53648', '2014-06-09 20:37:03', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53649', '2014-06-09 20:37:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53650', '2014-06-09 20:37:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53651', '2014-06-09 20:37:16', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53652', '2014-06-09 20:37:20', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53653', '2014-06-09 20:37:24', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53654', '2014-06-09 20:37:29', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53655', '2014-06-09 20:37:34', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53656', '2014-06-09 20:37:39', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53657', '2014-06-09 20:37:43', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53658', '2014-06-09 20:37:47', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53659', '2014-06-09 20:37:51', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53660', '2014-06-09 20:37:55', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53661', '2014-06-09 20:37:59', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53662', '2014-06-09 20:38:03', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53663', '2014-06-09 20:38:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53664', '2014-06-09 20:38:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53665', '2014-06-09 20:38:17', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53666', '2014-06-09 20:38:22', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53667', '2014-06-09 20:38:27', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53668', '2014-06-09 20:38:31', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53669', '2014-06-09 20:38:35', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53670', '2014-06-09 20:38:39', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53671', '2014-06-09 20:38:43', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53672', '2014-06-09 20:38:47', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53673', '2014-06-09 20:38:52', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53674', '2014-06-09 20:38:58', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53675', '2014-06-09 20:39:00', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53676', '2014-06-09 20:39:05', '176.9.181.42', '', 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.1; WOW64; Trident/6.0)', 'http://www.plrblogs.com/restorevision/');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53677', '2014-06-09 20:39:05', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53678', '2014-06-09 20:39:09', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53679', '2014-06-09 20:39:14', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53680', '2014-06-09 20:39:18', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53681', '2014-06-09 20:39:23', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53682', '2014-06-09 20:39:27', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53683', '2014-06-09 20:39:32', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53684', '2014-06-09 20:39:36', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53685', '2014-06-09 20:39:40', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53686', '2014-06-09 20:39:45', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53687', '2014-06-09 20:39:49', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53688', '2014-06-09 20:39:53', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53689', '2014-06-09 20:39:57', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53690', '2014-06-09 20:40:01', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53691', '2014-06-09 20:40:05', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53692', '2014-06-09 20:40:09', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53693', '2014-06-09 20:40:14', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53694', '2014-06-09 20:40:18', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53695', '2014-06-09 20:40:22', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53696', '2014-06-09 20:40:26', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53697', '2014-06-09 20:40:31', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53698', '2014-06-09 20:40:36', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53699', '2014-06-09 20:40:40', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53700', '2014-06-09 20:40:44', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53701', '2014-06-09 20:40:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53702', '2014-06-09 20:40:53', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53703', '2014-06-09 20:40:57', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53704', '2014-06-09 20:41:02', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53705', '2014-06-09 20:41:06', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53706', '2014-06-09 20:41:11', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53707', '2014-06-09 20:41:15', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53708', '2014-06-09 20:41:20', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53709', '2014-06-09 20:41:25', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53710', '2014-06-09 20:41:29', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53711', '2014-06-09 20:41:34', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53712', '2014-06-09 20:41:38', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53713', '2014-06-09 20:41:43', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53714', '2014-06-09 20:41:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53715', '2014-06-09 20:41:52', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53716', '2014-06-09 20:41:56', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53717', '2014-06-09 20:42:01', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53718', '2014-06-09 20:42:05', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53719', '2014-06-09 20:42:09', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53720', '2014-06-09 20:42:13', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53721', '2014-06-09 20:42:17', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53722', '2014-06-09 20:42:21', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53723', '2014-06-09 20:42:25', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53724', '2014-06-09 20:42:30', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53725', '2014-06-09 20:42:34', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53726', '2014-06-09 20:42:39', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53727', '2014-06-09 20:42:41', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53728', '2014-06-09 20:42:45', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53729', '2014-06-09 20:42:49', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53730', '2014-06-09 20:42:53', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53731', '2014-06-09 20:42:57', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53732', '2014-06-09 20:43:02', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53733', '2014-06-09 20:43:06', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53734', '2014-06-09 20:43:11', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53735', '2014-06-09 20:43:16', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53736', '2014-06-09 20:43:20', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53737', '2014-06-09 20:43:24', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53738', '2014-06-09 20:43:31', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53739', '2014-06-09 20:43:35', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53740', '2014-06-09 20:43:40', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53741', '2014-06-09 20:43:44', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53742', '2014-06-09 20:43:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53743', '2014-06-09 20:43:53', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53744', '2014-06-09 20:43:57', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53745', '2014-06-09 20:44:02', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53746', '2014-06-09 20:44:06', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53747', '2014-06-09 20:44:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53748', '2014-06-09 20:44:15', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53749', '2014-06-09 20:44:20', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53750', '2014-06-09 20:44:24', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53751', '2014-06-09 20:44:29', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53752', '2014-06-09 20:44:33', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53753', '2014-06-09 20:44:37', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53754', '2014-06-09 20:44:42', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53755', '2014-06-09 20:44:47', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53756', '2014-06-09 20:44:51', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53757', '2014-06-09 20:44:56', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53758', '2014-06-09 20:45:01', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53759', '2014-06-09 20:45:06', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53760', '2014-06-09 20:45:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53761', '2014-06-09 20:45:16', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53762', '2014-06-09 20:45:20', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53763', '2014-06-09 20:45:25', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53764', '2014-06-09 20:45:28', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53765', '2014-06-09 20:45:32', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53766', '2014-06-09 20:45:36', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53767', '2014-06-09 20:45:40', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53768', '2014-06-09 20:45:44', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53769', '2014-06-09 20:45:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53770', '2014-06-09 20:45:52', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53771', '2014-06-09 20:45:56', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53772', '2014-06-09 20:46:00', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53773', '2014-06-09 20:46:04', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53774', '2014-06-09 20:46:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53775', '2014-06-09 20:46:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53776', '2014-06-09 20:46:16', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53777', '2014-06-09 20:46:20', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53778', '2014-06-09 20:46:24', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53779', '2014-06-09 20:46:28', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53780', '2014-06-09 20:46:32', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53781', '2014-06-09 20:46:36', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53782', '2014-06-09 20:46:40', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53783', '2014-06-09 20:46:44', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53784', '2014-06-09 20:46:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53785', '2014-06-09 20:46:52', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53786', '2014-06-09 20:46:56', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53787', '2014-06-09 20:47:00', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53788', '2014-06-09 20:47:04', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53789', '2014-06-09 20:47:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53790', '2014-06-09 20:47:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53791', '2014-06-09 20:47:16', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53792', '2014-06-09 20:47:20', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53793', '2014-06-09 20:47:24', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53794', '2014-06-09 20:47:28', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53795', '2014-06-09 20:47:32', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53796', '2014-06-09 20:47:36', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53797', '2014-06-09 20:47:40', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53798', '2014-06-09 20:47:45', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53799', '2014-06-09 20:47:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53800', '2014-06-09 20:47:53', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53801', '2014-06-09 20:47:56', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53802', '2014-06-09 20:48:00', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53803', '2014-06-09 20:48:04', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53804', '2014-06-09 20:48:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53805', '2014-06-09 20:48:13', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53806', '2014-06-09 20:48:16', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53807', '2014-06-09 20:48:20', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53808', '2014-06-09 20:48:24', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53809', '2014-06-09 20:48:28', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53810', '2014-06-09 20:48:32', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53811', '2014-06-09 20:48:36', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53812', '2014-06-09 20:48:40', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53813', '2014-06-09 20:48:44', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53814', '2014-06-09 20:48:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53815', '2014-06-09 20:48:52', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53816', '2014-06-09 20:48:56', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53817', '2014-06-09 20:49:00', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53818', '2014-06-09 20:49:04', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53819', '2014-06-09 20:49:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53820', '2014-06-09 20:49:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53821', '2014-06-09 20:49:16', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53822', '2014-06-09 20:49:20', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53823', '2014-06-09 20:49:24', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53824', '2014-06-09 20:49:28', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53825', '2014-06-09 20:49:32', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53826', '2014-06-09 20:49:36', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53827', '2014-06-09 20:49:42', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53828', '2014-06-09 20:49:44', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53829', '2014-06-09 20:49:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53830', '2014-06-09 20:49:52', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53831', '2014-06-09 20:49:56', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53832', '2014-06-09 20:50:00', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53833', '2014-06-09 20:50:05', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53834', '2014-06-09 20:50:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53835', '2014-06-09 20:50:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53836', '2014-06-09 20:50:16', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53837', '2014-06-09 20:50:20', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53838', '2014-06-09 20:50:24', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53839', '2014-06-09 20:50:28', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53840', '2014-06-09 20:50:32', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53841', '2014-06-09 20:50:36', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53842', '2014-06-09 20:50:40', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53843', '2014-06-09 20:50:44', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53844', '2014-06-09 20:50:48', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53845', '2014-06-09 20:50:52', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53846', '2014-06-09 20:50:56', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53847', '2014-06-09 20:51:00', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53848', '2014-06-09 20:51:04', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53849', '2014-06-09 20:51:08', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53850', '2014-06-09 20:51:12', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53851', '2014-06-09 20:51:17', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53852', '2014-06-09 20:51:21', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53853', '2014-06-09 20:51:24', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53854', '2014-06-09 20:51:28', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53855', '2014-06-09 20:51:33', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53856', '2014-06-09 20:51:36', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
INSERT INTO `wp__wsd_plugin_live_traffic` VALUES('53857', '2014-06-09 20:51:40', '2.216.124.230', 'http://www.plrblogs.com/restorevision/', 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/35.0.1916.114 Safari/537.36', 'http://www.plrblogs.com/restorevision/undefined');
CREATE TABLE `wp_bad_behavior` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `ip` text NOT NULL,  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `request_method` text NOT NULL,  `request_uri` text NOT NULL,  `server_protocol` text NOT NULL,  `http_headers` text NOT NULL,  `user_agent` text NOT NULL,  `request_entity` text NOT NULL,  `key` text NOT NULL,  PRIMARY KEY (`id`),  KEY `ip` (`ip`(15)),  KEY `user_agent` (`user_agent`(10))) ENGINE=MyISAM AUTO_INCREMENT=59 DEFAULT CHARSET=latin1;
INSERT INTO `wp_bad_behavior` VALUES('56', '192.35.222.163', '2014-06-10 00:24:28', 'GET', '/restorevision/', 'HTTP/1.0', 'GET /restorevision/ HTTP/1.0\nAccept-Encoding: x-gzip, gzip, deflate\nAccept-Language: en-us,en-gb,en;q=0.7,*;q=0.3\nHost: www.plrblogs.com\nUser-Agent: Mozilla/4.0 (compatible; MSIE 6.1; Windows XP; .NET CLR 1.1.4322; .NET CLR 2.0.50727)/Nutch-1.3\n', 'Mozilla/4.0 (compatible; MSIE 6.1; Windows XP; .NET CLR 1.1.4322; .NET CLR 2.0.50727)/Nutch-1.3', '', '17566707');
INSERT INTO `wp_bad_behavior` VALUES('55', '49.128.54.28', '2014-06-10 00:21:24', 'POST', '/restorevision/trackback/', 'HTTP/1.1', 'POST /restorevision/trackback/ HTTP/1.1\nAccept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, application/x-shockwave-flash, */*\nAccept-Encoding: gzip, deflate\nConnection: Close\nHost: www.plrblogs.com\nReferer: http://www.plrblogs.com/restorevision/\nUser-Agent: Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.1; WOW64; Trident/5.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E)\n', 'Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.1; WOW64; Trident/5.0; SLCC2; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729; Media Center PC 6.0; .NET4.0C; .NET4.0E)', 'title: zAITkGQW\nurl: http://www.5U4o1Me0Kab1CW3ZBH883a.com/\nexcerpt: Restore Your Vision |\nblog_name: zAITkGQW\n', 'f0dcb3fd');
INSERT INTO `wp_bad_behavior` VALUES('57', '192.35.222.163', '2014-06-10 00:56:43', 'GET', '/restorevision/', 'HTTP/1.0', 'GET /restorevision/ HTTP/1.0\nAccept-Encoding: x-gzip, gzip, deflate\nAccept-Language: en-us,en-gb,en;q=0.7,*;q=0.3\nHost: www.plrblogs.com\nUser-Agent: Mozilla/4.0 (compatible; MSIE 6.1; Windows XP; .NET CLR 1.1.4322; .NET CLR 2.0.50727)/Nutch-1.3\n', 'Mozilla/4.0 (compatible; MSIE 6.1; Windows XP; .NET CLR 1.1.4322; .NET CLR 2.0.50727)/Nutch-1.3', '', '17566707');
INSERT INTO `wp_bad_behavior` VALUES('58', '192.35.222.163', '2014-06-10 00:59:53', 'GET', '/restorevision/', 'HTTP/1.0', 'GET /restorevision/ HTTP/1.0\nAccept-Encoding: x-gzip, gzip, deflate\nAccept-Language: en-us,en-gb,en;q=0.7,*;q=0.3\nHost: www.plrblogs.com\nUser-Agent: Mozilla/4.0 (compatible; MSIE 6.1; Windows XP; .NET CLR 1.1.4322; .NET CLR 2.0.50727)/Nutch-1.3\n', 'Mozilla/4.0 (compatible; MSIE 6.1; Windows XP; .NET CLR 1.1.4322; .NET CLR 2.0.50727)/Nutch-1.3', '', '17566707');
CREATE TABLE `wp_commentmeta` (  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `comment_id` bigint(20) unsigned NOT NULL DEFAULT '0',  `meta_key` varchar(255) DEFAULT NULL,  `meta_value` longtext,  PRIMARY KEY (`meta_id`),  KEY `comment_id` (`comment_id`),  KEY `meta_key` (`meta_key`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `wp_comments` (  `comment_ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `comment_post_ID` bigint(20) unsigned NOT NULL DEFAULT '0',  `comment_author` tinytext NOT NULL,  `comment_author_email` varchar(100) NOT NULL DEFAULT '',  `comment_author_url` varchar(200) NOT NULL DEFAULT '',  `comment_author_IP` varchar(100) NOT NULL DEFAULT '',  `comment_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `comment_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `comment_content` text NOT NULL,  `comment_karma` int(11) NOT NULL DEFAULT '0',  `comment_approved` varchar(20) NOT NULL DEFAULT '1',  `comment_agent` varchar(255) NOT NULL DEFAULT '',  `comment_type` varchar(20) NOT NULL DEFAULT '',  `comment_parent` bigint(20) unsigned NOT NULL DEFAULT '0',  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',  `vp_campaign_id` int(11) DEFAULT NULL,  PRIMARY KEY (`comment_ID`),  KEY `comment_post_ID` (`comment_post_ID`),  KEY `comment_approved_date_gmt` (`comment_approved`,`comment_date_gmt`),  KEY `comment_date_gmt` (`comment_date_gmt`),  KEY `comment_parent` (`comment_parent`),  KEY `vp_campaign_id` (`vp_campaign_id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `wp_links` (  `link_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `link_url` varchar(255) NOT NULL DEFAULT '',  `link_name` varchar(255) NOT NULL DEFAULT '',  `link_image` varchar(255) NOT NULL DEFAULT '',  `link_target` varchar(25) NOT NULL DEFAULT '',  `link_description` varchar(255) NOT NULL DEFAULT '',  `link_visible` varchar(20) NOT NULL DEFAULT 'Y',  `link_owner` bigint(20) unsigned NOT NULL DEFAULT '1',  `link_rating` int(11) NOT NULL DEFAULT '0',  `link_updated` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `link_rel` varchar(255) NOT NULL DEFAULT '',  `link_notes` mediumtext NOT NULL,  `link_rss` varchar(255) NOT NULL DEFAULT '',  PRIMARY KEY (`link_id`),  KEY `link_visible` (`link_visible`)) ENGINE=MyISAM AUTO_INCREMENT=8 DEFAULT CHARSET=utf8;
INSERT INTO `wp_links` VALUES('1', 'http://codex.wordpress.org/', 'Documentation', '', '', '', 'Y', '28', '0', '0000-00-00 00:00:00', '', '', '');
INSERT INTO `wp_links` VALUES('2', 'http://wordpress.org/news/', 'WordPress Blog', '', '', '', 'Y', '28', '0', '0000-00-00 00:00:00', '', '', 'http://wordpress.org/news/feed/');
INSERT INTO `wp_links` VALUES('3', 'http://wordpress.org/extend/ideas/', 'Suggest Ideas', '', '', '', 'Y', '28', '0', '0000-00-00 00:00:00', '', '', '');
INSERT INTO `wp_links` VALUES('4', 'http://wordpress.org/support/', 'Support Forum', '', '', '', 'Y', '28', '0', '0000-00-00 00:00:00', '', '', '');
INSERT INTO `wp_links` VALUES('5', 'http://wordpress.org/extend/plugins/', 'Plugins', '', '', '', 'Y', '28', '0', '0000-00-00 00:00:00', '', '', '');
INSERT INTO `wp_links` VALUES('6', 'http://wordpress.org/extend/themes/', 'Themes', '', '', '', 'Y', '28', '0', '0000-00-00 00:00:00', '', '', '');
INSERT INTO `wp_links` VALUES('7', 'http://planet.wordpress.org/', 'WordPress Planet', '', '', '', 'Y', '28', '0', '0000-00-00 00:00:00', '', '', '');
CREATE TABLE `wp_lockdowns` (  `lockdown_ID` bigint(20) NOT NULL AUTO_INCREMENT,  `user_id` bigint(20) NOT NULL,  `lockdown_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `release_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `lockdown_IP` varchar(100) NOT NULL DEFAULT '',  PRIMARY KEY (`lockdown_ID`)) ENGINE=MyISAM DEFAULT CHARSET=latin1;
CREATE TABLE `wp_login_fails` (  `login_attempt_ID` bigint(20) NOT NULL AUTO_INCREMENT,  `user_id` bigint(20) NOT NULL,  `login_attempt_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `login_attempt_IP` varchar(100) NOT NULL DEFAULT '',  PRIMARY KEY (`login_attempt_ID`)) ENGINE=MyISAM AUTO_INCREMENT=7 DEFAULT CHARSET=latin1;
INSERT INTO `wp_login_fails` VALUES('1', '18', '2012-04-21 20:57:29', '2.218.148.45');
INSERT INTO `wp_login_fails` VALUES('2', '24', '2012-11-01 11:36:50', '176.25.79.33');
INSERT INTO `wp_login_fails` VALUES('3', '26', '2013-06-04 19:45:00', '176.25.79.33');
INSERT INTO `wp_login_fails` VALUES('4', '26', '2013-06-04 19:45:11', '176.25.79.33');
INSERT INTO `wp_login_fails` VALUES('5', '26', '2013-08-08 12:38:44', '176.25.79.33');
INSERT INTO `wp_login_fails` VALUES('6', '26', '2013-11-11 15:44:00', '151.226.138.173');
CREATE TABLE `wp_options` (  `option_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `option_name` varchar(64) NOT NULL DEFAULT '',  `option_value` longtext NOT NULL,  `autoload` varchar(20) NOT NULL DEFAULT 'yes',  PRIMARY KEY (`option_id`),  UNIQUE KEY `option_name` (`option_name`)) ENGINE=MyISAM AUTO_INCREMENT=7949 DEFAULT CHARSET=utf8;
INSERT INTO `wp_options` VALUES('1', 'siteurl', 'http://www.plrblogs.com/restorevision', 'yes');
INSERT INTO `wp_options` VALUES('2', 'blogname', 'Restore Your Vision', 'yes');
INSERT INTO `wp_options` VALUES('3', 'blogdescription', '', 'yes');
INSERT INTO `wp_options` VALUES('4', 'users_can_register', '0', 'yes');
INSERT INTO `wp_options` VALUES('5', 'admin_email', 'youremail@youremail.com', 'yes');
INSERT INTO `wp_options` VALUES('6', 'start_of_week', '1', 'yes');
INSERT INTO `wp_options` VALUES('7', 'use_balanceTags', '0', 'yes');
INSERT INTO `wp_options` VALUES('8', 'use_smilies', '1', 'yes');
INSERT INTO `wp_options` VALUES('9', 'require_name_email', '1', 'yes');
INSERT INTO `wp_options` VALUES('10', 'comments_notify', '1', 'yes');
INSERT INTO `wp_options` VALUES('11', 'posts_per_rss', '10', 'yes');
INSERT INTO `wp_options` VALUES('12', 'rss_use_excerpt', '0', 'yes');
INSERT INTO `wp_options` VALUES('13', 'mailserver_url', 'mail.example.com', 'yes');
INSERT INTO `wp_options` VALUES('14', 'mailserver_login', 'login@example.com', 'yes');
INSERT INTO `wp_options` VALUES('15', 'mailserver_pass', 'password', 'yes');
INSERT INTO `wp_options` VALUES('16', 'mailserver_port', '110', 'yes');
INSERT INTO `wp_options` VALUES('17', 'default_category', '1', 'yes');
INSERT INTO `wp_options` VALUES('18', 'default_comment_status', 'open', 'yes');
INSERT INTO `wp_options` VALUES('19', 'default_ping_status', 'open', 'yes');
INSERT INTO `wp_options` VALUES('20', 'default_pingback_flag', '0', 'yes');
INSERT INTO `wp_options` VALUES('22', 'posts_per_page', '10', 'yes');
INSERT INTO `wp_options` VALUES('23', 'date_format', 'F j, Y', 'yes');
INSERT INTO `wp_options` VALUES('24', 'time_format', 'g:i a', 'yes');
INSERT INTO `wp_options` VALUES('25', 'links_updated_date_format', 'F j, Y g:i a', 'yes');
INSERT INTO `wp_options` VALUES('29', 'comment_moderation', '0', 'yes');
INSERT INTO `wp_options` VALUES('30', 'moderation_notify', '1', 'yes');
INSERT INTO `wp_options` VALUES('31', 'permalink_structure', '/%category%/%postname%', 'yes');
INSERT INTO `wp_options` VALUES('32', 'gzipcompression', '0', 'yes');
INSERT INTO `wp_options` VALUES('33', 'hack_file', '0', 'yes');
INSERT INTO `wp_options` VALUES('34', 'blog_charset', 'UTF-8', 'yes');
INSERT INTO `wp_options` VALUES('35', 'moderation_keys', '', 'no');
INSERT INTO `wp_options` VALUES('36', 'active_plugins', 'a:24:{i:0;s:35:\"ad-codez-widget/ad-codes-widget.php\";i:1;s:39:\"ad-squares-widget/ad-squares-widget.php\";i:2;s:43:\"all-in-one-seo-pack/all_in_one_seo_pack.php\";i:3;s:27:\"backupbuddy/backupbuddy.php\";i:4;s:39:\"bad-behavior/bad-behavior-wordpress.php\";i:5;s:36:\"contact-form-7/wp-contact-form-7.php\";i:6;s:46:\"custom-post-template/custom-post-templates.php\";i:7;s:23:\"digg-digg/digg-digg.php\";i:8;s:43:\"easy-privacy-policy/easy-privacy-policy.php\";i:9;s:36:\"google-sitemap-generator/sitemap.php\";i:10;s:32:\"login-lockdown/loginlockdown.php\";i:11;s:22:\"obox-mobile/mobile.php\";i:12;s:27:\"pretty-link/pretty-link.php\";i:13;s:26:\"secure-wordpress/index.php\";i:14;s:35:\"simply-show-ids/simply-show-ids.php\";i:15;s:39:\"sitemap-generator/sitemap-generator.php\";i:16;s:23:\"slideshow/slideshow.php\";i:17;s:30:\"smart-youtube/smartyoutube.php\";i:18;s:25:\"sucuri-scanner/sucuri.php\";i:19;s:65:\"timthumb-vulnerability-scanner/timthumb-vulnerability-scanner.php\";i:21;s:25:\"wp-cumulus/wp-cumulus.php\";i:22;s:49:\"wp-graphix-magic-light/wp-graphix-magic-light.php\";i:23;s:27:\"wp-pagenavi/wp-pagenavi.php\";i:24;s:31:\"youtube-embed/youtube-embed.php\";}', 'yes');
INSERT INTO `wp_options` VALUES('37', 'home', 'http://www.plrblogs.com/restorevision', 'yes');
INSERT INTO `wp_options` VALUES('38', 'category_base', '', 'yes');
INSERT INTO `wp_options` VALUES('39', 'ping_sites', 'http://rpc.pingomatic.com/', 'yes');
INSERT INTO `wp_options` VALUES('40', 'advanced_edit', '0', 'yes');
INSERT INTO `wp_options` VALUES('41', 'comment_max_links', '2', 'yes');
INSERT INTO `wp_options` VALUES('42', 'gmt_offset', '0', 'yes');
INSERT INTO `wp_options` VALUES('43', 'default_email_category', '1', 'yes');
INSERT INTO `wp_options` VALUES('44', 'recently_edited', 'a:5:{i:0;s:79:\"/home/scplrb10/public_html/restorevision/wp-content/plugins/akismet/akismet.php\";i:1;s:87:\"/home/scplrb10/public_html/restorevision/wp-content/themes/headlines_enhanced/index.php\";i:2;s:87:\"/home/scplrb10/public_html/restorevision/wp-content/themes/headlines_enhanced/style.css\";i:3;s:94:\"/home/scplrb10/public_html/restorevision/wp-content/themes/headlines_enhanced_v3/functions.php\";i:4;s:90:\"/home/scplrb10/public_html/restorevision/wp-content/themes/headlines_enhanced_v3/style.css\";}', 'no');
INSERT INTO `wp_options` VALUES('45', 'template', 'headlines_enhanced', 'yes');
INSERT INTO `wp_options` VALUES('46', 'stylesheet', 'headlines_enhanced', 'yes');
INSERT INTO `wp_options` VALUES('47', 'comment_whitelist', '1', 'yes');
INSERT INTO `wp_options` VALUES('48', 'blacklist_keys', '', 'no');
INSERT INTO `wp_options` VALUES('49', 'comment_registration', '0', 'yes');
INSERT INTO `wp_options` VALUES('51', 'html_type', 'text/html', 'yes');
INSERT INTO `wp_options` VALUES('52', 'use_trackback', '0', 'yes');
INSERT INTO `wp_options` VALUES('53', 'default_role', 'subscriber', 'yes');
INSERT INTO `wp_options` VALUES('54', 'db_version', '27916', 'yes');
INSERT INTO `wp_options` VALUES('55', 'uploads_use_yearmonth_folders', '1', 'yes');
INSERT INTO `wp_options` VALUES('56', 'upload_path', '', 'yes');
INSERT INTO `wp_options` VALUES('57', 'blog_public', '1', 'yes');
INSERT INTO `wp_options` VALUES('58', 'default_link_category', '2', 'yes');
INSERT INTO `wp_options` VALUES('59', 'show_on_front', 'posts', 'yes');
INSERT INTO `wp_options` VALUES('60', 'tag_base', '', 'yes');
INSERT INTO `wp_options` VALUES('61', 'show_avatars', '1', 'yes');
INSERT INTO `wp_options` VALUES('62', 'avatar_rating', 'G', 'yes');
INSERT INTO `wp_options` VALUES('63', 'upload_url_path', '', 'yes');
INSERT INTO `wp_options` VALUES('64', 'thumbnail_size_w', '150', 'yes');
INSERT INTO `wp_options` VALUES('65', 'thumbnail_size_h', '150', 'yes');
INSERT INTO `wp_options` VALUES('66', 'thumbnail_crop', '1', 'yes');
INSERT INTO `wp_options` VALUES('67', 'medium_size_w', '300', 'yes');
INSERT INTO `wp_options` VALUES('68', 'medium_size_h', '300', 'yes');
INSERT INTO `wp_options` VALUES('69', 'avatar_default', 'mystery', 'yes');
INSERT INTO `wp_options` VALUES('72', 'large_size_w', '1024', 'yes');
INSERT INTO `wp_options` VALUES('73', 'large_size_h', '1024', 'yes');
INSERT INTO `wp_options` VALUES('74', 'image_default_link_type', 'file', 'yes');
INSERT INTO `wp_options` VALUES('75', 'image_default_size', '', 'yes');
INSERT INTO `wp_options` VALUES('76', 'image_default_align', '', 'yes');
INSERT INTO `wp_options` VALUES('77', 'close_comments_for_old_posts', '0', 'yes');
INSERT INTO `wp_options` VALUES('78', 'close_comments_days_old', '14', 'yes');
INSERT INTO `wp_options` VALUES('79', 'thread_comments', '1', 'yes');
INSERT INTO `wp_options` VALUES('80', 'thread_comments_depth', '5', 'yes');
INSERT INTO `wp_options` VALUES('81', 'page_comments', '0', 'yes');
INSERT INTO `wp_options` VALUES('82', 'comments_per_page', '50', 'yes');
INSERT INTO `wp_options` VALUES('83', 'default_comments_page', 'newest', 'yes');
INSERT INTO `wp_options` VALUES('84', 'comment_order', 'asc', 'yes');
INSERT INTO `wp_options` VALUES('85', 'sticky_posts', 'a:5:{i:0;i:928;i:1;i:927;i:2;i:926;i:3;i:925;i:4;i:924;}', 'yes');
INSERT INTO `wp_options` VALUES('86', 'widget_categories', 'a:3:{i:2;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}i:3;a:4:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:12:\"hierarchical\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('87', 'widget_text', 'a:5:{i:2;a:0:{}i:3;a:3:{s:5:\"title\";s:14:\"Amazon Example\";s:4:\"text\";s:218:\"<a href=\"http://www.google.com\" title=\"Sample Product\" target=\"_blank\"><img src=\"http://www.plrblogs.com/restorevision/wp-content/uploads/2011/12/banner-example.jpg\" alt=\"Sample Product\" width=\"300\" height=\"250\" /></a>\";s:6:\"filter\";b:0;}i:4;a:3:{s:5:\"title\";s:17:\"Product X Example\";s:4:\"text\";s:219:\"<a href=\"http://www.google.com\" title=\"Sample Product\" target=\"_blank\"><img src=\"http://www.plrblogs.com/restorevision/wp-content/uploads/2011/12/banner-example2.jpg\" alt=\"Sample Product\" width=\"300\" height=\"250\" /></a>\";s:6:\"filter\";b:0;}i:5;a:3:{s:5:\"title\";s:17:\"Product Z Example\";s:4:\"text\";s:219:\"<a href=\"http://www.google.com\" title=\"Sample Product\" target=\"_blank\"><img src=\"http://www.plrblogs.com/restorevision/wp-content/uploads/2011/12/banner-example3.jpg\" alt=\"Sample Product\" width=\"300\" height=\"250\" /></a>\";s:6:\"filter\";b:0;}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('88', 'widget_rss', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('89', 'timezone_string', '', 'yes');
INSERT INTO `wp_options` VALUES('91', 'embed_size_w', '', 'yes');
INSERT INTO `wp_options` VALUES('92', 'embed_size_h', '600', 'yes');
INSERT INTO `wp_options` VALUES('93', 'page_for_posts', '0', 'yes');
INSERT INTO `wp_options` VALUES('95', 'default_post_format', '0', 'yes');
INSERT INTO `wp_options` VALUES('96', 'wp_user_roles', 'a:5:{s:13:\"administrator\";a:2:{s:4:\"name\";s:13:\"Administrator\";s:12:\"capabilities\";a:64:{s:13:\"switch_themes\";b:1;s:11:\"edit_themes\";b:1;s:16:\"activate_plugins\";b:1;s:12:\"edit_plugins\";b:1;s:10:\"edit_users\";b:1;s:10:\"edit_files\";b:1;s:14:\"manage_options\";b:1;s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:6:\"import\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:8:\"level_10\";b:1;s:7:\"level_9\";b:1;s:7:\"level_8\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;s:12:\"delete_users\";b:1;s:12:\"create_users\";b:1;s:17:\"unfiltered_upload\";b:1;s:14:\"edit_dashboard\";b:1;s:14:\"update_plugins\";b:1;s:14:\"delete_plugins\";b:1;s:15:\"install_plugins\";b:1;s:13:\"update_themes\";b:1;s:14:\"install_themes\";b:1;s:11:\"update_core\";b:1;s:10:\"list_users\";b:1;s:12:\"remove_users\";b:1;s:9:\"add_users\";b:1;s:13:\"promote_users\";b:1;s:18:\"edit_theme_options\";b:1;s:13:\"delete_themes\";b:1;s:6:\"export\";b:1;s:8:\"exec_php\";b:1;s:15:\"edit_others_php\";b:1;}}s:6:\"editor\";a:2:{s:4:\"name\";s:6:\"Editor\";s:12:\"capabilities\";a:34:{s:17:\"moderate_comments\";b:1;s:17:\"manage_categories\";b:1;s:12:\"manage_links\";b:1;s:12:\"upload_files\";b:1;s:15:\"unfiltered_html\";b:1;s:10:\"edit_posts\";b:1;s:17:\"edit_others_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:10:\"edit_pages\";b:1;s:4:\"read\";b:1;s:7:\"level_7\";b:1;s:7:\"level_6\";b:1;s:7:\"level_5\";b:1;s:7:\"level_4\";b:1;s:7:\"level_3\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:17:\"edit_others_pages\";b:1;s:20:\"edit_published_pages\";b:1;s:13:\"publish_pages\";b:1;s:12:\"delete_pages\";b:1;s:19:\"delete_others_pages\";b:1;s:22:\"delete_published_pages\";b:1;s:12:\"delete_posts\";b:1;s:19:\"delete_others_posts\";b:1;s:22:\"delete_published_posts\";b:1;s:20:\"delete_private_posts\";b:1;s:18:\"edit_private_posts\";b:1;s:18:\"read_private_posts\";b:1;s:20:\"delete_private_pages\";b:1;s:18:\"edit_private_pages\";b:1;s:18:\"read_private_pages\";b:1;}}s:6:\"author\";a:2:{s:4:\"name\";s:6:\"Author\";s:12:\"capabilities\";a:10:{s:12:\"upload_files\";b:1;s:10:\"edit_posts\";b:1;s:20:\"edit_published_posts\";b:1;s:13:\"publish_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_2\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;s:22:\"delete_published_posts\";b:1;}}s:11:\"contributor\";a:2:{s:4:\"name\";s:11:\"Contributor\";s:12:\"capabilities\";a:5:{s:10:\"edit_posts\";b:1;s:4:\"read\";b:1;s:7:\"level_1\";b:1;s:7:\"level_0\";b:1;s:12:\"delete_posts\";b:1;}}s:10:\"subscriber\";a:2:{s:4:\"name\";s:10:\"Subscriber\";s:12:\"capabilities\";a:2:{s:4:\"read\";b:1;s:7:\"level_0\";b:1;}}}', 'yes');
INSERT INTO `wp_options` VALUES('97', 'widget_search', 'a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('98', 'widget_recent-posts', 'a:4:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}i:3;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:10;}i:4;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('99', 'widget_recent-comments', 'a:2:{i:2;a:2:{s:5:\"title\";s:0:\"\";s:6:\"number\";i:5;}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('100', 'widget_archives', 'a:2:{i:2;a:3:{s:5:\"title\";s:0:\"\";s:5:\"count\";i:0;s:8:\"dropdown\";i:0;}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('101', 'widget_meta', 'a:2:{i:2;a:1:{s:5:\"title\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('102', 'sidebars_widgets', 'a:9:{s:19:\"wp_inactive_widgets\";a:20:{i:0;s:14:\"woo_adwidget-2\";i:1;s:10:\"woo_tabs-2\";i:2;s:13:\"woo_twitter-2\";i:3;s:7:\"pages-2\";i:4;s:10:\"calendar-2\";i:5;s:7:\"links-2\";i:6;s:6:\"text-2\";i:7;s:5:\"rss-2\";i:8;s:11:\"tag_cloud-2\";i:9;s:10:\"nav_menu-2\";i:10;s:21:\"ws_widget__ad_codes-4\";i:11;s:23:\"ws_widget__ad_squares-3\";i:12;s:23:\"pluginbuddy_slideshow-2\";i:13;s:22:\"youtube_embed_widget-2\";i:14;s:15:\"smart-youtube-2\";i:15;s:14:\"recent-posts-2\";i:16;s:17:\"recent-comments-2\";i:17;s:10:\"archives-2\";i:18;s:12:\"categories-2\";i:19;s:6:\"meta-2\";}s:9:\"sidebar-1\";a:3:{i:0;s:21:\"ws_widget__ad_codes-3\";i:1;s:14:\"recent-posts-3\";i:2;s:10:\"wp-cumulus\";}s:8:\"footer-1\";a:1:{i:0;s:14:\"recent-posts-4\";}s:8:\"footer-2\";a:1:{i:0;s:7:\"pages-3\";}s:8:\"footer-3\";a:1:{i:0;s:12:\"categories-3\";}s:18:\"left-column-widget\";a:1:{i:0;s:6:\"text-3\";}s:20:\"center-column-widget\";a:1:{i:0;s:6:\"text-4\";}s:19:\"right-column-widget\";a:1:{i:0;s:6:\"text-5\";}s:13:\"array_version\";i:3;}', 'yes');
INSERT INTO `wp_options` VALUES('103', 'cron', 'a:10:{i:1402365101;a:1:{s:25:\"swpa_cleanup_live_traffic\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:6:\"hourly\";s:4:\"args\";a:0:{}s:8:\"interval\";i:3600;}}}i:1402373953;a:3:{s:16:\"wp_update_themes\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:16:\"wp_version_check\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}s:17:\"wp_update_plugins\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1402373964;a:1:{s:19:\"wp_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1402375901;a:1:{s:21:\"swpa_check_user_admin\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:2:\"8h\";s:4:\"args\";a:0:{}s:8:\"interval\";i:28800;}}}i:1402384371;a:1:{s:42:\"pluginbuddy_backupbuddy-cron_final_cleanup\";a:1:{s:32:\"29c535ff022f2c07b8ce4f7c48efea0e\";a:2:{s:8:\"schedule\";b:0;s:4:\"args\";a:1:{i:0;s:10:\"eish69d83s\";}}}}i:1402385880;a:1:{s:20:\"wp_maybe_auto_update\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:10:\"twicedaily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:43200;}}}i:1402405850;a:1:{s:13:\"sm_ping_daily\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1402424548;a:1:{s:30:\"wp_scheduled_auto_draft_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}i:1402443427;a:1:{s:24:\"akismet_scheduled_delete\";a:1:{s:32:\"40cd750bba9870f18aada2478b24840a\";a:3:{s:8:\"schedule\";s:5:\"daily\";s:4:\"args\";a:0:{}s:8:\"interval\";i:86400;}}}s:7:\"version\";i:2;}', 'yes');
INSERT INTO `wp_options` VALUES('7830', '_transient_timeout_feed_e14a1e5a5b311579a7d9f87467c39a91', '1402924294', 'no');
INSERT INTO `wp_options` VALUES('7831', '_transient_feed_e14a1e5a5b311579a7d9f87467c39a91', 'a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:23:\"\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"Google Sitemap Generator Support Topics\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"Google Sitemap Generator Support Topics\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"http://www.arnebrachhold.de/projects/wordpress-plugins/google-xml-sitemaps-generator/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:30:\"Wed, 21 May 2014 5:23:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:3:{i:0;a:6:{s:4:\"data\";s:19:\"\n			\n			\n			\n			\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:4:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"Common error messages in Google Webmaster Tools\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://www.arnebrachhold.de/redir/sitemap-feed-gwterrs/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"C2VZYxeTESzcCF2IhS13\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 28 Apr 2014 00:00:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:19:\"\n			\n			\n			\n			\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:4:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:51:\"How to move your sitemap to the root of your domain\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://www.arnebrachhold.de/redir/sitemap-feed-movesm/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"C2VZYxeTESzcCF2IhS12\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 27 Apr 2014 00:00:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:19:\"\n			\n			\n			\n			\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:4:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"Introducing a new format for your sitemap\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"http://www.arnebrachhold.de/redir/sitemap-feed-newformat/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"C2VZYxeTESzcCF2IhS1l\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 26 Apr 2014 00:00:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:9:{s:6:\"server\";s:16:\"cloudflare-nginx\";s:4:\"date\";s:29:\"Mon, 09 Jun 2014 13:11:34 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=utf-8\";s:10:\"connection\";s:5:\"close\";s:10:\"set-cookie\";s:138:\"__cfduid=d6087110ae247e9da35054c789ce2bb011402319493814; expires=Mon, 23-Dec-2019 23:50:00 GMT; path=/; domain=.arnebrachhold.de; HttpOnly\";s:13:\"cache-control\";s:21:\"public, max-age=86400\";s:13:\"last-modified\";s:29:\"Wed, 21 May 2014 17:23:30 GMT\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:6:\"cf-ray\";s:20:\"137d9364546903e2-DFW\";}s:5:\"build\";s:14:\"20131111204433\";}', 'no');
INSERT INTO `wp_options` VALUES('1919', 'woo_disable_posts_date', 'false', 'yes');
INSERT INTO `wp_options` VALUES('1920', 'woo_disable_cats_date', 'false', 'yes');
INSERT INTO `wp_options` VALUES('1921', 'woo_disable_search_date', 'false', 'yes');
INSERT INTO `wp_options` VALUES('988', 'initial_db_version', '18226', 'yes');
INSERT INTO `wp_options` VALUES('110', '_transient_random_seed', 'bea4dd1779893da76c99df6fa8018be6', 'yes');
INSERT INTO `wp_options` VALUES('111', 'auth_salt', 'f!*e4!@T$;$WZV^uMI#|4X@xlA1w&o(N7DIW(N$:g0.s;sS em/2jB=Z0xJ{ek+h', 'yes');
INSERT INTO `wp_options` VALUES('112', 'logged_in_salt', '~#+o4Q>Np{iE?VV;h9AD>{*z]ReG#{ 0HhgW-9(1B6nq?``:H;lAt,m}0 Fc*;}i', 'yes');
INSERT INTO `wp_options` VALUES('113', 'widget_pages', 'a:3:{i:2;a:0:{}i:3;a:3:{s:5:\"title\";s:0:\"\";s:6:\"sortby\";s:10:\"post_title\";s:7:\"exclude\";s:0:\"\";}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('114', 'widget_calendar', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('115', 'widget_links', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('116', 'widget_tag_cloud', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('117', 'widget_nav_menu', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('118', 'widget_widget_twentyeleven_ephemera', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('121', 'dashboard_widget_options', 'a:4:{s:25:\"dashboard_recent_comments\";a:1:{s:5:\"items\";i:5;}s:24:\"dashboard_incoming_links\";a:5:{s:4:\"home\";s:37:\"http://www.plrblogs.com/restorevision\";s:4:\"link\";s:113:\"http://blogsearch.google.com/blogsearch?scoring=d&partner=wordpress&q=link:http://www.plrblogs.com/restorevision/\";s:3:\"url\";s:146:\"http://blogsearch.google.com/blogsearch_feeds?scoring=d&ie=utf-8&num=10&output=rss&partner=wordpress&q=link:http://www.plrblogs.com/restorevision/\";s:5:\"items\";i:10;s:9:\"show_date\";b:0;}s:17:\"dashboard_primary\";a:7:{s:4:\"link\";s:26:\"http://wordpress.org/news/\";s:3:\"url\";s:31:\"http://wordpress.org/news/feed/\";s:5:\"title\";s:14:\"WordPress Blog\";s:5:\"items\";i:2;s:12:\"show_summary\";i:1;s:11:\"show_author\";i:0;s:9:\"show_date\";i:1;}s:19:\"dashboard_secondary\";a:7:{s:4:\"link\";s:28:\"http://planet.wordpress.org/\";s:3:\"url\";s:33:\"http://planet.wordpress.org/feed/\";s:5:\"title\";s:20:\"Other WordPress News\";s:5:\"items\";i:5;s:12:\"show_summary\";i:0;s:11:\"show_author\";i:0;s:9:\"show_date\";i:0;}}', 'yes');
INSERT INTO `wp_options` VALUES('122', 'nonce_salt', ']u]lpAQC~0BfO##Sc/B>FXOG/ bp.:<rPBd-h11LeSh~DOT<h*YY.I_mjmH<[2+N', 'yes');
INSERT INTO `wp_options` VALUES('1917', 'akismet_spam_count', '4', 'yes');
INSERT INTO `wp_options` VALUES('1893', 'woo_custom_bg', '', 'yes');
INSERT INTO `wp_options` VALUES('1562', '_transient_ye_video_NGUxMmQwNjZlMTkzZjc0MzQ3ZGZhNjI4OTMxMjhjNmZj', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/i03mt72s5QU?version=3&amp;fs=0&amp;rel=0&amp;title=Natural+Remedies+%26amp%3B+Cleanses+%3A+How+to+Naturally+Reduce+High+Blood+Pressure%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1561', '_transient_timeout_ye_video_NGUxMmQwNjZlMTkzZjc0MzQ3ZGZhNjI4OTMx', '1328815661', 'no');
INSERT INTO `wp_options` VALUES('1555', '_transient_timeout_ye_video_Zjk0NmQ0Y2ZjYzNjNDFhMWRiZjQwMzJlMTAy', '1328815660', 'no');
INSERT INTO `wp_options` VALUES('1556', '_transient_ye_video_Zjk0NmQ0Y2ZjYzNjNDFhMWRiZjQwMzJlMTAyMGM1ZmM0', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/vWK6vWGeSMQ?version=3&amp;fs=0&amp;rel=0&amp;title=Alternative+Medicines+for+Common+Ailments+%3A+How+to+Use+Herbs+to+Lower+Blood+Pressure%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3940', '_transient_plugins_delete_result_26', '1', 'yes');
INSERT INTO `wp_options` VALUES('1535', '_transient_timeout_ye_video_YTk4Mjk1OTNhODNlODlkNmI5NmUyYjkyOWUz', '1328815660', 'no');
INSERT INTO `wp_options` VALUES('1536', '_transient_ye_video_YTk4Mjk1OTNhODNlODlkNmI5NmUyYjkyOWUzYmE5ZWYx', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/nrfj4LM5qj8?version=3&amp;fs=0&amp;rel=0&amp;title=High+Blood+Pressure+Tips+%26amp%3B+Treatments+%3A+Potassium+Rich+Food+for+High+Blood+Pressure%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1520', '_transient_plugins_delete_result_18', '1', 'yes');
INSERT INTO `wp_options` VALUES('1541', '_transient_timeout_ye_video_ZWU3YjUzNWVkZmI3MTg1NTVhOGRhODczODcw', '1328815660', 'no');
INSERT INTO `wp_options` VALUES('1542', '_transient_ye_video_ZWU3YjUzNWVkZmI3MTg1NTVhOGRhODczODcwOWU1NzNi', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/ONytpf8Rihs?version=3&amp;fs=0&amp;rel=0&amp;title=High+Blood+Pressure+Tips+%26amp%3B+Treatments+%3A+Exercise+for+High+Blood+Pressure%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1549', '_transient_timeout_ye_video_YzkyYjQ5OTRkYzJmMzEwNDllY2IwNzlhNDMx', '1328815660', 'no');
INSERT INTO `wp_options` VALUES('1550', '_transient_ye_video_YzkyYjQ5OTRkYzJmMzEwNDllY2IwNzlhNDMxNzA2MGJj', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/ztYRWoKGBnY?version=3&amp;fs=0&amp;rel=0&amp;title=Nutrition+Tips+%3A+About+Sesame+Oil+for+High+Blood+Pressure%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1362', 'theme_mods_headlines_enhanced', 'a:1:{i:0;b:0;}', 'yes');
INSERT INTO `wp_options` VALUES('1363', 'theme_switched', '', 'yes');
INSERT INTO `wp_options` VALUES('989', 'db_upgraded', '', 'yes');
INSERT INTO `wp_options` VALUES('1452', 'woo_page_nav_disable', '18,19,388', 'yes');
INSERT INTO `wp_options` VALUES('3516', 'youtube_embed_editor_sc', 'youtube', 'yes');
INSERT INTO `wp_options` VALUES('2113', 'woo_custom_footer_disclaimer', 'Disclaimer: This website is an officially authorized and remunerated associate for recommending high quality products found on this website. Links on this website may be associate links which means if you click on a link of a recommended product, I/we may receive monetary compensation. However, this does not affect any unbiased information presented on this website.', 'yes');
INSERT INTO `wp_options` VALUES('2115', 'woo_disclaimer_color', '', 'yes');
INSERT INTO `wp_options` VALUES('2117', 'woo_disclaimer_fontsize', '14', 'yes');
INSERT INTO `wp_options` VALUES('2139', 'woo_show_dislcaimer_footer', 'true', 'yes');
INSERT INTO `wp_options` VALUES('3695', '_transient_plugins_delete_result_24', '1', 'yes');
INSERT INTO `wp_options` VALUES('3143', '_transient_aye_video_NjFmMjdjMDg2YzBiNGEzOWQ0MjJmYTBiMzJkZTAyOTM', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/CrvBApGYEYw?fs=0&amp;rel=0&amp;title=Healthy+Skin+Care+%3A+How+to+Do+Homemade+Scar+Removal&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3393', '_transient_plugins_delete_result_23', '1', 'yes');
INSERT INTO `wp_options` VALUES('288', 'pluginbuddy_plugins', 'a:4:{s:23:\"pluginbuddy_backupbuddy\";O:8:\"stdClass\":9:{s:3:\"url\";s:68:\"http://www.plrblogs.com/bloodpressure/wp-content/plugins/backupbuddy\";s:4:\"slug\";s:23:\"pluginbuddy_backupbuddy\";s:7:\"package\";s:0:\"\";s:11:\"new_version\";s:6:\"2.2.33\";s:11:\"last_update\";i:1402360530;s:2:\"id\";s:1:\"0\";s:3:\"key\";s:0:\"\";s:10:\"key_status\";N;s:4:\"guid\";s:13:\"4ee047c895644\";}s:21:\"pluginbuddy_slideshow\";O:8:\"stdClass\":9:{s:3:\"url\";s:66:\"http://www.plrblogs.com/bloodpressure/wp-content/plugins/slideshow\";s:4:\"slug\";s:21:\"pluginbuddy_slideshow\";s:7:\"package\";s:0:\"\";s:11:\"new_version\";s:6:\"1.0.45\";s:11:\"last_update\";i:1402360410;s:2:\"id\";s:1:\"0\";s:3:\"key\";s:0:\"\";s:10:\"key_status\";N;s:4:\"guid\";s:13:\"4ee047c9d04d9\";}s:8:\"userhash\";s:0:\"\";s:8:\"username\";s:0:\"\";}', 'yes');
INSERT INTO `wp_options` VALUES('280', 'akismet_available_servers', 'a:4:{s:12:\"72.233.69.88\";b:1;s:12:\"72.233.69.89\";b:1;s:12:\"66.135.58.61\";b:1;s:12:\"66.135.58.62\";b:1;}', 'yes');
INSERT INTO `wp_options` VALUES('281', 'akismet_connectivity_time', '1339887644', 'yes');
INSERT INTO `wp_options` VALUES('282', 'wordpress_api_key', '3dad46be7226', 'yes');
INSERT INTO `wp_options` VALUES('283', 'akismet_discard_month', 'true', 'yes');
INSERT INTO `wp_options` VALUES('284', 'akismet_show_user_comments_approved', 'true', 'yes');
INSERT INTO `wp_options` VALUES('286', '_transient_update_plugins', '', 'yes');
INSERT INTO `wp_options` VALUES('159', 'recently_activated', 'a:1:{s:37:\"wp-content-magic/wp-content-magic.php\";i:1402359571;}', 'yes');
INSERT INTO `wp_options` VALUES('7665', '_transient_timeout_aioseop_oauth_current', '1402279969', 'no');
INSERT INTO `wp_options` VALUES('160', 'ws_widget__ad_codes_configured', '0', 'yes');
INSERT INTO `wp_options` VALUES('161', 'ws_widget__ad_codes_notices', 'a:0:{}', 'yes');
INSERT INTO `wp_options` VALUES('162', 'ws_widget__ad_codes_options', 'a:0:{}', 'yes');
INSERT INTO `wp_options` VALUES('163', 'ws_widget__ad_squares_configured', '0', 'yes');
INSERT INTO `wp_options` VALUES('164', 'ws_widget__ad_squares_notices', 'a:0:{}', 'yes');
INSERT INTO `wp_options` VALUES('165', 'ws_widget__ad_squares_options', 'a:0:{}', 'yes');
INSERT INTO `wp_options` VALUES('166', 'aioseop_options', 'a:59:{s:9:\"aiosp_can\";s:2:\"on\";s:12:\"aiosp_donate\";s:0:\"\";s:16:\"aiosp_home_title\";s:0:\"\";s:22:\"aiosp_home_description\";s:0:\"\";s:19:\"aiosp_home_keywords\";s:0:\"\";s:23:\"aiosp_max_words_excerpt\";s:0:\"\";s:20:\"aiosp_rewrite_titles\";s:1:\"1\";s:23:\"aiosp_post_title_format\";s:27:\"%post_title% | %blog_title%\";s:23:\"aiosp_page_title_format\";s:27:\"%page_title% | %blog_title%\";s:27:\"aiosp_category_title_format\";s:31:\"%category_title% | %blog_title%\";s:26:\"aiosp_archive_title_format\";s:21:\"%date% | %blog_title%\";s:22:\"aiosp_tag_title_format\";s:20:\"%tag% | %blog_title%\";s:25:\"aiosp_search_title_format\";s:23:\"%search% | %blog_title%\";s:24:\"aiosp_description_format\";s:13:\"%description%\";s:22:\"aiosp_404_title_format\";s:33:\"Nothing found for %request_words%\";s:18:\"aiosp_paged_format\";s:14:\" - Part %page%\";s:20:\"aiosp_use_categories\";s:0:\"\";s:32:\"aiosp_dynamic_postspage_keywords\";s:2:\"on\";s:22:\"aiosp_category_noindex\";s:2:\"on\";s:18:\"aiosp_tags_noindex\";s:0:\"\";s:14:\"aiosp_cap_cats\";s:2:\"on\";s:27:\"aiosp_generate_descriptions\";s:0:\"\";s:16:\"aiosp_debug_info\";s:0:\"\";s:20:\"aiosp_post_meta_tags\";s:0:\"\";s:20:\"aiosp_page_meta_tags\";s:0:\"\";s:20:\"aiosp_home_meta_tags\";s:0:\"\";s:13:\"aiosp_enabled\";s:1:\"1\";s:17:\"aiosp_enablecpost\";s:1:\"0\";s:26:\"aiosp_use_tags_as_keywords\";s:2:\"on\";s:16:\"aiosp_seopostcol\";s:0:\"\";s:18:\"aiosp_seocustptcol\";s:0:\"\";s:21:\"aiosp_posttypecolumns\";a:2:{i:0;s:4:\"post\";i:1;s:4:\"page\";}s:12:\"aiosp_do_log\";s:0:\"\";s:25:\"aiosp_google_analytics_id\";s:0:\"\";s:29:\"aiosp_ga_track_outbound_links\";s:0:\"\";s:14:\"aiosp_ex_pages\";s:0:\"\";s:22:\"aiosp_google_publisher\";s:0:\"\";s:15:\"aiosp_ga_domain\";s:0:\"\";s:21:\"aiosp_front_meta_tags\";s:0:\"\";s:21:\"aiosp_ga_multi_domain\";s:0:\"\";s:20:\"aiosp_togglekeywords\";s:1:\"0\";s:20:\"aiosp_force_rewrites\";s:1:\"1\";s:24:\"aiosp_use_original_title\";s:1:\"0\";s:16:\"aiosp_cap_titles\";s:2:\"on\";s:19:\"aiosp_cpostadvanced\";s:1:\"0\";s:17:\"aiosp_cpostactive\";a:2:{i:0;s:4:\"post\";i:1;s:4:\"page\";}s:17:\"aiosp_cposttitles\";s:0:\"\";s:15:\"aiosp_admin_bar\";s:2:\"on\";s:23:\"aiosp_custom_menu_order\";s:2:\"on\";s:19:\"aiosp_google_verify\";s:0:\"\";s:17:\"aiosp_bing_verify\";s:0:\"\";s:22:\"aiosp_pinterest_verify\";s:0:\"\";s:20:\"aiosp_unprotect_meta\";s:0:\"\";s:37:\"aiosp_wpcf7_contact_form_title_format\";s:27:\"%post_title% | %blog_title%\";s:31:\"aiosp_wooframework_title_format\";s:27:\"%post_title% | %blog_title%\";s:28:\"aiosp_archive_author_noindex\";s:2:\"on\";s:26:\"aiosp_archive_date_noindex\";s:2:\"on\";s:11:\"aiosp_token\";s:30:\"4/x1vP_Rm27TUg60Go4FuFHjCnDZGY\";s:12:\"aiosp_secret\";s:24:\"jESLUWf_lzGxb7kO0OOyjm4b\";}', 'yes');
INSERT INTO `wp_options` VALUES('167', 'pluginbuddy_backupbuddy', 'a:36:{s:12:\"data_version\";s:1:\"2\";s:15:\"import_password\";s:0:\"\";s:16:\"backup_reminders\";i:1;s:16:\"edits_since_last\";i:0;s:11:\"last_backup\";i:1402362771;s:18:\"last_backup_serial\";s:10:\"eish69d83s\";s:11:\"compression\";i:1;s:19:\"force_compatibility\";i:0;s:18:\"skip_database_dump\";i:0;s:19:\"backup_nonwp_tables\";i:0;s:14:\"include_tables\";a:0:{}s:14:\"exclude_tables\";a:0:{}s:15:\"integrity_check\";i:1;s:9:\"schedules\";a:0:{}s:9:\"log_level\";s:1:\"1\";s:8:\"excludes\";s:0:\"\";s:13:\"high_security\";i:0;s:19:\"next_schedule_index\";i:100;s:13:\"archive_limit\";i:0;s:18:\"archive_limit_size\";i:0;s:22:\"email_notify_scheduled\";s:0:\"\";s:19:\"email_notify_manual\";s:0:\"\";s:18:\"email_notify_error\";s:0:\"\";s:7:\"backups\";a:1:{s:10:\"eish69d83s\";a:14:{s:6:\"serial\";s:10:\"eish69d83s\";s:11:\"backup_mode\";s:1:\"2\";s:4:\"type\";s:4:\"full\";s:10:\"start_time\";i:1402362771;s:12:\"updated_time\";i:1402362771;s:6:\"status\";a:0:{}s:14:\"schedule_title\";s:0:\"\";s:16:\"backup_directory\";s:80:\"/home/scplrb10/public_html/restorevision/wp-content/uploads/backupbuddy_backups/\";s:12:\"archive_file\";s:143:\"/home/scplrb10/public_html/restorevision/wp-content/uploads/backupbuddy_backups/backup-www_plrblogs_com_restorevision-2014_06_10-eish69d83s.zip\";s:7:\"trigger\";s:6:\"manual\";s:19:\"force_compatibility\";b:0;s:5:\"steps\";a:2:{i:0;a:2:{s:8:\"function\";s:16:\"backup_zip_files\";s:4:\"args\";a:0:{}}i:1;a:2:{s:8:\"function\";s:11:\"post_backup\";s:4:\"args\";a:0:{}}}s:14:\"temp_directory\";s:88:\"/home/scplrb10/public_html/restorevision/wp-content/uploads/backupbuddy_temp/eish69d83s/\";s:23:\"temporary_zip_directory\";s:100:\"/home/scplrb10/public_html/restorevision/wp-content/uploads/backupbuddy_backups/temp_zip_eish69d83s/\";}}s:19:\"remote_destinations\";a:0:{}s:21:\"backup_file_integrity\";a:0:{}s:11:\"role_access\";s:13:\"administrator\";s:16:\"dropboxtemptoken\";s:0:\"\";s:11:\"backup_mode\";s:1:\"2\";s:16:\"multisite_export\";s:1:\"1\";s:16:\"backup_directory\";s:80:\"/home/scplrb10/public_html/restorevision/wp-content/uploads/backupbuddy_backups/\";s:20:\"repairbuddy_password\";s:0:\"\";s:10:\"log_serial\";s:10:\"29mdgqe92p\";s:17:\"temporary_options\";a:1:{s:16:\"experimental_zip\";s:1:\"0\";}i:0;b:0;s:7:\"updater\";a:2:{s:10:\"last_check\";i:1323321447;s:13:\"last_response\";a:6:{s:6:\"status\";s:2:\"ok\";s:10:\"key_status\";s:2:\"ok\";s:12:\"download_url\";s:209:\"http://updater.ithemes.com/?product=backupbuddy&action=download&siteurl=http://www.plrblogs.com/restorevision&guid=4ee047c895644&key=4EEX4861EF6DEX76722179&expires=1323407847&v=8a6f6ed83df765269a91a510f7c8be0b\";s:11:\"new_version\";b:1;s:14:\"latest_version\";s:6:\"2.2.31\";s:13:\"latest_update\";s:20:\"2011-11-17 12:16:06\n\";}}}', 'no');
INSERT INTO `wp_options` VALUES('7832', '_transient_timeout_feed_mod_e14a1e5a5b311579a7d9f87467c39a91', '1402924294', 'no');
INSERT INTO `wp_options` VALUES('7833', '_transient_feed_mod_e14a1e5a5b311579a7d9f87467c39a91', '1402319494', 'no');
INSERT INTO `wp_options` VALUES('7862', '_transient_timeout_vye_type_wnt4KP4B_V8', '1402435882', 'no');
INSERT INTO `wp_options` VALUES('7948', '_transient_doing_cron', '1402362921.0000000000000000000000', 'yes');
INSERT INTO `wp_options` VALUES('7863', '_transient_vye_type_wnt4KP4B_V8', 'v', 'no');
INSERT INTO `wp_options` VALUES('7864', '_transient_timeout_vye_title_wnt4KP4B_V8', '1402435882', 'no');
INSERT INTO `wp_options` VALUES('7856', '_transient_timeout_vye_type_IK0w7mfqMSc', '1402435882', 'no');
INSERT INTO `wp_options` VALUES('7857', '_transient_vye_type_IK0w7mfqMSc', 'v', 'no');
INSERT INTO `wp_options` VALUES('7858', '_transient_timeout_vye_title_IK0w7mfqMSc', '1402435882', 'no');
INSERT INTO `wp_options` VALUES('7859', '_transient_vye_title_IK0w7mfqMSc', 'Restore your eyesight naturally YOURSELF - (Myopia)', 'no');
INSERT INTO `wp_options` VALUES('7882', '_transient_timeout_vye_video_45cba14f740e7f16315c059fce5cad47', '1402363145', 'no');
INSERT INTO `wp_options` VALUES('7883', '_transient_vye_video_45cba14f740e7f16315c059fce5cad47', '\n<!-- Vixy YouTube Embed v3.2 -->\n<span itemscope=\"itemscope\" xmlns:media=\"http://search.yahoo.com/searchmonkey/media/\" xmlns:dc=\"http://purl.org/dc/terms/\">\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/IK0w7mfqMSc?enablejsapi=1&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;wmode=opaque\" ></iframe>\n<link itemprop=\"media:video\" rel=\"alternate\" href=\"http://www.youtube.com/v/IK0w7mfqMSc\"/>\n<link itemprop=\"media:thumbnail\" rel=\"icon\" href=\"http://i.ytimg.com/vi/IK0w7mfqMSc/hqdefault.jpg\"/>\n<link itemprop=\"media:thumbnail\" rel=\"icon\" href=\"http://i.ytimg.com/vi/IK0w7mfqMSc/default.jpg\"/>\n<meta itemprop=\"media:title\" content=\"Restore your eyesight naturally YOURSELF - (Myopia)\"/>\n<meta itemprop=\"media:width\" content=\"570\"/>\n<meta itemprop=\"media:height\" content=\"390\"/>\n	</span>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('7622', '_site_transient_timeout_browser_516dbc21177c71418daad301dad61862', '1402878713', 'yes');
INSERT INTO `wp_options` VALUES('7623', '_site_transient_browser_516dbc21177c71418daad301dad61862', 'a:9:{s:8:\"platform\";s:7:\"Windows\";s:4:\"name\";s:6:\"Chrome\";s:7:\"version\";s:13:\"35.0.1916.114\";s:10:\"update_url\";s:28:\"http://www.google.com/chrome\";s:7:\"img_src\";s:49:\"http://s.wordpress.org/images/browsers/chrome.png\";s:11:\"img_src_ssl\";s:48:\"https://wordpress.org/images/browsers/chrome.png\";s:15:\"current_version\";s:2:\"18\";s:7:\"upgrade\";b:0;s:8:\"insecure\";b:0;}', 'yes');
INSERT INTO `wp_options` VALUES('7826', '_transient_timeout_online_users', '1402317494', 'no');
INSERT INTO `wp_options` VALUES('7827', '_transient_online_users', 'a:1:{i:0;a:6:{s:7:\"user_id\";i:28;s:10:\"user_login\";s:5:\"admin\";s:10:\"user_email\";s:23:\"youremail@youremail.com\";s:15:\"user_registered\";s:19:\"2014-06-09 01:09:54\";s:13:\"last_activity\";i:1402315693;s:11:\"remote_addr\";s:13:\"2.216.124.230\";}}', 'no');
INSERT INTO `wp_options` VALUES('1724', 'woo_disable_date_posts', 'false', 'yes');
INSERT INTO `wp_options` VALUES('1725', 'woo_disable_date_cats', 'false', 'yes');
INSERT INTO `wp_options` VALUES('1726', 'woo_disable_date_search', 'false', 'yes');
INSERT INTO `wp_options` VALUES('1732', '_transient_timeout_ye_video_YThkMjc0ZTYzZDJhYmEzOGVkMjI2Y2FmMmZi', '1335248676', 'no');
INSERT INTO `wp_options` VALUES('1733', '_transient_ye_video_YThkMjc0ZTYzZDJhYmEzOGVkMjI2Y2FmMmZiY2RhNWMz', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/eIRmCGwurmE?version=3&amp;fs=0&amp;rel=0&amp;title=Healthy+Skin+Advice+%3A+Removing+Hanging+Warts%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('168', 'pluginbuddy_backupbuddy-updater-guid', '4ee047c895644', 'yes');
INSERT INTO `wp_options` VALUES('169', 'wpcf7', 'a:1:{s:7:\"version\";s:5:\"3.8.1\";}', 'yes');
INSERT INTO `wp_options` VALUES('170', 'ddsg_language', 'English', 'yes');
INSERT INTO `wp_options` VALUES('171', 'ddsg_items_per_page', '50', 'yes');
INSERT INTO `wp_options` VALUES('172', 'ddsg_sm_name', '', 'yes');
INSERT INTO `wp_options` VALUES('173', 'ddsg_what_to_show', 'both', 'yes');
INSERT INTO `wp_options` VALUES('174', 'ddsg_which_first', 'posts', 'yes');
INSERT INTO `wp_options` VALUES('175', 'ddsg_post_sort_order', 'title', 'yes');
INSERT INTO `wp_options` VALUES('176', 'ddsg_page_sort_order', 'title', 'yes');
INSERT INTO `wp_options` VALUES('177', 'ddsg_comments_on_posts', '', 'yes');
INSERT INTO `wp_options` VALUES('178', 'ddsg_comments_on_pages', '', 'yes');
INSERT INTO `wp_options` VALUES('179', 'ddsg_show_zero_comments', '', 'yes');
INSERT INTO `wp_options` VALUES('180', 'ddsg_hide_future', '', 'yes');
INSERT INTO `wp_options` VALUES('181', 'ddsg_new_window', '', 'yes');
INSERT INTO `wp_options` VALUES('182', 'ddsg_show_post_date', '', 'yes');
INSERT INTO `wp_options` VALUES('183', 'ddsg_show_page_date', '', 'yes');
INSERT INTO `wp_options` VALUES('184', 'ddsg_date_format', 'F jS, Y', 'yes');
INSERT INTO `wp_options` VALUES('185', 'ddsg_hide_protected', '1', 'yes');
INSERT INTO `wp_options` VALUES('186', 'ddsg_excluded_cats', '', 'yes');
INSERT INTO `wp_options` VALUES('187', 'ddsg_excluded_pages', '', 'yes');
INSERT INTO `wp_options` VALUES('188', 'ddsg_page_nav', '1', 'yes');
INSERT INTO `wp_options` VALUES('189', 'ddsg_page_nav_where', 'top', 'yes');
INSERT INTO `wp_options` VALUES('190', 'ddsg_xml_path', '', 'yes');
INSERT INTO `wp_options` VALUES('191', 'ddsg_xml_where', 'last', 'yes');
INSERT INTO `wp_options` VALUES('192', 'easy_privacy_sitename', '', 'yes');
INSERT INTO `wp_options` VALUES('193', 'easy_privacy_email', '', 'yes');
INSERT INTO `wp_options` VALUES('194', 'easy_privacy_pageurl', 'privacy-policy', 'yes');
INSERT INTO `wp_options` VALUES('195', 'easy_privacy_acknowlegement', '', 'yes');
INSERT INTO `wp_options` VALUES('196', 'easy_privacy_lastupdated', '', 'yes');
INSERT INTO `wp_options` VALUES('197', 'easy_privacy_pagetitle', 'Privacy Policy', 'yes');
INSERT INTO `wp_options` VALUES('198', 'easy_privacy_section_one_selected', '1', 'yes');
INSERT INTO `wp_options` VALUES('199', 'easy_privacy_section_one_title', 'Your Privacy', 'yes');
INSERT INTO `wp_options` VALUES('200', 'easy_privacy_section_one', 'Your privacy is important to us. To better protect your privacy we provide this notice explaining our online information practices and the choices you can make about the way your information is collected and used. To make this notice easy to find, we make it available on our homepage and at every point where personally identifiable information may be requested.', 'yes');
INSERT INTO `wp_options` VALUES('201', 'easy_privacy_section_two_selected', '1', 'yes');
INSERT INTO `wp_options` VALUES('202', 'easy_privacy_section_two_title', 'Google Adsense and the DoubleClick DART Cookie', 'yes');
INSERT INTO `wp_options` VALUES('203', 'easy_privacy_section_two', 'Google, as a third party advertisement vendor, uses cookies to serve ads on this site. The use of DART cookies by Google enables them to serve adverts to visitors that are based on their visits to this website as well as other sites on the internet.\r\n\r\nTo opt out of the DART cookies you may visit the Google ad and content network privacy policy at the following url http://www.google.com/privacy_ads.html Tracking of users through the DART cookie mechanisms are subject to Google\'s own privacy policies.\r\n\r\nOther Third Party ad servers or ad networks may also use cookies to track users activities on this website to measure advertisement effectiveness and other reasons that will be provided in their own privacy policies, @blogname has no access or control over these cookies that may be used by third party advertisers.', 'yes');
INSERT INTO `wp_options` VALUES('204', 'easy_privacy_section_three_selected', '', 'yes');
INSERT INTO `wp_options` VALUES('205', 'easy_privacy_section_three_title', 'Our Commitment To Childrens Privacy', 'yes');
INSERT INTO `wp_options` VALUES('206', 'easy_privacy_section_three', 'Protecting the privacy of the very young is especially important. For that reason, @blogname will never collect or maintain information at our website from those we actually know are under 18, and no part of our website is structured to attract anyone under 18.\r\nUnder our Terms of Service, children under 18 are not allowed to access our service.', 'yes');
INSERT INTO `wp_options` VALUES('207', 'easy_privacy_section_four_selected', '1', 'yes');
INSERT INTO `wp_options` VALUES('208', 'easy_privacy_section_four_title', 'Collection of Personal Information', 'yes');
INSERT INTO `wp_options` VALUES('209', 'easy_privacy_section_four', 'When visiting @blogname, the IP address used to access the site will be logged along with the dates and times of access. This information is purely used to analyze trends, administer the site, track users movement and gather broad demographic information for internal use. Most importantly, any recorded IP addresses are not linked to personally identifiable information.\r\n', 'yes');
INSERT INTO `wp_options` VALUES('210', 'easy_privacy_section_five_selected', '1', 'yes');
INSERT INTO `wp_options` VALUES('211', 'easy_privacy_section_five_title', 'Links to third party Websites', 'yes');
INSERT INTO `wp_options` VALUES('212', 'easy_privacy_section_five', 'We have included links on this site for your use and reference. We are not responsible for the privacy policies on these websites. You should be aware that the privacy policies of these sites may differ from our own. \r\n', 'yes');
INSERT INTO `wp_options` VALUES('213', 'easy_privacy_section_six_selected', '1', 'yes');
INSERT INTO `wp_options` VALUES('214', 'easy_privacy_section_six_title', 'Changes to this Privacy Statement', 'yes');
INSERT INTO `wp_options` VALUES('215', 'easy_privacy_section_six', 'The contents of this statement may be altered at any time, at our discretion. \r\n\r\nIf you have any questions regarding the privacy policy of @blogname then you may contact us at @email', 'yes');
INSERT INTO `wp_options` VALUES('216', 'loginlockdownAdminOptions', 'a:6:{s:17:\"max_login_retries\";i:3;s:14:\"retries_within\";i:5;s:14:\"lockout_length\";i:60;s:25:\"lockout_invalid_usernames\";s:2:\"no\";s:17:\"mask_login_errors\";s:2:\"no\";s:16:\"show_credit_link\";s:3:\"yes\";}', 'yes');
INSERT INTO `wp_options` VALUES('217', 'loginlockdown_db1_version', '', 'yes');
INSERT INTO `wp_options` VALUES('218', 'loginlockdown_db2_version', '', 'yes');
INSERT INTO `wp_options` VALUES('4213', 'mobile_custom_footer', '<a href=\"ADD-YOUR-URL\">ADD YOUR LINK TEXT</a>', 'yes');
INSERT INTO `wp_options` VALUES('4214', 'mobile_force', 'no', 'yes');
INSERT INTO `wp_options` VALUES('221', 'mobile_custom_logo', '', 'yes');
INSERT INTO `wp_options` VALUES('222', 'mobile_custom_background', '', 'yes');
INSERT INTO `wp_options` VALUES('223', 'mobile_app_icon', 'http://www.plrblogs.com/restorevision/wp-content/plugins/obox-mobile//admin/images/iphone_ico.png', 'yes');
INSERT INTO `wp_options` VALUES('224', 'mobile_license_key', '', 'yes');
INSERT INTO `wp_options` VALUES('225', 'prli_options', 'a:24:{s:16:\"prli_exclude_ips\";s:0:\"\";s:13:\"whitelist_ips\";s:0:\"\";s:13:\"filter_robots\";i:0;s:17:\"extended_tracking\";s:6:\"normal\";s:19:\"prettybar_image_url\";s:97:\"http://www.plrblogs.com/bloodpressure/wp-content/plugins/pretty-link/images/pretty-link-48x48.png\";s:30:\"prettybar_background_image_url\";s:94:\"http://www.plrblogs.com/bloodpressure/wp-content/plugins/pretty-link/images/bar_background.png\";s:15:\"prettybar_color\";s:0:\"\";s:20:\"prettybar_text_color\";s:6:\"000000\";s:20:\"prettybar_link_color\";s:6:\"0000ee\";s:21:\"prettybar_hover_color\";s:6:\"ababab\";s:23:\"prettybar_visited_color\";s:6:\"551a8b\";s:20:\"prettybar_show_title\";s:1:\"1\";s:26:\"prettybar_show_description\";s:1:\"1\";s:26:\"prettybar_show_share_links\";s:1:\"1\";s:30:\"prettybar_show_target_url_link\";s:1:\"1\";s:21:\"prettybar_title_limit\";s:2:\"25\";s:20:\"prettybar_desc_limit\";s:2:\"30\";s:20:\"prettybar_link_limit\";s:2:\"30\";s:18:\"link_redirect_type\";s:3:\"307\";s:20:\"link_redirect_action\";s:4:\"init\";s:11:\"link_prefix\";i:0;s:13:\"link_track_me\";s:1:\"1\";s:13:\"link_nofollow\";s:1:\"0\";s:16:\"bookmarklet_auth\";s:32:\"8be94e368ec807ef700a3b7754fc1c67\";}', 'yes');
INSERT INTO `wp_options` VALUES('226', 'prli_db_version', '12', 'yes');
INSERT INTO `wp_options` VALUES('227', 'AdsDisp', '3', 'yes');
INSERT INTO `wp_options` VALUES('228', 'BegnAds', '1', 'yes');
INSERT INTO `wp_options` VALUES('229', 'BegnRnd', '1', 'yes');
INSERT INTO `wp_options` VALUES('230', 'EndiAds', '1', 'yes');
INSERT INTO `wp_options` VALUES('231', 'EndiRnd', '0', 'yes');
INSERT INTO `wp_options` VALUES('232', 'MiddRnd', '0', 'yes');
INSERT INTO `wp_options` VALUES('233', 'MoreRnd', '0', 'yes');
INSERT INTO `wp_options` VALUES('234', 'Par1Rnd', '0', 'yes');
INSERT INTO `wp_options` VALUES('235', 'Par1Nup', '0', 'yes');
INSERT INTO `wp_options` VALUES('236', 'Par2Rnd', '0', 'yes');
INSERT INTO `wp_options` VALUES('237', 'Par2Nup', '0', 'yes');
INSERT INTO `wp_options` VALUES('238', 'Par3Rnd', '0', 'yes');
INSERT INTO `wp_options` VALUES('239', 'Par3Nup', '0', 'yes');
INSERT INTO `wp_options` VALUES('240', 'Img1Rnd', '0', 'yes');
INSERT INTO `wp_options` VALUES('241', 'Img1Nup', '0', 'yes');
INSERT INTO `wp_options` VALUES('242', 'AppPost', '1', 'yes');
INSERT INTO `wp_options` VALUES('243', 'AppPage', '1', 'yes');
INSERT INTO `wp_options` VALUES('244', 'QckTags', '1', 'yes');
INSERT INTO `wp_options` VALUES('245', 'AdsMargin1', '10', 'yes');
INSERT INTO `wp_options` VALUES('246', 'AdsAlign1', '2', 'yes');
INSERT INTO `wp_options` VALUES('247', 'AdsMargin2', '10', 'yes');
INSERT INTO `wp_options` VALUES('248', 'AdsAlign2', '2', 'yes');
INSERT INTO `wp_options` VALUES('249', 'AdsMargin3', '10', 'yes');
INSERT INTO `wp_options` VALUES('250', 'AdsAlign3', '2', 'yes');
INSERT INTO `wp_options` VALUES('251', 'AdsMargin4', '10', 'yes');
INSERT INTO `wp_options` VALUES('252', 'AdsAlign4', '2', 'yes');
INSERT INTO `wp_options` VALUES('253', 'AdsMargin5', '10', 'yes');
INSERT INTO `wp_options` VALUES('254', 'AdsAlign5', '2', 'yes');
INSERT INTO `wp_options` VALUES('255', 'AdsMargin6', '10', 'yes');
INSERT INTO `wp_options` VALUES('256', 'AdsAlign6', '2', 'yes');
INSERT INTO `wp_options` VALUES('257', 'AdsMargin7', '10', 'yes');
INSERT INTO `wp_options` VALUES('258', 'AdsAlign7', '2', 'yes');
INSERT INTO `wp_options` VALUES('259', 'AdsMargin8', '10', 'yes');
INSERT INTO `wp_options` VALUES('260', 'AdsAlign8', '2', 'yes');
INSERT INTO `wp_options` VALUES('261', 'AdsMargin9', '10', 'yes');
INSERT INTO `wp_options` VALUES('262', 'AdsAlign9', '2', 'yes');
INSERT INTO `wp_options` VALUES('263', 'AdsMargin10', '10', 'yes');
INSERT INTO `wp_options` VALUES('264', 'AdsAlign10', '2', 'yes');
INSERT INTO `wp_options` VALUES('265', 'secure-wp', 'a:11:{s:15:\"secure_wp_error\";s:0:\"\";s:17:\"secure_wp_version\";s:1:\"1\";s:23:\"secure_wp_admin_version\";s:1:\"1\";s:15:\"secure_wp_index\";s:1:\"1\";s:13:\"secure_wp_rsd\";s:1:\"1\";s:13:\"secure_wp_wlw\";s:0:\"\";s:13:\"secure_wp_rcu\";s:1:\"1\";s:13:\"secure_wp_rpu\";s:1:\"1\";s:13:\"secure_wp_rtu\";s:1:\"1\";s:13:\"secure_wp_wps\";s:0:\"\";s:16:\"secure_wp_amurlr\";s:1:\"1\";}', 'yes');
INSERT INTO `wp_options` VALUES('266', 'pluginbuddy_slideshow', 'a:4:{s:6:\"groups\";a:1:{i:0;a:37:{s:5:\"title\";s:19:\"Restore Your Vision\";s:6:\"images\";a:2:{i:0;i:939;i:1;i:940;}s:6:\"layout\";s:7:\"default\";s:4:\"type\";s:6:\"slider\";s:16:\"enable_css_files\";s:4:\"true\";s:11:\"image_width\";s:3:\"580\";s:12:\"image_height\";s:3:\"300\";s:17:\"thumb_image_width\";s:2:\"85\";s:18:\"thumb_image_height\";s:2:\"65\";s:12:\"slider-align\";s:6:\"center\";s:13:\"slider-effect\";s:4:\"fold\";s:13:\"slider-slices\";s:2:\"15\";s:16:\"slider-animSpeed\";s:3:\"600\";s:16:\"slider-pauseTime\";s:4:\"4000\";s:19:\"slider-directionNav\";s:4:\"true\";s:23:\"slider-directionNavHide\";s:4:\"true\";s:17:\"slider-controlNav\";s:5:\"false\";s:23:\"slider-controlNavThumbs\";s:5:\"false\";s:18:\"slider-keyboardNav\";s:5:\"false\";s:19:\"slider-pauseOnHover\";s:4:\"true\";s:21:\"slider-captionOpacity\";s:3:\"0.8\";s:14:\"slider-shadows\";s:5:\"false\";s:11:\"cycle-align\";s:6:\"center\";s:8:\"cycle-fx\";s:4:\"fade\";s:13:\"cycle-timeout\";s:4:\"4000\";s:16:\"cycle-continuous\";s:1:\"0\";s:11:\"cycle-speed\";s:4:\"1000\";s:13:\"cycle-speedIn\";s:1:\"0\";s:14:\"cycle-speedOut\";s:1:\"0\";s:10:\"cycle-sync\";s:1:\"1\";s:12:\"cycle-random\";s:1:\"0\";s:11:\"cycle-pause\";s:1:\"1\";s:14:\"cycle-autostop\";s:1:\"0\";s:19:\"cycle-autostopCount\";s:1:\"3\";s:11:\"cycle-delay\";s:1:\"0\";s:22:\"cycle-randomizeEffects\";s:1:\"1\";s:14:\"cycle-pb_pager\";s:1:\"0\";}}s:6:\"access\";s:16:\"activate_plugins\";i:0;b:0;s:7:\"updater\";a:2:{s:10:\"last_check\";i:1323381001;s:13:\"last_response\";a:6:{s:6:\"status\";s:2:\"ok\";s:10:\"key_status\";s:2:\"ok\";s:12:\"download_url\";s:207:\"http://updater.ithemes.com/?product=slideshow&action=download&siteurl=http://www.plrblogs.com/restorevision&guid=4ee047c9d04d9&key=4EEX488D93E27431939277&expires=1323467401&v=16e82f643b17a0c6cae90e5fb2647ab2\";s:11:\"new_version\";b:1;s:14:\"latest_version\";s:6:\"1.0.36\";s:13:\"latest_update\";s:20:\"2011-12-08 11:33:04\n\";}}}', 'no');
INSERT INTO `wp_options` VALUES('267', 'pluginbuddy_slideshow-updater-guid', '4ee047c9d04d9', 'yes');
INSERT INTO `wp_options` VALUES('268', 'smart_youtube_pro', 'a:37:{s:5:\"posts\";s:2:\"on\";s:8:\"comments\";s:3:\"off\";s:3:\"img\";s:3:\"off\";s:5:\"width\";i:425;s:6:\"height\";i:344;s:7:\"widthhq\";i:480;s:8:\"heighthq\";i:295;s:9:\"widthside\";i:200;s:10:\"heightside\";i:167;s:3:\"rel\";s:1:\"1\";s:4:\"link\";s:2:\"on\";s:5:\"valid\";s:3:\"off\";s:6:\"search\";s:3:\"off\";s:4:\"info\";s:2:\"on\";s:3:\"ann\";s:2:\"on\";s:8:\"template\";s:7:\"{video}\";s:8:\"autoplay\";i:0;s:14:\"autoplay_first\";i:0;s:7:\"privacy\";i:0;s:5:\"wtext\";s:0:\"\";s:6:\"wtitle\";s:0:\"\";s:3:\"tag\";s:0:\"\";s:6:\"iframe\";s:2:\"on\";s:4:\"http\";s:3:\"off\";s:3:\"www\";s:3:\"off\";s:4:\"loop\";i:0;s:5:\"thumb\";s:3:\"off\";s:8:\"colorbox\";s:3:\"off\";s:14:\"colorbox_theme\";i:1;s:7:\"excerpt\";s:3:\"not\";s:8:\"logoless\";s:2:\"on\";s:7:\"wiziapp\";s:3:\"off\";s:7:\"ogimage\";s:3:\"off\";s:5:\"theme\";s:4:\"dark\";s:13:\"excerpt_thumb\";s:4:\"left\";s:6:\"teheme\";s:4:\"dark\";s:13:\"excerpt_align\";s:4:\"left\";}', 'yes');
INSERT INTO `wp_options` VALUES('269', 'wpcumulus_options', 'a:13:{s:5:\"width\";s:3:\"550\";s:6:\"height\";s:3:\"375\";s:6:\"tcolor\";s:6:\"ffffff\";s:7:\"tcolor2\";s:6:\"ffffff\";s:7:\"hicolor\";s:6:\"ffffff\";s:7:\"bgcolor\";s:6:\"333333\";s:5:\"speed\";s:3:\"100\";s:5:\"trans\";s:5:\"false\";s:5:\"distr\";s:4:\"true\";s:4:\"args\";s:0:\"\";s:8:\"compmode\";s:5:\"false\";s:10:\"showwptags\";s:4:\"true\";s:4:\"mode\";s:4:\"tags\";}', 'yes');
INSERT INTO `wp_options` VALUES('270', 'wpcumulus_widget', 'a:14:{s:5:\"width\";s:3:\"280\";s:6:\"height\";s:3:\"220\";s:6:\"tcolor\";s:6:\"333333\";s:7:\"tcolor2\";s:6:\"333333\";s:7:\"hicolor\";s:6:\"000000\";s:7:\"bgcolor\";s:6:\"ffffff\";s:5:\"speed\";s:3:\"100\";s:5:\"trans\";s:0:\"\";s:5:\"distr\";s:4:\"true\";s:4:\"args\";s:0:\"\";s:8:\"compmode\";s:5:\"false\";s:10:\"showwptags\";s:4:\"true\";s:4:\"mode\";s:4:\"tags\";s:5:\"title\";s:0:\"\";}', 'yes');
INSERT INTO `wp_options` VALUES('271', 'widget_ws_widget__ad_codes', 'a:3:{i:3;a:2:{s:5:\"title\";s:23:\"Restore My Vision Today\";s:4:\"code\";s:146:\"<a href=\"[aff1link]\" title=\"[aff1tag]\"  target=\"_blank\"><img src=\"[aff1banner1]\" alt=\"[aff1tag]\" title=\"[aff1tag]\" width=\"300\" height=\"250\" /></a>\";}i:4;a:2:{s:5:\"title\";s:15:\"Ad Codes Widget\";s:4:\"code\";s:166:\"<img src=\"http://www.plrblogs.com/restorevision/wp-content/plugins/ad-codez-widget/images/300x250.png\" style=\"width:300px; height:250px; border:0px;\" alt=\"Ad Code\" />\";}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('272', 'widget_ws_widget__ad_squares', 'a:2:{i:3;a:12:{s:5:\"title\";s:17:\"Ad Squares Widget\";s:7:\"squares\";s:1:\"2\";s:7:\"padding\";s:2:\"15\";s:7:\"shuffle\";s:1:\"0\";s:6:\"code_1\";s:146:\"<a href=\"[aff1link]\" title=\"[aff1tag]\"  target=\"_blank\"><img src=\"[aff1banner2]\" alt=\"[aff1tag]\" title=\"[aff1tag]\" width=\"125\" height=\"125\" /></a>\";s:6:\"code_2\";s:129:\"<a href=\"[aff2link]\" title=\"[aff2tag]\"><img src=\"[aff2banner2]\" alt=\"[aff2tag]\" title=\"[aff2tag]\" width=\"125\" height=\"125\" /></a>\";s:6:\"code_3\";s:170:\"<img src=\"http://www.plrblogs.com/restorevision/wp-content/plugins/ad-squares-widget/images/125x125.png\" style=\"width:125px; height:125px; border:0px;\" alt=\"Ad Square\" />\";s:6:\"code_4\";s:170:\"<img src=\"http://www.plrblogs.com/restorevision/wp-content/plugins/ad-squares-widget/images/125x125.png\" style=\"width:125px; height:125px; border:0px;\" alt=\"Ad Square\" />\";s:6:\"code_5\";s:170:\"<img src=\"http://www.plrblogs.com/restorevision/wp-content/plugins/ad-squares-widget/images/125x125.png\" style=\"width:125px; height:125px; border:0px;\" alt=\"Ad Square\" />\";s:6:\"code_6\";s:170:\"<img src=\"http://www.plrblogs.com/restorevision/wp-content/plugins/ad-squares-widget/images/125x125.png\" style=\"width:125px; height:125px; border:0px;\" alt=\"Ad Square\" />\";s:6:\"code_7\";s:170:\"<img src=\"http://www.plrblogs.com/restorevision/wp-content/plugins/ad-squares-widget/images/125x125.png\" style=\"width:125px; height:125px; border:0px;\" alt=\"Ad Square\" />\";s:6:\"code_8\";s:170:\"<img src=\"http://www.plrblogs.com/restorevision/wp-content/plugins/ad-squares-widget/images/125x125.png\" style=\"width:125px; height:125px; border:0px;\" alt=\"Ad Square\" />\";}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('2029', '_transient_timeout_ye_video_MjY5ZGMzNWVjNGNkYTg4MDc3ZGY5ODZjNjZi', '1339675685', 'no');
INSERT INTO `wp_options` VALUES('2030', '_transient_ye_video_MjY5ZGMzNWVjNGNkYTg4MDc3ZGY5ODZjNjZiNTMwMjU0', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/CrvBApGYEYw?version=3&amp;fs=0&amp;rel=0&amp;title=Healthy+Skin+Care+%3A+How+to+Do+Homemade+Scar+Removal%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('2035', '_transient_timeout_ye_video_NjJhNTdkYWViZGI5NzFkNmI2NTc4OTA4NDE1', '1339675685', 'no');
INSERT INTO `wp_options` VALUES('2036', '_transient_ye_video_NjJhNTdkYWViZGI5NzFkNmI2NTc4OTA4NDE1OGI3MjNl', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/qiIZJJ9l5ZU?version=3&amp;fs=0&amp;rel=0&amp;title=Healthy+Skin+Care+%3A+How+to+Make+Scars+Go+Away%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('273', 'widget_pluginbuddy_slideshow', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('274', 'widget_youtube_embed_widget', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('275', 'widget_smart-youtube', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('276', 'exec-php', 'a:2:{s:7:\"version\";s:3:\"4.9\";s:14:\"widget_support\";b:1;}', 'yes');
INSERT INTO `wp_options` VALUES('277', 'youtube_embed_general', 'a:30:{s:13:\"editor_button\";s:1:\"1\";s:9:\"admin_bar\";s:1:\"1\";s:10:\"profile_no\";s:1:\"5\";s:7:\"list_no\";s:1:\"5\";s:11:\"embed_cache\";s:1:\"1\";s:10:\"info_cache\";s:2:\"24\";s:16:\"transcript_cache\";s:2:\"24\";s:11:\"fetch_title\";N;s:11:\"alt_profile\";s:1:\"0\";s:12:\"alt_profile2\";s:1:\"0\";s:7:\"bracket\";N;s:3:\"alt\";N;s:13:\"other_profile\";s:1:\"0\";s:11:\"url_profile\";s:1:\"0\";s:8:\"comments\";N;s:16:\"comments_profile\";s:1:\"0\";s:8:\"metadata\";s:1:\"1\";s:4:\"feed\";s:1:\"b\";s:3:\"api\";s:1:\"1\";s:13:\"error_message\";s:83:\"&lt;p&gt;The video cannot be shown at the moment. Please try again later.&lt;/p&gt;\";s:9:\"thumbnail\";s:1:\"2\";s:15:\"current_version\";s:3:\"3.2\";s:11:\"frameborder\";i:1;s:7:\"donated\";s:0:\"\";s:7:\"privacy\";i:0;s:7:\"widgets\";i:0;s:14:\"profile_access\";s:14:\"delete_plugins\";s:11:\"list_access\";s:14:\"delete_plugins\";s:11:\"menu_access\";s:10:\"list_users\";s:14:\"comments_cache\";i:60;}', 'yes');
INSERT INTO `wp_options` VALUES('285', '_transient_plugins_delete_result_1', '1', 'yes');
INSERT INTO `wp_options` VALUES('582', 'WPContentMagic_Options', 'a:25:{s:9:\"post_type\";s:4:\"post\";s:11:\"post_status\";s:7:\"publish\";s:15:\"post_title_from\";s:4:\"file\";s:16:\"auto_tag_article\";s:1:\"0\";s:30:\"keywords_typed_for_tag_article\";N;s:13:\"post_category\";s:3:\"332\";s:21:\"auto_posting_schedule\";s:6:\"custom\";s:20:\"custom_schedule_date\";s:16:\"05/03/2014 09:48\";s:21:\"schedule_number_begin\";s:1:\"2\";s:19:\"schedule_unit_begin\";s:4:\"days\";s:19:\"schedule_number_end\";s:1:\"4\";s:17:\"schedule_unit_end\";s:4:\"days\";s:27:\"seo_options_bold_decoration\";i:0;s:28:\"seo_options_bold_per_article\";s:1:\"1\";s:32:\"seo_options_underline_decoration\";i:0;s:33:\"seo_options_underline_per_article\";s:1:\"1\";s:32:\"seo_options_italicize_decoration\";i:0;s:33:\"seo_options_italicize_per_article\";s:1:\"1\";s:14:\"add_hyperlinks\";s:1:\"0\";s:30:\"in_content_hyperlinks_quantity\";N;s:15:\"csv_keyword_url\";N;s:11:\"cloak_links\";s:1:\"0\";s:11:\"track_links\";s:1:\"0\";s:27:\"outbound_links_add_nofollow\";i:0;s:30:\"outbound_links_open_new_window\";i:0;}', 'yes');
INSERT INTO `wp_options` VALUES('289', 'youtube_embed_url', '', 'yes');
INSERT INTO `wp_options` VALUES('290', 'youtube_embed_shortcode', 'a:2:{i:1;s:13:\"youtube_video\";i:2;s:0:\"\";}', 'yes');
INSERT INTO `wp_options` VALUES('808', 'theme_mods_twentyeleven', 'a:1:{i:0;b:0;}', 'yes');
INSERT INTO `wp_options` VALUES('1361', 'current_theme', 'Headlines Enhanced', 'yes');
INSERT INTO `wp_options` VALUES('294', 'theme_mods_headlines_enhanced_v3', 'a:2:{i:0;b:0;s:16:\"sidebars_widgets\";a:2:{s:4:\"time\";i:1326082259;s:4:\"data\";a:8:{s:19:\"wp_inactive_widgets\";a:20:{i:0;s:14:\"woo_adwidget-2\";i:1;s:10:\"woo_tabs-2\";i:2;s:13:\"woo_twitter-2\";i:3;s:7:\"pages-2\";i:4;s:10:\"calendar-2\";i:5;s:7:\"links-2\";i:6;s:6:\"text-2\";i:7;s:5:\"rss-2\";i:8;s:11:\"tag_cloud-2\";i:9;s:10:\"nav_menu-2\";i:10;s:21:\"ws_widget__ad_codes-2\";i:11;s:23:\"ws_widget__ad_squares-2\";i:12;s:23:\"pluginbuddy_slideshow-2\";i:13;s:22:\"youtube_embed_widget-2\";i:14;s:15:\"smart-youtube-2\";i:15;s:14:\"recent-posts-2\";i:16;s:17:\"recent-comments-2\";i:17;s:10:\"archives-2\";i:18;s:12:\"categories-2\";i:19;s:6:\"meta-2\";}s:18:\"left-column-widget\";a:1:{i:0;s:6:\"text-3\";}s:20:\"center-column-widget\";a:1:{i:0;s:6:\"text-4\";}s:19:\"right-column-widget\";a:1:{i:0;s:6:\"text-5\";}s:9:\"sidebar-1\";a:4:{i:0;s:21:\"ws_widget__ad_codes-3\";i:1;s:23:\"ws_widget__ad_squares-3\";i:2;s:14:\"recent-posts-3\";i:3;s:10:\"wp-cumulus\";}s:8:\"footer-1\";a:1:{i:0;s:14:\"recent-posts-4\";}s:8:\"footer-2\";a:1:{i:0;s:7:\"pages-3\";}s:8:\"footer-3\";a:1:{i:0;s:12:\"categories-3\";}}}}', 'yes');
INSERT INTO `wp_options` VALUES('295', 'woo_timthumb_update', '', 'yes');
INSERT INTO `wp_options` VALUES('296', 'widget_woo_adwidget', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('297', 'widget_woo_tabs', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('298', 'widget_woo_twitter', 'a:2:{i:2;a:0:{}s:12:\"_multiwidget\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('299', 'woo_framework_version', '4.7.2', 'yes');
INSERT INTO `wp_options` VALUES('300', 'woo_custom_seo_template', 'a:3:{i:0;a:5:{s:4:\"name\";s:10:\"seo_info_1\";s:3:\"std\";s:0:\"\";s:5:\"label\";s:4:\"SEO \";s:4:\"type\";s:4:\"info\";s:4:\"desc\";s:203:\"Additional SEO custom fields available: <strong>Custom Page Titles</strong>. Go to <a href=\"http://www.plrblogs.com/restorevision/wp-admin/admin.php?page=woothemes_seo\">SEO Settings</a> page to activate.\";}i:1;a:5:{s:4:\"name\";s:10:\"seo_follow\";s:3:\"std\";s:5:\"false\";s:5:\"label\";s:16:\"SEO - Set follow\";s:4:\"type\";s:8:\"checkbox\";s:4:\"desc\";s:77:\"Make links from this post/page <strong>followable</strong> by search engines.\";}i:2;a:5:{s:4:\"name\";s:11:\"seo_noindex\";s:3:\"std\";s:5:\"false\";s:5:\"label\";s:13:\"SEO - Noindex\";s:4:\"type\";s:8:\"checkbox\";s:4:\"desc\";s:56:\"Set the Page/Post to not be indexed by a search engines.\";}}', 'yes');
INSERT INTO `wp_options` VALUES('301', 'woo_options', 'a:117:{s:18:\"woo_alt_stylesheet\";s:12:\"skylight.css\";s:8:\"woo_logo\";s:0:\"\";s:13:\"woo_texttitle\";s:4:\"true\";s:19:\"woo_font_site_title\";a:5:{s:4:\"size\";s:2:\"49\";s:4:\"unit\";s:2:\"px\";s:4:\"face\";s:17:\"Yanone Kaffeesatz\";s:5:\"style\";s:4:\"bold\";s:5:\"color\";s:7:\"#ffffff\";}s:16:\"woo_font_tagline\";a:5:{s:4:\"size\";s:2:\"11\";s:4:\"unit\";s:2:\"px\";s:4:\"face\";s:17:\"Arial, sans-serif\";s:5:\"style\";s:6:\"normal\";s:5:\"color\";s:7:\"#bbbbbb\";}s:18:\"woo_custom_favicon\";s:0:\"\";s:20:\"woo_google_analytics\";s:0:\"\";s:18:\"woo_feedburner_url\";s:0:\"\";s:17:\"woo_feedburner_id\";s:0:\"\";s:21:\"woo_contactform_email\";s:0:\"\";s:14:\"woo_custom_css\";s:0:\"\";s:15:\"woo_custom_link\";s:7:\"#1079c9\";s:13:\"woo_custom_bg\";s:0:\"\";s:20:\"woo_page_nav_disable\";s:9:\"18,19,388\";s:18:\"woo_search_disable\";s:5:\"false\";s:22:\"woo_disable_posts_date\";s:5:\"false\";s:21:\"woo_disable_cats_date\";s:5:\"false\";s:23:\"woo_disable_search_date\";s:5:\"false\";s:25:\"woo_disable_comments_date\";s:5:\"false\";s:23:\"woo_show_number_results\";s:5:\"false\";s:19:\"woo_featured_slider\";s:4:\"true\";s:22:\"woo_featured_shortcode\";s:24:\"[pb_slideshow group=\"0\"]\";s:18:\"woo_featured_video\";s:5:\"false\";s:29:\"woo_featured_video_embed_code\";s:196:\"<iframe src=\"http://player.vimeo.com/video/27299211?title=0&amp;byline=0&amp;portrait=0\" width=\"580\" height=\"300\" frameborder=\"0\" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe>\";s:21:\"woo_sticky_posts_only\";s:4:\"true\";s:22:\"woo_sticky_posts_count\";s:1:\"5\";s:15:\"woo_top_widgets\";s:5:\"false\";s:24:\"woo_top_widgets_allposts\";s:5:\"false\";s:26:\"woo_top_widgets_bypost_ids\";s:0:\"\";s:24:\"woo_top_widgets_allpages\";s:5:\"false\";s:26:\"woo_top_widgets_bypage_ids\";s:0:\"\";s:25:\"woo_custom_l_ribbon_color\";s:7:\"#d00a0b\";s:30:\"woo_custom_l_ribbon_font_color\";s:7:\"#ffffff\";s:32:\"woo_custom_l_ribbon_border_color\";s:7:\"#6c88ad\";s:20:\"woo_add_l_star_image\";s:4:\"true\";s:21:\"woo_stars_left_ribbon\";s:7:\"5-stars\";s:25:\"woo_custom_c_ribbon_color\";s:7:\"#d00a0b\";s:30:\"woo_custom_c_ribbon_font_color\";s:7:\"#ffffff\";s:32:\"woo_custom_c_ribbon_border_color\";s:7:\"#6c88ad\";s:20:\"woo_add_c_star_image\";s:4:\"true\";s:23:\"woo_stars_center_ribbon\";s:7:\"4-stars\";s:25:\"woo_custom_r_ribbon_color\";s:7:\"#d00a0b\";s:30:\"woo_custom_r_ribbon_font_color\";s:7:\"#ffffff\";s:32:\"woo_custom_r_ribbon_border_color\";s:7:\"#6c88ad\";s:20:\"woo_add_r_star_image\";s:4:\"true\";s:22:\"woo_stars_right_ribbon\";s:7:\"3-stars\";s:9:\"woo_cufon\";s:4:\"true\";s:16:\"woo_home_content\";s:5:\"false\";s:19:\"woo_archive_content\";s:5:\"false\";s:23:\"woo_disable_post_author\";s:4:\"true\";s:23:\"woo_sp_noheadfoot_width\";s:3:\"950\";s:26:\"woo_sp_noheadfoot_fontsize\";s:2:\"14\";s:20:\"woo_sp_noheadfoot_bg\";s:0:\"\";s:24:\"woo_sp_noheadfoot_border\";s:0:\"\";s:28:\"woo_sp_noheadfoot_bordersize\";s:0:\"\";s:29:\"woo_sp_noheadfoot_borderstyle\";s:5:\"solid\";s:30:\"woo_sp_noheadfoot_borderradius\";s:2:\"30\";s:14:\"woo_padd_right\";s:3:\"150\";s:13:\"woo_padd_left\";s:3:\"150\";s:12:\"woo_padd_top\";s:2:\"20\";s:15:\"woo_padd_bottom\";s:2:\"20\";s:18:\"woo_show_sp_footer\";s:5:\"false\";s:21:\"woo_show_sp_footer_id\";s:0:\"\";s:22:\"woo_show_custom_footer\";s:5:\"false\";s:27:\"woo_show_custom_footer_code\";s:267:\"Paste Your Links HTML Here. For example, <a href=\"#\" title=\"About\" target=\"_self\">About</a> | <a href=\"#\" title=\"Terms\" target=\"_self\">Terms &amp; Conditions</a> | <a href=\"#\" title=\"FAQ\" target=\"_self\">FAQ</a> | <a href=\"#\" title=\"Support\" target=\"_self\">Support</a>\";s:28:\"woo_custom_footer_font_color\";s:0:\"\";s:27:\"woo_custom_footer_underline\";s:4:\"true\";s:0:\"\";b:0;s:11:\"woo_blank_1\";s:10:\"visionback\";s:11:\"woo_blank_2\";s:11:\"vendor id 2\";s:13:\"woo_aff1_link\";s:52:\"http://5d355rx2s5dcacfroeu9qad3ud.hop.clickbank.net/\";s:18:\"woo_aff1_title_tag\";s:23:\"Restore My Vision Today\";s:21:\"woo_aff1_banner_url_1\";s:81:\"http://www.plrblogs.com/restorevision/wp-content/uploads/2011/12/300x250-S-10.jpg\";s:21:\"woo_aff1_banner_url_2\";s:32:\"Put your 125x125 Banner URL here\";s:21:\"woo_aff1_banner_url_3\";s:77:\"http://www.plrblogs.com/restorevision/wp-content/uploads/2011/12/468x60-3.jpg\";s:13:\"woo_aff2_link\";s:30:\"Put your Affiliate URL #2 here\";s:18:\"woo_aff2_title_tag\";s:28:\"Put your Title/Alt info here\";s:21:\"woo_aff2_banner_url_1\";s:32:\"Put your 300x250 Banner URL here\";s:21:\"woo_aff2_banner_url_2\";s:32:\"Put your 125x125 Banner URL here\";s:21:\"woo_aff2_banner_url_3\";s:47:\"Put your 468x60 (on Video Page) Banner URL here\";s:10:\"woo_ad_top\";s:4:\"true\";s:16:\"woo_ad_top_image\";s:78:\"http://www.plrblogs.com/restorevision/wp-content/uploads/2011/12/468x60-31.jpg\";s:14:\"woo_ad_top_url\";s:52:\"http://5d355rx2s5dcacfroeu9qad3ud.hop.clickbank.net/\";s:18:\"woo_ad_top_adsense\";s:0:\"\";s:26:\"woo_show_dislcaimer_footer\";s:4:\"true\";s:28:\"woo_custom_footer_disclaimer\";s:368:\"Disclaimer: This website is an officially authorized and remunerated associate for recommending high quality products found on this website. Links on this website may be associate links which means if you click on a link of a recommended product, I/we may receive monetary compensation. However, this does not affect any unbiased information presented on this website.\";s:23:\"woo_disclaimer_fontsize\";s:2:\"14\";s:20:\"woo_disclaimer_color\";s:0:\"\";s:22:\"woo_post_image_support\";s:4:\"true\";s:14:\"woo_pis_resize\";s:4:\"true\";s:17:\"woo_pis_hard_crop\";s:4:\"true\";s:10:\"woo_resize\";s:4:\"true\";s:12:\"woo_auto_img\";s:5:\"false\";s:13:\"woo_rss_thumb\";s:5:\"false\";s:9:\"woo_align\";s:9:\"alignleft\";s:15:\"woo_thumb_width\";s:3:\"150\";s:16:\"woo_thumb_height\";s:3:\"150\";s:16:\"woo_image_single\";s:5:\"false\";s:16:\"woo_single_width\";s:3:\"200\";s:17:\"woo_single_height\";s:3:\"200\";s:14:\"woo_ad_content\";s:5:\"false\";s:22:\"woo_ad_content_adsense\";s:0:\"\";s:20:\"woo_ad_content_image\";s:15:\"Enter Image URL\";s:18:\"woo_ad_content_url\";s:24:\"http://www.woothemes.com\";s:14:\"woo_ads_rotate\";s:4:\"true\";s:14:\"woo_ad_image_1\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:12:\"woo_ad_url_1\";s:24:\"http://www.woothemes.com\";s:14:\"woo_ad_image_2\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:12:\"woo_ad_url_2\";s:24:\"http://www.woothemes.com\";s:14:\"woo_ad_image_3\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:12:\"woo_ad_url_3\";s:24:\"http://www.woothemes.com\";s:14:\"woo_ad_image_4\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:12:\"woo_ad_url_4\";s:24:\"http://www.woothemes.com\";s:14:\"woo_ad_image_5\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:12:\"woo_ad_url_5\";s:24:\"http://www.woothemes.com\";s:14:\"woo_ad_image_6\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:12:\"woo_ad_url_6\";s:24:\"http://www.woothemes.com\";}', 'yes');
INSERT INTO `wp_options` VALUES('302', 'woo_template', 'a:126:{i:0;a:3:{s:4:\"name\";s:16:\"General Settings\";s:4:\"icon\";s:7:\"general\";s:4:\"type\";s:7:\"heading\";}i:1;a:6:{s:4:\"name\";s:16:\"Theme Stylesheet\";s:4:\"desc\";s:44:\"Select your themes alternative color scheme.\";s:2:\"id\";s:18:\"woo_alt_stylesheet\";s:3:\"std\";s:11:\"default.css\";s:4:\"type\";s:6:\"select\";s:7:\"options\";a:21:{i:0;s:14:\"purplehaze.css\";i:1;s:14:\"tequilasun.css\";i:2;s:12:\"redslate.css\";i:3;s:14:\"greyorange.css\";i:4;s:9:\"berry.css\";i:5;s:13:\"blueberry.css\";i:6;s:14:\"springtime.css\";i:7;s:11:\"default.css\";i:8;s:11:\"redrock.css\";i:9;s:15:\"pomegranate.css\";i:10;s:14:\"chocoberry.css\";i:11;s:21:\"redhotchilipepper.css\";i:12;s:15:\"countryside.css\";i:13;s:12:\"skylight.css\";i:14;s:13:\"greenline.css\";i:15;s:13:\"fruitella.css\";i:16;s:14:\"orangeline.css\";i:17;s:12:\"blueline.css\";i:18;s:15:\"cottoncandy.css\";i:19;s:12:\"orangina.css\";i:20;s:9:\"salsa.css\";}}i:2;a:5:{s:4:\"name\";s:11:\"Custom Logo\";s:4:\"desc\";s:63:\"Upload a logo for your theme, or specify an image URL directly.\";s:2:\"id\";s:8:\"woo_logo\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"upload\";}i:3;a:6:{s:4:\"name\";s:10:\"Text Title\";s:4:\"desc\";s:85:\"Enable text-based Site Title and Tagline. Setup title & tagline in Settings->General.\";s:2:\"id\";s:13:\"woo_texttitle\";s:3:\"std\";s:5:\"false\";s:5:\"class\";s:9:\"collapsed\";s:4:\"type\";s:8:\"checkbox\";}i:4;a:6:{s:4:\"name\";s:10:\"Site Title\";s:4:\"desc\";s:62:\"Change the site title (must have \'Text Title\' option enabled).\";s:2:\"id\";s:19:\"woo_font_site_title\";s:3:\"std\";a:5:{s:4:\"size\";s:2:\"36\";s:4:\"unit\";s:2:\"px\";s:4:\"face\";s:5:\"Arial\";s:5:\"style\";s:4:\"bold\";s:5:\"color\";s:7:\"#ffffff\";}s:5:\"class\";s:6:\"hidden\";s:4:\"type\";s:10:\"typography\";}i:5;a:6:{s:4:\"name\";s:16:\"Site Description\";s:4:\"desc\";s:68:\"Change the site description (must have \'Text Title\' option enabled).\";s:2:\"id\";s:16:\"woo_font_tagline\";s:3:\"std\";a:5:{s:4:\"size\";s:2:\"11\";s:4:\"unit\";s:2:\"px\";s:4:\"face\";s:5:\"Arial\";s:5:\"style\";s:0:\"\";s:5:\"color\";s:7:\"#bbbbbb\";}s:5:\"class\";s:11:\"hidden last\";s:4:\"type\";s:10:\"typography\";}i:6;a:5:{s:4:\"name\";s:14:\"Custom Favicon\";s:4:\"desc\";s:113:\"Upload a 16px x 16px <a href=\'http://www.faviconr.com/\'>ico image</a> that will represent your website\'s favicon.\";s:2:\"id\";s:18:\"woo_custom_favicon\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:6:\"upload\";}i:7;a:5:{s:4:\"name\";s:13:\"Tracking Code\";s:4:\"desc\";s:117:\"Paste your Google Analytics (or other) tracking code here. This will be added into the footer template of your theme.\";s:2:\"id\";s:20:\"woo_google_analytics\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"textarea\";}i:8;a:5:{s:4:\"name\";s:7:\"RSS URL\";s:4:\"desc\";s:51:\"Enter your preferred RSS URL. (Feedburner or other)\";s:2:\"id\";s:18:\"woo_feedburner_url\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:9;a:5:{s:4:\"name\";s:10:\"E-Mail URL\";s:4:\"desc\";s:67:\"Enter your preferred E-mail subscription URL. (Feedburner or other)\";s:2:\"id\";s:17:\"woo_feedburner_id\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:10;a:5:{s:4:\"name\";s:19:\"Contact Form E-Mail\";s:4:\"desc\";s:67:\"Enter your E-mail address to use on the Contact Form Page Template.\";s:2:\"id\";s:21:\"woo_contactform_email\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:11;a:5:{s:4:\"name\";s:10:\"Custom CSS\";s:4:\"desc\";s:62:\"Quickly add some CSS to your theme by adding it to this block.\";s:2:\"id\";s:14:\"woo_custom_css\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"textarea\";}i:12;a:3:{s:4:\"name\";s:15:\"Styling Options\";s:4:\"type\";s:7:\"heading\";s:4:\"icon\";s:7:\"styling\";}i:13;a:5:{s:4:\"name\";s:17:\"Custom Link Color\";s:4:\"desc\";s:62:\"Add a custom hex color for the links in your site e.g. #697e09\";s:2:\"id\";s:15:\"woo_custom_link\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:14;a:5:{s:4:\"name\";s:23:\"Custom Background Color\";s:4:\"desc\";s:54:\"Add a custom hex color for the background e.g. #697e09\";s:2:\"id\";s:13:\"woo_custom_bg\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:15;a:3:{s:4:\"name\";s:18:\"Navigation Options\";s:4:\"icon\";s:3:\"nav\";s:4:\"type\";s:7:\"heading\";}i:16;a:5:{s:4:\"name\";s:35:\"Exclude Pages In Top Navigation Bar\";s:4:\"desc\";s:35:\"Comma separate Page IDs, e.g. 18,19\";s:2:\"id\";s:20:\"woo_page_nav_disable\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:17;a:5:{s:4:\"name\";s:20:\"Disable Search Field\";s:4:\"desc\";s:83:\"Remove the Search Field in the right side of nav, to make room for more categories.\";s:2:\"id\";s:18:\"woo_search_disable\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:18;a:5:{s:4:\"name\";s:52:\"Disable Date &amp; Comments Count (by line) On Posts\";s:4:\"desc\";s:60:\"Remove the Date and Comments from just below the post title.\";s:2:\"id\";s:22:\"woo_disable_posts_date\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:19;a:5:{s:4:\"name\";s:57:\"Disable Date &amp; Comments Count (by line) On Categories\";s:4:\"desc\";s:60:\"Remove the Date and Comments from just below the post title.\";s:2:\"id\";s:21:\"woo_disable_cats_date\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:20;a:5:{s:4:\"name\";s:69:\"Disable Date &amp; Comments Count (by line) On The Search Result Page\";s:4:\"desc\";s:60:\"Remove the Date and Comments from just below the post title.\";s:2:\"id\";s:23:\"woo_disable_search_date\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:21;a:5:{s:4:\"name\";s:35:\"Disable Date &amp; Time On Comments\";s:4:\"desc\";s:38:\"Remove Date and Time from on comments.\";s:2:\"id\";s:25:\"woo_disable_comments_date\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:22;a:5:{s:4:\"name\";s:50:\"Show Page Navigation At The Bottom Of The Homepage\";s:4:\"desc\";s:63:\"You must have more posts than what shows on Settings >> Reading\";s:2:\"id\";s:23:\"woo_show_number_results\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:23;a:3:{s:4:\"name\";s:16:\"Homepage Options\";s:4:\"icon\";s:8:\"featured\";s:4:\"type\";s:7:\"heading\";}i:24;a:6:{s:4:\"name\";s:25:\"Enable Slider On Homepage\";s:4:\"desc\";s:37:\"Show the slider on the homepage page.\";s:2:\"id\";s:19:\"woo_featured_slider\";s:3:\"std\";s:4:\"true\";s:5:\"class\";s:9:\"collapsed\";s:4:\"type\";s:8:\"checkbox\";}i:25;a:6:{s:4:\"name\";s:28:\"Slideshow Homepage Shortcode\";s:4:\"desc\";s:68:\"By default, this will display the first Slideshow shortcode created!\";s:2:\"id\";s:22:\"woo_featured_shortcode\";s:4:\"type\";s:4:\"text\";s:5:\"class\";s:11:\"hidden last\";s:3:\"std\";s:24:\"[pb_slideshow group=\"0\"]\";}i:26;a:6:{s:4:\"name\";s:49:\"Enable Video On Homepage <u>Instead Of</u> Slider\";s:4:\"desc\";s:47:\"Show video, e.g. YouTube, on the homepage page.\";s:2:\"id\";s:18:\"woo_featured_video\";s:3:\"std\";s:5:\"false\";s:5:\"class\";s:9:\"collapsed\";s:4:\"type\";s:8:\"checkbox\";}i:27;a:6:{s:4:\"name\";s:61:\"Video Embed Code - <i>Video Size Should Be 580px by 300px</i>\";s:4:\"desc\";s:61:\"Please note the ideal size of video should be 580px by 300px!\";s:2:\"id\";s:29:\"woo_featured_video_embed_code\";s:4:\"type\";s:8:\"textarea\";s:5:\"class\";s:11:\"hidden last\";s:3:\"std\";s:65:\"Paste Your Video Code Here. Size of video must be 580px by 300px!\";}i:28;a:5:{s:4:\"name\";s:49:\"Display Sticky Posts <u>Only</u> On The Homepage?\";s:4:\"desc\";s:34:\"Show only sticky posts on homepage\";s:2:\"id\";s:21:\"woo_sticky_posts_only\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:29;a:5:{s:4:\"name\";s:41:\"Number of Sticky Posts (Only) On Homepage\";s:4:\"desc\";s:36:\"Enter number of sticky posts to show\";s:2:\"id\";s:22:\"woo_sticky_posts_count\";s:4:\"type\";s:4:\"text\";s:3:\"std\";s:1:\"5\";}i:30;a:3:{s:4:\"name\";s:20:\"Homepage Top Sidebar\";s:4:\"icon\";s:10:\"topsidebar\";s:4:\"type\";s:7:\"heading\";}i:31;a:5:{s:4:\"name\";s:30:\"Display 3 Widgets On Homepage?\";s:4:\"desc\";s:53:\"Show 3 widgets below header &amp; above posts/sidebar\";s:2:\"id\";s:15:\"woo_top_widgets\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:32;a:5:{s:4:\"name\";s:18:\"Show On All Posts?\";s:4:\"desc\";s:61:\"Tick the box if you want to show the top sidebar on all Posts\";s:2:\"id\";s:24:\"woo_top_widgets_allposts\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:33;a:5:{s:4:\"name\";s:104:\"Show Top Sidebar By Post IDs Only <span style=\'color:#e82f0b;font-size:12px;\'>(Untick Box Above!)</span>\";s:4:\"desc\";s:42:\"Enter the Post IDs to show the top sidebar\";s:2:\"id\";s:26:\"woo_top_widgets_bypost_ids\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:34;a:5:{s:4:\"name\";s:18:\"Show on All Pages?\";s:4:\"desc\";s:61:\"Tick the box if you want to show the top sidebar on all Pages\";s:2:\"id\";s:24:\"woo_top_widgets_allpages\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:35;a:5:{s:4:\"name\";s:104:\"Show Top Sidebar By Page IDs Only <span style=\'color:#e82f0b;font-size:12px;\'>(Untick Box Above!)</span>\";s:4:\"desc\";s:42:\"Enter the Page IDs to show the top sidebar\";s:2:\"id\";s:26:\"woo_top_widgets_bypage_ids\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:36;a:5:{s:4:\"name\";s:24:\"Custom Left Ribbon Color\";s:4:\"desc\";s:61:\"Add a custom hex color for the left ribbon color e.g. #697e09\";s:2:\"id\";s:25:\"woo_custom_l_ribbon_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:37;a:5:{s:4:\"name\";s:29:\"Custom Left Ribbon Font Color\";s:4:\"desc\";s:66:\"Add a custom hex color for the left ribbon font color e.g. #697e09\";s:2:\"id\";s:30:\"woo_custom_l_ribbon_font_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:38;a:5:{s:4:\"name\";s:31:\"Custom Left Ribbon Border Color\";s:4:\"desc\";s:68:\"Add a custom hex color for the left ribbon border color e.g. #697e09\";s:2:\"id\";s:32:\"woo_custom_l_ribbon_border_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:39;a:5:{s:4:\"name\";s:31:\"Add Star Rating To Left Ribbon?\";s:4:\"desc\";s:65:\"Tick the box if you want to show a star rating on the left ribbon\";s:2:\"id\";s:20:\"woo_add_l_star_image\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:40;a:6:{s:4:\"name\";s:22:\"Select Number Of Stars\";s:4:\"desc\";s:16:\"Select star type\";s:2:\"id\";s:21:\"woo_stars_left_ribbon\";s:3:\"std\";s:5:\"solid\";s:4:\"type\";s:5:\"radio\";s:7:\"options\";a:5:{s:7:\"5-stars\";s:7:\"5 Stars\";s:7:\"4-stars\";s:7:\"4 Stars\";s:7:\"3-stars\";s:7:\"3 Stars\";s:7:\"2-stars\";s:7:\"2 Stars\";s:6:\"1-star\";s:6:\"1 Star\";}}i:41;a:5:{s:4:\"name\";s:26:\"Custom Center Ribbon Color\";s:4:\"desc\";s:63:\"Add a custom hex color for the center ribbon color e.g. #697e09\";s:2:\"id\";s:25:\"woo_custom_c_ribbon_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:42;a:5:{s:4:\"name\";s:31:\"Custom Center Ribbon Font Color\";s:4:\"desc\";s:66:\"Add a custom hex color for the left ribbon font color e.g. #697e09\";s:2:\"id\";s:30:\"woo_custom_c_ribbon_font_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:43;a:5:{s:4:\"name\";s:33:\"Custom Center Ribbon Border Color\";s:4:\"desc\";s:70:\"Add a custom hex color for the center ribbon border color e.g. #697e09\";s:2:\"id\";s:32:\"woo_custom_c_ribbon_border_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:44;a:5:{s:4:\"name\";s:33:\"Add Star Rating To Center Ribbon?\";s:4:\"desc\";s:67:\"Tick the box if you want to show a star rating on the center ribbon\";s:2:\"id\";s:20:\"woo_add_c_star_image\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:45;a:6:{s:4:\"name\";s:22:\"Select Number Of Stars\";s:4:\"desc\";s:16:\"Select star type\";s:2:\"id\";s:23:\"woo_stars_center_ribbon\";s:3:\"std\";s:5:\"solid\";s:4:\"type\";s:5:\"radio\";s:7:\"options\";a:5:{s:7:\"5-stars\";s:7:\"5 Stars\";s:7:\"4-stars\";s:7:\"4 Stars\";s:7:\"3-stars\";s:7:\"3 Stars\";s:7:\"2-stars\";s:7:\"2 Stars\";s:6:\"1-star\";s:6:\"1 Star\";}}i:46;a:5:{s:4:\"name\";s:25:\"Custom Right Ribbon Color\";s:4:\"desc\";s:62:\"Add a custom hex color for the right ribbon color e.g. #697e09\";s:2:\"id\";s:25:\"woo_custom_r_ribbon_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:47;a:5:{s:4:\"name\";s:30:\"Custom Right Ribbon Font Color\";s:4:\"desc\";s:67:\"Add a custom hex color for the right ribbon font color e.g. #697e09\";s:2:\"id\";s:30:\"woo_custom_r_ribbon_font_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:48;a:5:{s:4:\"name\";s:32:\"Custom Right Ribbon Border Color\";s:4:\"desc\";s:69:\"Add a custom hex color for the right ribbon border color e.g. #697e09\";s:2:\"id\";s:32:\"woo_custom_r_ribbon_border_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:49;a:5:{s:4:\"name\";s:32:\"Add Star Rating To Right Ribbon?\";s:4:\"desc\";s:66:\"Tick the box if you want to show a star rating on the right ribbon\";s:2:\"id\";s:20:\"woo_add_r_star_image\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:50;a:6:{s:4:\"name\";s:22:\"Select Number Of Stars\";s:4:\"desc\";s:16:\"Select star type\";s:2:\"id\";s:22:\"woo_stars_right_ribbon\";s:3:\"std\";s:5:\"solid\";s:4:\"type\";s:5:\"radio\";s:7:\"options\";a:5:{s:7:\"5-stars\";s:7:\"5 Stars\";s:7:\"4-stars\";s:7:\"4 Stars\";s:7:\"3-stars\";s:7:\"3 Stars\";s:7:\"2-stars\";s:7:\"2 Stars\";s:6:\"1-star\";s:6:\"1 Star\";}}i:51;a:3:{s:4:\"name\";s:14:\"Layout Options\";s:4:\"icon\";s:6:\"layout\";s:4:\"type\";s:7:\"heading\";}i:52;a:5:{s:4:\"name\";s:17:\"Enable Cufon font\";s:4:\"desc\";s:187:\"Enable <a href=\"http://cufon.shoqolate.com/generate/\">Cufon</a> font replacement. Replaces Headers to <a href=\"http://www.fontsquirrel.com/fonts/Liberation-Sans\">Liberation Sans</a> font.\";s:2:\"id\";s:9:\"woo_cufon\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:53;a:5:{s:4:\"name\";s:17:\"Full Content Home\";s:4:\"desc\";s:66:\"Show the full content in posts on homepage instead of the excerpt.\";s:2:\"id\";s:16:\"woo_home_content\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:54;a:5:{s:4:\"name\";s:20:\"Full Content Archive\";s:4:\"desc\";s:71:\"Show the full content in posts on archive pages instead of the excerpt.\";s:2:\"id\";s:19:\"woo_archive_content\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:55;a:5:{s:4:\"name\";s:19:\"Disable Post Author\";s:4:\"desc\";s:31:\"Disable post author below post?\";s:2:\"id\";s:23:\"woo_disable_post_author\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:56;a:3:{s:4:\"name\";s:18:\"Sales Page Options\";s:4:\"icon\";s:4:\"post\";s:4:\"type\";s:7:\"heading\";}i:57;a:5:{s:4:\"name\";s:58:\"Width For Page Template - \"Sales Page No Header No Footer\"\";s:4:\"desc\";s:30:\"Enter Width - Default is 960px\";s:2:\"id\";s:23:\"woo_sp_noheadfoot_width\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:58;a:5:{s:4:\"name\";s:9:\"Font Size\";s:4:\"desc\";s:38:\"Enter size of font in pixels e.g. 14px\";s:2:\"id\";s:26:\"woo_sp_noheadfoot_fontsize\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:59;a:5:{s:4:\"name\";s:23:\"Custom Background Color\";s:4:\"desc\";s:61:\"Add a custom hex color for the background color, e.g. #697e09\";s:2:\"id\";s:20:\"woo_sp_noheadfoot_bg\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:60;a:5:{s:4:\"name\";s:19:\"Custom Border Color\";s:4:\"desc\";s:51:\"Add a custom hex color for the border, e.g. #697e09\";s:2:\"id\";s:24:\"woo_sp_noheadfoot_border\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:61;a:5:{s:4:\"name\";s:18:\"Custom Border Size\";s:4:\"desc\";s:27:\"Enter size - default is 1px\";s:2:\"id\";s:28:\"woo_sp_noheadfoot_bordersize\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:62;a:6:{s:4:\"name\";s:19:\"Custom Border Style\";s:4:\"desc\";s:22:\"Select style of border\";s:2:\"id\";s:29:\"woo_sp_noheadfoot_borderstyle\";s:3:\"std\";s:5:\"solid\";s:4:\"type\";s:5:\"radio\";s:7:\"options\";a:3:{s:5:\"solid\";s:5:\"Solid\";s:6:\"dashed\";s:6:\"Dashed\";s:6:\"dotted\";s:6:\"Dotted\";}}i:63;a:5:{s:4:\"name\";s:20:\"Custom Border Radius\";s:4:\"desc\";s:49:\"Enter radius size, for example 10 (do not add px)\";s:2:\"id\";s:30:\"woo_sp_noheadfoot_borderradius\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:64;a:5:{s:4:\"name\";s:28:\"Add Padding Inside Page Area\";s:4:\"desc\";s:68:\"Enter an integer value i.e. 20 for the image size. Max width is 576.\";s:2:\"id\";s:0:\"\";s:3:\"std\";s:0:\"\";s:4:\"type\";a:4:{i:0;a:4:{s:2:\"id\";s:14:\"woo_padd_right\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:50;s:4:\"meta\";s:5:\"Right\";}i:1;a:4:{s:2:\"id\";s:13:\"woo_padd_left\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:50;s:4:\"meta\";s:4:\"Left\";}i:2;a:4:{s:2:\"id\";s:12:\"woo_padd_top\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:20;s:4:\"meta\";s:3:\"Top\";}i:3;a:4:{s:2:\"id\";s:15:\"woo_padd_bottom\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:20;s:4:\"meta\";s:6:\"Bottom\";}}}i:65;a:5:{s:4:\"name\";s:50:\"Show <u>Blog</u> Footer On <u>All</u> Sales Pages?\";s:4:\"desc\";s:55:\"Tick the box if you want to show the main blog\'s footer\";s:2:\"id\";s:18:\"woo_show_sp_footer\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:66;a:5:{s:4:\"name\";s:154:\"Show <u>Blog</u> Footer By Page IDs Only <span style=\'color:#e82f0b;font-size:12px;\'> (Untick \"Show <u>Blog</u> Footer On <u>All</u> Sales Pages!\")</span>\";s:4:\"desc\";s:37:\"Enter the Page IDs to show the footer\";s:2:\"id\";s:21:\"woo_show_sp_footer_id\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:67;a:6:{s:4:\"name\";s:155:\"Show <u>Custom</u> Footer On Sales Pages? <span style=\'color:#e82f0b;font-size:12px;\'> (Untick \"Show <u>Blog</u> Footer On <u>All</u> Sales Pages!\")</span>\";s:4:\"desc\";s:52:\"Tick the box if you want to show custom footer links\";s:2:\"id\";s:22:\"woo_show_custom_footer\";s:3:\"std\";s:5:\"false\";s:5:\"class\";s:9:\"collapsed\";s:4:\"type\";s:8:\"checkbox\";}i:68;a:6:{s:4:\"name\";s:27:\"Enter HTML Links Code below\";s:4:\"desc\";s:26:\"Enter your HTML Links Code\";s:2:\"id\";s:27:\"woo_show_custom_footer_code\";s:4:\"type\";s:8:\"textarea\";s:5:\"class\";s:6:\"hidden\";s:3:\"std\";s:267:\"Paste Your Links HTML Here. For example, <a href=\"#\" title=\"About\" target=\"_self\">About</a> | <a href=\"#\" title=\"Terms\" target=\"_self\">Terms &amp; Conditions</a> | <a href=\"#\" title=\"FAQ\" target=\"_self\">FAQ</a> | <a href=\"#\" title=\"Support\" target=\"_self\">Support</a>\";}i:69;a:6:{s:4:\"name\";s:24:\"Custom Footer Font Color\";s:4:\"desc\";s:66:\"Add a custom hex color for the left ribbon font color e.g. #697e09\";s:2:\"id\";s:28:\"woo_custom_footer_font_color\";s:3:\"std\";s:0:\"\";s:5:\"class\";s:6:\"hidden\";s:4:\"type\";s:5:\"color\";}i:70;a:6:{s:4:\"name\";s:30:\"Underline Custom Footer Links?\";s:4:\"desc\";s:47:\"Choose whether or not to underline footer links\";s:2:\"id\";s:27:\"woo_custom_footer_underline\";s:5:\"class\";s:6:\"hidden\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:71;a:3:{s:4:\"name\";s:22:\"Replace Affiliate URLs\";s:4:\"icon\";s:4:\"ads2\";s:4:\"type\";s:7:\"heading\";}i:72;a:3:{s:4:\"name\";s:219:\"<span style=\'padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;\'>Replace Affiliate URLs - Instructions</span>\";s:4:\"type\";s:4:\"para\";s:4:\"desc\";s:1421:\"<span style=\'font-weight:bold; color:#e82f0b;\'>Step 1)</span> - If using Clickbank, Click the Clickbank Hoplink Encoding URL below. It will open in a new window.<br /><br />\r\n								<span style=\'font-weight:bold; color:#e82f0b;\'>Step 2)</span> - On the Clickbank Hoplink Encoding webpage, add your Clickbank ID (aka Affiliate Nickname) and one of the Clickbank Vendor IDs below in Step 2.<br /><br />** Repeat Step 2 twice until you have BOTH your <strong>unique</strong> Affiliate URLs.<br /><br />\r\n								<span style=\'font-weight:bold; color:#e82f0b;\'>Steps 3 &amp; 4)</span> - Add Your Affiliate URLs (Clickbank, etc.), Title/Alt Tags, Banner URLs </strong>.<br /><br />\r\n								<span style=\'font-weight:bold; color:#e82f0b;\'>Step 5)</span> - Tick the box in <strong>Step 5</strong> to enable the 468px by 60px banner in the <strong>header area</strong>. Enter your Affiliate URL (Clickbank, etc.) that you created earlier that relates to the banner/product. You can replace the banner with Adsense if you prefer.<br /><br />\r\n								<span style=\'font-weight:bold; color:#e82f0b;\'>Step 6)</span> - Click the <strong>Save All Changes</strong> button at the bottom.<br /><br />\r\n								<span style=\'font-weight:bold; color:#e82f0b;\'>Step 7)</span> - Now go to your site and hover your mouse over each banner to make sure the correct Affiliate Links/Alt Tags/Banners are appearing!<br /><br /><br /><br />\r\n								\";}i:73;a:3:{s:4:\"name\";s:379:\"<span style=\'padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;\'>Step 1 - Click The Link Below To Create Your Encoded Hoplinks</span> <br /><br /><a href=\'https://www.clickbank.com/hoplink_encoding.htm\' target=\'_blank\'>https://www.clickbank.com/hoplink_encoding.htm</a>\";s:2:\"id\";s:0:\"\";s:3:\"std\";s:0:\"\";}i:74;a:5:{s:4:\"name\";s:254:\"<span style=\'padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;\'>Step 2 - Clickbank Vendor IDs To Encode Your Hoplinks From The URL Above</span>\";s:4:\"desc\";s:0:\"\";s:2:\"id\";s:0:\"\";s:3:\"std\";s:0:\"\";s:4:\"type\";a:2:{i:0;a:4:{s:2:\"id\";s:11:\"woo_blank_1\";s:3:\"std\";s:11:\"vendor id 1\";s:4:\"meta\";s:22:\"Clickbank Vendor ID #1\";s:4:\"type\";s:4:\"text\";}i:1;a:4:{s:2:\"id\";s:11:\"woo_blank_2\";s:3:\"std\";s:11:\"vendor id 2\";s:4:\"meta\";s:22:\"Clickbank Vendor ID #2\";s:4:\"type\";s:4:\"text\";}}}i:75;a:5:{s:4:\"name\";s:222:\"<span style=\'padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;\'>Step 3 - Add Your Affiliate URL #1 Below</span>\";s:4:\"desc\";s:107:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff1link]</strong></span>\";s:2:\"id\";s:13:\"woo_aff1_link\";s:3:\"std\";s:30:\"Put your Affiliate URL #1 here\";s:4:\"type\";s:4:\"text\";}i:76;a:5:{s:4:\"name\";s:112:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Banner Title/Alt Tags For Affiliate URL #1</span>\";s:4:\"desc\";s:106:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff1tag]</strong></span>\";s:2:\"id\";s:18:\"woo_aff1_title_tag\";s:3:\"std\";s:28:\"Put your Title/Alt info here\";s:4:\"type\";s:4:\"text\";}i:77;a:5:{s:4:\"name\";s:116:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Enter 300x250 Banner Link For Affiliate URL #1</span>\";s:4:\"desc\";s:110:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff1banner1]</strong></span>\";s:2:\"id\";s:21:\"woo_aff1_banner_url_1\";s:3:\"std\";s:32:\"Put your 300x250 Banner URL here\";s:4:\"type\";s:6:\"upload\";}i:78;a:5:{s:4:\"name\";s:116:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Enter 125x125 Banner Link For Affiliate URL #1</span>\";s:4:\"desc\";s:110:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff1banner2]</strong></span>\";s:2:\"id\";s:21:\"woo_aff1_banner_url_2\";s:3:\"std\";s:32:\"Put your 125x125 Banner URL here\";s:4:\"type\";s:6:\"upload\";}i:79;a:5:{s:4:\"name\";s:131:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Enter 468x60 Banner Link For Affiliate URL #1</span> (if applicable)\";s:4:\"desc\";s:110:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff1banner3]</strong></span>\";s:2:\"id\";s:21:\"woo_aff1_banner_url_3\";s:3:\"std\";s:31:\"Put your 468x60 Banner URL here\";s:4:\"type\";s:6:\"upload\";}i:80;a:5:{s:4:\"name\";s:222:\"<span style=\'padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;\'>Step 4 - Add Your Affiliate URL #2 Below</span>\";s:4:\"desc\";s:98:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff2link]</span>\";s:2:\"id\";s:13:\"woo_aff2_link\";s:3:\"std\";s:30:\"Put your Affiliate URL #2 here\";s:4:\"type\";s:4:\"text\";}i:81;a:5:{s:4:\"name\";s:112:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Banner Title/Alt Tags For Affiliate URL #2</span>\";s:4:\"desc\";s:106:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff2tag]</strong></span>\";s:2:\"id\";s:18:\"woo_aff2_title_tag\";s:3:\"std\";s:28:\"Put your Title/Alt info here\";s:4:\"type\";s:4:\"text\";}i:82;a:5:{s:4:\"name\";s:116:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Enter 300x250 Banner Link For Affiliate URL #2</span>\";s:4:\"desc\";s:110:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff2banner1]</strong></span>\";s:2:\"id\";s:21:\"woo_aff2_banner_url_1\";s:3:\"std\";s:32:\"Put your 300x250 Banner URL here\";s:4:\"type\";s:6:\"upload\";}i:83;a:5:{s:4:\"name\";s:116:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Enter 125x125 Banner Link For Affiliate URL #2</span>\";s:4:\"desc\";s:110:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff2banner2]</strong></span>\";s:2:\"id\";s:21:\"woo_aff2_banner_url_2\";s:3:\"std\";s:32:\"Put your 125x125 Banner URL here\";s:4:\"type\";s:6:\"upload\";}i:84;a:5:{s:4:\"name\";s:131:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Enter 468x60 Banner Link For Affiliate URL #2</span> (if applicable)\";s:4:\"desc\";s:110:\"<span style=\'font-size:11px; font-weight:normal;\'>This creates shortcode <strong>[aff2banner3]</strong></span>\";s:2:\"id\";s:21:\"woo_aff2_banner_url_3\";s:3:\"std\";s:47:\"Put your 468x60 (on Video Page) Banner URL here\";s:4:\"type\";s:6:\"upload\";}i:85;a:5:{s:4:\"name\";s:218:\"<span style=\'padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;\'>Step 5 - Enable 468x60 Header Banner</span>\";s:4:\"desc\";s:29:\"Enable 468x60 banner ad space\";s:2:\"id\";s:10:\"woo_ad_top\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:86;a:5:{s:4:\"name\";s:100:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Enter 468x60 Header Banner URL</span>\";s:4:\"desc\";s:46:\"Enter the URL to the banner ad image location.\";s:2:\"id\";s:16:\"woo_ad_top_image\";s:3:\"std\";s:40:\"http://www.woothemes.com/ads/468x60b.jpg\";s:4:\"type\";s:6:\"upload\";}i:87;a:5:{s:4:\"name\";s:110:\"<span style=\'color:#e82f0b; font-size:13px; font-weight:bold;\'>Enter 468x60 Header Banner Affiliate URL</span>\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:14:\"woo_ad_top_url\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:88;a:5:{s:4:\"name\";s:72:\"Adsense code (optional) - if you prefer Adsense over an affiliate banner\";s:4:\"desc\";s:56:\"Enter your adsense code (or other ad network code) here.\";s:2:\"id\";s:18:\"woo_ad_top_adsense\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"textarea\";}i:89;a:3:{s:4:\"name\";s:17:\"Footer Disclaimer\";s:4:\"icon\";s:4:\"post\";s:4:\"type\";s:7:\"heading\";}i:90;a:5:{s:4:\"name\";s:23:\"Show Footer Disclaimer?\";s:4:\"desc\";s:73:\"Tick the box if you want to show a disclaimer in the footer (recommended)\";s:2:\"id\";s:26:\"woo_show_dislcaimer_footer\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:91;a:5:{s:4:\"name\";s:44:\"Type In Your Disclaimer Or Use The One Below\";s:4:\"desc\";s:24:\"Type or Paste Disclaimer\";s:2:\"id\";s:28:\"woo_custom_footer_disclaimer\";s:3:\"std\";s:368:\"Disclaimer: This website is an officially authorized and remunerated associate for recommending high quality products found on this website. Links on this website may be associate links which means if you click on a link of a recommended product, I/we may receive monetary compensation. However, this does not affect any unbiased information presented on this website.\";s:4:\"type\";s:8:\"textarea\";}i:92;a:5:{s:4:\"name\";s:59:\"Disclaimer Font Size - Just Type The Number, Don\'t Add \'px\'\";s:4:\"desc\";s:41:\"Enter font size e.g. type 14 to mean 14px\";s:2:\"id\";s:23:\"woo_disclaimer_fontsize\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:4:\"text\";}i:93;a:5:{s:4:\"name\";s:17:\"Custom Link Color\";s:4:\"desc\";s:62:\"Add a custom hex color for the links in your site e.g. #697e09\";s:2:\"id\";s:20:\"woo_disclaimer_color\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:5:\"color\";}i:94;a:3:{s:4:\"name\";s:13:\"Backlink Tips\";s:4:\"icon\";s:10:\"linkseeker\";s:4:\"type\";s:7:\"heading\";}i:95;a:3:{s:4:\"name\";s:262:\"<span style=\'padding:5px; background-color:#e3f1f8; color:black; font-size:12px; border:1px solid #3bb5ed;-webkit-border-radius:5px;-moz-border-radius:5px;border-radius:5px;\'>Find .edu, .gov, and other URLs to \"drop your links\" - <u><i>Don\'t Spam!</i></u></span>\";s:4:\"type\";s:4:\"para\";s:4:\"desc\";s:1162:\"Click The Link Below To Search For Sites To Leave Well-Constructed Comments! <br /><br /><a href=\'http://dropmylink.com/\' target=\'_blank\'>Drop My Link</a><br /><br />\r\n							   <span style=\'font-weight:bold; color:#e82f0b;\'>Please Note:</span> While most links may be considered \"good\", don\'t fall for the <i>\".edu or .org links will skyrocket your site to the top of Google!\".</i> Mix up your backlink strategy for best results!<br /><br />\r\n							   ** Consider these other options:<br /><br />\r\n							   - Article directories like those listed below:<br /><br />\r\n								<ol>\r\n									<li><a href=\'http://www.ezinearticles.com\' target=\'_blank\'>EzineArticles.com</a></li>\r\n									<li><a href=\'http://www.goarticles.com\' target=\'_blank\'>GoArticles.com</a></li>\r\n									<li><a href=\'http://www.articlesbase.com\' target=\'_blank\'>ArticlesBase.com</a></li>\r\n								</ol><br />\r\n							   - Outsource link building, press releases etc. <br /><br />\r\n								<ol>\r\n									<li>Try the <a href=\'http://www.warriorforum.com/warriors-hire/\' target=\'_blank\'>Warrior\'s For Hire</a> section</li>\r\n								</ol><br />\r\n							   - And so on.<br /><br />\r\n								\";}i:96;a:3:{s:4:\"name\";s:14:\"Dynamic Images\";s:4:\"type\";s:7:\"heading\";s:4:\"icon\";s:5:\"image\";}i:97;a:6:{s:4:\"name\";s:39:\"Enable WordPress Post Thumbnail Support\";s:4:\"desc\";s:64:\"Use WordPress post thumbnail support to assign a post thumbnail.\";s:2:\"id\";s:22:\"woo_post_image_support\";s:3:\"std\";s:4:\"true\";s:5:\"class\";s:9:\"collapsed\";s:4:\"type\";s:8:\"checkbox\";}i:98;a:6:{s:4:\"name\";s:33:\"Dynamically Resize Post Thumbnail\";s:4:\"desc\";s:113:\"The post thumbnail will be dynamically resized using native WP resize functionality. <em>(Requires PHP 5.2+)</em>\";s:2:\"id\";s:14:\"woo_pis_resize\";s:3:\"std\";s:4:\"true\";s:5:\"class\";s:6:\"hidden\";s:4:\"type\";s:8:\"checkbox\";}i:99;a:6:{s:4:\"name\";s:24:\"Hard Crop Post Thumbnail\";s:4:\"desc\";s:59:\"The image will be cropped to match the target aspect ratio.\";s:2:\"id\";s:17:\"woo_pis_hard_crop\";s:3:\"std\";s:4:\"true\";s:5:\"class\";s:11:\"hidden last\";s:4:\"type\";s:8:\"checkbox\";}i:100;a:5:{s:4:\"name\";s:28:\"Enable Dynamic Image Resizer\";s:4:\"desc\";s:84:\"This will enable the thumb.php script which dynamically resizes images on your site.\";s:2:\"id\";s:10:\"woo_resize\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:101;a:5:{s:4:\"name\";s:22:\"Automatic Image Thumbs\";s:4:\"desc\";s:96:\"If no image is specified in the \'image\' custom field then the first uploaded post image is used.\";s:2:\"id\";s:12:\"woo_auto_img\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:102;a:5:{s:4:\"name\";s:22:\"Show Image in RSS feed\";s:4:\"desc\";s:69:\"Will show the image uploaded to \'image\' custom field in the RSS feed.\";s:2:\"id\";s:13:\"woo_rss_thumb\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:103;a:6:{s:4:\"name\";s:15:\"Image alignment\";s:4:\"desc\";s:69:\"Select how to align your images with posts (front page and archives).\";s:2:\"id\";s:9:\"woo_align\";s:3:\"std\";s:9:\"alignleft\";s:4:\"type\";s:5:\"radio\";s:7:\"options\";a:3:{s:9:\"alignleft\";s:4:\"Left\";s:10:\"alignright\";s:5:\"Right\";s:11:\"aligncenter\";s:6:\"Center\";}}i:104;a:5:{s:4:\"name\";s:16:\"Image Dimensions\";s:4:\"desc\";s:69:\"Enter an integer value i.e. 250 for the image size. Max width is 576.\";s:2:\"id\";s:20:\"woo_image_dimensions\";s:3:\"std\";s:0:\"\";s:4:\"type\";a:2:{i:0;a:4:{s:2:\"id\";s:15:\"woo_thumb_width\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:200;s:4:\"meta\";s:5:\"Width\";}i:1;a:4:{s:2:\"id\";s:16:\"woo_thumb_height\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:200;s:4:\"meta\";s:6:\"Height\";}}}i:105;a:5:{s:4:\"name\";s:20:\"Show in Single Posts\";s:4:\"desc\";s:100:\"Show the attached image in the single post page. <strong>Note:</strong> You must disable content ad.\";s:2:\"id\";s:16:\"woo_image_single\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:106;a:5:{s:4:\"name\";s:23:\"Single Image Dimensions\";s:4:\"desc\";s:69:\"Enter an integer value i.e. 250 for the image size. Max width is 576.\";s:2:\"id\";s:20:\"woo_image_dimensions\";s:3:\"std\";s:0:\"\";s:4:\"type\";a:2:{i:0;a:4:{s:2:\"id\";s:16:\"woo_single_width\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:200;s:4:\"meta\";s:5:\"Width\";}i:1;a:4:{s:2:\"id\";s:17:\"woo_single_height\";s:4:\"type\";s:4:\"text\";s:3:\"std\";i:200;s:4:\"meta\";s:6:\"Height\";}}}i:107;a:3:{s:4:\"name\";s:22:\"Content Ad (200x200px)\";s:4:\"icon\";s:3:\"ads\";s:4:\"type\";s:7:\"heading\";}i:108;a:5:{s:4:\"name\";s:9:\"Enable Ad\";s:4:\"desc\";s:19:\"Enable the ad space\";s:2:\"id\";s:14:\"woo_ad_content\";s:3:\"std\";s:5:\"false\";s:4:\"type\";s:8:\"checkbox\";}i:109;a:5:{s:4:\"name\";s:12:\"Adsense code\";s:4:\"desc\";s:56:\"Enter your adsense code (or other ad network code) here.\";s:2:\"id\";s:22:\"woo_ad_content_adsense\";s:3:\"std\";s:0:\"\";s:4:\"type\";s:8:\"textarea\";}i:110;a:5:{s:4:\"name\";s:14:\"Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:20:\"woo_ad_content_image\";s:3:\"std\";s:15:\"Enter Image URL\";s:4:\"type\";s:6:\"upload\";}i:111;a:5:{s:4:\"name\";s:15:\"Destination URL\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:18:\"woo_ad_content_url\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:112;a:3:{s:4:\"name\";s:20:\"Widget Ads (125x125)\";s:4:\"icon\";s:3:\"ads\";s:4:\"type\";s:7:\"heading\";}i:113;a:5:{s:4:\"name\";s:15:\"Rotate banners?\";s:4:\"desc\";s:45:\"Check this to randomly rotate the banner ads.\";s:2:\"id\";s:14:\"woo_ads_rotate\";s:3:\"std\";s:4:\"true\";s:4:\"type\";s:8:\"checkbox\";}i:114;a:5:{s:4:\"name\";s:29:\"Banner Ad #1 - Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:14:\"woo_ad_image_1\";s:3:\"std\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:4:\"type\";s:4:\"text\";}i:115;a:5:{s:4:\"name\";s:26:\"Banner Ad #1 - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:12:\"woo_ad_url_1\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:116;a:5:{s:4:\"name\";s:29:\"Banner Ad #2 - Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:14:\"woo_ad_image_2\";s:3:\"std\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:4:\"type\";s:4:\"text\";}i:117;a:5:{s:4:\"name\";s:26:\"Banner Ad #2 - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:12:\"woo_ad_url_2\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:118;a:5:{s:4:\"name\";s:29:\"Banner Ad #3 - Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:14:\"woo_ad_image_3\";s:3:\"std\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:4:\"type\";s:4:\"text\";}i:119;a:5:{s:4:\"name\";s:26:\"Banner Ad #3 - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:12:\"woo_ad_url_3\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:120;a:5:{s:4:\"name\";s:29:\"Banner Ad #4 - Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:14:\"woo_ad_image_4\";s:3:\"std\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:4:\"type\";s:4:\"text\";}i:121;a:5:{s:4:\"name\";s:26:\"Banner Ad #4 - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:12:\"woo_ad_url_4\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:122;a:5:{s:4:\"name\";s:29:\"Banner Ad #5 - Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:14:\"woo_ad_image_5\";s:3:\"std\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:4:\"type\";s:4:\"text\";}i:123;a:5:{s:4:\"name\";s:26:\"Banner Ad #5 - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:12:\"woo_ad_url_5\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}i:124;a:5:{s:4:\"name\";s:29:\"Banner Ad #6 - Image Location\";s:4:\"desc\";s:33:\"Enter the URL for this banner ad.\";s:2:\"id\";s:14:\"woo_ad_image_6\";s:3:\"std\";s:41:\"http://www.woothemes.com/ads/125x125b.jpg\";s:4:\"type\";s:4:\"text\";}i:125;a:5:{s:4:\"name\";s:26:\"Banner Ad #6 - Destination\";s:4:\"desc\";s:45:\"Enter the URL where this banner ad points to.\";s:2:\"id\";s:12:\"woo_ad_url_6\";s:3:\"std\";s:24:\"http://www.woothemes.com\";s:4:\"type\";s:4:\"text\";}}', 'yes');
INSERT INTO `wp_options` VALUES('303', 'woo_themename', 'Headlines Enhanced', 'yes');
INSERT INTO `wp_options` VALUES('304', 'woo_shortname', 'woo', 'yes');
INSERT INTO `wp_options` VALUES('305', 'woo_manual', 'http://www.woothemes.com/support/theme-documentation/headlines', 'yes');
INSERT INTO `wp_options` VALUES('306', 'woo_custom_template', 'a:2:{s:5:\"image\";a:5:{s:4:\"name\";s:5:\"image\";s:3:\"std\";s:0:\"\";s:5:\"label\";s:22:\"Custom Thumbnail Image\";s:4:\"type\";s:6:\"upload\";s:4:\"desc\";s:39:\"Upload an image to show with your post.\";}s:5:\"embed\";a:5:{s:4:\"name\";s:5:\"embed\";s:3:\"std\";s:0:\"\";s:5:\"label\";s:10:\"Embed Code\";s:4:\"type\";s:8:\"textarea\";s:4:\"desc\";s:69:\"Enter the video embed code for your video (YouTube, Vimeo or similar)\";}}', 'yes');
INSERT INTO `wp_options` VALUES('7878', 'category_children', 'a:0:{}', 'yes');
INSERT INTO `wp_options` VALUES('731', '_transient_timeout_ye_video_MGE3YjI3ZjdiNjVkMDU5YmI0OGJhNDk3OTc0', '1323459904', 'no');
INSERT INTO `wp_options` VALUES('4207', 'mobile_category_exclude', '0', 'yes');
INSERT INTO `wp_options` VALUES('4208', 'mobile_home_page', '0', 'yes');
INSERT INTO `wp_options` VALUES('4209', 'mobile_auto_excerpt', 'yes', 'yes');
INSERT INTO `wp_options` VALUES('4210', 'mobile_thumbnail_usage', 'image', 'yes');
INSERT INTO `wp_options` VALUES('354', 'mobile_thumbnail_custom', '', 'yes');
INSERT INTO `wp_options` VALUES('4211', 'mobile_slider_category', '0', 'yes');
INSERT INTO `wp_options` VALUES('4212', 'mobile_slider_count', '3', 'yes');
INSERT INTO `wp_options` VALUES('4215', 'update_ocmx', 'general_site_options, 1', 'yes');
INSERT INTO `wp_options` VALUES('360', 'woo_alt_stylesheet', 'skylight.css', 'yes');
INSERT INTO `wp_options` VALUES('361', 'woo_logo', '', 'yes');
INSERT INTO `wp_options` VALUES('362', 'woo_texttitle', 'true', 'yes');
INSERT INTO `wp_options` VALUES('363', 'woo_font_site_title', 'a:5:{s:4:\"size\";s:2:\"49\";s:4:\"unit\";s:2:\"px\";s:4:\"face\";s:17:\"Yanone Kaffeesatz\";s:5:\"style\";s:4:\"bold\";s:5:\"color\";s:7:\"#ffffff\";}', 'yes');
INSERT INTO `wp_options` VALUES('364', 'woo_font_tagline', 'a:5:{s:4:\"size\";s:2:\"11\";s:4:\"unit\";s:2:\"px\";s:4:\"face\";s:17:\"Arial, sans-serif\";s:5:\"style\";s:6:\"normal\";s:5:\"color\";s:7:\"#bbbbbb\";}', 'yes');
INSERT INTO `wp_options` VALUES('365', 'woo_custom_favicon', '', 'yes');
INSERT INTO `wp_options` VALUES('366', 'woo_google_analytics', '', 'yes');
INSERT INTO `wp_options` VALUES('367', 'woo_feedburner_url', '', 'yes');
INSERT INTO `wp_options` VALUES('368', 'woo_feedburner_id', '', 'yes');
INSERT INTO `wp_options` VALUES('369', 'woo_contactform_email', '', 'yes');
INSERT INTO `wp_options` VALUES('370', 'woo_custom_css', '', 'yes');
INSERT INTO `wp_options` VALUES('371', 'woo_custom_link', '#1079c9', 'yes');
INSERT INTO `wp_options` VALUES('372', 'woo_search_disable', 'false', 'yes');
INSERT INTO `wp_options` VALUES('373', 'woo_featured_slider', 'true', 'yes');
INSERT INTO `wp_options` VALUES('374', 'woo_featured_shortcode', '[pb_slideshow group=\"0\"]', 'yes');
INSERT INTO `wp_options` VALUES('375', 'woo_featured_video', 'false', 'yes');
INSERT INTO `wp_options` VALUES('376', 'woo_featured_video_embed_code', '<iframe src=\"http://player.vimeo.com/video/27299211?title=0&amp;byline=0&amp;portrait=0\" width=\"580\" height=\"300\" frameborder=\"0\" webkitAllowFullScreen mozallowfullscreen allowFullScreen></iframe>', 'yes');
INSERT INTO `wp_options` VALUES('377', 'woo_sticky_posts_only', 'true', 'yes');
INSERT INTO `wp_options` VALUES('378', 'woo_sticky_posts_count', '5', 'yes');
INSERT INTO `wp_options` VALUES('379', 'woo_top_widgets', 'false', 'yes');
INSERT INTO `wp_options` VALUES('380', 'woo_top_widgets_allposts', 'false', 'yes');
INSERT INTO `wp_options` VALUES('381', 'woo_top_widgets_bypost_ids', '', 'yes');
INSERT INTO `wp_options` VALUES('382', 'woo_top_widgets_allpages', 'false', 'yes');
INSERT INTO `wp_options` VALUES('383', 'woo_top_widgets_bypage_ids', '', 'yes');
INSERT INTO `wp_options` VALUES('384', 'woo_custom_l_ribbon_color', '#d00a0b', 'yes');
INSERT INTO `wp_options` VALUES('385', 'woo_custom_l_ribbon_font_color', '#ffffff', 'yes');
INSERT INTO `wp_options` VALUES('386', 'woo_custom_l_ribbon_border_color', '#6c88ad', 'yes');
INSERT INTO `wp_options` VALUES('387', 'woo_add_l_star_image', 'true', 'yes');
INSERT INTO `wp_options` VALUES('388', 'woo_stars_left_ribbon', '5-stars', 'yes');
INSERT INTO `wp_options` VALUES('389', 'woo_custom_c_ribbon_color', '#d00a0b', 'yes');
INSERT INTO `wp_options` VALUES('390', 'woo_custom_c_ribbon_font_color', '#ffffff', 'yes');
INSERT INTO `wp_options` VALUES('391', 'woo_custom_c_ribbon_border_color', '#6c88ad', 'yes');
INSERT INTO `wp_options` VALUES('392', 'woo_add_c_star_image', 'true', 'yes');
INSERT INTO `wp_options` VALUES('393', 'woo_stars_center_ribbon', '4-stars', 'yes');
INSERT INTO `wp_options` VALUES('394', 'woo_custom_r_ribbon_color', '#d00a0b', 'yes');
INSERT INTO `wp_options` VALUES('395', 'woo_custom_r_ribbon_font_color', '#ffffff', 'yes');
INSERT INTO `wp_options` VALUES('396', 'woo_custom_r_ribbon_border_color', '#6c88ad', 'yes');
INSERT INTO `wp_options` VALUES('397', 'woo_add_r_star_image', 'true', 'yes');
INSERT INTO `wp_options` VALUES('398', 'woo_stars_right_ribbon', '3-stars', 'yes');
INSERT INTO `wp_options` VALUES('399', 'woo_cufon', 'true', 'yes');
INSERT INTO `wp_options` VALUES('400', 'woo_home_content', 'false', 'yes');
INSERT INTO `wp_options` VALUES('401', 'woo_archive_content', 'false', 'yes');
INSERT INTO `wp_options` VALUES('402', 'woo_disable_post_author', 'true', 'yes');
INSERT INTO `wp_options` VALUES('403', 'woo_sp_noheadfoot_width', '950', 'yes');
INSERT INTO `wp_options` VALUES('404', 'woo_sp_noheadfoot_fontsize', '14', 'yes');
INSERT INTO `wp_options` VALUES('405', 'woo_sp_noheadfoot_bg', '', 'yes');
INSERT INTO `wp_options` VALUES('406', 'woo_sp_noheadfoot_border', '', 'yes');
INSERT INTO `wp_options` VALUES('407', 'woo_sp_noheadfoot_bordersize', '', 'yes');
INSERT INTO `wp_options` VALUES('408', 'woo_sp_noheadfoot_borderstyle', 'solid', 'yes');
INSERT INTO `wp_options` VALUES('409', 'woo_sp_noheadfoot_borderradius', '30', 'yes');
INSERT INTO `wp_options` VALUES('410', 'woo_padd_right', '150', 'yes');
INSERT INTO `wp_options` VALUES('411', 'woo_padd_left', '150', 'yes');
INSERT INTO `wp_options` VALUES('412', 'woo_padd_top', '20', 'yes');
INSERT INTO `wp_options` VALUES('413', 'woo_padd_bottom', '20', 'yes');
INSERT INTO `wp_options` VALUES('414', 'woo_show_sp_footer', 'false', 'yes');
INSERT INTO `wp_options` VALUES('415', 'woo_show_sp_footer_id', '', 'yes');
INSERT INTO `wp_options` VALUES('416', 'woo_show_custom_footer', 'false', 'yes');
INSERT INTO `wp_options` VALUES('417', 'woo_show_custom_footer_code', 'Paste Your Links HTML Here. For example, <a href=\"#\" title=\"About\" target=\"_self\">About</a> | <a href=\"#\" title=\"Terms\" target=\"_self\">Terms &amp; Conditions</a> | <a href=\"#\" title=\"FAQ\" target=\"_self\">FAQ</a> | <a href=\"#\" title=\"Support\" target=\"_self\">Support</a>', 'yes');
INSERT INTO `wp_options` VALUES('418', 'woo_custom_footer_font_color', '', 'yes');
INSERT INTO `wp_options` VALUES('419', 'woo_custom_footer_underline', 'true', 'yes');
INSERT INTO `wp_options` VALUES('420', 'woo_show_custom_footer_id', '', 'yes');
INSERT INTO `wp_options` VALUES('421', 'woo_blank_1', 'visionback', 'yes');
INSERT INTO `wp_options` VALUES('422', 'woo_blank_2', 'vendor id 2', 'yes');
INSERT INTO `wp_options` VALUES('423', 'woo_aff1_link', 'http://5d355rx2s5dcacfroeu9qad3ud.hop.clickbank.net/', 'yes');
INSERT INTO `wp_options` VALUES('424', 'woo_aff1_title_tag', 'Restore My Vision Today', 'yes');
INSERT INTO `wp_options` VALUES('425', 'woo_aff1_banner_url_1', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2011/12/300x250-S-10.jpg', 'yes');
INSERT INTO `wp_options` VALUES('426', 'woo_aff1_banner_url_2', 'Put your 125x125 Banner URL here', 'yes');
INSERT INTO `wp_options` VALUES('427', 'woo_aff1_banner_url_3', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2011/12/468x60-3.jpg', 'yes');
INSERT INTO `wp_options` VALUES('2041', '_transient_timeout_ye_video_ODhhMzlhZDYwNWMyNjhhNjBjNTA2YjAxOTQ3', '1339675685', 'no');
INSERT INTO `wp_options` VALUES('428', 'woo_aff2_link', 'Put your Affiliate URL #2 here', 'yes');
INSERT INTO `wp_options` VALUES('429', 'woo_aff2_title_tag', 'Put your Title/Alt info here', 'yes');
INSERT INTO `wp_options` VALUES('430', 'woo_aff2_banner_url_1', 'Put your 300x250 Banner URL here', 'yes');
INSERT INTO `wp_options` VALUES('431', 'woo_aff2_banner_url_2', 'Put your 125x125 Banner URL here', 'yes');
INSERT INTO `wp_options` VALUES('432', 'woo_aff2_banner_url_3', 'Put your 468x60 (on Video Page) Banner URL here', 'yes');
INSERT INTO `wp_options` VALUES('433', 'woo_ad_top', 'true', 'yes');
INSERT INTO `wp_options` VALUES('434', 'woo_ad_top_image', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2011/12/468x60-31.jpg', 'yes');
INSERT INTO `wp_options` VALUES('435', 'woo_ad_top_url', 'http://5d355rx2s5dcacfroeu9qad3ud.hop.clickbank.net/', 'yes');
INSERT INTO `wp_options` VALUES('436', 'woo_ad_top_adsense', '', 'yes');
INSERT INTO `wp_options` VALUES('437', 'woo_post_image_support', 'true', 'yes');
INSERT INTO `wp_options` VALUES('438', 'woo_pis_resize', 'true', 'yes');
INSERT INTO `wp_options` VALUES('439', 'woo_pis_hard_crop', 'true', 'yes');
INSERT INTO `wp_options` VALUES('440', 'woo_resize', 'true', 'yes');
INSERT INTO `wp_options` VALUES('441', 'woo_auto_img', 'false', 'yes');
INSERT INTO `wp_options` VALUES('442', 'woo_rss_thumb', 'false', 'yes');
INSERT INTO `wp_options` VALUES('443', 'woo_align', 'alignleft', 'yes');
INSERT INTO `wp_options` VALUES('444', 'woo_thumb_width', '150', 'yes');
INSERT INTO `wp_options` VALUES('445', 'woo_thumb_height', '150', 'yes');
INSERT INTO `wp_options` VALUES('446', 'woo_image_single', 'false', 'yes');
INSERT INTO `wp_options` VALUES('447', 'woo_single_width', '200', 'yes');
INSERT INTO `wp_options` VALUES('448', 'woo_single_height', '200', 'yes');
INSERT INTO `wp_options` VALUES('449', 'woo_ad_content', 'false', 'yes');
INSERT INTO `wp_options` VALUES('450', 'woo_ad_content_adsense', '', 'yes');
INSERT INTO `wp_options` VALUES('451', 'woo_ad_content_image', 'Enter Image URL', 'yes');
INSERT INTO `wp_options` VALUES('452', 'woo_ad_content_url', 'http://www.woothemes.com', 'yes');
INSERT INTO `wp_options` VALUES('453', 'woo_ads_rotate', 'true', 'yes');
INSERT INTO `wp_options` VALUES('454', 'woo_ad_image_1', 'http://www.woothemes.com/ads/125x125b.jpg', 'yes');
INSERT INTO `wp_options` VALUES('455', 'woo_ad_url_1', 'http://www.woothemes.com', 'yes');
INSERT INTO `wp_options` VALUES('456', 'woo_ad_image_2', 'http://www.woothemes.com/ads/125x125b.jpg', 'yes');
INSERT INTO `wp_options` VALUES('457', 'woo_ad_url_2', 'http://www.woothemes.com', 'yes');
INSERT INTO `wp_options` VALUES('458', 'woo_ad_image_3', 'http://www.woothemes.com/ads/125x125b.jpg', 'yes');
INSERT INTO `wp_options` VALUES('459', 'woo_ad_url_3', 'http://www.woothemes.com', 'yes');
INSERT INTO `wp_options` VALUES('460', 'woo_ad_image_4', 'http://www.woothemes.com/ads/125x125b.jpg', 'yes');
INSERT INTO `wp_options` VALUES('461', 'woo_ad_url_4', 'http://www.woothemes.com', 'yes');
INSERT INTO `wp_options` VALUES('462', 'woo_ad_image_5', 'http://www.woothemes.com/ads/125x125b.jpg', 'yes');
INSERT INTO `wp_options` VALUES('463', 'woo_ad_url_5', 'http://www.woothemes.com', 'yes');
INSERT INTO `wp_options` VALUES('464', 'woo_ad_image_6', 'http://www.woothemes.com/ads/125x125b.jpg', 'yes');
INSERT INTO `wp_options` VALUES('465', 'woo_ad_url_6', 'http://www.woothemes.com', 'yes');
INSERT INTO `wp_options` VALUES('468', 'sm_options', 'a:51:{s:18:\"sm_b_prio_provider\";s:41:\"GoogleSitemapGeneratorPrioByCountProvider\";s:9:\"sm_b_ping\";b:1;s:10:\"sm_b_stats\";b:0;s:12:\"sm_b_pingmsn\";b:1;s:12:\"sm_b_autozip\";b:1;s:11:\"sm_b_memory\";s:0:\"\";s:9:\"sm_b_time\";i:-1;s:18:\"sm_b_style_default\";b:1;s:10:\"sm_b_style\";s:0:\"\";s:12:\"sm_b_baseurl\";s:0:\"\";s:11:\"sm_b_robots\";b:1;s:9:\"sm_b_html\";b:1;s:12:\"sm_b_exclude\";a:0:{}s:17:\"sm_b_exclude_cats\";a:0:{}s:10:\"sm_in_home\";b:1;s:11:\"sm_in_posts\";b:1;s:15:\"sm_in_posts_sub\";b:0;s:11:\"sm_in_pages\";b:1;s:10:\"sm_in_cats\";b:0;s:10:\"sm_in_arch\";b:0;s:10:\"sm_in_auth\";b:0;s:10:\"sm_in_tags\";b:0;s:9:\"sm_in_tax\";a:0:{}s:17:\"sm_in_customtypes\";a:0:{}s:13:\"sm_in_lastmod\";b:1;s:10:\"sm_cf_home\";s:5:\"daily\";s:11:\"sm_cf_posts\";s:7:\"monthly\";s:11:\"sm_cf_pages\";s:6:\"weekly\";s:10:\"sm_cf_cats\";s:6:\"weekly\";s:10:\"sm_cf_auth\";s:6:\"weekly\";s:15:\"sm_cf_arch_curr\";s:5:\"daily\";s:14:\"sm_cf_arch_old\";s:6:\"yearly\";s:10:\"sm_cf_tags\";s:6:\"weekly\";s:10:\"sm_pr_home\";d:1;s:11:\"sm_pr_posts\";d:0.59999999999999997779553950749686919152736663818359375;s:15:\"sm_pr_posts_min\";d:0.200000000000000011102230246251565404236316680908203125;s:11:\"sm_pr_pages\";d:0.59999999999999997779553950749686919152736663818359375;s:10:\"sm_pr_cats\";d:0.299999999999999988897769753748434595763683319091796875;s:10:\"sm_pr_arch\";d:0.299999999999999988897769753748434595763683319091796875;s:10:\"sm_pr_auth\";d:0.299999999999999988897769753748434595763683319091796875;s:10:\"sm_pr_tags\";d:0.299999999999999988897769753748434595763683319091796875;s:12:\"sm_i_donated\";b:0;s:17:\"sm_i_hide_donated\";b:0;s:17:\"sm_i_install_date\";i:1323379239;s:14:\"sm_i_hide_note\";b:0;s:15:\"sm_i_hide_works\";b:0;s:16:\"sm_i_hide_donors\";b:0;s:9:\"sm_i_hash\";s:20:\"32052fa1725189d06d7f\";s:13:\"sm_i_lastping\";i:1402361622;s:16:\"sm_i_supportfeed\";b:1;s:22:\"sm_i_supportfeed_cache\";i:1402319494;}', 'yes');
INSERT INTO `wp_options` VALUES('471', 'sm_status', 'O:28:\"GoogleSitemapGeneratorStatus\":4:{s:39:\"\0GoogleSitemapGeneratorStatus\0startTime\";d:1402361621.638722896575927734375;s:37:\"\0GoogleSitemapGeneratorStatus\0endTime\";d:1402361621.9044640064239501953125;s:41:\"\0GoogleSitemapGeneratorStatus\0pingResults\";a:2:{s:6:\"google\";a:5:{s:9:\"startTime\";d:1402361621.6401500701904296875;s:7:\"endTime\";d:1402361621.745728015899658203125;s:7:\"success\";b:1;s:3:\"url\";s:114:\"http://www.google.com/webmasters/sitemaps/ping?sitemap=http%3A%2F%2Fwww.plrblogs.com%2Frestorevision%2Fsitemap.xml\";s:4:\"name\";s:6:\"Google\";}s:4:\"bing\";a:5:{s:9:\"startTime\";d:1402361621.74683094024658203125;s:7:\"endTime\";d:1402361621.9024689197540283203125;s:7:\"success\";b:1;s:3:\"url\";s:107:\"http://www.bing.com/webmaster/ping.aspx?siteMap=http%3A%2F%2Fwww.plrblogs.com%2Frestorevision%2Fsitemap.xml\";s:4:\"name\";s:4:\"Bing\";}}s:38:\"\0GoogleSitemapGeneratorStatus\0autoSave\";b:1;}', 'no');
INSERT INTO `wp_options` VALUES('469', 'woo_custom_upload_tracking', 'a:0:{}', 'yes');
INSERT INTO `wp_options` VALUES('569', '_transient_timeout_ye_video_ZDE0NTFiYmY3YzczOWViNTFlNTczMTRjOTg1', '1326512801', 'no');
INSERT INTO `wp_options` VALUES('476', 'easy_privacy_CreatePageId', '18', 'yes');
INSERT INTO `wp_options` VALUES('483', 'youtube_embed_profile0', 'a:39:{s:5:\"width\";i:560;s:6:\"height\";d:315;s:10:\"fullscreen\";s:0:\"\";s:8:\"template\";s:7:\"%video%\";s:8:\"autoplay\";s:0:\"\";s:5:\"start\";s:1:\"0\";s:4:\"loop\";s:0:\"\";s:2:\"cc\";s:0:\"\";s:10:\"annotation\";s:1:\"1\";s:7:\"related\";s:0:\"\";s:4:\"info\";s:1:\"1\";s:4:\"link\";s:1:\"1\";s:5:\"react\";s:1:\"1\";s:4:\"stop\";s:1:\"0\";s:9:\"sweetspot\";s:1:\"1\";s:4:\"type\";s:1:\"v\";s:9:\"disablekb\";s:0:\"\";s:8:\"autohide\";s:1:\"2\";s:8:\"controls\";s:1:\"1\";s:8:\"playlist\";s:1:\"v\";s:8:\"fallback\";s:1:\"v\";s:5:\"wmode\";s:6:\"opaque\";s:6:\"shadow\";s:1:\"0\";s:5:\"audio\";s:0:\"\";s:2:\"hd\";s:1:\"1\";s:5:\"style\";s:0:\"\";s:5:\"color\";s:3:\"red\";s:5:\"theme\";s:4:\"dark\";s:5:\"https\";s:1:\"0\";s:4:\"name\";s:7:\"Default\";s:6:\"modest\";i:1;s:7:\"dynamic\";s:0:\"\";s:5:\"fixed\";s:0:\"\";s:8:\"download\";s:0:\"\";s:14:\"download_style\";s:0:\"\";s:13:\"download_text\";s:32:\"Click here to download the video\";s:15:\"link_to_youtube\";s:0:\"\";s:13:\"vixy_download\";s:0:\"\";s:2:\"vq\";s:0:\"\";}', 'yes');
INSERT INTO `wp_options` VALUES('488', '_transient_timeout_ye_video_Yzk2NGI3OWYyYzdkZjYyZTJkMTg5ZmM2OTA4', '1323383161', 'no');
INSERT INTO `wp_options` VALUES('489', '_transient_ye_video_Yzk2NGI3OWYyYzdkZjYyZTJkMTg5ZmM2OTA4MjM3ZTQ1', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/J2C_7QLwsnc?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('498', '_transient_timeout_ye_video_MjA1ZjY4YTQwOWNlMjA3Mzc4NzNhNGQ5NTg1', '1323383161', 'no');
INSERT INTO `wp_options` VALUES('499', '_transient_ye_video_MjA1ZjY4YTQwOWNlMjA3Mzc4NzNhNGQ5NTg1NTRlY2Vi', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"270\" height=\"200\" src=\"http://www.youtube.com/embed/I3BxvHhz4XQ?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('504', '_transient_timeout_ye_video_MzRmZDI4YjdkNjE1OGI0OGU1OTdhMWEzYmRj', '1323383161', 'no');
INSERT INTO `wp_options` VALUES('505', '_transient_ye_video_MzRmZDI4YjdkNjE1OGI0OGU1OTdhMWEzYmRjYmFlZTg2', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"270\" height=\"200\" src=\"http://www.youtube.com/embed/h_FZMRZ1_Xg?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('510', '_transient_timeout_ye_video_MGRhZjg2ZTA0N2YzNDkyZjg4ZTk5MDg5NzQx', '1323383161', 'no');
INSERT INTO `wp_options` VALUES('511', '_transient_ye_video_MGRhZjg2ZTA0N2YzNDkyZjg4ZTk5MDg5NzQxNjAwZmFl', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"270\" height=\"200\" src=\"http://www.youtube.com/embed/UFSc3rrAYLQ?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('732', '_transient_ye_video_MGE3YjI3ZjdiNjVkMDU5YmI0OGJhNDk3OTc0NjZjNTI1', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/5LOcUkm8m9w?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('562', '_transient_timeout_ye_video_NGE2MWFiOTNjMTk2NWZmYzIwYzU1MDBiZmFi', '1323384353', 'no');
INSERT INTO `wp_options` VALUES('517', '_transient_timeout_ye_video_NWQ2M2FhZThiMWFkNTIyMjZjMTdlNDA1ZTVj', '1326512800', 'no');
INSERT INTO `wp_options` VALUES('518', '_transient_ye_video_NWQ2M2FhZThiMWFkNTIyMjZjMTdlNDA1ZTVjNmNiMjRk', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/nrfj4LM5qj8?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('523', '_transient_timeout_ye_video_YmRjNzhhNTU3NzBhMzZjZWRiN2Q2NDVkOGFh', '1323383214', 'no');
INSERT INTO `wp_options` VALUES('524', '_transient_ye_video_YmRjNzhhNTU3NzBhMzZjZWRiN2Q2NDVkOGFhNmRiMTdl', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"270\" height=\"200\" src=\"http://www.youtube.com/embed/ONytpf8Rihs?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('529', '_transient_timeout_ye_video_YTVjZTdkNzU1NjFlMzViMWRjMGZhZDRhNThh', '1323383214', 'no');
INSERT INTO `wp_options` VALUES('530', '_transient_ye_video_YTVjZTdkNzU1NjFlMzViMWRjMGZhZDRhNThhNmNjNTYy', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"270\" height=\"200\" src=\"http://www.youtube.com/embed/ztYRWoKGBnY?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('535', '_transient_timeout_ye_video_MTlkYzY4M2Y4NzQ3ZTg2ZDk5ZjNlZWQxMDBj', '1323383214', 'no');
INSERT INTO `wp_options` VALUES('536', '_transient_ye_video_MTlkYzY4M2Y4NzQ3ZTg2ZDk5ZjNlZWQxMDBjOGQxMTEy', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"270\" height=\"200\" src=\"http://www.youtube.com/embed/vWK6vWGeSMQ?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('541', '_transient_timeout_ye_video_ZTY2MWRiZjRlYzkxNGQ5ZmZkOTUyZGYxZDQ4', '1323383214', 'no');
INSERT INTO `wp_options` VALUES('542', '_transient_ye_video_ZTY2MWRiZjRlYzkxNGQ5ZmZkOTUyZGYxZDQ4OGNiMTMy', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"270\" height=\"200\" src=\"http://www.youtube.com/embed/i03mt72s5QU?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('544', '_transient_timeout_ye_video_NWQ1OTkxNWIwN2M4N2FkZWMwYjEwMTRlMmQ1', '1323383241', 'no');
INSERT INTO `wp_options` VALUES('545', '_transient_ye_video_NWQ1OTkxNWIwN2M4N2FkZWMwYjEwMTRlMmQ1NTQ1M2Nm', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"260\" height=\"200\" src=\"http://www.youtube.com/embed/ONytpf8Rihs?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('546', '_transient_timeout_ye_video_NjQwMWI3ZGFiYjRmZDRhNDM5ODI1NjM5NTdk', '1323383241', 'no');
INSERT INTO `wp_options` VALUES('547', '_transient_ye_video_NjQwMWI3ZGFiYjRmZDRhNDM5ODI1NjM5NTdkMmU2ZDky', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"260\" height=\"200\" src=\"http://www.youtube.com/embed/ztYRWoKGBnY?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('548', '_transient_timeout_ye_video_OTQxZjNjZjYzYmE3NmQxODI3NGE4ZjFkNjA2', '1323383241', 'no');
INSERT INTO `wp_options` VALUES('549', '_transient_ye_video_OTQxZjNjZjYzYmE3NmQxODI3NGE4ZjFkNjA2NmE2ODc4', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"260\" height=\"200\" src=\"http://www.youtube.com/embed/vWK6vWGeSMQ?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('550', '_transient_timeout_ye_video_NTAwYjhiMThiZmQ3Njc5MzM4YmVjMmY4ZTg2', '1323383241', 'no');
INSERT INTO `wp_options` VALUES('551', '_transient_ye_video_NTAwYjhiMThiZmQ3Njc5MzM4YmVjMmY4ZTg2YjVhMzM0', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"260\" height=\"200\" src=\"http://www.youtube.com/embed/i03mt72s5QU?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('553', '_transient_timeout_ye_video_NjVmYjczOGYyNmI0OWEwYjhkYjYzZDIxMWFl', '1323383282', 'no');
INSERT INTO `wp_options` VALUES('554', '_transient_ye_video_NjVmYjczOGYyNmI0OWEwYjhkYjYzZDIxMWFlYjU1NTJh', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"250\" height=\"200\" src=\"http://www.youtube.com/embed/ONytpf8Rihs?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('555', '_transient_timeout_ye_video_M2Q1ZDZlMzhhMGMyY2NhZmJhNDFmYjkyMTYw', '1323383282', 'no');
INSERT INTO `wp_options` VALUES('556', '_transient_ye_video_M2Q1ZDZlMzhhMGMyY2NhZmJhNDFmYjkyMTYwMzVlMzRk', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"250\" height=\"200\" src=\"http://www.youtube.com/embed/ztYRWoKGBnY?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('557', '_transient_timeout_ye_video_OTdmNGY4NTUyNzU0YzdlOTRkOGJjMWI3NTA4', '1323384354', 'no');
INSERT INTO `wp_options` VALUES('558', '_transient_ye_video_OTdmNGY4NTUyNzU0YzdlOTRkOGJjMWI3NTA4N2VmMGYw', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"250\" height=\"200\" src=\"http://www.youtube.com/embed/vWK6vWGeSMQ?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('559', '_transient_timeout_ye_video_NWM3M2RmMjdiZmZlMjZjYmQ0OGM5ZmM2ZmVk', '1323384354', 'no');
INSERT INTO `wp_options` VALUES('560', '_transient_ye_video_NWM3M2RmMjdiZmZlMjZjYmQ0OGM5ZmM2ZmVkZDBkNDAw', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"250\" height=\"200\" src=\"http://www.youtube.com/embed/i03mt72s5QU?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('563', '_transient_ye_video_NGE2MWFiOTNjMTk2NWZmYzIwYzU1MDBiZmFiN2JhOTBi', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"200\" height=\"200\" src=\"http://www.youtube.com/embed/ONytpf8Rihs?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('564', '_transient_timeout_ye_video_NTA0YjYzM2FkZGUzMjMyMjY2ZmZjNzBiZTU3', '1323384354', 'no');
INSERT INTO `wp_options` VALUES('565', '_transient_ye_video_NTA0YjYzM2FkZGUzMjMyMjY2ZmZjNzBiZTU3ZjkzMTdi', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"200\" height=\"200\" src=\"http://www.youtube.com/embed/ztYRWoKGBnY?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('570', '_transient_ye_video_ZDE0NTFiYmY3YzczOWViNTFlNTczMTRjOTg1ZTA4NjY5', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/ONytpf8Rihs?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('571', '_transient_timeout_ye_video_MWU2ODJkMTEzYWJlNjNmNWM3NjYzZjVlMzNm', '1326512801', 'no');
INSERT INTO `wp_options` VALUES('572', '_transient_ye_video_MWU2ODJkMTEzYWJlNjNmNWM3NjYzZjVlMzNmNmEzZDYw', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/ztYRWoKGBnY?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('573', '_transient_timeout_ye_video_ZDgxNWM4MDhmMzJlODk5NjFhMjc3ZDNjYjhm', '1326512801', 'no');
INSERT INTO `wp_options` VALUES('574', '_transient_ye_video_ZDgxNWM4MDhmMzJlODk5NjFhMjc3ZDNjYjhmYmYwNjI4', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/vWK6vWGeSMQ?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('575', '_transient_timeout_ye_video_OTgyODQyNmVjMmJmNDQwNTE2MTViMDhiZTU3', '1326512801', 'no');
INSERT INTO `wp_options` VALUES('576', '_transient_ye_video_OTgyODQyNmVjMmJmNDQwNTE2MTViMDhiZTU3MDlkYjEw', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/i03mt72s5QU?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('583', 'WPContentMagic_StopWords', 'a,about,above,across,after,again,against,all,almost,alone,along,already,also,although,always,among,an,and,another,any,anybody,anyone,anything,anywhere,are,area,areas,around,as,ask,asked,asking,asks,at,away,b,back,backed,backing,backs,be,became,because,become,becomes,been,before,began,behind,being,beings,best,better,between,big,both,but,by,c,came,can,cannot,case,cases,certain,certainly,clear,clearly,come,could,d,did,differ,different,differently,do,does,done,down,down,downed,downing,downs,during,e,each,early,either,end,ended,ending,ends,enough,even,evenly,ever,every,everybody,everyone,everything,everywhere,f,face,faces,fact,facts,far,felt,few,find,finds,first,for,four,from,full,fully,further,furthered,furthering,furthers,g,gave,general,generally,get,gets,give,given,gives,go,going,good,goods,got,great,greater,greatest,group,grouped,grouping,groups,h,had,has,have,having,he,her,here,herself,high,high,high,higher,highest,him,himself,his,how,however,i,if,important,in,interest,interested,interesting,interests,into,is,it,its,itself,j,just,k,keep,keeps,kind,knew,know,known,knows,l,large,largely,last,later,latest,least,less,let,lets,like,likely,long,longer,longest,m,made,make,making,man,many,may,me,member,members,men,might,more,most,mostly,mr,mrs,much,must,my,myself,n,necessary,need,needed,needing,needs,never,new,new,newer,newest,next,no,nobody,non,noone,not,nothing,now,nowhere,number,numbers,o,of,off,often,old,older,oldest,on,once,one,only,open,opened,opening,opens,or,order,ordered,ordering,orders,other,others,our,out,over,p,part,parted,parting,parts,per,perhaps,place,places,point,pointed,pointing,points,possible,present,presented,presenting,presents,problem,problems,put,puts,q,quite,r,rather,really,right,right,room,rooms,s,said,same,saw,say,says,second,seconds,see,seem,seemed,seeming,seems,sees,several,shall,she,should,show,showed,showing,shows,side,sides,since,small,smaller,smallest,so,some,somebody,someone,something,somewhere,state,states,still,still,such,sure,t,take,taken,than,that,the,their,them,then,there,therefore,these,they,thing,things,think,thinks,this,those,though,thought,thoughts,three,through,thus,to,today,together,too,took,toward,turn,turned,turning,turns,two,u,under,until,up,upon,us,use,used,uses,v,very,w,want,wanted,wanting,wants,was,way,ways,we,well,wells,went,were,what,when,where,whether,which,while,who,whole,whose,why,will,with,within,without,work,worked,working,works,would,x,y,year,years,yet,you,young,younger,youngest,your,yours,z', 'yes');
INSERT INTO `wp_options` VALUES('734', '_transient_timeout_ye_video_NGMwMGM3NjEwMzJiNThkZGU2OTQzNjRjZmQz', '1323465249', 'no');
INSERT INTO `wp_options` VALUES('4940', 'SWPA_PLUGIN_ENTRIES_LIVE_TRAFFIC', '1036', 'yes');
INSERT INTO `wp_options` VALUES('735', '_transient_ye_video_NGMwMGM3NjEwMzJiNThkZGU2OTQzNjRjZmQzYTg1NGY5', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"650\" height=\"390\" src=\"http://www.youtube.com/embed/5LOcUkm8m9w?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('772', '_transient_timeout_ye_video_YTkxZjRkMmRkNjYxNTRlNGFjYmIxMmM5MWNk', '1323465594', 'no');
INSERT INTO `wp_options` VALUES('773', '_transient_ye_video_YTkxZjRkMmRkNjYxNTRlNGFjYmIxMmM5MWNkOThlYmUw', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"650\" height=\"390\" src=\"http://www.youtube.com/embed/GRmDGvdkg8E?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('779', '_transient_timeout_ye_video_MjRkMjBlYTM4YTRkMDQ0MjZkZTY4MTRmYjc4', '1323925660', 'no');
INSERT INTO `wp_options` VALUES('780', '_transient_ye_video_MjRkMjBlYTM4YTRkMDQ0MjZkZTY4MTRmYjc4YjgyMjUy', '\n<!-- YouTube Embed v2.3.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe style=\"border: 0;\" class=\"youtube-player\" width=\"650\" height=\"390\" src=\"http://www.youtube.com/embed/2jYJV9zHy04?version=3&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;showinfo=1&amp;wmode=opaque\"></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3042', 'page_on_front', '0', 'yes');
INSERT INTO `wp_options` VALUES('1628', '_transient_timeout_ye_video_ZmE3ZWZjOGU4NTZiN2ZhY2E5MTBlMGY0OTMx', '1329414745', 'no');
INSERT INTO `wp_options` VALUES('1629', '_transient_ye_video_ZmE3ZWZjOGU4NTZiN2ZhY2E5MTBlMGY0OTMxN2QwNjg1', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/eIRmCGwurmE?version=3&amp;fs=0&amp;rel=0&amp;title=Healthy+Skin+Advice+%3A+Removing+Hanging+Warts%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('4941', 'cg_tvs_data', 'a:8:{s:21:\"script_latest_version\";s:6:\"2.8.11\";s:19:\"script_safe_version\";s:5:\"2.8.2\";s:18:\"last_version_check\";i:1402360349;s:16:\"script_instances\";a:2:{i:0;a:2:{s:4:\"path\";s:109:\"/home/scplrb10/public_html/restorevision/wp-content/plugins/obox-mobile/themes/default/functions/timthumb.php\";s:7:\"version\";s:6:\"2.8.11\";}i:1;a:2:{s:4:\"path\";s:97:\"/home/scplrb10/public_html/restorevision/wp-content/themes/headlines_enhanced/functions/thumb.php\";s:7:\"version\";s:6:\"2.8.11\";}}s:16:\"suspicious_files\";N;s:9:\"last_scan\";i:1384203159;s:10:\"scan_daily\";b:1;s:12:\"scan_summary\";a:3:{s:10:\"Vulnerable\";i:0;s:8:\"Outdated\";i:0;s:10:\"Up to Date\";i:2;}}', 'yes');
INSERT INTO `wp_options` VALUES('7633', '_transient_timeout_feed_mod_867bd5c64f85878d03a060509cd2f92c', '1402317128', 'no');
INSERT INTO `wp_options` VALUES('7634', '_transient_feed_mod_867bd5c64f85878d03a060509cd2f92c', '1402273928', 'no');
INSERT INTO `wp_options` VALUES('7635', '_transient_timeout_feed_b9388c83948825c1edaef0d856b7b109', '1402317128', 'no');
INSERT INTO `wp_options` VALUES('7636', '_transient_feed_b9388c83948825c1edaef0d856b7b109', 'a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n	\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:72:\"\n		\n		\n		\n		\n		\n		\n				\n\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n		\n\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:44:\"http://wordpress.org/plugins/browse/popular/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:39:\"WordPress Plugins » View: Most Popular\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 09 Jun 2014 00:24:59 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://bbpress.org/?v=1.1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:15:{i:0;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"WordPress SEO by Yoast\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://wordpress.org/plugins/wordpress-seo/#post-8321\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 Jan 2009 20:34:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"8321@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:131:\"Improve your WordPress SEO: Write better content and have a fully optimized WordPress site using the WordPress SEO plugin by Yoast.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Joost de Valk\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"Google XML Sitemaps\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.org/plugins/google-sitemap-generator/#post-132\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:31:32 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"132@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"This plugin will generate a special XML sitemap which will help search engines to better index your blog.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"arnee\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Contact Form 7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"http://wordpress.org/plugins/contact-form-7/#post-2141\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 02 Aug 2007 12:45:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"2141@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"Just another contact form plugin. Simple but flexible.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"Takayuki Miyoshi\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:19:\"All in One SEO Pack\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://wordpress.org/plugins/all-in-one-seo-pack/#post-753\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 30 Mar 2007 20:08:18 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"753@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:126:\"All in One SEO Pack is a WordPress SEO plugin to automatically optimize your WordPress blog for Search Engines such as Google.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"uberdose\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:24:\"Jetpack by WordPress.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://wordpress.org/plugins/jetpack/#post-23862\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Jan 2011 02:21:38 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"23862@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"Supercharge your WordPress site with powerful features previously only available to WordPress.com users.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Tim Moore\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Akismet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/plugins/akismet/#post-15\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 09 Mar 2007 22:11:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"15@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"Akismet checks your comments against the Akismet web service to see if they look like spam or not.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WooCommerce - excelling eCommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"http://wordpress.org/plugins/woocommerce/#post-29860\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 05 Sep 2011 08:13:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29860@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"WooCommerce is a powerful, extendable eCommerce plugin that helps you sell anything. Beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"WooThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"MailPoet Newsletters\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/wysija-newsletters/#post-32629\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 02 Dec 2011 17:09:16 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"32629@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"Send newsletters, post notifications or autoresponders from WordPress easily, and beautifully.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"MailPoet Staff\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"Wordfence Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/plugins/wordfence/#post-29832\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 04 Sep 2011 03:13:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"29832@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:137:\"Wordfence Security is a free enterprise class security and performance plugin that makes your site up to 50 times faster and more secure.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Wordfence\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"WordPress Importer\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/wordpress-importer/#post-18101\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 May 2010 17:42:45 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"18101@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"Import posts, pages, comments, custom fields, categories, tags and more from a WordPress export file.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Brian Colinger\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"WPtouch Mobile Plugin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"http://wordpress.org/plugins/wptouch/#post-5468\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 01 May 2008 04:58:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"5468@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"Create a slick mobile WordPress website with just a few clicks.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:17:\"BraveNewCode Inc.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:15:\"NextGEN Gallery\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/plugins/nextgen-gallery/#post-1169\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 23 Apr 2007 20:08:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"1169@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:121:\"The most popular WordPress gallery plugin and one of the most popular plugins of all time with over 10 million downloads.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:9:\"Alex Rabe\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:46:\"iThemes Security (formerly Better WP Security)\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/plugins/better-wp-security/#post-21738\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 22 Oct 2010 22:06:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"21738@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"The easiest, most effective way to secure WordPress in seconds.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Chris Wiegman\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"Google Analytics Dashboard for WP\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"http://wordpress.org/plugins/google-analytics-dashboard-for-wp/#post-50539\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 10 Mar 2013 17:07:11 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"50539@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"Displays Google Analytics Reports and Real-Time Statistics in your Dashboard. Automatically inserts the tracking code in every page of your website.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:10:\"Alin Marcu\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:30:\"\n			\n			\n			\n			\n			\n			\n					\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"Disqus Comment System\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"http://wordpress.org/plugins/disqus-comment-system/#post-6808\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 28 Aug 2008 01:22:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:34:\"6808@http://wordpress.org/plugins/\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:113:\"The Disqus comment system replaces your WordPress comment system with your comments hosted and powered by Disqus.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Disqus\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:45:\"http://wordpress.org/plugins/rss/view/popular\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:7:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Mon, 09 Jun 2014 00:32:08 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Thu, 01 Jan 2009 20:34:44 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20131111204433\";}', 'no');
INSERT INTO `wp_options` VALUES('7637', '_transient_timeout_feed_mod_b9388c83948825c1edaef0d856b7b109', '1402317128', 'no');
INSERT INTO `wp_options` VALUES('7638', '_transient_feed_mod_b9388c83948825c1edaef0d856b7b109', '1402273928', 'no');
INSERT INTO `wp_options` VALUES('7639', '_transient_timeout_plugin_slugs', '1402445983', 'no');
INSERT INTO `wp_options` VALUES('7640', '_transient_plugin_slugs', 'a:26:{i:0;s:26:\"secure-wordpress/index.php\";i:1;s:35:\"ad-codez-widget/ad-codes-widget.php\";i:2;s:39:\"ad-squares-widget/ad-squares-widget.php\";i:3;s:43:\"all-in-one-seo-pack/all_in_one_seo_pack.php\";i:4;s:27:\"backupbuddy/backupbuddy.php\";i:5;s:39:\"bad-behavior/bad-behavior-wordpress.php\";i:6;s:36:\"contact-form-7/wp-contact-form-7.php\";i:7;s:46:\"custom-post-template/custom-post-templates.php\";i:8;s:39:\"sitemap-generator/sitemap-generator.php\";i:9;s:23:\"digg-digg/digg-digg.php\";i:10;s:43:\"easy-privacy-policy/easy-privacy-policy.php\";i:11;s:36:\"google-sitemap-generator/sitemap.php\";i:12;s:9:\"hello.php\";i:13;s:32:\"login-lockdown/loginlockdown.php\";i:14;s:22:\"obox-mobile/mobile.php\";i:15;s:27:\"pretty-link/pretty-link.php\";i:16;s:31:\"quick-adsense/quick-adsense.php\";i:17;s:35:\"simply-show-ids/simply-show-ids.php\";i:18;s:23:\"slideshow/slideshow.php\";i:19;s:30:\"smart-youtube/smartyoutube.php\";i:20;s:25:\"sucuri-scanner/sucuri.php\";i:21;s:65:\"timthumb-vulnerability-scanner/timthumb-vulnerability-scanner.php\";i:22;s:31:\"youtube-embed/youtube-embed.php\";i:23;s:25:\"wp-cumulus/wp-cumulus.php\";i:24;s:27:\"wp-pagenavi/wp-pagenavi.php\";i:25;s:49:\"wp-graphix-magic-light/wp-graphix-magic-light.php\";}', 'no');
INSERT INTO `wp_options` VALUES('7641', '_transient_timeout_dash_4077549d03da2e451c8b5f002294ff51', '1402317128', 'no');
INSERT INTO `wp_options` VALUES('7642', '_transient_dash_4077549d03da2e451c8b5f002294ff51', '<div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wordpress.org/news/2014/05/wordpress-3-9-1/\' title=\'After three weeks and more than 9 million downloads of WordPress 3.9, we’re pleased to announce that WordPress 3.9.1 is now available. This maintenance release fixes 34 bugs in 3.9, including numerous fixes for multisite networks, customizing widgets while previewing themes, and the updated visual editor. We’ve also made some improvements to the new audio/video […]\'>WordPress 3.9.1 Maintenance Release</a> <span class=\"rss-date\">May 8, 2014</span><div class=\'rssSummary\'>After three weeks and more than 9 million downloads of WordPress 3.9, we’re pleased to announce that WordPress 3.9.1 is now available. This maintenance release fixes 34 bugs in 3.9, including numerous fixes for multisite networks, customizing widgets while previewing themes, and the updated visual editor. We’ve also made some improvements to the new audio/vi [&hellip;]</div></li></ul></div><div class=\"rss-widget\"><ul><li><a class=\'rsswidget\' href=\'http://wordpress.tv/2014/06/08/eric-mann-ten-lessons-on-customer-centric-development/\' title=\'    \'>WordPress.tv: Eric Mann: Ten Lessons on Customer-centric Development</a></li><li><a class=\'rsswidget\' href=\'http://wordpress.tv/2014/06/08/clinton-warren-an-accidental-career-in-wordpress/\' title=\'    \'>WordPress.tv: Clinton Warren: An Accidental Career In WordPress</a></li><li><a class=\'rsswidget\' href=\'http://wordpress.tv/2014/06/08/helen-hou-sandi-how-i-convinced-my-boss-to-let-me-work-on-wordpress-full-time/\' title=\'    \'>WordPress.tv: Helen Hou-Sandi: How I Convinced My Boss to Let Me Work on WordPress Full-time</a></li></ul></div><div class=\"rss-widget\"><ul><li class=\'dashboard-news-plugin\'><span>Popular Plugin:</span> <a href=\'http://wordpress.org/plugins/google-analytics-dashboard-for-wp/\' class=\'dashboard-news-plugin-link\'>Google Analytics Dashboard for WP</a></h5>&nbsp;<span>(<a href=\'plugin-install.php?tab=plugin-information&amp;plugin=google-analytics-dashboard-for-wp&amp;_wpnonce=b3300fe74a&amp;TB_iframe=true&amp;width=600&amp;height=800\' class=\'thickbox\' title=\'Google Analytics Dashboard for WP\'>Install</a>)</span></li></ul></div>', 'no');
INSERT INTO `wp_options` VALUES('1634', '_transient_timeout_ye_video_M2YwNTRjY2YzNjg5NzRhYWY2ODgzOGUwYzE2', '1329414745', 'no');
INSERT INTO `wp_options` VALUES('1635', '_transient_ye_video_M2YwNTRjY2YzNjg5NzRhYWY2ODgzOGUwYzE2YmM2NzI0', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/im5RzdwrhcU?version=3&amp;fs=0&amp;rel=0&amp;title=Healthy+Skin+Advice+%3A+Removing+Warts+at+Home%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3043', 'uninstall_plugins', 'a:3:{i:0;b:0;s:27:\"wp-pagenavi/wp-pagenavi.php\";s:14:\"__return_false\";s:26:\"secure-wordpress/index.php\";a:2:{i:0;s:10:\"SwpaPlugin\";i:1;s:9:\"uninstall\";}}', 'no');
INSERT INTO `wp_options` VALUES('4937', 'WSD-PLUGIN-CAN-RUN-TASKS', '1', 'yes');
INSERT INTO `wp_options` VALUES('4938', 'wsdplugin_settings', 'a:15:{s:17:\"fix_hideWpVersion\";a:3:{s:4:\"name\";s:17:\"fix_hideWpVersion\";s:5:\"value\";i:0;s:4:\"desc\";s:55:\"Hide WordPress version for all users but administrators\";}s:34:\"fix_removeWpMetaGeneratorsFrontend\";a:3:{s:4:\"name\";s:34:\"fix_removeWpMetaGeneratorsFrontend\";s:5:\"value\";i:0;s:4:\"desc\";s:84:\"Remove various meta tags generators from the blog\'s head tag for non-administrators.\";}s:31:\"fix_removeReallySimpleDiscovery\";a:3:{s:4:\"name\";s:31:\"fix_removeReallySimpleDiscovery\";s:5:\"value\";i:0;s:4:\"desc\";s:55:\"Remove Really Simple Discovery meta tags from front-end\";}s:27:\"fix_removeWindowsLiveWriter\";a:3:{s:4:\"name\";s:27:\"fix_removeWindowsLiveWriter\";s:5:\"value\";i:0;s:4:\"desc\";s:51:\"Remove Windows Live Writer meta tags from front-end\";}s:25:\"fix_disableErrorReporting\";a:3:{s:4:\"name\";s:25:\"fix_disableErrorReporting\";s:5:\"value\";i:0;s:4:\"desc\";s:61:\"Disable error reporting (php + db) for all but administrators\";}s:32:\"fix_removeCoreUpdateNotification\";a:3:{s:4:\"name\";s:32:\"fix_removeCoreUpdateNotification\";s:5:\"value\";i:0;s:4:\"desc\";s:73:\"Remove core update notifications from back-end for all but administrators\";}s:35:\"fix_removePluginUpdateNotifications\";a:3:{s:4:\"name\";s:35:\"fix_removePluginUpdateNotifications\";s:5:\"value\";i:0;s:4:\"desc\";s:50:\"Remove plug-ins update notifications from back-end\";}s:34:\"fix_removeThemeUpdateNotifications\";a:3:{s:4:\"name\";s:34:\"fix_removeThemeUpdateNotifications\";s:5:\"value\";i:0;s:4:\"desc\";s:48:\"Remove themes update notifications from back-end\";}s:41:\"fix_removeLoginErrorNotificationsFrontEnd\";a:3:{s:4:\"name\";s:41:\"fix_removeLoginErrorNotificationsFrontEnd\";s:5:\"value\";i:0;s:4:\"desc\";s:47:\"Remove login error notifications from front-end\";}s:26:\"fix_hideAdminNotifications\";a:3:{s:4:\"name\";s:26:\"fix_hideAdminNotifications\";s:5:\"value\";i:0;s:4:\"desc\";s:40:\"Hide admin notifications for non admins.\";}s:27:\"fix_preventDirectoryListing\";a:3:{s:4:\"name\";s:27:\"fix_preventDirectoryListing\";s:5:\"value\";i:0;s:4:\"desc\";s:153:\"Try to create the index.php file in the wp-content, wp-content/plugins, wp-content/themes and wp-content/uploads directories to prevent directory listing\";}s:28:\"fix_removeWpVersionFromLinks\";a:3:{s:4:\"name\";s:28:\"fix_removeWpVersionFromLinks\";s:5:\"value\";i:0;s:4:\"desc\";s:38:\"Remove the version parameter from urls\";}s:27:\"fix_emptyReadmeFileFromRoot\";a:3:{s:4:\"name\";s:27:\"fix_emptyReadmeFileFromRoot\";s:5:\"value\";i:0;s:4:\"desc\";s:66:\"Empty the content of the readme.html file from the root directory.\";}s:25:\"keepNumEntriesLiveTraffic\";i:500;s:26:\"liveTrafficRefreshRateAjax\";i:10;}', 'yes');
INSERT INTO `wp_options` VALUES('1640', '_transient_timeout_ye_video_MTIxYWIwZDQ4ZmYzNDRlYmI5YmZlOGQ0YjU2', '1329414745', 'no');
INSERT INTO `wp_options` VALUES('1641', '_transient_ye_video_MTIxYWIwZDQ4ZmYzNDRlYmI5YmZlOGQ0YjU2ZjY1MDFm', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/xsNOZdwWk5Q?version=3&amp;fs=0&amp;rel=0&amp;title=Healthy+Skin+Advice+%3A+Removing+Plantar+Warts%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1646', '_transient_timeout_ye_video_ZTZmNDg1NmJlYmQxY2MzOWViZjgxNDQyN2Iw', '1329414745', 'no');
INSERT INTO `wp_options` VALUES('1647', '_transient_ye_video_ZTZmNDg1NmJlYmQxY2MzOWViZjgxNDQyN2IwNDFiODNh', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/g1g3DzM7rz8?version=3&amp;fs=0&amp;rel=0&amp;title=How+to+Remove+a+Plantar+Wart+from+Foot+Procedure%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1652', '_transient_timeout_ye_video_YTUyMWNiZjI1N2Y1NGMyYmM1MjI1MTJiMDA2', '1329414745', 'no');
INSERT INTO `wp_options` VALUES('1653', '_transient_ye_video_YTUyMWNiZjI1N2Y1NGMyYmM1MjI1MTJiMDA2NDkyZmIz', '\n<!-- YouTube Embed v2.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/HiooHVe2Cdw?version=3&amp;fs=0&amp;rel=0&amp;title=wart+Remove+without+pain+-+only+apple+cider+vinegar%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('2023', '_transient_timeout_ye_video_MmMyMDQ4NDRmN2M2N2Q0ZDhkZGQxZWIwMThh', '1339675685', 'no');
INSERT INTO `wp_options` VALUES('1738', '_transient_timeout_ye_video_OTIzNjJiZjQzNDZjNmE5Yzg2MjdiNDQxZjgx', '1335248676', 'no');
INSERT INTO `wp_options` VALUES('1739', '_transient_ye_video_OTIzNjJiZjQzNDZjNmE5Yzg2MjdiNDQxZjgxMmZjZjMw', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/im5RzdwrhcU?version=3&amp;fs=0&amp;rel=0&amp;title=Healthy+Skin+Advice+%3A+Removing+Warts+at+Home%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1744', '_transient_timeout_ye_video_MWVlMGI5MjQ3YjRiNzQxODRmYWJkMzYwYTAz', '1335248676', 'no');
INSERT INTO `wp_options` VALUES('1745', '_transient_ye_video_MWVlMGI5MjQ3YjRiNzQxODRmYWJkMzYwYTAzNmE1NzIw', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/xsNOZdwWk5Q?version=3&amp;fs=0&amp;rel=0&amp;title=Healthy+Skin+Advice+%3A+Removing+Plantar+Warts%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1750', '_transient_timeout_ye_video_MzFmMWQ3M2QwMTliNmNjMmUwMjg3NzlhOTc2', '1335248676', 'no');
INSERT INTO `wp_options` VALUES('1751', '_transient_ye_video_MzFmMWQ3M2QwMTliNmNjMmUwMjg3NzlhOTc2MTllZWJj', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/g1g3DzM7rz8?version=3&amp;fs=0&amp;rel=0&amp;title=How+to+Remove+a+Plantar+Wart+from+Foot+Procedure%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1756', '_transient_timeout_ye_video_NjVlOTE4NTJlNjczODM1MzNhYTlhMGU0Y2Fh', '1335248676', 'no');
INSERT INTO `wp_options` VALUES('1757', '_transient_ye_video_NjVlOTE4NTJlNjczODM1MzNhYTlhMGU0Y2FhYmI3NDRk', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/HiooHVe2Cdw?version=3&amp;fs=0&amp;rel=0&amp;title=wart+Remove+without+pain+-+only+apple+cider+vinegar%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('1774', 'pagenavi_options', 'a:15:{s:10:\"pages_text\";s:36:\"Page %CURRENT_PAGE% of %TOTAL_PAGES%\";s:12:\"current_text\";s:13:\"%PAGE_NUMBER%\";s:9:\"page_text\";s:13:\"%PAGE_NUMBER%\";s:10:\"first_text\";s:13:\"&laquo; First\";s:9:\"last_text\";s:12:\"Last &raquo;\";s:9:\"prev_text\";s:7:\"&laquo;\";s:9:\"next_text\";s:7:\"&raquo;\";s:12:\"dotleft_text\";s:3:\"...\";s:13:\"dotright_text\";s:3:\"...\";s:9:\"num_pages\";i:5;s:23:\"num_larger_page_numbers\";i:3;s:28:\"larger_page_numbers_multiple\";i:10;s:11:\"always_show\";b:0;s:16:\"use_pagenavi_css\";b:1;s:5:\"style\";i:1;}', 'yes');
INSERT INTO `wp_options` VALUES('1789', 'woo_show_number_results', 'false', 'yes');
INSERT INTO `wp_options` VALUES('1816', 'dd_global_config', 'a:6:{s:24:\"dd_global_twitter_option\";a:1:{s:31:\"dd_global_twitter_option_source\";s:0:\"\";}s:23:\"dd_global_buffer_option\";a:1:{s:30:\"dd_global_buffer_option_source\";s:0:\"\";}s:26:\"dd_global_tweetmeme_option\";a:3:{s:33:\"dd_global_tweetmeme_option_source\";s:0:\"\";s:34:\"dd_global_tweetmeme_option_service\";s:0:\"\";s:38:\"dd_global_tweetmeme_option_service_api\";s:0:\"\";}s:22:\"dd_global_topsy_option\";a:2:{s:29:\"dd_global_topsy_option_source\";s:0:\"\";s:28:\"dd_global_topsy_option_theme\";s:4:\"blue\";}s:25:\"dd_global_facebook_option\";a:5:{s:32:\"dd_global_facebook_option_locale\";s:5:\"en_US\";s:30:\"dd_global_facebook_option_send\";s:0:\"\";s:30:\"dd_global_facebook_option_face\";s:0:\"\";s:31:\"dd_global_facebook_option_thumb\";s:10:\"checked=on\";s:39:\"dd_global_facebook_option_default_thumb\";s:0:\"\";}s:23:\"dd_global_flattr_option\";a:1:{s:27:\"dd_global_flattr_option_uid\";s:0:\"\";}}', 'yes');
INSERT INTO `wp_options` VALUES('1817', 'dd_normal_display_config', 'a:5:{s:14:\"display_option\";a:6:{s:19:\"display_option_home\";s:0:\"\";s:19:\"display_option_post\";s:2:\"on\";s:19:\"display_option_page\";s:0:\"\";s:18:\"display_option_cat\";s:0:\"\";s:18:\"display_option_tag\";s:0:\"\";s:22:\"display_option_archive\";s:0:\"\";}s:15:\"category_option\";a:3:{s:21:\"category_option_radio\";s:29:\"category_option_radio_include\";s:23:\"category_option_include\";s:3:\"All\";s:23:\"category_option_exclude\";s:4:\"None\";}s:10:\"dd_line_up\";a:1:{s:17:\"dd_line_up_select\";s:10:\"Horizontal\";}s:16:\"dd_status_option\";a:1:{s:24:\"dd_status_option_display\";s:2:\"on\";}s:16:\"dd_excerp_option\";a:1:{s:24:\"dd_excerp_option_display\";s:2:\"on\";}}', 'yes');
INSERT INTO `wp_options` VALUES('1818', 'dd_normal_button', 'a:2:{s:24:\"dd_normal_button_display\";a:24:{s:14:\"dd_button_digg\";O:7:\"DD_Digg\":30:{s:12:\"buttonLayout\";a:4:{s:4:\"Wide\";s:8:\"DiggWide\";s:6:\"Normal\";s:10:\"DiggMedium\";s:7:\"Compact\";s:11:\"DiggCompact\";s:4:\"Icon\";s:8:\"DiggIcon\";}s:16:\"buttonLayoutLazy\";a:4:{s:4:\"Wide\";s:8:\"DiggWide\";s:6:\"Normal\";s:10:\"DiggMedium\";s:7:\"Compact\";s:11:\"DiggCompact\";s:4:\"Icon\";s:8:\"DiggIcon\";}s:4:\"name\";s:4:\"Digg\";s:10:\"websiteURL\";s:19:\"http://www.digg.com\";s:6:\"apiURL\";s:44:\"http://about.digg.com/downloads/button/smart\";s:7:\"baseURL\";s:383:\"<script type=\'text/javascript\'>(function() {var s = document.createElement(\'SCRIPT\'), s1 = document.getElementsByTagName(\'SCRIPT\')[0];s.type = \'text/javascript\';s.async = true;s.src = \'http://widgets.digg.com/buttons.js\';s1.parentNode.insertBefore(s, s1);})();</script> <a class=\'DiggThisButton VOTE_BUTTON_DESIGN\' href=\'http://digg.com/submit?url=VOTE_URL&amp;title=VOTE_TITLE\'></a>\";s:12:\"baseURL_lazy\";s:123:\"<div class=\'dd-digg-ajax-load dd-digg-POST_ID\'></div><a class=\'DiggThisButton DD_DIGG_AJAX_POST_ID VOTE_BUTTON_DESIGN\'></a>\";s:19:\"baseURL_lazy_script\";s:253:\" function loadDigg_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-digg-POST_ID\').remove();$(\'.DD_DIGG_AJAX_POST_ID\').attr(\'href\',\'http://digg.com/submit?url=VOTE_URL&amp;title=VOTE_TITLE\');$.getScript(\'http://widgets.digg.com/buttons.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:56:\"window.setTimeout(\'loadDigg_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:18:\"dd_digg_appendType\";s:4:\"none\";s:20:\"dd_digg_buttonDesign\";s:6:\"Normal\";s:23:\"dd_digg_ajax_left_float\";s:0:\"\";s:17:\"dd_digg_lazy_load\";s:0:\"\";s:21:\"dd_digg_button_weight\";s:2:\"95\";}s:18:\"option_append_type\";s:18:\"dd_digg_appendType\";s:20:\"option_button_design\";s:20:\"dd_digg_buttonDesign\";s:20:\"option_button_weight\";s:21:\"dd_digg_button_weight\";s:22:\"option_ajax_left_float\";s:23:\"dd_digg_ajax_left_float\";s:16:\"option_lazy_load\";s:17:\"dd_digg_lazy_load\";s:19:\"button_weight_value\";s:2:\"95\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:16:\"dd_button_reddit\";O:9:\"DD_Reddit\":31:{s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:21:\"button2.html?width=51\";s:7:\"Compact\";s:22:\"button1.html?width=120\";s:4:\"Icon\";s:21:\"button3.html?width=69\";}s:16:\"buttonLayoutLazy\";a:3:{s:6:\"Normal\";s:21:\"button2.html?width=51\";s:7:\"Compact\";s:22:\"button1.html?width=120\";s:4:\"Icon\";s:21:\"button3.html?width=69\";}s:21:\"buttonLayoutLazyWidth\";a:3:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";s:4:\"Icon\";s:2:\"69\";}s:22:\"buttonLayoutLazyHeight\";a:3:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";s:4:\"Icon\";s:2:\"52\";}s:23:\"buttonLayoutWidthHeight\";a:3:{s:6:\"Normal\";s:22:\"height=\"69\" width=\"51\"\";s:7:\"Compact\";s:23:\"height=\"22\" width=\"120\"\";s:4:\"Icon\";s:22:\"height=\"52\" width=\"69\"\";}s:4:\"name\";s:6:\"Reddit\";s:10:\"websiteURL\";s:21:\"http://www.reddit.com\";s:6:\"apiURL\";s:30:\"http://www.reddit.com/buttons/\";s:7:\"baseURL\";s:165:\"<iframe src=\"http://www.reddit.com/static/button/VOTE_BUTTON_DESIGN&url=VOTE_URL&title=VOTE_TITLE&newwindow=\'1\'\" EXTRA_VALUE scrolling=\'no\' frameborder=\'0\'></iframe>\";s:12:\"baseURL_lazy\";s:164:\"<div class=\'dd-reddit-ajax-load dd-reddit-POST_ID\'></div><iframe class=\'DD_REDDIT_AJAX_POST_ID\' src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\'></iframe>\";s:19:\"baseURL_lazy_script\";s:400:\" function loadReddit_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-reddit-POST_ID\').remove();$(\'.DD_REDDIT_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_REDDIT_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_REDDIT_AJAX_POST_ID\').attr(\'src\',\'http://www.reddit.com/static/button/VOTE_BUTTON_DESIGN&url=VOTE_URL&title=VOTE_TITLE&newwindow=1\'); }); }\";s:21:\"scheduler_lazy_script\";s:58:\"window.setTimeout(\'loadReddit_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:20:\"dd_reddit_appendType\";s:4:\"none\";s:22:\"dd_reddit_buttonDesign\";s:6:\"Normal\";s:25:\"dd_reddit_ajax_left_float\";s:0:\"\";s:19:\"dd_reddit_lazy_load\";s:0:\"\";s:23:\"dd_reddit_button_weight\";s:2:\"99\";}s:18:\"option_append_type\";s:20:\"dd_reddit_appendType\";s:20:\"option_button_design\";s:22:\"dd_reddit_buttonDesign\";s:20:\"option_button_weight\";s:23:\"dd_reddit_button_weight\";s:22:\"option_ajax_left_float\";s:25:\"dd_reddit_ajax_left_float\";s:16:\"option_lazy_load\";s:19:\"dd_reddit_lazy_load\";s:19:\"button_weight_value\";s:2:\"99\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:15:\"dd_button_gbuzz\";O:8:\"DD_GBuzz\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:12:\"normal-count\";s:7:\"Compact\";s:11:\"small-count\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:12:\"normal-count\";s:7:\"Compact\";s:11:\"small-count\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:11:\"Google Buzz\";s:10:\"websiteURL\";s:26:\"http://www.google.com/buzz\";s:6:\"apiURL\";s:53:\"http://www.google.com/buzz/api/admin/configPostWidget\";s:7:\"baseURL\";s:247:\"<a title=\'Post on Google Buzz\' class=\'google-buzz-button\' href=\'http://www.google.com/buzz/post\' data-button-style=\'VOTE_BUTTON_DESIGN\' data-url=\'VOTE_URL\'></a><script type=\'text/javascript\' src=\'http://www.google.com/buzz/api/button.js\'></script>\";s:12:\"baseURL_lazy\";s:215:\"<div class=\'dd-gbuzz-ajax-load dd-gbuzz-POST_ID\'></div><a title=\'Post on Google Buzz\' class=\'google-buzz-button\' href=\'http://www.google.com/buzz/post\' data-button-style=\'VOTE_BUTTON_DESIGN\' data-url=\'VOTE_URL\'></a>\";s:19:\"baseURL_lazy_script\";s:162:\" function loadGBuzz_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-gbuzz-POST_ID\').remove();$.getScript(\'http://www.google.com/buzz/api/button.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:57:\"window.setTimeout(\'loadGBuzz_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:19:\"dd_gbuzz_appendType\";s:4:\"none\";s:21:\"dd_gbuzz_buttonDesign\";s:6:\"Normal\";s:24:\"dd_gbuzz_ajax_left_float\";s:0:\"\";s:18:\"dd_gbuzz_lazy_load\";s:0:\"\";s:22:\"dd_gbuzz_button_weight\";s:2:\"98\";}s:18:\"option_append_type\";s:19:\"dd_gbuzz_appendType\";s:20:\"option_button_design\";s:21:\"dd_gbuzz_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_gbuzz_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_gbuzz_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_gbuzz_lazy_load\";s:19:\"button_weight_value\";s:2:\"98\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:15:\"dd_button_dzone\";O:8:\"DD_DZone\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:25:\"1\' height=\'70\' width=\'50\'\";s:7:\"Compact\";s:26:\"2\' height=\'25\' width=\'155\'\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:1:\"1\";s:7:\"Compact\";s:1:\"2\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"50\";s:7:\"Compact\";s:3:\"155\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"70\";s:7:\"Compact\";s:2:\"25\";}s:4:\"name\";s:5:\"DZone\";s:10:\"websiteURL\";s:20:\"http://www.dzone.com\";s:6:\"apiURL\";s:38:\"http://www.dzone.com/links/buttons.jsp\";s:7:\"baseURL\";s:163:\"<iframe src=\'http://widgets.dzone.com/links/widgets/zoneit.html?url=VOTE_URL&amp;title=VOTE_TITLE&amp;t=VOTE_BUTTON_DESIGN frameborder=\'0\' scrolling=\'no\'></iframe>\";s:12:\"baseURL_lazy\";s:161:\"<div class=\'dd-dzone-ajax-load dd-dzone-POST_ID\'></div><iframe class=\'DD_DZONE_AJAX_POST_ID\' src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\'></iframe>\";s:19:\"baseURL_lazy_script\";s:400:\" function loadDzone_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-dzone-POST_ID\').remove();$(\'.DD_DZONE_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_DZONE_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_DZONE_AJAX_POST_ID\').attr(\'src\',\'http://widgets.dzone.com/links/widgets/zoneit.html?url=VOTE_URL&title=VOTE_TITLE&t=VOTE_BUTTON_DESIGN\'); }); }\";s:21:\"scheduler_lazy_script\";s:57:\"window.setTimeout(\'loadDzone_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:19:\"dd_dzone_appendType\";s:4:\"none\";s:21:\"dd_dzone_buttonDesign\";s:6:\"Normal\";s:24:\"dd_dzone_ajax_left_float\";s:0:\"\";s:18:\"dd_dzone_lazy_load\";s:0:\"\";s:22:\"dd_dzone_button_weight\";s:2:\"97\";}s:18:\"option_append_type\";s:19:\"dd_dzone_appendType\";s:20:\"option_button_design\";s:21:\"dd_dzone_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_dzone_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_dzone_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_dzone_lazy_load\";s:19:\"button_weight_value\";s:2:\"97\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:17:\"dd_button_fbshare\";O:10:\"DD_FbShare\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:9:\"box_count\";s:7:\"Compact\";s:12:\"button_count\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:9:\"box_count\";s:7:\"Compact\";s:12:\"button_count\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:14:\"Facebook Share\";s:10:\"websiteURL\";s:23:\"http://www.facebook.com\";s:6:\"apiURL\";s:30:\"http://www.facebook.com/share/\";s:7:\"baseURL\";s:209:\"<a name=\'fb_share\' type=\'VOTE_BUTTON_DESIGN\' share_url=\'VOTE_URL\' href=\'http://www.facebook.com/sharer.php\'></a><script src=\'http://static.ak.fbcdn.net/connect.php/js/FB.Share\' type=\'text/javascript\'></script>\";s:12:\"baseURL_lazy\";s:203:\"<div class=\'dd-fbshare-ajax-load dd-fbshare-POST_ID\'></div><a class=\'DD_FBSHARE_AJAX_POST_ID\' name=\'fb_share\' type=\'VOTE_BUTTON_DESIGN\' share_url=\'VOTE_URL\' href=\'http://www.facebook.com/sharer.php\'></a>\";s:19:\"baseURL_lazy_script\";s:177:\" function loadFBShare_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-fbshare-POST_ID\').remove(); $.getScript(\'http://static.ak.fbcdn.net/connect.php/js/FB.Share\'); }); }\";s:21:\"scheduler_lazy_script\";s:59:\"window.setTimeout(\'loadFBShare_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:21:\"dd_fbshare_appendType\";s:4:\"none\";s:23:\"dd_fbshare_buttonDesign\";s:7:\"Compact\";s:26:\"dd_fbshare_ajax_left_float\";s:0:\"\";s:20:\"dd_fbshare_lazy_load\";s:0:\"\";s:24:\"dd_fbshare_button_weight\";s:2:\"95\";}s:18:\"option_append_type\";s:21:\"dd_fbshare_appendType\";s:20:\"option_button_design\";s:23:\"dd_fbshare_buttonDesign\";s:20:\"option_button_weight\";s:24:\"dd_fbshare_button_weight\";s:22:\"option_ajax_left_float\";s:26:\"dd_fbshare_ajax_left_float\";s:16:\"option_lazy_load\";s:20:\"dd_fbshare_lazy_load\";s:19:\"button_weight_value\";s:2:\"95\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_delicious\";O:12:\"DD_Delicious\":30:{s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:25:\"dd_delicious_normal_image\";s:7:\"Compact\";s:26:\"dd_delicious_compact_image\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:25:\"dd_delicious_normal_image\";s:7:\"Compact\";s:26:\"dd_delicious_compact_image\";}s:4:\"name\";s:9:\"Delicious\";s:10:\"websiteURL\";s:24:\"http://www.delicious.com\";s:6:\"apiURL\";s:35:\"http://www.delicious.com/help/feeds\";s:7:\"baseURL\";s:436:\"<div class=\'VOTE_BUTTON_DESIGN dd_delicious\'><a class=\'VOTE_BUTTON_DESIGN\' href=\'http://delicious.com/save\' onclick=\"window.open(\'http://delicious.com/save?v=5&amp;noui&amp;jump=close&amp;url=\'+encodeURIComponent(\'VOTE_URL\')+\'&amp;title=\'+encodeURIComponent(\'VOTE_TITLE\'),\'delicious\', \'toolbar=no,width=550,height=550\'); return false;\"><span id=\'DD_DELICIOUS_AJAX_POST_ID\'><div style=\'padding-top:3px\'>SAVED_COUNT</div></span></a></div>\";s:12:\"baseURL_lazy\";s:374:\"<div class=\'VOTE_BUTTON_DESIGN dd_delicious\'><a href=\'http://delicious.com/save\' onclick=\"window.open(\'http://delicious.com/save?v=5&amp;noui&amp;jump=close&amp;url=\'+encodeURIComponent(\'VOTE_URL\')+\'&amp;title=\'+encodeURIComponent(\'VOTE_TITLE\'),\'delicious\', \'toolbar=no,width=550,height=550\'); return false;\"><span id=\'DD_DELICIOUS_AJAX_POST_ID\'>SAVED_COUNT</span></a></div>\";s:19:\"baseURL_lazy_script\";s:428:\" function loadDelicious_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-delicious-POST_ID\').remove();$.getJSON(\'http://feeds.delicious.com/v2/json/urlinfo/data?url=VOTE_URL&amp;callback=?\',function(data) {var msg =\'\';var count = 0;if (data.length > 0) {count = data[0].total_posts;if(count ==0){msg = \'0\';}else if(count ==1){msg = \'1\';}else{msg = count}}else{msg = \'0\';}$(\'#DD_DELICIOUS_AJAX_POST_ID\').text(msg);}); }); }\";s:21:\"scheduler_lazy_script\";s:61:\"window.setTimeout(\'loadDelicious_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:23:\"dd_delicious_appendType\";s:4:\"none\";s:25:\"dd_delicious_buttonDesign\";s:6:\"Normal\";s:28:\"dd_delicious_ajax_left_float\";s:0:\"\";s:22:\"dd_delicious_lazy_load\";s:0:\"\";s:26:\"dd_delicious_button_weight\";s:2:\"93\";}s:18:\"option_append_type\";s:23:\"dd_delicious_appendType\";s:20:\"option_button_design\";s:25:\"dd_delicious_buttonDesign\";s:20:\"option_button_weight\";s:26:\"dd_delicious_button_weight\";s:22:\"option_ajax_left_float\";s:28:\"dd_delicious_ajax_left_float\";s:16:\"option_lazy_load\";s:22:\"dd_delicious_lazy_load\";s:19:\"button_weight_value\";s:2:\"93\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:16:\"dd_button_fblike\";O:9:\"DD_FbLike\":31:{s:19:\"float_button_design\";s:14:\"Like Box Count\";s:12:\"buttonLayout\";a:6:{s:13:\"Like Standard\";s:81:\"layout=standard&amp;action=like&amp;width=350&amp;height=24&amp;colorscheme=light\";s:17:\"Like Button Count\";s:84:\"layout=button_count&amp;action=like&amp;width=92&amp;height=20&amp;colorscheme=light\";s:14:\"Like Box Count\";s:81:\"layout=box_count&amp;action=like&amp;width=50&amp;height=60&amp;colorscheme=light\";s:18:\"Recommend Standard\";s:86:\"layout=standard&amp;action=recommend&amp;width=400&amp;height=24&amp;colorscheme=light\";s:22:\"Recommend Button Count\";s:90:\"layout=button_count&amp;action=recommend&amp;width=130&amp;height=20&amp;colorscheme=light\";s:19:\"Recommend Box Count\";s:86:\"layout=box_count&amp;action=recommend&amp;width=90&amp;height=60&amp;colorscheme=light\";}s:16:\"buttonLayoutLazy\";a:6:{s:13:\"Like Standard\";s:81:\"layout=standard&amp;action=like&amp;width=350&amp;height=24&amp;colorscheme=light\";s:17:\"Like Button Count\";s:84:\"layout=button_count&amp;action=like&amp;width=92&amp;height=20&amp;colorscheme=light\";s:14:\"Like Box Count\";s:81:\"layout=box_count&amp;action=like&amp;width=50&amp;height=60&amp;colorscheme=light\";s:18:\"Recommend Standard\";s:86:\"layout=standard&amp;action=recommend&amp;width=400&amp;height=24&amp;colorscheme=light\";s:22:\"Recommend Button Count\";s:90:\"layout=button_count&amp;action=recommend&amp;width=130&amp;height=20&amp;colorscheme=light\";s:19:\"Recommend Box Count\";s:86:\"layout=box_count&amp;action=recommend&amp;width=90&amp;height=60&amp;colorscheme=light\";}s:23:\"buttonLayoutWidthHeight\";a:6:{s:13:\"Like Standard\";s:25:\"width:500px; height:24px;\";s:17:\"Like Button Count\";s:24:\"width:92px; height:20px;\";s:14:\"Like Box Count\";s:24:\"width:50px; height:62px;\";s:18:\"Recommend Standard\";s:25:\"width:500px; height:24px;\";s:22:\"Recommend Button Count\";s:25:\"width:130px; height:20px;\";s:19:\"Recommend Box Count\";s:24:\"width:90px; height:60px;\";}s:21:\"buttonLayoutLazyWidth\";a:6:{s:13:\"Like Standard\";s:3:\"500\";s:17:\"Like Button Count\";s:2:\"92\";s:14:\"Like Box Count\";s:2:\"50\";s:18:\"Recommend Standard\";s:3:\"500\";s:22:\"Recommend Button Count\";s:3:\"130\";s:19:\"Recommend Box Count\";s:2:\"90\";}s:22:\"buttonLayoutLazyHeight\";a:6:{s:13:\"Like Standard\";s:2:\"24\";s:17:\"Like Button Count\";s:2:\"20\";s:14:\"Like Box Count\";s:2:\"62\";s:18:\"Recommend Standard\";s:2:\"24\";s:22:\"Recommend Button Count\";s:2:\"20\";s:19:\"Recommend Box Count\";s:2:\"60\";}s:4:\"name\";s:22:\"Facebook Like (IFrame)\";s:10:\"websiteURL\";s:23:\"http://www.facebook.com\";s:6:\"apiURL\";s:58:\"http://developers.facebook.com/docs/reference/plugins/like\";s:7:\"baseURL\";s:234:\"<iframe src=\'http://www.facebook.com/plugins/like.php?href=VOTE_URL&amp;locale=FACEBOOK_LOCALE&amp;VOTE_BUTTON_DESIGN\' scrolling=\'no\' frameborder=\'0\' style=\'border:none; overflow:hidden; EXTRA_VALUE\' allowTransparency=\'true\'></iframe>\";s:12:\"baseURL_lazy\";s:189:\"<div class=\'dd-fblike-ajax-load dd-fblike-POST_ID\'></div><iframe class=\"DD_FBLIKE_AJAX_POST_ID\" src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\' allowTransparency=\'true\'></iframe>\";s:19:\"baseURL_lazy_script\";s:408:\" function loadFBLike_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-fblike-POST_ID\').remove();$(\'.DD_FBLIKE_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_FBLIKE_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_FBLIKE_AJAX_POST_ID\').attr(\'src\',\'http://www.facebook.com/plugins/like.php?href=VOTE_URL&amp;locale=FACEBOOK_LOCALE&amp;VOTE_BUTTON_DESIGN\'); }); }\";s:21:\"scheduler_lazy_script\";s:58:\"window.setTimeout(\'loadFBLike_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:20:\"dd_fblike_appendType\";s:13:\"after_content\";s:22:\"dd_fblike_buttonDesign\";s:14:\"Like Box Count\";s:25:\"dd_fblike_ajax_left_float\";s:0:\"\";s:19:\"dd_fblike_lazy_load\";s:0:\"\";s:23:\"dd_fblike_button_weight\";s:3:\"106\";}s:18:\"option_append_type\";s:20:\"dd_fblike_appendType\";s:20:\"option_button_design\";s:22:\"dd_fblike_buttonDesign\";s:20:\"option_button_weight\";s:23:\"dd_fblike_button_weight\";s:22:\"option_ajax_left_float\";s:25:\"dd_fblike_ajax_left_float\";s:16:\"option_lazy_load\";s:19:\"dd_fblike_lazy_load\";s:19:\"button_weight_value\";s:2:\"96\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:21:\"dd_button_stumbleupon\";O:14:\"DD_StumbleUpon\":30:{s:19:\"islazyLoadAvailable\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:1:\"5\";s:7:\"Compact\";s:1:\"1\";}s:4:\"name\";s:11:\"Stumbleupon\";s:10:\"websiteURL\";s:26:\"http://www.stumbleupon.com\";s:6:\"apiURL\";s:34:\"http://www.stumbleupon.com/badges/\";s:7:\"baseURL\";s:102:\"<script src=\'http://www.stumbleupon.com/hostedbadge.php?s=VOTE_BUTTON_DESIGN&amp;r=VOTE_URL\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:10:\"wp_options\";a:5:{s:25:\"dd_stumbleupon_appendType\";s:4:\"none\";s:27:\"dd_stumbleupon_buttonDesign\";s:6:\"Normal\";s:30:\"dd_stumbleupon_ajax_left_float\";s:0:\"\";s:24:\"dd_stumbleupon_lazy_load\";s:0:\"\";s:28:\"dd_stumbleupon_button_weight\";s:2:\"97\";}s:18:\"option_append_type\";s:25:\"dd_stumbleupon_appendType\";s:20:\"option_button_design\";s:27:\"dd_stumbleupon_buttonDesign\";s:20:\"option_button_weight\";s:28:\"dd_stumbleupon_button_weight\";s:22:\"option_ajax_left_float\";s:30:\"dd_stumbleupon_ajax_left_float\";s:16:\"option_lazy_load\";s:24:\"dd_stumbleupon_lazy_load\";s:19:\"button_weight_value\";s:2:\"97\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_yahoobuzz\";O:8:\"DD_YBuzz\":30:{s:19:\"islazyLoadAvailable\";b:0;s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:6:\"square\";s:7:\"Compact\";s:11:\"small-votes\";s:12:\"Compact_Text\";s:10:\"text-votes\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:10:\"Yahoo Buzz\";s:10:\"websiteURL\";s:21:\"http://buzz.yahoo.com\";s:6:\"apiURL\";s:29:\"http://buzz.yahoo.com/buttons\";s:7:\"baseURL\";s:216:\"<script type=\'text/javascript\'>yahooBuzzArticleHeadline=\"VOTE_TITLE\";yahooBuzzArticleId=\"VOTE_URL\";</script><script type=\'text/javascript\' src=\'http://d.yimg.com/ds/badge2.js\' badgetype=\'VOTE_BUTTON_DESIGN\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:19:\"dd_ybuzz_appendType\";s:4:\"none\";s:21:\"dd_ybuzz_buttonDesign\";s:6:\"Normal\";s:24:\"dd_ybuzz_ajax_left_float\";s:0:\"\";s:18:\"dd_ybuzz_lazy_load\";s:0:\"\";s:22:\"dd_ybuzz_button_weight\";s:2:\"90\";}s:18:\"option_append_type\";s:19:\"dd_ybuzz_appendType\";s:20:\"option_button_design\";s:21:\"dd_ybuzz_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_ybuzz_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_ybuzz_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_ybuzz_lazy_load\";s:19:\"button_weight_value\";s:2:\"90\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_fbshareme\";O:12:\"DD_FbShareMe\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:5:\"large\";s:7:\"Compact\";s:5:\"small\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:5:\"large\";s:7:\"Compact\";s:5:\"small\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"53\";s:7:\"Compact\";s:2:\"80\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"18\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:10:\"fbShare.me\";s:10:\"websiteURL\";s:21:\"http://www.fbshare.me\";s:6:\"apiURL\";s:21:\"http://www.fbshare.me\";s:7:\"baseURL\";s:142:\"<script>var fbShare = {url: \'VOTE_URL\',size: \'VOTE_BUTTON_DESIGN\',}</script><script src=\'http://widgets.fbshare.me/files/fbshare.js\'></script>\";s:12:\"baseURL_lazy\";s:198:\"<div class=\'dd-fbshareme-ajax-load dd-fbshareme-POST_ID\'></div><iframe class=\"DD_FBSHAREME_AJAX_POST_ID\" src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\' allowtransparency=\'true\'></iframe>\";s:19:\"baseURL_lazy_script\";s:400:\" function loadFBShareMe_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-fbshareme-POST_ID\').remove();$(\'.DD_FBSHAREME_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_FBSHAREME_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_FBSHAREME_AJAX_POST_ID\').attr(\'src\',\'http://widgets.fbshare.me/files/fbshare.php?url=VOTE_URL&size=VOTE_BUTTON_DESIGN\');  }); }\";s:21:\"scheduler_lazy_script\";s:61:\"window.setTimeout(\'loadFBShareMe_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:23:\"dd_fbshareme_appendType\";s:4:\"none\";s:25:\"dd_fbshareme_buttonDesign\";s:6:\"Normal\";s:28:\"dd_fbshareme_ajax_left_float\";s:0:\"\";s:22:\"dd_fbshareme_lazy_load\";s:0:\"\";s:26:\"dd_fbshareme_button_weight\";s:2:\"94\";}s:18:\"option_append_type\";s:23:\"dd_fbshareme_appendType\";s:20:\"option_button_design\";s:25:\"dd_fbshareme_buttonDesign\";s:20:\"option_button_weight\";s:26:\"dd_fbshareme_button_weight\";s:22:\"option_ajax_left_float\";s:28:\"dd_fbshareme_ajax_left_float\";s:16:\"option_lazy_load\";s:22:\"dd_fbshareme_lazy_load\";s:19:\"button_weight_value\";s:2:\"94\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:21:\"dd_button_blogenagage\";O:13:\"DD_BlogEngage\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:1:{s:6:\"Normal\";s:11:\"button4.php\";}s:4:\"name\";s:10:\"BlogEngage\";s:10:\"websiteURL\";s:25:\"http://www.blogengage.com\";s:6:\"apiURL\";s:43:\"http://www.blogengage.com/profile_promo.php\";s:7:\"baseURL\";s:132:\"<script type=\'text/javascript\'>submit_url = \'VOTE_URL\';</script><script src=\'http://blogengage.com/evb/VOTE_BUTTON_DESIGN\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:24:\"dd_blogengage_appendType\";s:4:\"none\";s:26:\"dd_blogengage_buttonDesign\";s:6:\"Normal\";s:29:\"dd_blogengage_ajax_left_float\";s:0:\"\";s:23:\"dd_blogengage_lazy_load\";s:0:\"\";s:27:\"dd_blogengage_button_weight\";s:2:\"84\";}s:18:\"option_append_type\";s:24:\"dd_blogengage_appendType\";s:20:\"option_button_design\";s:26:\"dd_blogengage_buttonDesign\";s:20:\"option_button_weight\";s:27:\"dd_blogengage_button_weight\";s:22:\"option_ajax_left_float\";s:29:\"dd_blogengage_ajax_left_float\";s:16:\"option_lazy_load\";s:23:\"dd_blogengage_lazy_load\";s:19:\"button_weight_value\";s:2:\"84\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:21:\"dd_button_thewebblend\";O:14:\"DD_TheWebBlend\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:0:\"\";s:7:\"Compact\";s:21:\"badge_size=\'compact\';\";}s:4:\"name\";s:11:\"TheWebBlend\";s:10:\"websiteURL\";s:26:\"http://www.thewebblend.com\";s:6:\"apiURL\";s:33:\"http://thewebblend.com/tools/vote\";s:7:\"baseURL\";s:194:\"<script type=\'text/javascript\'>url_site=\'VOTE_URL\'; VOTE_BUTTON_DESIGN</script><script src=\'http://thewebblend.com/sites/all/modules/drigg_external/js/button.js\' type=\'text/javascript\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:22:\"dd_webblend_appendType\";s:4:\"none\";s:24:\"dd_webblend_buttonDesign\";s:6:\"Normal\";s:27:\"dd_webblend_ajax_left_float\";s:0:\"\";s:21:\"dd_webblend_lazy_load\";s:0:\"\";s:25:\"dd_webblend_button_weight\";s:2:\"85\";}s:18:\"option_append_type\";s:22:\"dd_webblend_appendType\";s:20:\"option_button_design\";s:24:\"dd_webblend_buttonDesign\";s:20:\"option_button_weight\";s:25:\"dd_webblend_button_weight\";s:22:\"option_ajax_left_float\";s:27:\"dd_webblend_ajax_left_float\";s:16:\"option_lazy_load\";s:21:\"dd_webblend_lazy_load\";s:19:\"button_weight_value\";s:2:\"85\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:20:\"dd_button_designbump\";O:13:\"DD_DesignBump\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:1:{s:6:\"Normal\";s:6:\"Normal\";}s:4:\"name\";s:10:\"DesignBump\";s:10:\"websiteURL\";s:25:\"http://www.designbump.com\";s:6:\"apiURL\";s:33:\"http://designbump.com/content/evb\";s:7:\"baseURL\";s:176:\"<script type=\'text/javascript\'>url_site=\'VOTE_URL\'; </script> <script src=\'http://designbump.com/sites/all/modules/drigg_external/js/button.js\' type=\'text/javascript\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:24:\"dd_designbump_appendType\";s:4:\"none\";s:26:\"dd_designbump_buttonDesign\";s:6:\"Normal\";s:29:\"dd_designbump_ajax_left_float\";s:0:\"\";s:23:\"dd_designbump_lazy_load\";s:0:\"\";s:27:\"dd_designbump_button_weight\";s:2:\"87\";}s:18:\"option_append_type\";s:24:\"dd_designbump_appendType\";s:20:\"option_button_design\";s:26:\"dd_designbump_buttonDesign\";s:20:\"option_button_weight\";s:27:\"dd_designbump_button_weight\";s:22:\"option_ajax_left_float\";s:29:\"dd_designbump_ajax_left_float\";s:16:\"option_lazy_load\";s:23:\"dd_designbump_lazy_load\";s:19:\"button_weight_value\";s:2:\"87\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:17:\"dd_button_twitter\";O:10:\"DD_Twitter\":30:{s:11:\"append_type\";s:10:\"left_float\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:7:\"Twitter\";s:10:\"websiteURL\";s:22:\"http://www.twitter.com\";s:6:\"apiURL\";s:38:\"http://twitter.com/goodies/tweetbutton\";s:7:\"baseURL\";s:252:\"<a href=\"http://twitter.com/share\" class=\"twitter-share-button\" data-url=\"VOTE_URL\" data-count=\"VOTE_BUTTON_DESIGN\" data-text=\"VOTE_TITLE\" data-via=\"VOTE_SOURCE\" ></a><script type=\"text/javascript\" src=\"http://platform.twitter.com/widgets.js\"></script>\";s:12:\"baseURL_lazy\";s:226:\"<div class=\'dd-twitter-ajax-load dd-twitter-POST_ID\'></div><a href=\"http://twitter.com/share\" class=\"twitter-share-button\" data-url=\"VOTE_URL\" data-count=\"VOTE_BUTTON_DESIGN\" data-text=\"VOTE_TITLE\" data-via=\"VOTE_SOURCE\" ></a>\";s:19:\"baseURL_lazy_script\";s:164:\" function loadTwitter_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-twitter-POST_ID\').remove();$.getScript(\'http://platform.twitter.com/widgets.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:59:\"window.setTimeout(\'loadTwitter_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:21:\"dd_twitter_appendType\";s:13:\"after_content\";s:23:\"dd_twitter_buttonDesign\";s:6:\"Normal\";s:26:\"dd_twitter_ajax_left_float\";s:0:\"\";s:20:\"dd_twitter_lazy_load\";s:0:\"\";s:24:\"dd_twitter_button_weight\";s:3:\"110\";}s:18:\"option_append_type\";s:21:\"dd_twitter_appendType\";s:20:\"option_button_design\";s:23:\"dd_twitter_buttonDesign\";s:20:\"option_button_weight\";s:24:\"dd_twitter_button_weight\";s:22:\"option_ajax_left_float\";s:26:\"dd_twitter_ajax_left_float\";s:16:\"option_lazy_load\";s:20:\"dd_twitter_lazy_load\";s:19:\"button_weight_value\";s:3:\"110\";s:19:\"float_button_design\";s:6:\"Normal\";s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_tweetmeme\";O:12:\"DD_TweetMeme\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:30:\"normal\' height=\'61\' width=\'50\'\";s:7:\"Compact\";s:31:\"compact\' height=\'20\' width=\'90\'\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"normal\";s:7:\"Compact\";s:7:\"compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"50\";s:7:\"Compact\";s:2:\"90\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"61\";s:7:\"Compact\";s:2:\"20\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:9:\"TweetMeme\";s:10:\"websiteURL\";s:25:\"http://www.tweetmeme.com/\";s:6:\"apiURL\";s:46:\"http://wordpress.org/extend/plugins/tweetmeme/\";s:7:\"baseURL\";s:200:\"<iframe src=\'http://api.tweetmeme.com/button.js?url=VOTE_URL&source=VOTE_SOURCE&service=VOTE_SERVICE_NAME&service_api=VOTE_SERVICE_API&style=VOTE_BUTTON_DESIGN frameborder=\'0\' scrolling=\'no\'></iframe>\";s:12:\"baseURL_lazy\";s:173:\"<div class=\'dd-tweetmeme-ajax-load dd-tweetmeme-POST_ID\'></div><iframe class=\'DD_TWEETMEME_AJAX_POST_ID\' src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\'></iframe>\";s:19:\"baseURL_lazy_script\";s:465:\" function loadTweetMeme_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-tweetmeme-POST_ID\').remove();$(\'.DD_TWEETMEME_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_TWEETMEME_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_TWEETMEME_AJAX_POST_ID\').attr(\'src\',\'http://api.tweetmeme.com/button.js?url=VOTE_URL&source=VOTE_SOURCE&style=VOTE_BUTTON_DESIGN&service=VOTE_SERVICE_NAME&service_api=VOTE_SERVICE_API\'); }); }\";s:21:\"scheduler_lazy_script\";s:61:\"window.setTimeout(\'loadTweetMeme_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:23:\"dd_tweetmeme_appendType\";s:4:\"none\";s:25:\"dd_tweetmeme_buttonDesign\";s:6:\"Normal\";s:28:\"dd_tweetmeme_ajax_left_float\";s:0:\"\";s:22:\"dd_tweetmeme_lazy_load\";s:0:\"\";s:26:\"dd_tweetmeme_button_weight\";s:2:\"97\";}s:18:\"option_append_type\";s:23:\"dd_tweetmeme_appendType\";s:20:\"option_button_design\";s:25:\"dd_tweetmeme_buttonDesign\";s:20:\"option_button_weight\";s:26:\"dd_tweetmeme_button_weight\";s:22:\"option_ajax_left_float\";s:28:\"dd_tweetmeme_ajax_left_float\";s:16:\"option_lazy_load\";s:22:\"dd_tweetmeme_lazy_load\";s:19:\"button_weight_value\";s:2:\"97\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:15:\"dd_button_topsy\";O:8:\"DD_Topsy\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:3:\"big\";s:7:\"Compact\";s:7:\"compact\";}s:4:\"name\";s:5:\"Topsy\";s:10:\"websiteURL\";s:20:\"http://www.topsy.com\";s:6:\"apiURL\";s:44:\"http://labs.topsy.com/button/retweet-button/\";s:7:\"baseURL\";s:233:\"<script type=\"text/javascript\" src=\"http://cdn.topsy.com/topsy.js?init=topsyWidgetCreator\"></script><div class=\"topsy_widget_data\"><!--{\"url\":\"VOTE_URL\",\"style\":\"VOTE_BUTTON_DESIGN\",\"theme\":\"VOTE_THEME\",\"nick\":\"VOTE_SOURCE\"}--></div>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:19:\"dd_topsy_appendType\";s:4:\"none\";s:21:\"dd_topsy_buttonDesign\";s:6:\"Normal\";s:24:\"dd_topsy_ajax_left_float\";s:0:\"\";s:18:\"dd_topsy_lazy_load\";s:0:\"\";s:22:\"dd_topsy_button_weight\";s:2:\"96\";}s:18:\"option_append_type\";s:19:\"dd_topsy_appendType\";s:20:\"option_button_design\";s:21:\"dd_topsy_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_topsy_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_topsy_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_topsy_lazy_load\";s:19:\"button_weight_value\";s:2:\"96\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:18:\"dd_button_comments\";O:11:\"DD_Comments\":30:{s:19:\"islazyLoadAvailable\";b:0;s:12:\"buttonLayout\";a:1:{s:6:\"Normal\";s:6:\"Normal\";}s:4:\"name\";s:8:\"Comments\";s:10:\"websiteURL\";s:11:\"http://none\";s:6:\"apiURL\";s:11:\"http://none\";s:7:\"baseURL\";s:142:\"<div id=\'dd_comments\'><a class=\'clcount\' href=VOTE_URL><span class=\'ctotal\'>COMMENTS_COUNT</span></a><a class=\'clink\' href=VOTE_URL></a></div>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:10:\"wp_options\";a:5:{s:22:\"dd_comments_appendType\";s:4:\"none\";s:24:\"dd_comments_buttonDesign\";s:6:\"Normal\";s:27:\"dd_comments_ajax_left_float\";s:0:\"\";s:21:\"dd_comments_lazy_load\";s:0:\"\";s:25:\"dd_comments_button_weight\";s:2:\"88\";}s:18:\"option_append_type\";s:22:\"dd_comments_appendType\";s:20:\"option_button_design\";s:24:\"dd_comments_buttonDesign\";s:20:\"option_button_weight\";s:25:\"dd_comments_button_weight\";s:22:\"option_ajax_left_float\";s:27:\"dd_comments_ajax_left_float\";s:16:\"option_lazy_load\";s:21:\"dd_comments_lazy_load\";s:19:\"button_weight_value\";s:2:\"88\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:18:\"dd_button_linkedin\";O:11:\"DD_Linkedin\":30:{s:11:\"append_type\";s:10:\"left_float\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:3:\"top\";s:7:\"Compact\";s:5:\"right\";s:7:\"NoCount\";s:4:\"none\";}s:16:\"buttonLayoutLazy\";a:3:{s:6:\"Normal\";s:3:\"top\";s:7:\"Compact\";s:5:\"right\";s:7:\"NoCount\";s:4:\"none\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:8:\"Linkedin\";s:10:\"websiteURL\";s:23:\"http://www.linkedin.com\";s:6:\"apiURL\";s:34:\"http://www.linkedin.com/publishers\";s:7:\"baseURL\";s:168:\"<script type=\'text/javascript\' src=\'http://platform.linkedin.com/in.js\'></script><script type=\'IN/share\' data-url=\'VOTE_URL\' data-counter=\'VOTE_BUTTON_DESIGN\'></script>\";s:12:\"baseURL_lazy\";s:148:\"<div class=\'dd-linkedin-ajax-load dd-linkedin-POST_ID\'></div><script type=\'IN/share\' data-url=\'VOTE_URL\' data-counter=\'VOTE_BUTTON_DESIGN\'></script>\";s:19:\"baseURL_lazy_script\";s:162:\" function loadLinkedin_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-linkedin-POST_ID\').remove();$.getScript(\'http://platform.linkedin.com/in.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:60:\"window.setTimeout(\'loadLinkedin_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:22:\"dd_linkedin_appendType\";s:13:\"after_content\";s:24:\"dd_linkedin_buttonDesign\";s:6:\"Normal\";s:27:\"dd_linkedin_ajax_left_float\";s:0:\"\";s:21:\"dd_linkedin_lazy_load\";s:0:\"\";s:25:\"dd_linkedin_button_weight\";s:3:\"108\";}s:18:\"option_append_type\";s:22:\"dd_linkedin_appendType\";s:20:\"option_button_design\";s:24:\"dd_linkedin_buttonDesign\";s:20:\"option_button_weight\";s:25:\"dd_linkedin_button_weight\";s:22:\"option_ajax_left_float\";s:27:\"dd_linkedin_ajax_left_float\";s:16:\"option_lazy_load\";s:21:\"dd_linkedin_lazy_load\";s:19:\"button_weight_value\";s:2:\"94\";s:19:\"float_button_design\";s:6:\"Normal\";s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:15:\"dd_button_serpd\";O:8:\"DD_Serpd\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:1:{s:6:\"Normal\";s:0:\"\";}s:4:\"name\";s:5:\"Serpd\";s:10:\"websiteURL\";s:20:\"http://www.serpd.com\";s:6:\"apiURL\";s:29:\"http://www.serpd.com/widgets/\";s:7:\"baseURL\";s:150:\"<script type=\"text/javascript\">submit_url = \"VOTE_URL\";</script><script type=\"text/javascript\" src=\"http://www.serpd.com/index.php?page=evb\"></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:19:\"dd_serpd_appendType\";s:4:\"none\";s:21:\"dd_serpd_buttonDesign\";s:6:\"Normal\";s:24:\"dd_serpd_ajax_left_float\";s:0:\"\";s:18:\"dd_serpd_lazy_load\";s:0:\"\";s:22:\"dd_serpd_button_weight\";s:2:\"86\";}s:18:\"option_append_type\";s:19:\"dd_serpd_appendType\";s:20:\"option_button_design\";s:21:\"dd_serpd_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_serpd_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_serpd_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_serpd_lazy_load\";s:19:\"button_weight_value\";s:2:\"86\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:22:\"dd_button_fblike_xfbml\";O:15:\"DD_FbLike_XFBML\":30:{s:11:\"append_type\";s:10:\"left_float\";s:13:\"button_design\";s:17:\"Like Button Count\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:19:\"islazyLoadAvailable\";b:0;s:19:\"float_button_design\";s:14:\"Like Box Count\";s:12:\"buttonLayout\";a:6:{s:13:\"Like Standard\";s:13:\" width=\"450\" \";s:17:\"Like Button Count\";s:34:\" layout=\"button_count\" width=\"92\" \";s:14:\"Like Box Count\";s:31:\" layout=\"box_count\" width=\"50\" \";s:18:\"Recommend Standard\";s:32:\" action=\"recommend\" width=\"400\" \";s:22:\"Recommend Button Count\";s:54:\" action=\"recommend\" layout=\"button_count\" width=\"130\" \";s:19:\"Recommend Box Count\";s:50:\" action=\"recommend\" layout=\"box_count\" width=\"90\" \";}s:4:\"name\";s:21:\"Facebook Like (XFBML)\";s:10:\"websiteURL\";s:23:\"http://www.facebook.com\";s:6:\"apiURL\";s:58:\"http://developers.facebook.com/docs/reference/plugins/like\";s:7:\"baseURL\";s:170:\"<script src=\"http://connect.facebook.net/FACEBOOK_LOCALE/all.js#xfbml=1\"></script><fb:like href=\"VOTE_URL\" FACEBOOK_SEND FACEBOOK_SHOW_FACE VOTE_BUTTON_DESIGN ></fb:like>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:10:\"wp_options\";a:5:{s:26:\"dd_fblike_xfbml_appendType\";s:4:\"none\";s:28:\"dd_fblike_xfbml_buttonDesign\";s:17:\"Like Button Count\";s:31:\"dd_fblike_xfbml_ajax_left_float\";s:0:\"\";s:25:\"dd_fblike_xfbml_lazy_load\";s:0:\"\";s:29:\"dd_fblike_xfbml_button_weight\";s:2:\"96\";}s:18:\"option_append_type\";s:26:\"dd_fblike_xfbml_appendType\";s:20:\"option_button_design\";s:28:\"dd_fblike_xfbml_buttonDesign\";s:20:\"option_button_weight\";s:29:\"dd_fblike_xfbml_button_weight\";s:22:\"option_ajax_left_float\";s:31:\"dd_fblike_xfbml_ajax_left_float\";s:16:\"option_lazy_load\";s:25:\"dd_fblike_xfbml_lazy_load\";s:19:\"button_weight_value\";s:2:\"96\";s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:17:\"dd_button_google1\";O:10:\"DD_Google1\":30:{s:11:\"append_type\";s:10:\"left_float\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:4:{s:6:\"Normal\";s:4:\"tall\";s:14:\"Compact (15px)\";s:5:\"small\";s:14:\"Compact (20px)\";s:6:\"medium\";s:14:\"Compact (24px)\";s:4:\"none\";}s:16:\"buttonLayoutLazy\";a:4:{s:6:\"Normal\";s:4:\"tall\";s:14:\"Compact (15px)\";s:5:\"small\";s:14:\"Compact (20px)\";s:6:\"medium\";s:14:\"Compact (24px)\";s:4:\"none\";}s:4:\"name\";s:9:\"Google +1\";s:10:\"websiteURL\";s:32:\"http://www.google.com/+1/button/\";s:6:\"apiURL\";s:37:\"http://code.google.com/apis/+1button/\";s:7:\"baseURL\";s:149:\"<script type=\'text/javascript\' src=\'https://apis.google.com/js/plusone.js\'></script><g:plusone size=\'VOTE_BUTTON_DESIGN\' href=\'VOTE_URL\'></g:plusone>\";s:12:\"baseURL_lazy\";s:124:\"<div class=\'dd-google1-ajax-load dd-google1-POST_ID\'></div><g:plusone size=\'VOTE_BUTTON_DESIGN\' href=\'VOTE_URL\'></g:plusone>\";s:19:\"baseURL_lazy_script\";s:163:\" function loadGoogle1_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-google1-POST_ID\').remove();$.getScript(\'https://apis.google.com/js/plusone.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:59:\"window.setTimeout(\'loadGoogle1_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:21:\"dd_google1_appendType\";s:13:\"after_content\";s:23:\"dd_google1_buttonDesign\";s:6:\"Normal\";s:26:\"dd_google1_ajax_left_float\";s:0:\"\";s:20:\"dd_google1_lazy_load\";s:0:\"\";s:24:\"dd_google1_button_weight\";s:3:\"109\";}s:18:\"option_append_type\";s:21:\"dd_google1_appendType\";s:20:\"option_button_design\";s:23:\"dd_google1_buttonDesign\";s:20:\"option_button_weight\";s:24:\"dd_google1_button_weight\";s:22:\"option_ajax_left_float\";s:26:\"dd_google1_ajax_left_float\";s:16:\"option_lazy_load\";s:20:\"dd_google1_lazy_load\";s:19:\"button_weight_value\";s:2:\"95\";s:19:\"float_button_design\";s:6:\"Normal\";s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:16:\"dd_button_buffer\";O:9:\"DD_Buffer\":30:{s:11:\"append_type\";s:13:\"after_content\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";s:8:\"No Count\";s:4:\"none\";}s:16:\"buttonLayoutLazy\";a:3:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";s:8:\"No Count\";s:4:\"none\";}s:4:\"name\";s:6:\"Buffer\";s:10:\"websiteURL\";s:21:\"http://bufferapp.com/\";s:6:\"apiURL\";s:36:\"http://bufferapp.com/goodies/button/\";s:7:\"baseURL\";s:234:\"<a href=\"http://bufferapp.com/add\" class=\"buffer-add-button\" data-count=\"VOTE_BUTTON_DESIGN\" data-url=\"VOTE_URL\" data-via=\"VOTE_BUFFER_SOURCE\"></a><script type=\"text/javascript\" src=\"http://static.bufferapp.com/js/button.js\"></script>\";s:12:\"baseURL_lazy\";s:147:\"<a href=\"http://bufferapp.com/add\" class=\"buffer-add-button\" data-count=\"VOTE_BUTTON_DESIGN\" data-url=\"VOTE_URL\" data-via=\"VOTE_BUFFER_SOURCE\"></a>\";s:19:\"baseURL_lazy_script\";s:163:\"function loadBuffer_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-buffer-POST_ID\').remove();$.getScript(\'http://static.bufferapp.com/js/button.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:58:\"window.setTimeout(\'loadBuffer_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:20:\"dd_buffer_appendType\";s:4:\"none\";s:22:\"dd_buffer_buttonDesign\";s:6:\"Normal\";s:25:\"dd_buffer_ajax_left_float\";s:0:\"\";s:19:\"dd_buffer_lazy_load\";s:0:\"\";s:23:\"dd_buffer_button_weight\";s:2:\"99\";}s:18:\"option_append_type\";s:20:\"dd_buffer_appendType\";s:20:\"option_button_design\";s:22:\"dd_buffer_buttonDesign\";s:20:\"option_button_weight\";s:23:\"dd_buffer_button_weight\";s:22:\"option_ajax_left_float\";s:25:\"dd_buffer_ajax_left_float\";s:16:\"option_lazy_load\";s:19:\"dd_buffer_lazy_load\";s:19:\"button_weight_value\";s:2:\"99\";s:19:\"float_button_design\";s:6:\"Normal\";s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_pinterest\";O:12:\"DD_Pinterest\":30:{s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";s:8:\"No Count\";s:4:\"none\";}s:16:\"buttonLayoutLazy\";a:3:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";s:8:\"No Count\";s:4:\"none\";}s:4:\"name\";s:9:\"Pinterest\";s:10:\"websiteURL\";s:20:\"http://pinterest.com\";s:6:\"apiURL\";s:55:\"http://pinterest.com/about/goodies/#button_for_websites\";s:7:\"baseURL\";s:249:\"<a href=\"http://pinterest.com/pin/create/button/?url=VOTE_URL&description=VOTE_TITLE&media=VOTE_IMAGE\" class=\"pin-it-button\" count-layout=\"VOTE_BUTTON_DESIGN\"></a><script type=\"text/javascript\" src=\"http://assets.pinterest.com/js/pinit.js\"></script>\";s:12:\"baseURL_lazy\";s:207:\"<a href=\"http://pinterest.com/pin/create/button/?url=VOTE_URL&description=VOTE_TITLE&media=VOTE_IMAGE\" class=\"pin-it-button dd-pinterest-ajax-load dd-pinterest-POST_ID\" count-layout=\"VOTE_BUTTON_DESIGN\"></a>\";s:19:\"baseURL_lazy_script\";s:132:\"function loadPinterest_POST_ID(){ jQuery(document).ready(function($) { $.getScript(\'http://assets.pinterest.com/js/pinit.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:61:\"window.setTimeout(\'loadPinterest_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:23:\"dd_pinterest_appendType\";s:13:\"after_content\";s:25:\"dd_pinterest_buttonDesign\";s:6:\"Normal\";s:28:\"dd_pinterest_ajax_left_float\";s:0:\"\";s:22:\"dd_pinterest_lazy_load\";s:0:\"\";s:26:\"dd_pinterest_button_weight\";s:3:\"107\";}s:18:\"option_append_type\";s:23:\"dd_pinterest_appendType\";s:20:\"option_button_design\";s:25:\"dd_pinterest_buttonDesign\";s:20:\"option_button_weight\";s:26:\"dd_pinterest_button_weight\";s:22:\"option_ajax_left_float\";s:28:\"dd_pinterest_ajax_left_float\";s:16:\"option_lazy_load\";s:22:\"dd_pinterest_lazy_load\";s:19:\"button_weight_value\";s:2:\"10\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:16:\"dd_button_flattr\";O:9:\"DD_Flattr\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:7:\"default\";s:7:\"Compact\";s:7:\"compact\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:7:\"default\";s:7:\"Compact\";s:7:\"compact\";}s:4:\"name\";s:6:\"Flattr\";s:10:\"websiteURL\";s:17:\"http://flattr.com\";s:6:\"apiURL\";s:36:\"http://developers.flattr.net/button/\";s:7:\"baseURL\";s:257:\"<script src=\"http://api.flattr.com/js/0.6/load.js?mode=auto\"></script><a class=\"FlattrButton\" href=\"VOTE_URL\" style=\"display:none;\" title=\"VOTE_TITLE\" data-flattr-uid=\"VOTE_FLATTR_UID\" data-flattr-button=\"VOTE_BUTTON_DESIGN\" data-flattr-category=\"text\"></a>\";s:12:\"baseURL_lazy\";s:187:\"<a class=\"FlattrButton\" href=\"VOTE_URL\" style=\"display:none;\" title=\"VOTE_TITLE\" data-flattr-uid=\"VOTE_FLATTR_UID\" data-flattr-button=\"VOTE_BUTTON_DESIGN\" data-flattr-category=\"text\"></a>\";s:19:\"baseURL_lazy_script\";s:136:\"function loadFlattr_POST_ID(){ jQuery(document).ready(function($) { $.getScript(\'http://api.flattr.com/js/0.6/load.js?mode=auto\'); }); }\";s:21:\"scheduler_lazy_script\";s:58:\"window.setTimeout(\'loadFlattr_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:20:\"dd_flattr_appendType\";s:4:\"none\";s:22:\"dd_flattr_buttonDesign\";s:6:\"Normal\";s:25:\"dd_flattr_ajax_left_float\";s:0:\"\";s:19:\"dd_flattr_lazy_load\";s:0:\"\";s:23:\"dd_flattr_button_weight\";s:2:\"10\";}s:18:\"option_append_type\";s:20:\"dd_flattr_appendType\";s:20:\"option_button_design\";s:22:\"dd_flattr_buttonDesign\";s:20:\"option_button_weight\";s:23:\"dd_flattr_button_weight\";s:22:\"option_ajax_left_float\";s:25:\"dd_flattr_ajax_left_float\";s:16:\"option_lazy_load\";s:19:\"dd_flattr_lazy_load\";s:19:\"button_weight_value\";s:2:\"10\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}}s:22:\"dd_normal_button_final\";a:5:{s:16:\"dd_button_fblike\";r:279;s:17:\"dd_button_twitter\";r:609;s:18:\"dd_button_linkedin\";r:784;s:17:\"dd_button_google1\";r:921;s:19:\"dd_button_pinterest\";r:1015;}}', 'yes');
INSERT INTO `wp_options` VALUES('1819', 'dd_float_display_config', 'a:6:{s:14:\"display_option\";a:6:{s:19:\"display_option_home\";s:0:\"\";s:19:\"display_option_post\";s:2:\"on\";s:19:\"display_option_page\";s:0:\"\";s:18:\"display_option_cat\";s:0:\"\";s:18:\"display_option_tag\";s:0:\"\";s:22:\"display_option_archive\";s:0:\"\";}s:15:\"category_option\";a:3:{s:21:\"category_option_radio\";s:29:\"category_option_radio_include\";s:23:\"category_option_include\";s:3:\"All\";s:23:\"category_option_exclude\";s:4:\"None\";}s:16:\"dd_status_option\";a:1:{s:24:\"dd_status_option_display\";s:0:\"\";}s:15:\"dd_float_option\";a:2:{s:22:\"dd_float_option_credit\";s:2:\"on\";s:20:\"dd_float_option_left\";s:2:\"60\";}s:21:\"dd_extra_option_email\";a:2:{s:28:\"dd_extra_option_email_status\";s:0:\"\";s:31:\"dd_extra_option_email_sharethis\";s:0:\"\";}s:21:\"dd_extra_option_print\";a:1:{s:28:\"dd_extra_option_print_status\";s:0:\"\";}}', 'yes');
INSERT INTO `wp_options` VALUES('1820', 'dd_float_button', 'a:2:{s:23:\"dd_float_button_display\";a:24:{s:14:\"dd_button_digg\";O:7:\"DD_Digg\":30:{s:12:\"buttonLayout\";a:4:{s:4:\"Wide\";s:8:\"DiggWide\";s:6:\"Normal\";s:10:\"DiggMedium\";s:7:\"Compact\";s:11:\"DiggCompact\";s:4:\"Icon\";s:8:\"DiggIcon\";}s:16:\"buttonLayoutLazy\";a:4:{s:4:\"Wide\";s:8:\"DiggWide\";s:6:\"Normal\";s:10:\"DiggMedium\";s:7:\"Compact\";s:11:\"DiggCompact\";s:4:\"Icon\";s:8:\"DiggIcon\";}s:4:\"name\";s:4:\"Digg\";s:10:\"websiteURL\";s:19:\"http://www.digg.com\";s:6:\"apiURL\";s:44:\"http://about.digg.com/downloads/button/smart\";s:7:\"baseURL\";s:383:\"<script type=\'text/javascript\'>(function() {var s = document.createElement(\'SCRIPT\'), s1 = document.getElementsByTagName(\'SCRIPT\')[0];s.type = \'text/javascript\';s.async = true;s.src = \'http://widgets.digg.com/buttons.js\';s1.parentNode.insertBefore(s, s1);})();</script> <a class=\'DiggThisButton VOTE_BUTTON_DESIGN\' href=\'http://digg.com/submit?url=VOTE_URL&amp;title=VOTE_TITLE\'></a>\";s:12:\"baseURL_lazy\";s:123:\"<div class=\'dd-digg-ajax-load dd-digg-POST_ID\'></div><a class=\'DiggThisButton DD_DIGG_AJAX_POST_ID VOTE_BUTTON_DESIGN\'></a>\";s:19:\"baseURL_lazy_script\";s:253:\" function loadDigg_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-digg-POST_ID\').remove();$(\'.DD_DIGG_AJAX_POST_ID\').attr(\'href\',\'http://digg.com/submit?url=VOTE_URL&amp;title=VOTE_TITLE\');$.getScript(\'http://widgets.digg.com/buttons.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:56:\"window.setTimeout(\'loadDigg_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:18:\"dd_digg_appendType\";s:0:\"\";s:20:\"dd_digg_buttonDesign\";s:0:\"\";s:23:\"dd_digg_ajax_left_float\";s:0:\"\";s:17:\"dd_digg_lazy_load\";s:0:\"\";s:21:\"dd_digg_button_weight\";s:2:\"95\";}s:18:\"option_append_type\";s:18:\"dd_digg_appendType\";s:20:\"option_button_design\";s:20:\"dd_digg_buttonDesign\";s:20:\"option_button_weight\";s:21:\"dd_digg_button_weight\";s:22:\"option_ajax_left_float\";s:23:\"dd_digg_ajax_left_float\";s:16:\"option_lazy_load\";s:17:\"dd_digg_lazy_load\";s:19:\"button_weight_value\";s:2:\"95\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:16:\"dd_button_reddit\";O:9:\"DD_Reddit\":31:{s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:21:\"button2.html?width=51\";s:7:\"Compact\";s:22:\"button1.html?width=120\";s:4:\"Icon\";s:21:\"button3.html?width=69\";}s:16:\"buttonLayoutLazy\";a:3:{s:6:\"Normal\";s:21:\"button2.html?width=51\";s:7:\"Compact\";s:22:\"button1.html?width=120\";s:4:\"Icon\";s:21:\"button3.html?width=69\";}s:21:\"buttonLayoutLazyWidth\";a:3:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";s:4:\"Icon\";s:2:\"69\";}s:22:\"buttonLayoutLazyHeight\";a:3:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";s:4:\"Icon\";s:2:\"52\";}s:23:\"buttonLayoutWidthHeight\";a:3:{s:6:\"Normal\";s:22:\"height=\"69\" width=\"51\"\";s:7:\"Compact\";s:23:\"height=\"22\" width=\"120\"\";s:4:\"Icon\";s:22:\"height=\"52\" width=\"69\"\";}s:4:\"name\";s:6:\"Reddit\";s:10:\"websiteURL\";s:21:\"http://www.reddit.com\";s:6:\"apiURL\";s:30:\"http://www.reddit.com/buttons/\";s:7:\"baseURL\";s:165:\"<iframe src=\"http://www.reddit.com/static/button/VOTE_BUTTON_DESIGN&url=VOTE_URL&title=VOTE_TITLE&newwindow=\'1\'\" EXTRA_VALUE scrolling=\'no\' frameborder=\'0\'></iframe>\";s:12:\"baseURL_lazy\";s:164:\"<div class=\'dd-reddit-ajax-load dd-reddit-POST_ID\'></div><iframe class=\'DD_REDDIT_AJAX_POST_ID\' src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\'></iframe>\";s:19:\"baseURL_lazy_script\";s:400:\" function loadReddit_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-reddit-POST_ID\').remove();$(\'.DD_REDDIT_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_REDDIT_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_REDDIT_AJAX_POST_ID\').attr(\'src\',\'http://www.reddit.com/static/button/VOTE_BUTTON_DESIGN&url=VOTE_URL&title=VOTE_TITLE&newwindow=1\'); }); }\";s:21:\"scheduler_lazy_script\";s:58:\"window.setTimeout(\'loadReddit_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:20:\"dd_reddit_appendType\";s:0:\"\";s:22:\"dd_reddit_buttonDesign\";s:0:\"\";s:25:\"dd_reddit_ajax_left_float\";s:0:\"\";s:19:\"dd_reddit_lazy_load\";s:0:\"\";s:23:\"dd_reddit_button_weight\";s:2:\"99\";}s:18:\"option_append_type\";s:20:\"dd_reddit_appendType\";s:20:\"option_button_design\";s:22:\"dd_reddit_buttonDesign\";s:20:\"option_button_weight\";s:23:\"dd_reddit_button_weight\";s:22:\"option_ajax_left_float\";s:25:\"dd_reddit_ajax_left_float\";s:16:\"option_lazy_load\";s:19:\"dd_reddit_lazy_load\";s:19:\"button_weight_value\";s:2:\"99\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:15:\"dd_button_gbuzz\";O:8:\"DD_GBuzz\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:12:\"normal-count\";s:7:\"Compact\";s:11:\"small-count\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:12:\"normal-count\";s:7:\"Compact\";s:11:\"small-count\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:11:\"Google Buzz\";s:10:\"websiteURL\";s:26:\"http://www.google.com/buzz\";s:6:\"apiURL\";s:53:\"http://www.google.com/buzz/api/admin/configPostWidget\";s:7:\"baseURL\";s:247:\"<a title=\'Post on Google Buzz\' class=\'google-buzz-button\' href=\'http://www.google.com/buzz/post\' data-button-style=\'VOTE_BUTTON_DESIGN\' data-url=\'VOTE_URL\'></a><script type=\'text/javascript\' src=\'http://www.google.com/buzz/api/button.js\'></script>\";s:12:\"baseURL_lazy\";s:215:\"<div class=\'dd-gbuzz-ajax-load dd-gbuzz-POST_ID\'></div><a title=\'Post on Google Buzz\' class=\'google-buzz-button\' href=\'http://www.google.com/buzz/post\' data-button-style=\'VOTE_BUTTON_DESIGN\' data-url=\'VOTE_URL\'></a>\";s:19:\"baseURL_lazy_script\";s:162:\" function loadGBuzz_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-gbuzz-POST_ID\').remove();$.getScript(\'http://www.google.com/buzz/api/button.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:57:\"window.setTimeout(\'loadGBuzz_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:19:\"dd_gbuzz_appendType\";s:0:\"\";s:21:\"dd_gbuzz_buttonDesign\";s:0:\"\";s:24:\"dd_gbuzz_ajax_left_float\";s:0:\"\";s:18:\"dd_gbuzz_lazy_load\";s:0:\"\";s:22:\"dd_gbuzz_button_weight\";s:2:\"98\";}s:18:\"option_append_type\";s:19:\"dd_gbuzz_appendType\";s:20:\"option_button_design\";s:21:\"dd_gbuzz_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_gbuzz_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_gbuzz_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_gbuzz_lazy_load\";s:19:\"button_weight_value\";s:2:\"98\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:15:\"dd_button_dzone\";O:8:\"DD_DZone\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:25:\"1\' height=\'70\' width=\'50\'\";s:7:\"Compact\";s:26:\"2\' height=\'25\' width=\'155\'\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:1:\"1\";s:7:\"Compact\";s:1:\"2\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"50\";s:7:\"Compact\";s:3:\"155\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"70\";s:7:\"Compact\";s:2:\"25\";}s:4:\"name\";s:5:\"DZone\";s:10:\"websiteURL\";s:20:\"http://www.dzone.com\";s:6:\"apiURL\";s:38:\"http://www.dzone.com/links/buttons.jsp\";s:7:\"baseURL\";s:163:\"<iframe src=\'http://widgets.dzone.com/links/widgets/zoneit.html?url=VOTE_URL&amp;title=VOTE_TITLE&amp;t=VOTE_BUTTON_DESIGN frameborder=\'0\' scrolling=\'no\'></iframe>\";s:12:\"baseURL_lazy\";s:161:\"<div class=\'dd-dzone-ajax-load dd-dzone-POST_ID\'></div><iframe class=\'DD_DZONE_AJAX_POST_ID\' src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\'></iframe>\";s:19:\"baseURL_lazy_script\";s:400:\" function loadDzone_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-dzone-POST_ID\').remove();$(\'.DD_DZONE_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_DZONE_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_DZONE_AJAX_POST_ID\').attr(\'src\',\'http://widgets.dzone.com/links/widgets/zoneit.html?url=VOTE_URL&title=VOTE_TITLE&t=VOTE_BUTTON_DESIGN\'); }); }\";s:21:\"scheduler_lazy_script\";s:57:\"window.setTimeout(\'loadDzone_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:19:\"dd_dzone_appendType\";s:0:\"\";s:21:\"dd_dzone_buttonDesign\";s:0:\"\";s:24:\"dd_dzone_ajax_left_float\";s:0:\"\";s:18:\"dd_dzone_lazy_load\";s:0:\"\";s:22:\"dd_dzone_button_weight\";s:2:\"97\";}s:18:\"option_append_type\";s:19:\"dd_dzone_appendType\";s:20:\"option_button_design\";s:21:\"dd_dzone_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_dzone_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_dzone_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_dzone_lazy_load\";s:19:\"button_weight_value\";s:2:\"97\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:17:\"dd_button_fbshare\";O:10:\"DD_FbShare\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:9:\"box_count\";s:7:\"Compact\";s:12:\"button_count\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:9:\"box_count\";s:7:\"Compact\";s:12:\"button_count\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:14:\"Facebook Share\";s:10:\"websiteURL\";s:23:\"http://www.facebook.com\";s:6:\"apiURL\";s:30:\"http://www.facebook.com/share/\";s:7:\"baseURL\";s:209:\"<a name=\'fb_share\' type=\'VOTE_BUTTON_DESIGN\' share_url=\'VOTE_URL\' href=\'http://www.facebook.com/sharer.php\'></a><script src=\'http://static.ak.fbcdn.net/connect.php/js/FB.Share\' type=\'text/javascript\'></script>\";s:12:\"baseURL_lazy\";s:203:\"<div class=\'dd-fbshare-ajax-load dd-fbshare-POST_ID\'></div><a class=\'DD_FBSHARE_AJAX_POST_ID\' name=\'fb_share\' type=\'VOTE_BUTTON_DESIGN\' share_url=\'VOTE_URL\' href=\'http://www.facebook.com/sharer.php\'></a>\";s:19:\"baseURL_lazy_script\";s:177:\" function loadFBShare_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-fbshare-POST_ID\').remove(); $.getScript(\'http://static.ak.fbcdn.net/connect.php/js/FB.Share\'); }); }\";s:21:\"scheduler_lazy_script\";s:59:\"window.setTimeout(\'loadFBShare_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:21:\"dd_fbshare_appendType\";s:0:\"\";s:23:\"dd_fbshare_buttonDesign\";s:0:\"\";s:26:\"dd_fbshare_ajax_left_float\";s:0:\"\";s:20:\"dd_fbshare_lazy_load\";s:0:\"\";s:24:\"dd_fbshare_button_weight\";s:2:\"95\";}s:18:\"option_append_type\";s:21:\"dd_fbshare_appendType\";s:20:\"option_button_design\";s:23:\"dd_fbshare_buttonDesign\";s:20:\"option_button_weight\";s:24:\"dd_fbshare_button_weight\";s:22:\"option_ajax_left_float\";s:26:\"dd_fbshare_ajax_left_float\";s:16:\"option_lazy_load\";s:20:\"dd_fbshare_lazy_load\";s:19:\"button_weight_value\";s:2:\"95\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_delicious\";O:12:\"DD_Delicious\":30:{s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:25:\"dd_delicious_normal_image\";s:7:\"Compact\";s:26:\"dd_delicious_compact_image\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:25:\"dd_delicious_normal_image\";s:7:\"Compact\";s:26:\"dd_delicious_compact_image\";}s:4:\"name\";s:9:\"Delicious\";s:10:\"websiteURL\";s:24:\"http://www.delicious.com\";s:6:\"apiURL\";s:35:\"http://www.delicious.com/help/feeds\";s:7:\"baseURL\";s:436:\"<div class=\'VOTE_BUTTON_DESIGN dd_delicious\'><a class=\'VOTE_BUTTON_DESIGN\' href=\'http://delicious.com/save\' onclick=\"window.open(\'http://delicious.com/save?v=5&amp;noui&amp;jump=close&amp;url=\'+encodeURIComponent(\'VOTE_URL\')+\'&amp;title=\'+encodeURIComponent(\'VOTE_TITLE\'),\'delicious\', \'toolbar=no,width=550,height=550\'); return false;\"><span id=\'DD_DELICIOUS_AJAX_POST_ID\'><div style=\'padding-top:3px\'>SAVED_COUNT</div></span></a></div>\";s:12:\"baseURL_lazy\";s:374:\"<div class=\'VOTE_BUTTON_DESIGN dd_delicious\'><a href=\'http://delicious.com/save\' onclick=\"window.open(\'http://delicious.com/save?v=5&amp;noui&amp;jump=close&amp;url=\'+encodeURIComponent(\'VOTE_URL\')+\'&amp;title=\'+encodeURIComponent(\'VOTE_TITLE\'),\'delicious\', \'toolbar=no,width=550,height=550\'); return false;\"><span id=\'DD_DELICIOUS_AJAX_POST_ID\'>SAVED_COUNT</span></a></div>\";s:19:\"baseURL_lazy_script\";s:428:\" function loadDelicious_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-delicious-POST_ID\').remove();$.getJSON(\'http://feeds.delicious.com/v2/json/urlinfo/data?url=VOTE_URL&amp;callback=?\',function(data) {var msg =\'\';var count = 0;if (data.length > 0) {count = data[0].total_posts;if(count ==0){msg = \'0\';}else if(count ==1){msg = \'1\';}else{msg = count}}else{msg = \'0\';}$(\'#DD_DELICIOUS_AJAX_POST_ID\').text(msg);}); }); }\";s:21:\"scheduler_lazy_script\";s:61:\"window.setTimeout(\'loadDelicious_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:23:\"dd_delicious_appendType\";s:0:\"\";s:25:\"dd_delicious_buttonDesign\";s:0:\"\";s:28:\"dd_delicious_ajax_left_float\";s:0:\"\";s:22:\"dd_delicious_lazy_load\";s:0:\"\";s:26:\"dd_delicious_button_weight\";s:2:\"93\";}s:18:\"option_append_type\";s:23:\"dd_delicious_appendType\";s:20:\"option_button_design\";s:25:\"dd_delicious_buttonDesign\";s:20:\"option_button_weight\";s:26:\"dd_delicious_button_weight\";s:22:\"option_ajax_left_float\";s:28:\"dd_delicious_ajax_left_float\";s:16:\"option_lazy_load\";s:22:\"dd_delicious_lazy_load\";s:19:\"button_weight_value\";s:2:\"93\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:16:\"dd_button_fblike\";O:9:\"DD_FbLike\":31:{s:19:\"float_button_design\";s:14:\"Like Box Count\";s:12:\"buttonLayout\";a:6:{s:13:\"Like Standard\";s:81:\"layout=standard&amp;action=like&amp;width=350&amp;height=24&amp;colorscheme=light\";s:17:\"Like Button Count\";s:84:\"layout=button_count&amp;action=like&amp;width=92&amp;height=20&amp;colorscheme=light\";s:14:\"Like Box Count\";s:81:\"layout=box_count&amp;action=like&amp;width=50&amp;height=60&amp;colorscheme=light\";s:18:\"Recommend Standard\";s:86:\"layout=standard&amp;action=recommend&amp;width=400&amp;height=24&amp;colorscheme=light\";s:22:\"Recommend Button Count\";s:90:\"layout=button_count&amp;action=recommend&amp;width=130&amp;height=20&amp;colorscheme=light\";s:19:\"Recommend Box Count\";s:86:\"layout=box_count&amp;action=recommend&amp;width=90&amp;height=60&amp;colorscheme=light\";}s:16:\"buttonLayoutLazy\";a:6:{s:13:\"Like Standard\";s:81:\"layout=standard&amp;action=like&amp;width=350&amp;height=24&amp;colorscheme=light\";s:17:\"Like Button Count\";s:84:\"layout=button_count&amp;action=like&amp;width=92&amp;height=20&amp;colorscheme=light\";s:14:\"Like Box Count\";s:81:\"layout=box_count&amp;action=like&amp;width=50&amp;height=60&amp;colorscheme=light\";s:18:\"Recommend Standard\";s:86:\"layout=standard&amp;action=recommend&amp;width=400&amp;height=24&amp;colorscheme=light\";s:22:\"Recommend Button Count\";s:90:\"layout=button_count&amp;action=recommend&amp;width=130&amp;height=20&amp;colorscheme=light\";s:19:\"Recommend Box Count\";s:86:\"layout=box_count&amp;action=recommend&amp;width=90&amp;height=60&amp;colorscheme=light\";}s:23:\"buttonLayoutWidthHeight\";a:6:{s:13:\"Like Standard\";s:25:\"width:500px; height:24px;\";s:17:\"Like Button Count\";s:24:\"width:92px; height:20px;\";s:14:\"Like Box Count\";s:24:\"width:50px; height:62px;\";s:18:\"Recommend Standard\";s:25:\"width:500px; height:24px;\";s:22:\"Recommend Button Count\";s:25:\"width:130px; height:20px;\";s:19:\"Recommend Box Count\";s:24:\"width:90px; height:60px;\";}s:21:\"buttonLayoutLazyWidth\";a:6:{s:13:\"Like Standard\";s:3:\"500\";s:17:\"Like Button Count\";s:2:\"92\";s:14:\"Like Box Count\";s:2:\"50\";s:18:\"Recommend Standard\";s:3:\"500\";s:22:\"Recommend Button Count\";s:3:\"130\";s:19:\"Recommend Box Count\";s:2:\"90\";}s:22:\"buttonLayoutLazyHeight\";a:6:{s:13:\"Like Standard\";s:2:\"24\";s:17:\"Like Button Count\";s:2:\"20\";s:14:\"Like Box Count\";s:2:\"62\";s:18:\"Recommend Standard\";s:2:\"24\";s:22:\"Recommend Button Count\";s:2:\"20\";s:19:\"Recommend Box Count\";s:2:\"60\";}s:4:\"name\";s:22:\"Facebook Like (IFrame)\";s:10:\"websiteURL\";s:23:\"http://www.facebook.com\";s:6:\"apiURL\";s:58:\"http://developers.facebook.com/docs/reference/plugins/like\";s:7:\"baseURL\";s:234:\"<iframe src=\'http://www.facebook.com/plugins/like.php?href=VOTE_URL&amp;locale=FACEBOOK_LOCALE&amp;VOTE_BUTTON_DESIGN\' scrolling=\'no\' frameborder=\'0\' style=\'border:none; overflow:hidden; EXTRA_VALUE\' allowTransparency=\'true\'></iframe>\";s:12:\"baseURL_lazy\";s:189:\"<div class=\'dd-fblike-ajax-load dd-fblike-POST_ID\'></div><iframe class=\"DD_FBLIKE_AJAX_POST_ID\" src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\' allowTransparency=\'true\'></iframe>\";s:19:\"baseURL_lazy_script\";s:408:\" function loadFBLike_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-fblike-POST_ID\').remove();$(\'.DD_FBLIKE_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_FBLIKE_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_FBLIKE_AJAX_POST_ID\').attr(\'src\',\'http://www.facebook.com/plugins/like.php?href=VOTE_URL&amp;locale=FACEBOOK_LOCALE&amp;VOTE_BUTTON_DESIGN\'); }); }\";s:21:\"scheduler_lazy_script\";s:58:\"window.setTimeout(\'loadFBLike_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:20:\"dd_fblike_appendType\";s:0:\"\";s:22:\"dd_fblike_buttonDesign\";s:0:\"\";s:25:\"dd_fblike_ajax_left_float\";s:2:\"on\";s:19:\"dd_fblike_lazy_load\";s:0:\"\";s:23:\"dd_fblike_button_weight\";s:2:\"96\";}s:18:\"option_append_type\";s:20:\"dd_fblike_appendType\";s:20:\"option_button_design\";s:22:\"dd_fblike_buttonDesign\";s:20:\"option_button_weight\";s:23:\"dd_fblike_button_weight\";s:22:\"option_ajax_left_float\";s:25:\"dd_fblike_ajax_left_float\";s:16:\"option_lazy_load\";s:19:\"dd_fblike_lazy_load\";s:19:\"button_weight_value\";s:2:\"96\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:21:\"dd_button_stumbleupon\";O:14:\"DD_StumbleUpon\":30:{s:19:\"islazyLoadAvailable\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:1:\"5\";s:7:\"Compact\";s:1:\"1\";}s:4:\"name\";s:11:\"Stumbleupon\";s:10:\"websiteURL\";s:26:\"http://www.stumbleupon.com\";s:6:\"apiURL\";s:34:\"http://www.stumbleupon.com/badges/\";s:7:\"baseURL\";s:102:\"<script src=\'http://www.stumbleupon.com/hostedbadge.php?s=VOTE_BUTTON_DESIGN&amp;r=VOTE_URL\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:10:\"wp_options\";a:5:{s:25:\"dd_stumbleupon_appendType\";s:0:\"\";s:27:\"dd_stumbleupon_buttonDesign\";s:0:\"\";s:30:\"dd_stumbleupon_ajax_left_float\";s:0:\"\";s:24:\"dd_stumbleupon_lazy_load\";s:0:\"\";s:28:\"dd_stumbleupon_button_weight\";s:2:\"97\";}s:18:\"option_append_type\";s:25:\"dd_stumbleupon_appendType\";s:20:\"option_button_design\";s:27:\"dd_stumbleupon_buttonDesign\";s:20:\"option_button_weight\";s:28:\"dd_stumbleupon_button_weight\";s:22:\"option_ajax_left_float\";s:30:\"dd_stumbleupon_ajax_left_float\";s:16:\"option_lazy_load\";s:24:\"dd_stumbleupon_lazy_load\";s:19:\"button_weight_value\";s:2:\"97\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_yahoobuzz\";O:8:\"DD_YBuzz\":30:{s:19:\"islazyLoadAvailable\";b:0;s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:6:\"square\";s:7:\"Compact\";s:11:\"small-votes\";s:12:\"Compact_Text\";s:10:\"text-votes\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:10:\"Yahoo Buzz\";s:10:\"websiteURL\";s:21:\"http://buzz.yahoo.com\";s:6:\"apiURL\";s:29:\"http://buzz.yahoo.com/buttons\";s:7:\"baseURL\";s:216:\"<script type=\'text/javascript\'>yahooBuzzArticleHeadline=\"VOTE_TITLE\";yahooBuzzArticleId=\"VOTE_URL\";</script><script type=\'text/javascript\' src=\'http://d.yimg.com/ds/badge2.js\' badgetype=\'VOTE_BUTTON_DESIGN\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:19:\"dd_ybuzz_appendType\";s:0:\"\";s:21:\"dd_ybuzz_buttonDesign\";s:0:\"\";s:24:\"dd_ybuzz_ajax_left_float\";s:0:\"\";s:18:\"dd_ybuzz_lazy_load\";s:0:\"\";s:22:\"dd_ybuzz_button_weight\";s:2:\"90\";}s:18:\"option_append_type\";s:19:\"dd_ybuzz_appendType\";s:20:\"option_button_design\";s:21:\"dd_ybuzz_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_ybuzz_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_ybuzz_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_ybuzz_lazy_load\";s:19:\"button_weight_value\";s:2:\"90\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_fbshareme\";O:12:\"DD_FbShareMe\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:5:\"large\";s:7:\"Compact\";s:5:\"small\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:5:\"large\";s:7:\"Compact\";s:5:\"small\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"53\";s:7:\"Compact\";s:2:\"80\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"18\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:10:\"fbShare.me\";s:10:\"websiteURL\";s:21:\"http://www.fbshare.me\";s:6:\"apiURL\";s:21:\"http://www.fbshare.me\";s:7:\"baseURL\";s:142:\"<script>var fbShare = {url: \'VOTE_URL\',size: \'VOTE_BUTTON_DESIGN\',}</script><script src=\'http://widgets.fbshare.me/files/fbshare.js\'></script>\";s:12:\"baseURL_lazy\";s:198:\"<div class=\'dd-fbshareme-ajax-load dd-fbshareme-POST_ID\'></div><iframe class=\"DD_FBSHAREME_AJAX_POST_ID\" src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\' allowtransparency=\'true\'></iframe>\";s:19:\"baseURL_lazy_script\";s:400:\" function loadFBShareMe_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-fbshareme-POST_ID\').remove();$(\'.DD_FBSHAREME_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_FBSHAREME_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_FBSHAREME_AJAX_POST_ID\').attr(\'src\',\'http://widgets.fbshare.me/files/fbshare.php?url=VOTE_URL&size=VOTE_BUTTON_DESIGN\');  }); }\";s:21:\"scheduler_lazy_script\";s:61:\"window.setTimeout(\'loadFBShareMe_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:23:\"dd_fbshareme_appendType\";s:0:\"\";s:25:\"dd_fbshareme_buttonDesign\";s:0:\"\";s:28:\"dd_fbshareme_ajax_left_float\";s:0:\"\";s:22:\"dd_fbshareme_lazy_load\";s:0:\"\";s:26:\"dd_fbshareme_button_weight\";s:2:\"94\";}s:18:\"option_append_type\";s:23:\"dd_fbshareme_appendType\";s:20:\"option_button_design\";s:25:\"dd_fbshareme_buttonDesign\";s:20:\"option_button_weight\";s:26:\"dd_fbshareme_button_weight\";s:22:\"option_ajax_left_float\";s:28:\"dd_fbshareme_ajax_left_float\";s:16:\"option_lazy_load\";s:22:\"dd_fbshareme_lazy_load\";s:19:\"button_weight_value\";s:2:\"94\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:21:\"dd_button_blogenagage\";O:13:\"DD_BlogEngage\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:1:{s:6:\"Normal\";s:11:\"button4.php\";}s:4:\"name\";s:10:\"BlogEngage\";s:10:\"websiteURL\";s:25:\"http://www.blogengage.com\";s:6:\"apiURL\";s:43:\"http://www.blogengage.com/profile_promo.php\";s:7:\"baseURL\";s:132:\"<script type=\'text/javascript\'>submit_url = \'VOTE_URL\';</script><script src=\'http://blogengage.com/evb/VOTE_BUTTON_DESIGN\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:24:\"dd_blogengage_appendType\";s:0:\"\";s:26:\"dd_blogengage_buttonDesign\";s:0:\"\";s:29:\"dd_blogengage_ajax_left_float\";s:0:\"\";s:23:\"dd_blogengage_lazy_load\";s:0:\"\";s:27:\"dd_blogengage_button_weight\";s:2:\"84\";}s:18:\"option_append_type\";s:24:\"dd_blogengage_appendType\";s:20:\"option_button_design\";s:26:\"dd_blogengage_buttonDesign\";s:20:\"option_button_weight\";s:27:\"dd_blogengage_button_weight\";s:22:\"option_ajax_left_float\";s:29:\"dd_blogengage_ajax_left_float\";s:16:\"option_lazy_load\";s:23:\"dd_blogengage_lazy_load\";s:19:\"button_weight_value\";s:2:\"84\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:21:\"dd_button_thewebblend\";O:14:\"DD_TheWebBlend\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:0:\"\";s:7:\"Compact\";s:21:\"badge_size=\'compact\';\";}s:4:\"name\";s:11:\"TheWebBlend\";s:10:\"websiteURL\";s:26:\"http://www.thewebblend.com\";s:6:\"apiURL\";s:33:\"http://thewebblend.com/tools/vote\";s:7:\"baseURL\";s:194:\"<script type=\'text/javascript\'>url_site=\'VOTE_URL\'; VOTE_BUTTON_DESIGN</script><script src=\'http://thewebblend.com/sites/all/modules/drigg_external/js/button.js\' type=\'text/javascript\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:22:\"dd_webblend_appendType\";s:0:\"\";s:24:\"dd_webblend_buttonDesign\";s:0:\"\";s:27:\"dd_webblend_ajax_left_float\";s:0:\"\";s:21:\"dd_webblend_lazy_load\";s:0:\"\";s:25:\"dd_webblend_button_weight\";s:2:\"85\";}s:18:\"option_append_type\";s:22:\"dd_webblend_appendType\";s:20:\"option_button_design\";s:24:\"dd_webblend_buttonDesign\";s:20:\"option_button_weight\";s:25:\"dd_webblend_button_weight\";s:22:\"option_ajax_left_float\";s:27:\"dd_webblend_ajax_left_float\";s:16:\"option_lazy_load\";s:21:\"dd_webblend_lazy_load\";s:19:\"button_weight_value\";s:2:\"85\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:20:\"dd_button_designbump\";O:13:\"DD_DesignBump\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:1:{s:6:\"Normal\";s:6:\"Normal\";}s:4:\"name\";s:10:\"DesignBump\";s:10:\"websiteURL\";s:25:\"http://www.designbump.com\";s:6:\"apiURL\";s:33:\"http://designbump.com/content/evb\";s:7:\"baseURL\";s:176:\"<script type=\'text/javascript\'>url_site=\'VOTE_URL\'; </script> <script src=\'http://designbump.com/sites/all/modules/drigg_external/js/button.js\' type=\'text/javascript\'></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:24:\"dd_designbump_appendType\";s:0:\"\";s:26:\"dd_designbump_buttonDesign\";s:0:\"\";s:29:\"dd_designbump_ajax_left_float\";s:0:\"\";s:23:\"dd_designbump_lazy_load\";s:0:\"\";s:27:\"dd_designbump_button_weight\";s:2:\"87\";}s:18:\"option_append_type\";s:24:\"dd_designbump_appendType\";s:20:\"option_button_design\";s:26:\"dd_designbump_buttonDesign\";s:20:\"option_button_weight\";s:27:\"dd_designbump_button_weight\";s:22:\"option_ajax_left_float\";s:29:\"dd_designbump_ajax_left_float\";s:16:\"option_lazy_load\";s:23:\"dd_designbump_lazy_load\";s:19:\"button_weight_value\";s:2:\"87\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:17:\"dd_button_twitter\";O:10:\"DD_Twitter\":30:{s:11:\"append_type\";s:10:\"left_float\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:7:\"Twitter\";s:10:\"websiteURL\";s:22:\"http://www.twitter.com\";s:6:\"apiURL\";s:38:\"http://twitter.com/goodies/tweetbutton\";s:7:\"baseURL\";s:252:\"<a href=\"http://twitter.com/share\" class=\"twitter-share-button\" data-url=\"VOTE_URL\" data-count=\"VOTE_BUTTON_DESIGN\" data-text=\"VOTE_TITLE\" data-via=\"VOTE_SOURCE\" ></a><script type=\"text/javascript\" src=\"http://platform.twitter.com/widgets.js\"></script>\";s:12:\"baseURL_lazy\";s:226:\"<div class=\'dd-twitter-ajax-load dd-twitter-POST_ID\'></div><a href=\"http://twitter.com/share\" class=\"twitter-share-button\" data-url=\"VOTE_URL\" data-count=\"VOTE_BUTTON_DESIGN\" data-text=\"VOTE_TITLE\" data-via=\"VOTE_SOURCE\" ></a>\";s:19:\"baseURL_lazy_script\";s:164:\" function loadTwitter_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-twitter-POST_ID\').remove();$.getScript(\'http://platform.twitter.com/widgets.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:59:\"window.setTimeout(\'loadTwitter_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:21:\"dd_twitter_appendType\";s:0:\"\";s:23:\"dd_twitter_buttonDesign\";s:0:\"\";s:26:\"dd_twitter_ajax_left_float\";s:2:\"on\";s:20:\"dd_twitter_lazy_load\";s:0:\"\";s:24:\"dd_twitter_button_weight\";s:3:\"110\";}s:18:\"option_append_type\";s:21:\"dd_twitter_appendType\";s:20:\"option_button_design\";s:23:\"dd_twitter_buttonDesign\";s:20:\"option_button_weight\";s:24:\"dd_twitter_button_weight\";s:22:\"option_ajax_left_float\";s:26:\"dd_twitter_ajax_left_float\";s:16:\"option_lazy_load\";s:20:\"dd_twitter_lazy_load\";s:19:\"button_weight_value\";s:3:\"110\";s:19:\"float_button_design\";s:6:\"Normal\";s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_tweetmeme\";O:12:\"DD_TweetMeme\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:30:\"normal\' height=\'61\' width=\'50\'\";s:7:\"Compact\";s:31:\"compact\' height=\'20\' width=\'90\'\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"normal\";s:7:\"Compact\";s:7:\"compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"50\";s:7:\"Compact\";s:2:\"90\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"61\";s:7:\"Compact\";s:2:\"20\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:9:\"TweetMeme\";s:10:\"websiteURL\";s:25:\"http://www.tweetmeme.com/\";s:6:\"apiURL\";s:46:\"http://wordpress.org/extend/plugins/tweetmeme/\";s:7:\"baseURL\";s:200:\"<iframe src=\'http://api.tweetmeme.com/button.js?url=VOTE_URL&source=VOTE_SOURCE&service=VOTE_SERVICE_NAME&service_api=VOTE_SERVICE_API&style=VOTE_BUTTON_DESIGN frameborder=\'0\' scrolling=\'no\'></iframe>\";s:12:\"baseURL_lazy\";s:173:\"<div class=\'dd-tweetmeme-ajax-load dd-tweetmeme-POST_ID\'></div><iframe class=\'DD_TWEETMEME_AJAX_POST_ID\' src=\'\' height=\'0\' width=\'0\' scrolling=\'no\' frameborder=\'0\'></iframe>\";s:19:\"baseURL_lazy_script\";s:465:\" function loadTweetMeme_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-tweetmeme-POST_ID\').remove();$(\'.DD_TWEETMEME_AJAX_POST_ID\').attr(\'width\',\'VOTE_BUTTON_DESIGN_LAZY_WIDTH\');$(\'.DD_TWEETMEME_AJAX_POST_ID\').attr(\'height\',\'VOTE_BUTTON_DESIGN_LAZY_HEIGHT\');$(\'.DD_TWEETMEME_AJAX_POST_ID\').attr(\'src\',\'http://api.tweetmeme.com/button.js?url=VOTE_URL&source=VOTE_SOURCE&style=VOTE_BUTTON_DESIGN&service=VOTE_SERVICE_NAME&service_api=VOTE_SERVICE_API\'); }); }\";s:21:\"scheduler_lazy_script\";s:61:\"window.setTimeout(\'loadTweetMeme_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:23:\"dd_tweetmeme_appendType\";s:0:\"\";s:25:\"dd_tweetmeme_buttonDesign\";s:0:\"\";s:28:\"dd_tweetmeme_ajax_left_float\";s:0:\"\";s:22:\"dd_tweetmeme_lazy_load\";s:0:\"\";s:26:\"dd_tweetmeme_button_weight\";s:2:\"97\";}s:18:\"option_append_type\";s:23:\"dd_tweetmeme_appendType\";s:20:\"option_button_design\";s:25:\"dd_tweetmeme_buttonDesign\";s:20:\"option_button_weight\";s:26:\"dd_tweetmeme_button_weight\";s:22:\"option_ajax_left_float\";s:28:\"dd_tweetmeme_ajax_left_float\";s:16:\"option_lazy_load\";s:22:\"dd_tweetmeme_lazy_load\";s:19:\"button_weight_value\";s:2:\"97\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;}s:15:\"dd_button_topsy\";O:8:\"DD_Topsy\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:3:\"big\";s:7:\"Compact\";s:7:\"compact\";}s:4:\"name\";s:5:\"Topsy\";s:10:\"websiteURL\";s:20:\"http://www.topsy.com\";s:6:\"apiURL\";s:44:\"http://labs.topsy.com/button/retweet-button/\";s:7:\"baseURL\";s:233:\"<script type=\"text/javascript\" src=\"http://cdn.topsy.com/topsy.js?init=topsyWidgetCreator\"></script><div class=\"topsy_widget_data\"><!--{\"url\":\"VOTE_URL\",\"style\":\"VOTE_BUTTON_DESIGN\",\"theme\":\"VOTE_THEME\",\"nick\":\"VOTE_SOURCE\"}--></div>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:19:\"dd_topsy_appendType\";s:0:\"\";s:21:\"dd_topsy_buttonDesign\";s:0:\"\";s:24:\"dd_topsy_ajax_left_float\";s:0:\"\";s:18:\"dd_topsy_lazy_load\";s:0:\"\";s:22:\"dd_topsy_button_weight\";s:2:\"96\";}s:18:\"option_append_type\";s:19:\"dd_topsy_appendType\";s:20:\"option_button_design\";s:21:\"dd_topsy_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_topsy_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_topsy_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_topsy_lazy_load\";s:19:\"button_weight_value\";s:2:\"96\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:18:\"dd_button_comments\";O:11:\"DD_Comments\":30:{s:19:\"islazyLoadAvailable\";b:0;s:12:\"buttonLayout\";a:1:{s:6:\"Normal\";s:6:\"Normal\";}s:4:\"name\";s:8:\"Comments\";s:10:\"websiteURL\";s:11:\"http://none\";s:6:\"apiURL\";s:11:\"http://none\";s:7:\"baseURL\";s:142:\"<div id=\'dd_comments\'><a class=\'clcount\' href=VOTE_URL><span class=\'ctotal\'>COMMENTS_COUNT</span></a><a class=\'clink\' href=VOTE_URL></a></div>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:10:\"wp_options\";a:5:{s:22:\"dd_comments_appendType\";s:0:\"\";s:24:\"dd_comments_buttonDesign\";s:0:\"\";s:27:\"dd_comments_ajax_left_float\";s:0:\"\";s:21:\"dd_comments_lazy_load\";s:0:\"\";s:25:\"dd_comments_button_weight\";s:2:\"88\";}s:18:\"option_append_type\";s:22:\"dd_comments_appendType\";s:20:\"option_button_design\";s:24:\"dd_comments_buttonDesign\";s:20:\"option_button_weight\";s:25:\"dd_comments_button_weight\";s:22:\"option_ajax_left_float\";s:27:\"dd_comments_ajax_left_float\";s:16:\"option_lazy_load\";s:21:\"dd_comments_lazy_load\";s:19:\"button_weight_value\";s:2:\"88\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:18:\"dd_button_linkedin\";O:11:\"DD_Linkedin\":30:{s:11:\"append_type\";s:10:\"left_float\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:3:\"top\";s:7:\"Compact\";s:5:\"right\";s:7:\"NoCount\";s:4:\"none\";}s:16:\"buttonLayoutLazy\";a:3:{s:6:\"Normal\";s:3:\"top\";s:7:\"Compact\";s:5:\"right\";s:7:\"NoCount\";s:4:\"none\";}s:16:\"isEncodeRequired\";b:0;s:4:\"name\";s:8:\"Linkedin\";s:10:\"websiteURL\";s:23:\"http://www.linkedin.com\";s:6:\"apiURL\";s:34:\"http://www.linkedin.com/publishers\";s:7:\"baseURL\";s:168:\"<script type=\'text/javascript\' src=\'http://platform.linkedin.com/in.js\'></script><script type=\'IN/share\' data-url=\'VOTE_URL\' data-counter=\'VOTE_BUTTON_DESIGN\'></script>\";s:12:\"baseURL_lazy\";s:148:\"<div class=\'dd-linkedin-ajax-load dd-linkedin-POST_ID\'></div><script type=\'IN/share\' data-url=\'VOTE_URL\' data-counter=\'VOTE_BUTTON_DESIGN\'></script>\";s:19:\"baseURL_lazy_script\";s:162:\" function loadLinkedin_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-linkedin-POST_ID\').remove();$.getScript(\'http://platform.linkedin.com/in.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:60:\"window.setTimeout(\'loadLinkedin_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:22:\"dd_linkedin_appendType\";s:0:\"\";s:24:\"dd_linkedin_buttonDesign\";s:0:\"\";s:27:\"dd_linkedin_ajax_left_float\";s:2:\"on\";s:21:\"dd_linkedin_lazy_load\";s:0:\"\";s:25:\"dd_linkedin_button_weight\";s:2:\"94\";}s:18:\"option_append_type\";s:22:\"dd_linkedin_appendType\";s:20:\"option_button_design\";s:24:\"dd_linkedin_buttonDesign\";s:20:\"option_button_weight\";s:25:\"dd_linkedin_button_weight\";s:22:\"option_ajax_left_float\";s:27:\"dd_linkedin_ajax_left_float\";s:16:\"option_lazy_load\";s:21:\"dd_linkedin_lazy_load\";s:19:\"button_weight_value\";s:2:\"94\";s:19:\"float_button_design\";s:6:\"Normal\";s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:15:\"dd_button_serpd\";O:8:\"DD_Serpd\":30:{s:19:\"islazyLoadAvailable\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:1:{s:6:\"Normal\";s:0:\"\";}s:4:\"name\";s:5:\"Serpd\";s:10:\"websiteURL\";s:20:\"http://www.serpd.com\";s:6:\"apiURL\";s:29:\"http://www.serpd.com/widgets/\";s:7:\"baseURL\";s:150:\"<script type=\"text/javascript\">submit_url = \"VOTE_URL\";</script><script type=\"text/javascript\" src=\"http://www.serpd.com/index.php?page=evb\"></script>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:10:\"wp_options\";a:5:{s:19:\"dd_serpd_appendType\";s:0:\"\";s:21:\"dd_serpd_buttonDesign\";s:0:\"\";s:24:\"dd_serpd_ajax_left_float\";s:0:\"\";s:18:\"dd_serpd_lazy_load\";s:0:\"\";s:22:\"dd_serpd_button_weight\";s:2:\"86\";}s:18:\"option_append_type\";s:19:\"dd_serpd_appendType\";s:20:\"option_button_design\";s:21:\"dd_serpd_buttonDesign\";s:20:\"option_button_weight\";s:22:\"dd_serpd_button_weight\";s:22:\"option_ajax_left_float\";s:24:\"dd_serpd_ajax_left_float\";s:16:\"option_lazy_load\";s:18:\"dd_serpd_lazy_load\";s:19:\"button_weight_value\";s:2:\"86\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:22:\"dd_button_fblike_xfbml\";O:15:\"DD_FbLike_XFBML\":30:{s:11:\"append_type\";s:10:\"left_float\";s:13:\"button_design\";s:17:\"Like Button Count\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:19:\"islazyLoadAvailable\";b:0;s:19:\"float_button_design\";s:14:\"Like Box Count\";s:12:\"buttonLayout\";a:6:{s:13:\"Like Standard\";s:13:\" width=\"450\" \";s:17:\"Like Button Count\";s:34:\" layout=\"button_count\" width=\"92\" \";s:14:\"Like Box Count\";s:31:\" layout=\"box_count\" width=\"50\" \";s:18:\"Recommend Standard\";s:32:\" action=\"recommend\" width=\"400\" \";s:22:\"Recommend Button Count\";s:54:\" action=\"recommend\" layout=\"button_count\" width=\"130\" \";s:19:\"Recommend Box Count\";s:50:\" action=\"recommend\" layout=\"box_count\" width=\"90\" \";}s:4:\"name\";s:21:\"Facebook Like (XFBML)\";s:10:\"websiteURL\";s:23:\"http://www.facebook.com\";s:6:\"apiURL\";s:58:\"http://developers.facebook.com/docs/reference/plugins/like\";s:7:\"baseURL\";s:170:\"<script src=\"http://connect.facebook.net/FACEBOOK_LOCALE/all.js#xfbml=1\"></script><fb:like href=\"VOTE_URL\" FACEBOOK_SEND FACEBOOK_SHOW_FACE VOTE_BUTTON_DESIGN ></fb:like>\";s:12:\"baseURL_lazy\";N;s:19:\"baseURL_lazy_script\";N;s:21:\"scheduler_lazy_script\";N;s:20:\"scheduler_lazy_timer\";N;s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:10:\"wp_options\";a:5:{s:26:\"dd_fblike_xfbml_appendType\";s:0:\"\";s:28:\"dd_fblike_xfbml_buttonDesign\";s:0:\"\";s:31:\"dd_fblike_xfbml_ajax_left_float\";s:0:\"\";s:25:\"dd_fblike_xfbml_lazy_load\";s:0:\"\";s:29:\"dd_fblike_xfbml_button_weight\";s:2:\"96\";}s:18:\"option_append_type\";s:26:\"dd_fblike_xfbml_appendType\";s:20:\"option_button_design\";s:28:\"dd_fblike_xfbml_buttonDesign\";s:20:\"option_button_weight\";s:29:\"dd_fblike_xfbml_button_weight\";s:22:\"option_ajax_left_float\";s:31:\"dd_fblike_xfbml_ajax_left_float\";s:16:\"option_lazy_load\";s:25:\"dd_fblike_xfbml_lazy_load\";s:19:\"button_weight_value\";s:2:\"96\";s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:6:\"Normal\";s:7:\"Compact\";s:7:\"Compact\";}s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:17:\"dd_button_google1\";O:10:\"DD_Google1\":30:{s:11:\"append_type\";s:10:\"left_float\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:4:{s:6:\"Normal\";s:4:\"tall\";s:14:\"Compact (15px)\";s:5:\"small\";s:14:\"Compact (20px)\";s:6:\"medium\";s:14:\"Compact (24px)\";s:4:\"none\";}s:16:\"buttonLayoutLazy\";a:4:{s:6:\"Normal\";s:4:\"tall\";s:14:\"Compact (15px)\";s:5:\"small\";s:14:\"Compact (20px)\";s:6:\"medium\";s:14:\"Compact (24px)\";s:4:\"none\";}s:4:\"name\";s:9:\"Google +1\";s:10:\"websiteURL\";s:32:\"http://www.google.com/+1/button/\";s:6:\"apiURL\";s:37:\"http://code.google.com/apis/+1button/\";s:7:\"baseURL\";s:149:\"<script type=\'text/javascript\' src=\'https://apis.google.com/js/plusone.js\'></script><g:plusone size=\'VOTE_BUTTON_DESIGN\' href=\'VOTE_URL\'></g:plusone>\";s:12:\"baseURL_lazy\";s:124:\"<div class=\'dd-google1-ajax-load dd-google1-POST_ID\'></div><g:plusone size=\'VOTE_BUTTON_DESIGN\' href=\'VOTE_URL\'></g:plusone>\";s:19:\"baseURL_lazy_script\";s:163:\" function loadGoogle1_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-google1-POST_ID\').remove();$.getScript(\'https://apis.google.com/js/plusone.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:59:\"window.setTimeout(\'loadGoogle1_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:21:\"dd_google1_appendType\";s:0:\"\";s:23:\"dd_google1_buttonDesign\";s:0:\"\";s:26:\"dd_google1_ajax_left_float\";s:2:\"on\";s:20:\"dd_google1_lazy_load\";s:0:\"\";s:24:\"dd_google1_button_weight\";s:2:\"95\";}s:18:\"option_append_type\";s:21:\"dd_google1_appendType\";s:20:\"option_button_design\";s:23:\"dd_google1_buttonDesign\";s:20:\"option_button_weight\";s:24:\"dd_google1_button_weight\";s:22:\"option_ajax_left_float\";s:26:\"dd_google1_ajax_left_float\";s:16:\"option_lazy_load\";s:20:\"dd_google1_lazy_load\";s:19:\"button_weight_value\";s:2:\"95\";s:19:\"float_button_design\";s:6:\"Normal\";s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:16:\"dd_button_buffer\";O:9:\"DD_Buffer\":30:{s:11:\"append_type\";s:13:\"after_content\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";s:2:\"on\";s:9:\"lazy_load\";b:0;s:16:\"isEncodeRequired\";b:0;s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";s:8:\"No Count\";s:4:\"none\";}s:16:\"buttonLayoutLazy\";a:3:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";s:8:\"No Count\";s:4:\"none\";}s:4:\"name\";s:6:\"Buffer\";s:10:\"websiteURL\";s:21:\"http://bufferapp.com/\";s:6:\"apiURL\";s:36:\"http://bufferapp.com/goodies/button/\";s:7:\"baseURL\";s:234:\"<a href=\"http://bufferapp.com/add\" class=\"buffer-add-button\" data-count=\"VOTE_BUTTON_DESIGN\" data-url=\"VOTE_URL\" data-via=\"VOTE_BUFFER_SOURCE\"></a><script type=\"text/javascript\" src=\"http://static.bufferapp.com/js/button.js\"></script>\";s:12:\"baseURL_lazy\";s:147:\"<a href=\"http://bufferapp.com/add\" class=\"buffer-add-button\" data-count=\"VOTE_BUTTON_DESIGN\" data-url=\"VOTE_URL\" data-via=\"VOTE_BUFFER_SOURCE\"></a>\";s:19:\"baseURL_lazy_script\";s:163:\"function loadBuffer_POST_ID(){ jQuery(document).ready(function($) { $(\'.dd-buffer-POST_ID\').remove();$.getScript(\'http://static.bufferapp.com/js/button.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:58:\"window.setTimeout(\'loadBuffer_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:20:\"dd_buffer_appendType\";s:0:\"\";s:22:\"dd_buffer_buttonDesign\";s:0:\"\";s:25:\"dd_buffer_ajax_left_float\";s:0:\"\";s:19:\"dd_buffer_lazy_load\";s:0:\"\";s:23:\"dd_buffer_button_weight\";s:2:\"99\";}s:18:\"option_append_type\";s:20:\"dd_buffer_appendType\";s:20:\"option_button_design\";s:22:\"dd_buffer_buttonDesign\";s:20:\"option_button_weight\";s:23:\"dd_buffer_button_weight\";s:22:\"option_ajax_left_float\";s:25:\"dd_buffer_ajax_left_float\";s:16:\"option_lazy_load\";s:19:\"dd_buffer_lazy_load\";s:19:\"button_weight_value\";s:2:\"99\";s:19:\"float_button_design\";s:6:\"Normal\";s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:19:\"dd_button_pinterest\";O:12:\"DD_Pinterest\":30:{s:12:\"buttonLayout\";a:3:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";s:8:\"No Count\";s:4:\"none\";}s:16:\"buttonLayoutLazy\";a:3:{s:6:\"Normal\";s:8:\"vertical\";s:7:\"Compact\";s:10:\"horizontal\";s:8:\"No Count\";s:4:\"none\";}s:4:\"name\";s:9:\"Pinterest\";s:10:\"websiteURL\";s:20:\"http://pinterest.com\";s:6:\"apiURL\";s:55:\"http://pinterest.com/about/goodies/#button_for_websites\";s:7:\"baseURL\";s:249:\"<a href=\"http://pinterest.com/pin/create/button/?url=VOTE_URL&description=VOTE_TITLE&media=VOTE_IMAGE\" class=\"pin-it-button\" count-layout=\"VOTE_BUTTON_DESIGN\"></a><script type=\"text/javascript\" src=\"http://assets.pinterest.com/js/pinit.js\"></script>\";s:12:\"baseURL_lazy\";s:207:\"<a href=\"http://pinterest.com/pin/create/button/?url=VOTE_URL&description=VOTE_TITLE&media=VOTE_IMAGE\" class=\"pin-it-button dd-pinterest-ajax-load dd-pinterest-POST_ID\" count-layout=\"VOTE_BUTTON_DESIGN\"></a>\";s:19:\"baseURL_lazy_script\";s:132:\"function loadPinterest_POST_ID(){ jQuery(document).ready(function($) { $.getScript(\'http://assets.pinterest.com/js/pinit.js\'); }); }\";s:21:\"scheduler_lazy_script\";s:61:\"window.setTimeout(\'loadPinterest_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:23:\"dd_pinterest_appendType\";s:0:\"\";s:25:\"dd_pinterest_buttonDesign\";s:0:\"\";s:28:\"dd_pinterest_ajax_left_float\";s:2:\"on\";s:22:\"dd_pinterest_lazy_load\";s:0:\"\";s:26:\"dd_pinterest_button_weight\";s:2:\"10\";}s:18:\"option_append_type\";s:23:\"dd_pinterest_appendType\";s:20:\"option_button_design\";s:25:\"dd_pinterest_buttonDesign\";s:20:\"option_button_weight\";s:26:\"dd_pinterest_button_weight\";s:22:\"option_ajax_left_float\";s:28:\"dd_pinterest_ajax_left_float\";s:16:\"option_lazy_load\";s:22:\"dd_pinterest_lazy_load\";s:19:\"button_weight_value\";s:2:\"10\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}s:16:\"dd_button_flattr\";O:9:\"DD_Flattr\":30:{s:12:\"buttonLayout\";a:2:{s:6:\"Normal\";s:7:\"default\";s:7:\"Compact\";s:7:\"compact\";}s:16:\"buttonLayoutLazy\";a:2:{s:6:\"Normal\";s:7:\"default\";s:7:\"Compact\";s:7:\"compact\";}s:4:\"name\";s:6:\"Flattr\";s:10:\"websiteURL\";s:17:\"http://flattr.com\";s:6:\"apiURL\";s:36:\"http://developers.flattr.net/button/\";s:7:\"baseURL\";s:257:\"<script src=\"http://api.flattr.com/js/0.6/load.js?mode=auto\"></script><a class=\"FlattrButton\" href=\"VOTE_URL\" style=\"display:none;\" title=\"VOTE_TITLE\" data-flattr-uid=\"VOTE_FLATTR_UID\" data-flattr-button=\"VOTE_BUTTON_DESIGN\" data-flattr-category=\"text\"></a>\";s:12:\"baseURL_lazy\";s:187:\"<a class=\"FlattrButton\" href=\"VOTE_URL\" style=\"display:none;\" title=\"VOTE_TITLE\" data-flattr-uid=\"VOTE_FLATTR_UID\" data-flattr-button=\"VOTE_BUTTON_DESIGN\" data-flattr-category=\"text\"></a>\";s:19:\"baseURL_lazy_script\";s:136:\"function loadFlattr_POST_ID(){ jQuery(document).ready(function($) { $.getScript(\'http://api.flattr.com/js/0.6/load.js?mode=auto\'); }); }\";s:21:\"scheduler_lazy_script\";s:58:\"window.setTimeout(\'loadFlattr_POST_ID()\',SCHEDULER_TIMER);\";s:20:\"scheduler_lazy_timer\";s:4:\"1000\";s:8:\"finalURL\";N;s:13:\"finalURL_lazy\";N;s:20:\"finalURL_lazy_script\";N;s:27:\"final_scheduler_lazy_script\";N;s:16:\"isEncodeRequired\";b:1;s:19:\"islazyLoadAvailable\";b:1;s:10:\"wp_options\";a:5:{s:20:\"dd_flattr_appendType\";s:0:\"\";s:22:\"dd_flattr_buttonDesign\";s:0:\"\";s:25:\"dd_flattr_ajax_left_float\";s:0:\"\";s:19:\"dd_flattr_lazy_load\";s:0:\"\";s:23:\"dd_flattr_button_weight\";s:2:\"10\";}s:18:\"option_append_type\";s:20:\"dd_flattr_appendType\";s:20:\"option_button_design\";s:22:\"dd_flattr_buttonDesign\";s:20:\"option_button_weight\";s:23:\"dd_flattr_button_weight\";s:22:\"option_ajax_left_float\";s:25:\"dd_flattr_ajax_left_float\";s:16:\"option_lazy_load\";s:19:\"dd_flattr_lazy_load\";s:19:\"button_weight_value\";s:2:\"10\";s:19:\"float_button_design\";s:6:\"Normal\";s:11:\"append_type\";s:4:\"none\";s:13:\"button_design\";s:6:\"Normal\";s:15:\"ajax_left_float\";b:0;s:9:\"lazy_load\";b:0;s:21:\"buttonLayoutLazyWidth\";a:2:{s:6:\"Normal\";s:2:\"51\";s:7:\"Compact\";s:3:\"120\";}s:22:\"buttonLayoutLazyHeight\";a:2:{s:6:\"Normal\";s:2:\"69\";s:7:\"Compact\";s:2:\"22\";}}}s:21:\"dd_float_button_final\";a:5:{s:16:\"dd_button_fblike\";r:279;s:17:\"dd_button_twitter\";r:609;s:18:\"dd_button_linkedin\";r:784;s:17:\"dd_button_google1\";r:921;s:19:\"dd_button_pinterest\";r:1015;}}', 'yes');
INSERT INTO `wp_options` VALUES('1821', 'dd_client_version', '5', 'yes');
INSERT INTO `wp_options` VALUES('2024', '_transient_ye_video_MmMyMDQ4NDRmN2M2N2Q0ZDhkZGQxZWIwMThhMjk0N2Y2', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/1AQBZYUltq8?version=3&amp;fs=0&amp;rel=0&amp;title=Acne+%26amp%3B+Dermatology+%3A+How+to+Make+Acne+Scars+Disappear%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('7847', '_site_transient_timeout_theme_roots', '1402344544', 'yes');
INSERT INTO `wp_options` VALUES('7848', '_site_transient_theme_roots', 'a:2:{s:18:\"headlines_enhanced\";s:7:\"/themes\";s:14:\"twentyfourteen\";s:7:\"/themes\";}', 'yes');
INSERT INTO `wp_options` VALUES('1922', 'woo_disable_comments_date', 'false', 'yes');
INSERT INTO `wp_options` VALUES('2017', '_transient_timeout_ye_video_ZjcyYWZhMGI0YjIxZTE1ODg2YjgyMjFmZmQ5', '1339675685', 'no');
INSERT INTO `wp_options` VALUES('2018', '_transient_ye_video_ZjcyYWZhMGI0YjIxZTE1ODg2YjgyMjFmZmQ5OTYxN2Rl', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/uCtUI6Ot_ns?version=3&amp;fs=0&amp;rel=0&amp;title=Acne+%26amp%3B+Dermatology+%3A+How+to+Get+Rid+of+Acne+Scars%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('2042', '_transient_ye_video_ODhhMzlhZDYwNWMyNjhhNjBjNTA2YjAxOTQ3MGU3OTRi', '\n<!-- YouTube Embed v2.4.1 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/g4j1BMWAGAs?version=3&amp;fs=0&amp;rel=0&amp;title=Nutritional+Supplements+%3A+Benefits+of+Vitamin+E+Oil%3C%2Ftitle%3E%3Ccont&amp;wmode=opaque\" ></iframe>\n\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3046', 'logged_in_key', 'lWrQ$2u<[7uCnwcASz~o#LP>H$}-MT1q)!k|b:G-{,SDC{,%vo,2`(PlhlnP1w/Q', 'yes');
INSERT INTO `wp_options` VALUES('3044', 'auth_key', '-NJt7|~>6L12<P@UW6O5^:2[.Y3|>72(22kd@XxA&pquGcReW:QO@Y;}&DfM$=l_', 'yes');
INSERT INTO `wp_options` VALUES('3048', 'nonce_key', 'G[n;]M-Vh>S{;P()jLOT.s j[G]dN#2S}0~W_>QKN:M{6tt*%j6?(q0q]GGXlig}', 'yes');
INSERT INTO `wp_options` VALUES('3110', '_transient_plugins_delete_result_22', '1', 'yes');
INSERT INTO `wp_options` VALUES('3142', '_transient_timeout_aye_video_NjFmMjdjMDg2YzBiNGEzOWQ0MjJmYTBiMzJ', '1340424934', 'no');
INSERT INTO `wp_options` VALUES('3130', '_transient_timeout_aye_video_ODA3NDgwODczNGE3M2NiZWQwNTc0Y2QxZmF', '1340424934', 'no');
INSERT INTO `wp_options` VALUES('3192', '_transient_timeout_aye_video_NjA2OGZmNjBjNWJhZjZjZGZkZjE3NDFjOWZ', '1340995876', 'no');
INSERT INTO `wp_options` VALUES('3136', '_transient_timeout_aye_video_MjM4MTI4MzkxMjhhZjI4NDZjMjUxYjFmZTE', '1340424934', 'no');
INSERT INTO `wp_options` VALUES('3137', '_transient_aye_video_MjM4MTI4MzkxMjhhZjI4NDZjMjUxYjFmZTE4ZjkzYmU', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/1AQBZYUltq8?fs=0&amp;rel=0&amp;title=Acne+%26amp%3B+Dermatology+%3A+How+to+Make+Acne+Scars+Disappear&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3131', '_transient_aye_video_ODA3NDgwODczNGE3M2NiZWQwNTc0Y2QxZmFmMzI2NWE', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/uCtUI6Ot_ns?fs=0&amp;rel=0&amp;title=Acne+%26amp%3B+Dermatology+%3A+How+to+Get+Rid+of+Acne+Scars&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3148', '_transient_timeout_aye_video_MjQ4YTMyZWI4NWZmZDY2NTUyNGU4NDczN2U', '1340424934', 'no');
INSERT INTO `wp_options` VALUES('3149', '_transient_aye_video_MjQ4YTMyZWI4NWZmZDY2NTUyNGU4NDczN2UwNzBhMmU', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/qiIZJJ9l5ZU?fs=0&amp;rel=0&amp;title=Healthy+Skin+Care+%3A+How+to+Make+Scars+Go+Away&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3154', '_transient_timeout_aye_video_MmRhNmZjZGM5YWQyZTkxOTVlMjVlMmMwNTY', '1340424934', 'no');
INSERT INTO `wp_options` VALUES('3155', '_transient_aye_video_MmRhNmZjZGM5YWQyZTkxOTVlMjVlMmMwNTY3YzU2NzY', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/g4j1BMWAGAs?fs=0&amp;rel=0&amp;title=Nutritional+Supplements+%3A+Benefits+of+Vitamin+E+Oil&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3193', '_transient_aye_video_NjA2OGZmNjBjNWJhZjZjZGZkZjE3NDFjOWZhOTdkYWY', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/pGZHNqP8WnY?fs=0&amp;rel=0&amp;title=Clickbank+Tutorial&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3198', '_transient_timeout_aye_video_ZWJjNDVhMmNmOTYxYjBlMGE3Yzc2NDczNzB', '1340995876', 'no');
INSERT INTO `wp_options` VALUES('3199', '_transient_aye_video_ZWJjNDVhMmNmOTYxYjBlMGE3Yzc2NDczNzBiY2Q0NGJ', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/vAMRXJj5J_A?fs=0&amp;rel=0&amp;title=ClickBank+Tutorial+2011+%7C+Use+This+To+Pick+The+Most+Profitable+Product+From+ClickBank+MarketPlace&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3204', '_transient_timeout_aye_video_MDk1YzY0YmNhZjQ2MGFjMzMwM2M3ZjQzMzd', '1340995876', 'no');
INSERT INTO `wp_options` VALUES('3205', '_transient_aye_video_MDk1YzY0YmNhZjQ2MGFjMzMwM2M3ZjQzMzdkNTBkYzY', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/53Zx_n4hgK0?fs=0&amp;rel=0&amp;title=ClickBank+Tools+Tutorial+Tips+%7C+Use+This+FREE+ClickBank+Marketplace+Tool+To+Boost+Your+Commission&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3210', '_transient_timeout_aye_video_ZjY5ZTNmNzE2ZmMyZTdjZjU0Mjc0ODY5YjR', '1340995876', 'no');
INSERT INTO `wp_options` VALUES('3211', '_transient_aye_video_ZjY5ZTNmNzE2ZmMyZTdjZjU0Mjc0ODY5YjRlYmQ5MWJ', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/SAVV-ZrlWeI?fs=0&amp;rel=0&amp;title=Clickbank+Tutorial&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3216', '_transient_timeout_aye_video_MzQ2ZWY0NGFlYTgzYmE5NTI2MDNkOWNlMTg', '1340995876', 'no');
INSERT INTO `wp_options` VALUES('3217', '_transient_aye_video_MzQ2ZWY0NGFlYTgzYmE5NTI2MDNkOWNlMTgxMjQ5Njg', '\n<!-- YouTube Embed v2.5.4 | http://www.artiss.co.uk/artiss-youtube-embed -->\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/cSUiqwcHKRw?fs=0&amp;rel=0&amp;title=Youtube+Clickbank+Tutorial+-+Follow+All+Guide+in+Video+To+Make+Big+Money+in+Clickbank&amp;wmode=opaque\" ></iframe>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('3822', 'link_manager_enabled', '1', 'yes');
INSERT INTO `wp_options` VALUES('5895', 'sm_rewrite_done', '$Id: sitemap-loader.php 925789 2014-06-03 17:03:07Z arnee $', 'yes');
INSERT INTO `wp_options` VALUES('7852', 'rewrite_rules', 'a:76:{s:34:\"sitemap(-+([a-zA-Z0-9_-]+))?\\.xml$\";s:40:\"index.php?xml_sitemap=params=$matches[2]\";s:38:\"sitemap(-+([a-zA-Z0-9_-]+))?\\.xml\\.gz$\";s:49:\"index.php?xml_sitemap=params=$matches[2];zip=true\";s:35:\"sitemap(-+([a-zA-Z0-9_-]+))?\\.html$\";s:50:\"index.php?xml_sitemap=params=$matches[2];html=true\";s:38:\"sitemap(-+([a-zA-Z0-9_-]+))?\\.html.gz$\";s:59:\"index.php?xml_sitemap=params=$matches[2];html=true;zip=true\";s:47:\"category/(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:42:\"category/(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:35:\"category/(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:17:\"category/(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";s:44:\"tag/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:39:\"tag/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?tag=$matches[1]&feed=$matches[2]\";s:32:\"tag/([^/]+)/page/?([0-9]{1,})/?$\";s:43:\"index.php?tag=$matches[1]&paged=$matches[2]\";s:14:\"tag/([^/]+)/?$\";s:25:\"index.php?tag=$matches[1]\";s:45:\"type/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:40:\"type/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?post_format=$matches[1]&feed=$matches[2]\";s:33:\"type/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?post_format=$matches[1]&paged=$matches[2]\";s:15:\"type/([^/]+)/?$\";s:33:\"index.php?post_format=$matches[1]\";s:48:\".*wp-(atom|rdf|rss|rss2|feed|commentsrss2)\\.php$\";s:18:\"index.php?feed=old\";s:20:\".*wp-app\\.php(/.*)?$\";s:19:\"index.php?error=403\";s:18:\".*wp-register.php$\";s:23:\"index.php?register=true\";s:32:\"feed/(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:27:\"(feed|rdf|rss|rss2|atom)/?$\";s:27:\"index.php?&feed=$matches[1]\";s:20:\"page/?([0-9]{1,})/?$\";s:28:\"index.php?&paged=$matches[1]\";s:41:\"comments/feed/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:36:\"comments/(feed|rdf|rss|rss2|atom)/?$\";s:42:\"index.php?&feed=$matches[1]&withcomments=1\";s:44:\"search/(.+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:39:\"search/(.+)/(feed|rdf|rss|rss2|atom)/?$\";s:40:\"index.php?s=$matches[1]&feed=$matches[2]\";s:32:\"search/(.+)/page/?([0-9]{1,})/?$\";s:41:\"index.php?s=$matches[1]&paged=$matches[2]\";s:14:\"search/(.+)/?$\";s:23:\"index.php?s=$matches[1]\";s:47:\"author/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:42:\"author/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:50:\"index.php?author_name=$matches[1]&feed=$matches[2]\";s:35:\"author/([^/]+)/page/?([0-9]{1,})/?$\";s:51:\"index.php?author_name=$matches[1]&paged=$matches[2]\";s:17:\"author/([^/]+)/?$\";s:33:\"index.php?author_name=$matches[1]\";s:69:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:64:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:80:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&feed=$matches[4]\";s:57:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:81:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]&paged=$matches[4]\";s:39:\"([0-9]{4})/([0-9]{1,2})/([0-9]{1,2})/?$\";s:63:\"index.php?year=$matches[1]&monthnum=$matches[2]&day=$matches[3]\";s:56:\"([0-9]{4})/([0-9]{1,2})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:51:\"([0-9]{4})/([0-9]{1,2})/(feed|rdf|rss|rss2|atom)/?$\";s:64:\"index.php?year=$matches[1]&monthnum=$matches[2]&feed=$matches[3]\";s:44:\"([0-9]{4})/([0-9]{1,2})/page/?([0-9]{1,})/?$\";s:65:\"index.php?year=$matches[1]&monthnum=$matches[2]&paged=$matches[3]\";s:26:\"([0-9]{4})/([0-9]{1,2})/?$\";s:47:\"index.php?year=$matches[1]&monthnum=$matches[2]\";s:43:\"([0-9]{4})/feed/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:38:\"([0-9]{4})/(feed|rdf|rss|rss2|atom)/?$\";s:43:\"index.php?year=$matches[1]&feed=$matches[2]\";s:31:\"([0-9]{4})/page/?([0-9]{1,})/?$\";s:44:\"index.php?year=$matches[1]&paged=$matches[2]\";s:13:\"([0-9]{4})/?$\";s:26:\"index.php?year=$matches[1]\";s:27:\".?.+?/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:37:\".?.+?/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:57:\".?.+?/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:52:\".?.+?/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)/trackback/?$\";s:35:\"index.php?pagename=$matches[1]&tb=1\";s:40:\"(.?.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:35:\"(.?.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:47:\"index.php?pagename=$matches[1]&feed=$matches[2]\";s:28:\"(.?.+?)/page/?([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&paged=$matches[2]\";s:35:\"(.?.+?)/comment-page-([0-9]{1,})/?$\";s:48:\"index.php?pagename=$matches[1]&cpage=$matches[2]\";s:20:\"(.?.+?)(/[0-9]+)?/?$\";s:47:\"index.php?pagename=$matches[1]&page=$matches[2]\";s:31:\".+?/[^/]+/attachment/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:41:\".+?/[^/]+/attachment/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:61:\".+?/[^/]+/attachment/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:56:\".+?/[^/]+/attachment/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:56:\".+?/[^/]+/attachment/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:26:\"(.+?)/([^/]+)/trackback/?$\";s:57:\"index.php?category_name=$matches[1]&name=$matches[2]&tb=1\";s:46:\"(.+?)/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:69:\"index.php?category_name=$matches[1]&name=$matches[2]&feed=$matches[3]\";s:41:\"(.+?)/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:69:\"index.php?category_name=$matches[1]&name=$matches[2]&feed=$matches[3]\";s:34:\"(.+?)/([^/]+)/page/?([0-9]{1,})/?$\";s:70:\"index.php?category_name=$matches[1]&name=$matches[2]&paged=$matches[3]\";s:41:\"(.+?)/([^/]+)/comment-page-([0-9]{1,})/?$\";s:70:\"index.php?category_name=$matches[1]&name=$matches[2]&cpage=$matches[3]\";s:26:\"(.+?)/([^/]+)(/[0-9]+)?/?$\";s:69:\"index.php?category_name=$matches[1]&name=$matches[2]&page=$matches[3]\";s:20:\".+?/[^/]+/([^/]+)/?$\";s:32:\"index.php?attachment=$matches[1]\";s:30:\".+?/[^/]+/([^/]+)/trackback/?$\";s:37:\"index.php?attachment=$matches[1]&tb=1\";s:50:\".+?/[^/]+/([^/]+)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:45:\".+?/[^/]+/([^/]+)/(feed|rdf|rss|rss2|atom)/?$\";s:49:\"index.php?attachment=$matches[1]&feed=$matches[2]\";s:45:\".+?/[^/]+/([^/]+)/comment-page-([0-9]{1,})/?$\";s:50:\"index.php?attachment=$matches[1]&cpage=$matches[2]\";s:38:\"(.+?)/feed/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:33:\"(.+?)/(feed|rdf|rss|rss2|atom)/?$\";s:52:\"index.php?category_name=$matches[1]&feed=$matches[2]\";s:26:\"(.+?)/page/?([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&paged=$matches[2]\";s:33:\"(.+?)/comment-page-([0-9]{1,})/?$\";s:53:\"index.php?category_name=$matches[1]&cpage=$matches[2]\";s:8:\"(.+?)/?$\";s:35:\"index.php?category_name=$matches[1]\";}', 'yes');
INSERT INTO `wp_options` VALUES('7647', '_site_transient_update_core', 'O:8:\"stdClass\":4:{s:7:\"updates\";a:1:{i:0;O:8:\"stdClass\":10:{s:8:\"response\";s:6:\"latest\";s:8:\"download\";s:59:\"https://downloads.wordpress.org/release/wordpress-3.9.1.zip\";s:6:\"locale\";s:5:\"en_US\";s:8:\"packages\";O:8:\"stdClass\":5:{s:4:\"full\";s:59:\"https://downloads.wordpress.org/release/wordpress-3.9.1.zip\";s:10:\"no_content\";s:70:\"https://downloads.wordpress.org/release/wordpress-3.9.1-no-content.zip\";s:11:\"new_bundled\";s:71:\"https://downloads.wordpress.org/release/wordpress-3.9.1-new-bundled.zip\";s:7:\"partial\";b:0;s:8:\"rollback\";b:0;}s:7:\"current\";s:5:\"3.9.1\";s:7:\"version\";s:5:\"3.9.1\";s:11:\"php_version\";s:5:\"5.2.4\";s:13:\"mysql_version\";s:3:\"5.0\";s:11:\"new_bundled\";s:3:\"3.8\";s:15:\"partial_version\";s:0:\"\";}}s:12:\"last_checked\";i:1402342745;s:15:\"version_checked\";s:5:\"3.9.1\";s:12:\"translations\";a:0:{}}', 'yes');
INSERT INTO `wp_options` VALUES('7649', 'can_compress_scripts', '1', 'yes');
INSERT INTO `wp_options` VALUES('7865', '_transient_vye_title_wnt4KP4B_V8', 'Restore Your Eyesight Naturally With Simple Exercise', 'no');
INSERT INTO `wp_options` VALUES('7781', '_site_transient_update_themes', 'O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1402342745;s:7:\"checked\";a:2:{s:18:\"headlines_enhanced\";s:5:\"3.2.8\";s:14:\"twentyfourteen\";s:3:\"1.1\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}', 'yes');
INSERT INTO `wp_options` VALUES('7650', '_transient_timeout_feed_94bc6e7dd050c2a74ce39668c35643cd', '1402317736', 'no');
INSERT INTO `wp_options` VALUES('7651', '_transient_feed_94bc6e7dd050c2a74ce39668c35643cd', 'a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:51:\"\n	\n	\n	\n	\n	\n	\n		\n		\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:6:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"iThemes\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:18:\"http://ithemes.com\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"Your one-stop shop for WordPress themes, plugins and training.\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Jun 2014 17:18:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"How to Use Our Unbranded WordPress Tutorials to Train Your Clients\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"http://ithemes.com/2014/06/05/use-unbranded-wordpress-tutorials-train-clients-use-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"http://ithemes.com/2014/06/05/use-unbranded-wordpress-tutorials-train-clients-use-wordpress/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 05 Jun 2014 14:00:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:27:\"WordPress Freelancer Series\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:19:\"WordPress Tutorials\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"http://ithemes.com/?p=24081\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:355:\"One of the great perks of being an iThemes Toolkit member is access to our unbranded WordPress tutorials. Our unbranded tutorials are based on our 24 free WordPress 101 tutorial videos, but they&#8217;re designed to be an added bonus to the Toolkit because they can be white-labeled with your branding to train your clients to use their site. [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Kristen Wright\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:9221:\"<p>One of the great perks of being an <a href=\"http://ithemes.com/toolkit/\">iThemes Toolkit</a> member is access to our unbranded WordPress tutorials. Our unbranded tutorials are based on our <a href=\"http://ithemes.com/tutorial/category/wordpress-101/\">24 free WordPress 101 tutorial videos</a>, but they&#8217;re designed to be an added bonus to the Toolkit because they can be white-labeled with your branding to train your clients to use their site.</p>\n<p><strong>Today we&#8217;re glad to announce that our unbranded tutorials just got a total overhaul and are now updated for WordPress 3.9.</strong> Current Toolkit members will now find their unbranded tutorials available for download from the <a href=\"http://ithemes.com/member\">iThemes Member Panel</a>.</p>\n<p style=\"text-align: center;\"><a class=\"btn green\" href=\"http://ithemes.com/member\">Log in and download</a></p>\n<h2 style=\"margin-top: 40px;\">Why Use the Unbranded WordPress Tutorials?</h2>\n<ul>\n<li><strong>Save time training clients - </strong>We know that it can be a challenge to train your clients to use their site (especially if they&#8217;re total WordPress newbies). Ultimately, you can spend more time building and deploying new websites and less time answering client questions about how to add a new post, make updates to a page or manage comments.</li>\n<li><strong>Add a polished, professional bonus to your own web design packages</strong> <strong>- </strong>With a set of pre-packaged video tutorials, you can add a new benefit to your web design packages.</li>\n<li><strong>Happier clients &#8211; </strong>By giving clients these resources, they can feel assured that they can really &#8220;own&#8221; their website and have more confidence in being able to use it. That also means they don&#8217;t have to come to you for simple edits they could easily manage on their own.<strong><br />\n</strong></li>\n</ul>\n<h2 style=\"margin-top: 40px;\">Downloading the Unbranded Tutorials</h2>\n<p>Toolkit customers can download the unbranded tutorials from the <a href=\"http://ithemes.com/member\">iThemes Member Panel</a>. From the <strong>Downloads</strong> page, navigate to the <strong>Other</strong> tab. From here, you&#8217;ll see the <strong>Wp101 &#8211; Unbranded</strong> zip file. Click <strong>download</strong>.</p>\n<p><img class=\"alignnone size-full wp-image-24117\" alt=\"iThemes Member Panel (2)\" src=\"http://ithemes.com/wp-content/uploads/2014/06/iThemes-Member-Panel-2.png\" width=\"1229\" height=\"865\" /></p>\n<h2 style=\"margin-top: 40px;\">Creating Custom Bumpers for the Videos</h2>\n<p>After you&#8217;ve downloaded and unzipped the Unbranded Tutorials zip file, you can start adding your own branding with front and end bumpers (or slides).</p>\n<p>To create these slides, create an image at 1067px x 597px using Photoshop.</p>\n<p><img class=\"alignnone size-full wp-image-24091\" alt=\"Screen Shot 2014-06-04 at 3.29.00 PM\" src=\"http://ithemes.com/wp-content/uploads/2014/06/Screen-Shot-2014-06-04-at-3.29.00-PM.png\" width=\"588\" height=\"329\" /></p>\n<p>Now, you can add a custom design for your front and end bumpers. Use your company&#8217;s logo and add a message. Save this file as a PNG or JPG.</p>\n<p>Here&#8217;s a quick example slide:</p>\n<p><img class=\"alignnone size-full wp-image-24089\" alt=\"front-bumper\" src=\"http://ithemes.com/wp-content/uploads/2014/06/front-bumper.png\" width=\"1067\" height=\"597\" /></p>\n<p>You can <a href=\"http://365psd.com/day/4-162/\">download the free PSD for the devices used above</a> here.</p>\n<h2 style=\"margin-top: 40px;\">Adding Your Own Branding to the Videos Using Camtasia</h2>\n<p><a href=\"http://www.techsmith.com/camtasia.html\">Camtasia</a> is a really easy-to-use video editing software that allows you to record on-screen videos or import videos to customize or edit content (we use Camtasia to create and edit <a href=\"http://ithemes.com/tutorials\">all of our own tutorial videos</a>). You can also use <a href=\"http://www.telestream.net/screenflow/overview.htm\">Screenflow</a>, another screen-capturing and video editing program. Just use a software that will allow you to import a mp4v and add beginning and end frames.</p>\n<p>1. To get started adding your own bumpers, import the file to a new Camtasia project. From the Camtasia menu, visit <strong>File &gt; Import Media</strong>.</p>\n<p><img class=\"alignnone size-full wp-image-24086\" alt=\"camtasia-import-media\" src=\"http://ithemes.com/wp-content/uploads/2014/06/camtasia-import-media.png\" width=\"581\" height=\"366\" /></p>\n<p>2. Select the video you&#8217;d like edit and click <strong>Import</strong>.</p>\n<p><img class=\"alignnone size-full wp-image-24087\" alt=\"Screen Shot 2014-06-04 at 2.58.06 PM\" src=\"http://ithemes.com/wp-content/uploads/2014/06/Screen-Shot-2014-06-04-at-2.58.06-PM.png\" width=\"944\" height=\"503\" /></p>\n<p>3. Drag the new imported media file into the timeline at the bottom of the screen, leaving some room at the beginning to insert your beginning slide.</p>\n<p><img class=\"alignnone size-full wp-image-24088\" alt=\"camtasia-edit\" src=\"http://ithemes.com/wp-content/uploads/2014/06/camtasia-edit.png\" width=\"1064\" height=\"769\" /></p>\n<p>4. Import your bumpers by navigating again to <strong>File &gt; Import Media</strong>. Drag your bumpers to the beginning and end of the video.</p>\n<p><img class=\"alignnone size-full wp-image-24093\" alt=\"Screen Shot 2014-06-04 at 3.37.00 PM\" src=\"http://ithemes.com/wp-content/uploads/2014/06/Screen-Shot-2014-06-04-at-3.37.00-PM.png\" width=\"1244\" height=\"853\" /></p>\n<p>5. Add transitions to the bumper and video frames so the video &#8220;flows.&#8221; The default Camtasia <strong>Fade In/Out Transition</strong> is a smooth, simple transition. Click Transitions in the top menu and drag them to the beginning and ends of each segment of the video.</p>\n<p><img class=\"alignnone size-full wp-image-24094\" alt=\"Screen Shot 2014-06-04 at 3.39.44 PM\" src=\"http://ithemes.com/wp-content/uploads/2014/06/Screen-Shot-2014-06-04-at-3.39.44-PM.png\" width=\"1244\" height=\"850\" /></p>\n<p>6. Preview the video and then you&#8217;re ready to export (save). From the Camtasia menu, click <strong>Share &gt; Advanced Export</strong>.</p>\n<p><img class=\"alignnone size-full wp-image-24095\" alt=\"Screen Shot 2014-06-04 at 3.42.22 PM\" src=\"http://ithemes.com/wp-content/uploads/2014/06/Screen-Shot-2014-06-04-at-3.42.22-PM.png\" width=\"1243\" height=\"872\" /></p>\n<p>7. To preserve the HD quality of the video, make sure you&#8217;re exporting to MP4 and click options to select your frame rate and quality settings. Click <strong>OK</strong> to begin the export. Now your new video file is ready.</p>\n<p><img class=\"alignnone size-full wp-image-24096\" alt=\"Screen Shot 2014-06-04 at 3.43.44 PM\" src=\"http://ithemes.com/wp-content/uploads/2014/06/Screen-Shot-2014-06-04-at-3.43.44-PM.png\" width=\"710\" height=\"491\" /></p>\n<p>Once you&#8217;ve exported all the videos, you&#8217;re free to upload them to Vimeo, YouTube or host from your own website.</p>\n<h2 style=\"margin-top: 40px;\">Creating a Special Client Training Page on Your Site with iThemes Exchange</h2>\n<p>To further customize your client experience, you could use <a href=\"http://ithemes.com/exchange\">iThemes Exchange</a> to create a client-only training page with the <a href=\"http://ithemes.com/purchase/invoices/\">Invoices Add-on</a> (included with your Toolkit membership)</p>\n<p>1. Create a page on your site and embed the videos.</p>\n<p>2. Set up your client&#8217;s invoice. Here&#8217;s more information on <a href=\"http://ithemes.com/2013/12/19/send-invoices-with-wordpress/\">how to use the Invoices Add-on for iThemes Exchange</a>.</p>\n<p><img class=\"alignnone size-full wp-image-24099\" alt=\"Screen Shot 2014-06-04 at 4.00.42 PM\" src=\"http://ithemes.com/wp-content/uploads/2014/06/Screen-Shot-2014-06-04-at-4.00.42-PM.png\" width=\"678\" height=\"815\" /></p>\n<p>3. In the <strong>Purchase Message</strong> field of the Invoice editor, add a message and the link to access their training videos.</p>\n<p><img class=\"alignnone size-full wp-image-24098\" alt=\"Screen Shot 2014-06-04 at 4.02.34 PM\" src=\"http://ithemes.com/wp-content/uploads/2014/06/Screen-Shot-2014-06-04-at-4.02.34-PM.png\" width=\"756\" height=\"428\" /></p>\n<p>3. Once a client pays their invoice, their email confirmation receipt will contain their training link. Here&#8217;s a preview of how that could look:</p>\n<p><img class=\"alignnone size-full wp-image-24100\" alt=\"Screen Shot 2014-06-04 at 4.05.37 PM\" src=\"http://ithemes.com/wp-content/uploads/2014/06/Screen-Shot-2014-06-04-at-4.05.37-PM.png\" width=\"401\" height=\"450\" /></p>\n<h2>Log in and Download</h2>\n<div class=\"content-callout green\">All current Toolkit members will now find the Unbranded Tutorials available for download from the <a href=\"http://ithemes.com/member\">iThemes Member Panel</a>. Not a Toolkit member yet? The Toolkit includes our entire inventory of WordPress themes, plugins and annual membership at WebDesign.com, plus additional perks like our unbranded WordPress tutorials. It&#8217;s everything you need to run a WordPress web design business.</div>\n<p style=\"text-align: center;\"><a class=\"btn blue\" href=\"http://ithemes.com/toolkit\">Get the Toolkit now</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"http://ithemes.com/2014/06/05/use-unbranded-wordpress-tutorials-train-clients-use-wordpress/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:48:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"New WordPress 101 Tutorials\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"http://ithemes.com/2014/06/04/new-wordpress-101-tutorials/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"http://ithemes.com/2014/06/04/new-wordpress-101-tutorials/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Jun 2014 17:03:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:9:\"Tutorials\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:14:\"WordPress Tips\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:19:\"WordPress Tutorials\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"http://ithemes.com/?p=24035\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:350:\"We have a brand new line-up of WordPress 101 training tutorials available to you, for free! WordPress has changed quite a bit since we first posted the WordPress 101 training tutorial series. We&#8217;ve updated the tutorials to WordPress 3.9 so they are current with the latest major version of WordPress. Who Needs WordPress 101 Tutorials [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Ashley Hurney\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3010:\"<p><a href=\"http://ithemes.com/tutorial/category/wordpress-101/\"><img class=\"aligncenter size-full wp-image-24069\" alt=\"WordPress 101 Tutorials Screenshot\" src=\"http://ithemes.com/wp-content/uploads/2014/06/WordPress-101-Tutorials-Screenshot.png\" width=\"1900\" height=\"962\" /></a></p>\n<p>We have a brand new line-up of <a href=\"http://ithemes.com/tutorial/category/wordpress-101/\">WordPress 101</a> training tutorials available to you, for free!</p>\n<p>WordPress has changed quite a bit since we first posted the WordPress 101 training tutorial series. <strong>We&#8217;ve updated the tutorials to WordPress 3.9</strong> so they are current with the latest major version of WordPress.</p>\n<h2>Who Needs WordPress 101 Tutorials</h2>\n<ul>\n<li>Students</li>\n<li>New bloggers</li>\n<li>Freelance clients</li>\n<li>New web designers</li>\n<li>Anyone just starting out in WordPress</li>\n</ul>\n<h2>Make the Tutorials Work for You</h2>\n<blockquote><p>Any iThemes <a href=\"http://ithemes.com/toolkit/\">Toolkit</a> member has access to the unbranded WordPress 101 tutorials. You can add your own branding and package them to ship directly to your clients &#8211; <strong>saving you time and money.</strong></p></blockquote>\n<p>If you&#8217;re a freelancer, you know how much your time is worth. Saving time training clients is a huge perk that frees you up to build your business.</p>\n<h2>What WordPress 101 Tutorials Cover</h2>\n<ul>\n<li><a href=\"http://ithemes.com/tutorials/what-is-wordpress/\">What is WordPress?</a></li>\n<li><a href=\"http://ithemes.com/tutorials/wordpress-com-vs-wordpress-org/\">WordPress.com vs. WordPress.org</a></li>\n<li><a href=\"http://ithemes.com/tutorials/wordpress-dashboard/\">Exploring the WordPress Dashboard</a></li>\n<li><a href=\"http://ithemes.com/tutorials/exploring-wordpress-settings/\">Exploring WordPress Settings</a></li>\n<li><a href=\"http://ithemes.com/tutorials/wordpress-posts-vs-pages/\">WordPress Posts vs. Pages</a></li>\n<li><a href=\"http://ithemes.com/tutorials/using-wordpress-categories-and-tags/\">WordPress Categories and Tags</a></li>\n<li><a href=\"http://ithemes.com/tutorials/applying-wordpress-page-template/\">Applying a WordPress Page Template</a></li>\n<li><a href=\"http://ithemes.com/tutorials/installing-wordpress-plugins/\">Installing WordPress Plugins</a></li>\n<li><a href=\"http://ithemes.com/tutorials/how-to-install-a-wordpress-theme/\">How to Install a WordPress Theme</a></li>\n<li><a href=\"http://ithemes.com/tutorials/creating-users-in-wordpress/\">Creating Users in WordPress</a></li>\n<li><a href=\"http://ithemes.com/tutorial/category/wordpress-101/\">And 14 more topics!</a></li>\n</ul>\n<p>This series of WordPress tutorials covers everything any beginner needs to know to get started using WordPress.</p>\n<h2>What do you want to learn about WordPress?</h2>\n<p>What’s something new you would like to learn about WordPress? Help us keep iThemes Tutorials stocked up by <a href=\"http://ithemes.com/what-do-you-want-to-learn/\">telling us what you want to learn</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://ithemes.com/2014/06/04/new-wordpress-101-tutorials/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"5\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:58:\"New! Easy Canadian Sales Taxes Add-on for iThemes Exchange\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://ithemes.com/2014/06/04/easy-canadian-sales-taxes-add-ithemes-exchange/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"http://ithemes.com/2014/06/04/easy-canadian-sales-taxes-add-ithemes-exchange/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Jun 2014 15:51:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Exchange\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:19:\"WordPress Ecommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"http://ithemes.com/?p=24045\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:321:\"You asked for it and you got it &#8211; Easy Canadian Sales Taxes add-on for iThemes Exchange is now available. This feature was requested by our users and customers on the iThemes Exchange Public Roadmap. The roadmap have proven to be a great tool to stay in communication with Exchange users and allows you to [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Ashley Hurney\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3649:\"<p><a href=\"http://ithemes.com/purchase/easy-canadian-sales-taxes-ithemes-exchange-add-on/\"><img class=\"aligncenter size-full wp-image-24044\" alt=\"easy-canadian-taxes\" src=\"http://ithemes.com/wp-content/uploads/2014/06/easy-canadian-taxes.png\" width=\"445\" height=\"445\" /></a></p>\n<p>You asked for it and you got it &#8211; <a href=\"http://ithemes.com/purchase/easy-canadian-sales-taxes-ithemes-exchange-add-on/\">Easy Canadian Sales Taxes</a> add-on for iThemes Exchange is now available. This feature was requested by our users and customers on the <a href=\"https://trello.com/b/IZk2NDLt/ithemes-exchange-public-roadmap\">iThemes Exchange Public Roadmap</a>. The roadmap have proven to be a great tool to stay in communication with Exchange users and allows you to vote on any feature you would like to see implemented!</p>\n<p>This add-on allows you to automatically track and charge taxes based on the various tax rates across all the Canadian provinces. It also instantly displays sales taxes for any Canadian address.</p>\n<blockquote><p>Our goal with iThemes Exchange is simple: provide the easiest way to sell your products, downloads or memberships online.</p></blockquote>\n<h2>Pro Pack just got even better</h2>\n<p>iThemes Exchange <a href=\"http://ithemes.com/exchange/pro-pack/\">Pro Pack</a> contains awesome add-ons like:</p>\n<ul>\n<li><a style=\"font-size: medium;font-style: normal\" href=\"http://ithemes.com/purchase/membership-add-on/\">Membership</a></li>\n<li><a style=\"font-size: medium;font-style: normal\" href=\"http://ithemes.com/purchase/ithemes-exchange-product-variants-add-on/\">Product Variants</a></li>\n<li><a style=\"font-size: medium;font-style: normal\" href=\"http://ithemes.com/purchase/modify-default-redirects-ithemes-exchange-add-on/\">Modify Default Redirects</a> (launched earlier this week)</li>\n<li><a href=\"http://ithemes.com/purchase/mailchimp-add-on/\">MailChimp</a></li>\n<li><a href=\"http://ithemes.com/exchange/pro-pack/\">Many more</a></li>\n</ul>\n<p>Today, Pro Pack becomes even more robust with the addition of Easy Canadian Sales Taxes. This is the first step in being able to handle international sales taxes on your iThemes Exchange site.</p>\n<h2>How to setup Easy Canadian Sales Taxes</h2>\n<p>Just upload and activate the Easy Canadian Sales Taxes Add-on then navigate to <strong>Exchange &gt; Add-ons</strong>.</p>\n<p><strong>Click the settings gear icon</strong> to access the Easy Canadian Sales Taxes Settings page.</p>\n<p>From here, you can <b>select the Canadian province, tax type, tax rate and whether to apply taxes to shipping</b>.</p>\n<p><img class=\"aligncenter size-medium wp-image-24042\" alt=\"easy-canadian-sales-taxes-wordpress\" src=\"http://ithemes.com/wp-content/uploads/2014/06/easy-canadian-sales-taxes-wordpress-437x540.png\" width=\"437\" height=\"540\" /></p>\n<p>We&#8217;re excited to bring you this add-on. As mentioned earlier, this is a step in the international tax handling direction so be watching for even more add-ons for iThemes Exchange.</p>\n<div class=\"coupon-callout\" style=\"text-align: center\">Save 30% off the <a href=\"http://ithemes.com/plugin-suite/\">Plugin Suite</a> (includes iThemes Exchange Pro Pack + 15 other plugins) through June 14, 2014 with coupon code <a href=\"http://ithemes.com/member/cart.php\">WPPLUGINS30</a><a href=\"http://ithemes.com/plugin-suite/\"><br />\n</a></div>\n<p><a class=\"mcnButton \" style=\"font-weight: bold;letter-spacing: -1px;line-height: 100%;text-align: center;text-decoration: none;color: #5e5018\" title=\"Save 30% off the Plugin Suite\" href=\"http://ithemes.com/member/cart.php?action=add&amp;id=115&amp;coupon=WPPLUGINS30\" target=\"_blank\"> </a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"http://ithemes.com/2014/06/04/easy-canadian-sales-taxes-add-ithemes-exchange/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"Bulk Install Plugins &amp; Themes Across Multiple WordPress Sites in Seconds – New in iThemes Sync\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"http://ithemes.com/2014/06/04/bulk-install-wordpress-themes-plugins-in-seconds-ithemes-sync/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"http://ithemes.com/2014/06/04/bulk-install-wordpress-themes-plugins-in-seconds-ithemes-sync/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Jun 2014 15:10:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"iThemes Sync\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"http://ithemes.com/?p=23983\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:359:\"If you&#8217;re a freelancer building sites for clients, you probably know the headache of spinning up a new WordPress installation that includes all your go-to themes and plugins. Since these files have to be individually installed (either directly from the WordPress dashboard, or unzipped and uploaded to your server via FTP), the process can get [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Kristen Wright\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:7125:\"<p>If you&#8217;re a freelancer building sites for clients, you probably know the headache of spinning up a new WordPress installation that includes all your go-to themes and plugins. Since these files have to be individually installed (either directly from the WordPress dashboard, or unzipped and uploaded to your server via FTP), the process can get time-consuming.</p>\n<p><a href=\"http://ithemes.com/2013/05/13/jumpstarting-your-wordpress-development-process-with-backupbuddy/\">BackupBuddy can help package your base WordPress development install</a> with your usual combination of themes and plugins, but we have a new way to help you quickly deploy new sites (and keep your current ones up-to-date) directly from the <a href=\"http://sync.ithemes.com\">iThemes Sync dashboard</a>.</p>\n<p style=\"text-align: center;\"><a class=\"btn green\" href=\"http://ithemes.com/member/cart.php?action=add&amp;id=361\">Get Your 10 Free Sync Sites</a></p>\n<h2 style=\"margin-top: 40px;\">Bulk Install All Your iThemes Themes and Plugins in Seconds</h2>\n<p>We hope Sync&#8217;s new Bulk Install feature will enhance your iThemes member experience — because now you don&#8217;t have to manually log in to the iThemes Member Panel to download your purchased themes and plugins each time you need to install them on a new site. <strong>Sync will handle it for you — saving you download and installation steps (so, ultimately, lots of time!)</strong></p>\n<p><img class=\"alignnone size-full wp-image-24028\" alt=\"sync-bulk-install\" src=\"http://ithemes.com/wp-content/uploads/2014/06/sync-bulk-install.gif\" width=\"1130\" height=\"584\" /></p>\n<h2>Getting Started with iThemes Sync</h2>\n<p>If you&#8217;re new to iThemes Sync, here&#8217;s a recap of how to get started managing all your WordPress sites from one place with Sync.</p>\n<p>1.<strong> Download and install the Sync plugin on each of your WordPress sites</strong>. <em>Note: You&#8217;ll need to make sure you&#8217;re running v.1.5 or higher to take advantage of the new Sync Install feature.</em></p>\n<p>The Sync plugin can be downloaded directly from the <a href=\"http://sync.ithemes.com\">iThemes Sync dashboard</a>. If you&#8217;re not a current iThemes customer, you can <a href=\"http://ithemes.com/member/cart.php?action=add&amp;id=361\">sign up for the free Sync 10 Sites Plan here</a> so you&#8217;ll be able to access the Sync dashboard.</p>\n<p><img class=\"alignnone size-full wp-image-23995\" alt=\"download-sync\" src=\"http://ithemes.com/wp-content/uploads/2014/06/download-sync.png\" width=\"1103\" height=\"734\" /></p>\n<p>For more info on setting up Sync, check out our <a href=\"http://ithemes.com/2013/11/11/how-to-set-up-ithemes-sync/\">Sync Quick Setup Guide</a>.</p>\n<p>2. <strong>License your iThemes themes and plugins</strong>. For Sync to be able to &#8220;communicate&#8221; with your site&#8217;s themes and plugins, you&#8217;ll need to add licenses to iThemes Sync and all other iThemes products.</p>\n<p><img class=\"alignnone size-full wp-image-23997\" alt=\"ithemes-licensing\" src=\"http://ithemes.com/wp-content/uploads/2014/06/ithemes-licensing.png\" width=\"669\" height=\"338\" /></p>\n<p>To add licenses, visit <strong>Settings &gt; iThemes Licensing </strong>from the WordPress dashboard<strong>. </strong>Using your iThemes username and password, add licenses to all unlicensed products.</p>\n<p><img class=\"alignnone size-full wp-image-23998\" alt=\"iThemes Licensing-add-new\" src=\"http://ithemes.com/wp-content/uploads/2014/06/iThemes-Licensing-add-new.png\" width=\"1019\" height=\"557\" /></p>\n<h2>Using the New Sync Bulk Install Feature</h2>\n<p><em>Note: Make sure you&#8217;re running Sync v1.5 or higher. You can update the Sync plugin right from the Sync dashboard.</em></p>\n<p>1. Login to the <a href=\"http://sync.ithemes.com\">Sync dashboard</a>. Click the new <strong>Install</strong> menu item on the left.</p>\n<p><img class=\"alignnone size-full wp-image-24002\" alt=\"ithemes-sync-install-feature\" src=\"http://ithemes.com/wp-content/uploads/2014/06/ithemes-sync-install-feature.png\" width=\"1160\" height=\"682\" /></p>\n<p>2. From the Install Plugins &amp; Themes Page, <strong>select the sites</strong> that you&#8217;d like to install your themes and plugins.</p>\n<p><img class=\"alignnone size-full wp-image-24006\" alt=\"sync-install-themes-plugins\" src=\"http://ithemes.com/wp-content/uploads/2014/06/sync-install-themes-plugins.png\" width=\"1137\" height=\"594\" /></p>\n<p>Sites that can&#8217;t be selected indicate an older version of Sync. If you click on one of the sites, you&#8217;ll get a reminder from Sync to update your version of iThemes Sync.</p>\n<p><img class=\"alignnone size-full wp-image-24008\" alt=\"update-sync\" src=\"http://ithemes.com/wp-content/uploads/2014/06/update-sync.png\" width=\"1137\" height=\"589\" /></p>\n<p>3. Next up, Sync will give you the option of selecting plugins or themes. Depending on your iThemes membership, Sync will generate a list of the available themes or plugins to install.</p>\n<p><img class=\"alignnone size-full wp-image-24009\" alt=\"sync-install\" src=\"http://ithemes.com/wp-content/uploads/2014/06/sync-install.gif\" width=\"1130\" height=\"584\" /></p>\n<p>4. Select <strong>Add to Queue</strong> next to any theme or plugin (or even multiple themes and plugins) from the list. If you&#8217;d like for Sync to automatically activate the themes or plugins after installation, click the <strong>Activate Plugin after installation</strong> button at the top of the list.</p>\n<p><img class=\"alignnone size-full wp-image-24014\" alt=\"sync-queue\" src=\"http://ithemes.com/wp-content/uploads/2014/06/sync-queue.png\" width=\"1137\" height=\"590\" /></p>\n<p>Here&#8217;s the new Sync Bulk Install feature in action. In the last few frames, I&#8217;ve navigated back to my WordPress site to confirm the plugins were successfully installed.</p>\n<p><img class=\"alignnone size-full wp-image-24011\" alt=\"sync-install-in-action\" src=\"http://ithemes.com/wp-content/uploads/2014/06/sync-install-in-action.gif\" width=\"1130\" height=\"584\" /></p>\n<h2>What About Non-iThemes Themes and Plugins?</h2>\n<p>Right now, you can use Sync to bulk install your iThemes themes and plugins, but we have plans to also include installations via a zip uploader and by searching the WordPress.org repo. <a href=\"https://trello.com/b/IY0dxdOg/ithemes-sync-public-roadmap\">Check out the iThemes Sync Roadmap to see all Sync&#8217;s future features and add your request</a>.</p>\n<h2>Get iThemes Sync Today</h2>\n<p>If you aren&#8217;t already using iThemes Sync to manage your WordPress sites from one place, <a href=\"http://ithemes.com/member/cart.php?action=add&amp;id=361\">get your 10 free site plan now</a>. Current iThemes customers can <a href=\"http://sync.ithemes.com\">log in to the Sync Dashboard</a> now to download Sync and start using the new Sync Bulk Install Feature.</p>\n<p>If you need more than 10 sites, <a href=\"http://ithemes.com/sync/#plans\">check out our Sync Site Plans for 25, 50 and 100 sites</a>.</p>\n<p style=\"text-align: center;\"><a class=\"btn green\" href=\"http://ithemes.com/member/cart.php?action=add&amp;id=361\">Get Your 10 Free Sync Sites</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:97:\"http://ithemes.com/2014/06/04/bulk-install-wordpress-themes-plugins-in-seconds-ithemes-sync/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"4\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"Change Default Customer Login &amp; Registration Redirects in iThemes Exchange – New Add-on\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"http://ithemes.com/2014/06/02/change-default-customer-login-registration-pages-ithemes-exchange/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"http://ithemes.com/2014/06/02/change-default-customer-login-registration-pages-ithemes-exchange/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Jun 2014 15:42:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Exchange\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:19:\"WordPress Ecommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"http://ithemes.com/?p=23929\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:380:\"The new Modify Default Redirects Add-on for iThemes Exchange allows you to customize where a customer is redirected after completing a specific action on your Exchange-powered store. This can be helpful if you&#8217;d like to customize what your customers see after registering an account, logging in or completing a purchase. Redirection Options Included in the Modify [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Kristen Wright\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:4453:\"<p>The new <a href=\"http://ithemes.com/purchase/modify-default-redirects-ithemes-exchange-add-on/\">Modify Default Redirects Add-on for iThemes Exchange</a> allows you to customize where a customer is redirected after completing a specific action on your Exchange-powered store. This can be helpful if you&#8217;d like to customize what your customers see after registering an account, logging in or completing a purchase.</p>\n<h2>Redirection Options Included in the Modify Default Redirects Add-on</h2>\n<p>With the Modify Default Redirects Add-on, you can change default Exchange redirects to any WordPress post or page for the following customer actions:</p>\n<ul>\n<li><strong>Successful login from the Login Page</strong></li>\n<li><strong>Successful login from the Checkout Page </strong></li>\n<li><strong>Successful registration from the Registration Page</strong></li>\n<li><strong>Successful registration from the Checkout Page </strong></li>\n</ul>\n<p>Need more options? <a href=\"http://ithemes.com/exchange/feature-request/\">Let us know</a>.</p>\n<h2 style=\"margin-top: 40px;\">Understanding Default Exchange Pages &amp; Action Redirects</h2>\n<p>By default, Exchange generates &#8220;pages&#8221; for your store (customer account pages, checkout, cart, etc.) To see the pages Exchange creates, visit <strong>Exchange &gt; Settings</strong>. Click the <strong>Pages</strong> tab.</p>\n<p>From here, you can see (and change) the page type, title and slug for default Exchange pages.</p>\n<p><img class=\"alignnone size-full wp-image-23946\" alt=\"ithemes-exchange-default-pages\" src=\"http://ithemes.com/wp-content/uploads/2014/05/ithemes-exchange-default-pages.png\" width=\"1251\" height=\"884\" /></p>\n<p>In addition to these default pages, Exchange also handles redirects for customer actions like logins, registration and checkouts — which is where the Modify Default Redirects Add-on comes in. It handles any customizations you&#8217;d like to make to these default redirects.</p>\n<h2>How to Use the Modify Redirects Add-on for iThemes Exchange</h2>\n<p>1. Follow the normal WordPress plugin installation methods to install and activate the Modify Redirects Add-on plugin.</p>\n<p>2. After installing and activating, you&#8217;ll see the Modify Default Redirects Add-on has been enabled from the <strong>Exchange &gt; Add-ons</strong> page.</p>\n<p><img class=\"alignnone size-full wp-image-23940\" alt=\"modify-default-redirects-settings\" src=\"http://ithemes.com/wp-content/uploads/2014/05/modify-default-redirects-settings.png\" width=\"1238\" height=\"723\" /></p>\n<p>3. Click the Settings gear. You&#8217;ll now see the Modify Default Redirects settings page.</p>\n<p><img class=\"alignnone size-full wp-image-23941\" alt=\"modify-redirects-settings-options\" src=\"http://ithemes.com/wp-content/uploads/2014/05/modify-redirects-settings-options.png\" width=\"1093\" height=\"688\" /></p>\n<p>4. From here, you can change select the page type (Default, Exchange Page, WordPress Page or Post).</p>\n<p><img class=\"alignnone size-full wp-image-23943\" alt=\"change-exchange-page-type\" src=\"http://ithemes.com/wp-content/uploads/2014/05/change-exchange-page-type.png\" width=\"961\" height=\"491\" /></p>\n<p>5. After selecting your page type, another drop-down will populate with a list to correspond with your selection.</p>\n<p><img class=\"alignnone size-full wp-image-23942\" alt=\"change-exchange-login-page\" src=\"http://ithemes.com/wp-content/uploads/2014/05/change-exchange-login-page.png\" width=\"951\" height=\"437\" /></p>\n<p>6. Select your Page or Post and click <strong>Save Changes</strong>. Now customers will be redirected to your custom post or page after they complete the corresponding actin.</p>\n<h2>Download and Purchase Info</h2>\n<p>All current Toolkit, Plugin Suite and Exchange Pro Pack customers will find the Modify Default Redirects Add-on available for download from the iThemes Member Panel.</p>\n<p><a class=\"btn blue\" href=\"http://ithemes.com/member\">Log in and download</a></p>\n<div class=\"content-callout green\">The <a href=\"http://ithemes.com/purchase/modify-default-redirects-ithemes-exchange-add-on/\">Modify Default Page Redirects Add-on</a> is included with the <a href=\"http://ithemes.com/exchange/pro-pack/\">Exchange Pro Pack</a>. The Exchange Pro Pack includes all iThemes-built Exchange Add-ons like Membership, Invoices and Product Variants.</div>\n<p><a class=\"btn green\" href=\"http://ithemes.com/exchange/pro-pack/\">Get the Exchange Pro Pack</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"http://ithemes.com/2014/06/02/change-default-customer-login-registration-pages-ithemes-exchange/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:62:\"How We Made our WordPress Ecommerce Site with iThemes Exchange\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://ithemes.com/2014/06/02/made-wordpress-ecommerce-site-ithemes-exchange/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"http://ithemes.com/2014/06/02/made-wordpress-ecommerce-site-ithemes-exchange/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Jun 2014 14:10:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Exchange\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:19:\"WordPress Ecommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"http://ithemes.com/?p=23724\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:375:\"Today we&#8217;re launching a fully functioning ecommerce site using iThemes Exchange &#8211; enter iThemesSwag.com. This is a fun project site where you can purchase swag, something we&#8217;ve been asked for years, and really see iThemes Exchange in action. The Purpose The purpose and goal of iThemesSwag.com is to: Use iThemes Exchange to sell things, something [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Ashley Hurney\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:7384:\"<p style=\"text-align: left;\"><img class=\"aligncenter  wp-image-23916\" alt=\"Swag store trifecta\" src=\"http://ithemes.com/wp-content/uploads/2014/05/Swag-store-trifecta.png\" width=\"540\" height=\"347\" />Today we&#8217;re launching a fully functioning ecommerce site using iThemes Exchange &#8211; enter <a href=\"https://ithemesswag.com/\">iThemesSwag.com</a>. This is a fun project site where you can purchase swag, something we&#8217;ve been asked for years, and really see iThemes Exchange in action.</p>\n<h2>The Purpose</h2>\n<p>The purpose and goal of iThemesSwag.com is to:</p>\n<ol>\n<li>Use iThemes Exchange to sell things, something we ask our customers to do.</li>\n<li>Offer a way for our community to get swag in between times we aren&#8217;t giving it away.</li>\n</ol>\n<blockquote><p>&#8220;We wanted to drink our own Kool-Aid with Exchange. What better way than to have a live physical products aka swag store running on it.&#8221; &#8211; Cory Miller, iThemes Founder and CEO.</p></blockquote>\n<h2>The Process</h2>\n<p>I&#8217;ve never been a part of building an ecommerce store from the ground up, until now. After a quick meeting with Cory, I immediately started planning what products we would have in the store. Later that week the site designer, Cody and I had an initial design meeting. I showed him my drawings of how I envisioned the pages. These drawings included specific content, buttons and widget placement. Cody and I talked out our options and what we wanted the site to do.</p>\n<p>We were in constant communication. Cody  let me know when questions popped up and vice versa. Using the <a title=\"Madison\" href=\"http://ithemes.com/purchase/madison/\">Madison</a> theme with customization as framework for the site I was then able to build physical products in iThemes Exchange using the physical products add-on as well as the <a title=\"Product Variants\" href=\"http://ithemes.com/purchase/ithemes-exchange-product-variants-add-on/\">Product Variants add-on</a> to allow for multiple shirt sizes (which is pre-loaded in the add-on). I gradually added each product into the store and then fine-tuned the copy and Cody got all the images squared away.</p>\n<p>It was awesome to use the <a title=\"Easy U.S. Sales Taxes\" href=\"http://ithemes.com/purchase/ithemes-exchange-easy-u-s-sales-taxes-add-on/\">Easy U.S. Sales Tax add-on</a> to not have to worry about figuring tax rates. Something that is really valuable to me keeping track of all the inventory is the Inventory Tracking in the Product Variants add-on.</p>\n<p><img class=\"aligncenter size-full wp-image-23918\" alt=\"Variants Inventory GIF (3.2)\" src=\"http://ithemes.com/wp-content/uploads/2014/05/Variants-Inventory-GIF-3.2.gif\" width=\"1528\" height=\"867\" /></p>\n<p>It&#8217;s so easy to track and it helped me to remember to put inventory in each size offered. You can also assign an image to your variants &#8211; I didn&#8217;t need it for this site but I played with it. I then worked through the supporting features like Coupons and <a title=\"MailChimp\" href=\"http://ithemes.com/purchase/mailchimp-add-on/\">MailChimp</a>.</p>\n<h2>Notes from Cody, the Designer</h2>\n<p>I started by spinning up a brand new installation of WordPress on my local development environment, and downloading/installing several of our products (listed below). By working locally, I could test things and make changes without worrying about anyone &#8220;accidentally&#8221; stumbling onto the site as a work in progress. (NOTE: You can develop on the server and install a maintenance mode plugin while you develop; I just chose to develop locally.)</p>\n<p>We discussed designing and developing a new theme, but ultimately decided to use one of our recent Builder Theme releases, <a title=\"Madison\" href=\"http://ithemes.com/purchase/madison/\">Madison</a>, and customize it as we saw fit.</p>\n<p>I tweaked a few lines of CSS to swap out the color scheme, and also used minimum CSS/HTML to build an email signup form.<strong> By far, the longest part of the process was creating product mockups/templates for our shirts and other items, and entering the actual product information.</strong> But with Exchange, this was still super simple and made our lives easy.</p>\n<p>After we were mostly happy with the way things looked and functioned, we needed to migrate the site over to our hosting provider of choice, <a href=\"http://www.siteground.com/wordpress-hosting.htm?afcode=bf950a6e9cce4abb999f35c780144e6e&amp;utm_expid=339965-8.0O4yum7FTYaQBZNo2kUWxQ.0&amp;utm_referrer=http%3A%2F%2Fithemes.com%2Fmember%2Fpanel%2Findex.php%3Fr%3D46248\">SiteGround</a>. Again, <a title=\"BackupBuddy\" href=\"http://ithemes.com/purchase/backupbuddy/\">BackupBuddy</a> made this simple. A few clicks and I was done.</p>\n<h2>What We Learned</h2>\n<p>We went through all the normal questions like &#8220;will we need an SSL even though we&#8217;re using Stripe&#8230;&#8221; (Pro tip: don&#8217;t install SSL when the dev is migrating the site.) I talked through our SSL options with SiteGround&#8217;s Chat Support. Super quick and easy. This was the inspiration for the <a title=\"SSL for WordPress eCommerce\" href=\"http://ithemes.com/2014/05/14/ssl-for-wordpress-ecommerce/\">WordPress ecommerce SSL</a> post I wrote a few weeks ago.</p>\n<p>This project site was something Cody and I worked on between several other things. <strong>Getting the site launch ready took about three weeks while working on our other tasks.</strong> Lesson &#8211; sometimes things take longer than planned.</p>\n<h2>Here&#8217;s a list of everything we used</h2>\n<ul>\n<li><a href=\"http://www.siteground.com/wordpress-hosting.htm?afcode=bf950a6e9cce4abb999f35c780144e6e&amp;utm_expid=339965-8.0O4yum7FTYaQBZNo2kUWxQ.0&amp;utm_referrer=http%3A%2F%2Fithemes.com%2Fmember%2Fpanel%2Findex.php%3Fr%3D46248\">SiteGround hosting/SSL</a></li>\n<li><a href=\"http://ithemes.com/purchase/madison/\">Builder &#8211; Madison Theme</a></li>\n<li><a href=\"http://ithemes.com/purchase/backupbuddy/\">BackupBuddy</a></li>\n<li><a href=\"http://ithemes.com/security/\">iThemes Security Pro</a></li>\n<li><a href=\"http://www.gravityforms.com\">Gravity Forms</a></li>\n<li><a href=\"http://ithemes.com/exchange/\">iThemes Exchange</a></li>\n<li><a href=\"http://ithemes.com/purchase/ithemes-exchange-easy-u-s-sales-taxes-add-on/\">iThemes Exchange &#8211; Easy U.S. Sales Taxes</a></li>\n<li><a href=\"http://ithemes.com/purchase/mailchimp-add-on/\">iThemes Exchange &#8211; MailChimp Add-on</a></li>\n<li><a href=\"http://ithemes.com/purchase/ithemes-exchange-product-variants-add-on/\">iThemes Exchange &#8211; Product Variants</a></li>\n<li><a href=\"http://ithemes.com/purchase/stripe-add-on/\">iThemes Exchange &#8211; Stripe Add-on</a></li>\n<li><a href=\"http://ithemes.com/sync/\">iThemes Sync</a></li>\n<li><a href=\"https://yoast.com/wordpress/plugins/seo/\">WordPress SEO</a></li>\n<li><a href=\"http://akismet.com\">Akismet</a></li>\n<li><a href=\"http://tri.be/shop/wordpress-image-widget/\">Image Widget </a></li>\n</ul>\n<p>All-in-all the experience of building the site as a two-person team was great &#8211; we were always on chat helping each other brainstorm and make decisions. We hope that you find some awesome swag for purchase, and if you haven&#8217;t already, check out the <a href=\"http://www.ithemesswag.com\">site</a>!</p>\n<p><a class=\"btn blue\" href=\"http://ithemesswag.com\">Visit the iThemes Swag Store</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"http://ithemes.com/2014/06/02/made-wordpress-ecommerce-site-ithemes-exchange/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:48:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"Getting Started with iThemes Security: New In-Depth Video Tutorials\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"http://ithemes.com/2014/05/29/getting-started-ithemes-security-new-depth-video-tutorials/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:98:\"http://ithemes.com/2014/05/29/getting-started-ithemes-security-new-depth-video-tutorials/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 29 May 2014 16:26:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:16:\"iThemes Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:18:\"WordPress Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"http://ithemes.com/?p=23872\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:379:\"Just getting started with iThemes Security? We just added 4 new iThemes Security video tutorials to our free WordPress training library. This in-depth training series taught by iThemes Security plugin developer Chris Wiegman covers everything you need to know about getting your WordPress site secured with iThemes Security. Getting Started with iThemes Security Part 1 [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Kristen Wright\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3496:\"<p>Just getting started with iThemes Security? We just added <a href=\"http://ithemes.com/tutorial/category/ithemes-security/\">4 new iThemes Security video tutorials</a> to our <a href=\"http://ithemes.com/tutorials\">free WordPress training library</a>.</p>\n<p>This in-depth training series taught by iThemes Security plugin developer Chris Wiegman covers everything you need to know about getting your WordPress site secured with iThemes Security.</p>\n<h2 style=\"margin-top: 50px; text-align: left;\">Getting Started with iThemes Security Part 1</h2>\n<p>In this tutorial, we cover how to install and activate the iThemes Security plugin plus a walk-through of the plugin navigation menu in the WordPress dashboard. We also cover important first steps and settings.</p>\n<p style=\"text-align: left;\"><iframe src=\"//player.vimeo.com/video/96810799\" height=\"281\" width=\"500\" allowfullscreen=\"\" frameborder=\"0\"></iframe><br />\n<a class=\"btn green\" href=\"http://ithemes.com/tutorials/getting-started-ithemes-security-part-1/\">Watch the tutorial</a></p>\n<p style=\"text-align: left;\"><img class=\"alignnone size-full wp-image-16905\" alt=\"Divider\" src=\"http://ithemes.com/wp-content/uploads/2013/03/Screen_shot_2012_05_31_at_11_2.38.04_AM.png\" width=\"576\" height=\"13\" /></p>\n<h2 style=\"margin-top: 40px; text-align: left;\">Part 2: Global Settings</h2>\n<p>This tutorial covers each iThemes Security global setting in more detail.</p>\n<p style=\"text-align: left;\"><iframe src=\"//player.vimeo.com/video/96810802\" height=\"281\" width=\"500\" allowfullscreen=\"\" frameborder=\"0\"></iframe><br />\n<a class=\"btn green\" href=\"http://ithemes.com/tutorials/getting-started-ithemes-security-part-2-global-settings/\">Watch the tutorial</a></p>\n<p style=\"text-align: left;\"><img class=\"alignnone size-full wp-image-16905\" alt=\"Divider\" src=\"http://ithemes.com/wp-content/uploads/2013/03/Screen_shot_2012_05_31_at_11_2.38.04_AM.png\" width=\"576\" height=\"13\" /></p>\n<h2 style=\"margin-top: 40px; text-align: left;\">Part 3: 404 Detection</h2>\n<p>This tutorial covers the 404 Detection feature included in iThemes Security. Chris walks through understanding this feature, how to configure it properly to avoid unwanted lockouts and how to use 404 logs. He also covers how to temporarily whitelist your own IP while testing or making changes to your site.</p>\n<p style=\"text-align: left;\"><iframe src=\"//player.vimeo.com/video/96810801\" height=\"281\" width=\"500\" allowfullscreen=\"\" frameborder=\"0\"></iframe><br />\n<a class=\"btn green\" href=\"http://ithemes.com/tutorials/getting-started-ithemes-security-part-3-404-detection/\">Watch the tutorial</a></p>\n<p style=\"text-align: left;\"><img class=\"alignnone size-full wp-image-16905\" alt=\"Divider\" src=\"http://ithemes.com/wp-content/uploads/2013/03/Screen_shot_2012_05_31_at_11_2.38.04_AM.png\" width=\"576\" height=\"13\" /></p>\n<h2 style=\"margin-top: 40px; text-align: left;\">Part 4: Away Mode</h2>\n<p>In this tutorial, Chris covers how to use the iThemes Security Away Mode feature. He also covers how to use <a href=\"http://ithemes.com/sync\">iThemes Sync</a> to enable and disable Away mode remotely.</p>\n<p style=\"text-align: left;\"><iframe src=\"//player.vimeo.com/video/96810800\" height=\"281\" width=\"500\" allowfullscreen=\"\" frameborder=\"0\"></iframe><br />\n<a class=\"btn green\" href=\"http://ithemes.com/tutorials/getting-started-ithemes-security-part-4-away-mode/\">Watch the tutorial</a></p>\n<h5>Stay tuned for many more iThemes Security tutorials — we&#8217;ll keep you posted!</h5>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:94:\"http://ithemes.com/2014/05/29/getting-started-ithemes-security-new-depth-video-tutorials/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"How to Use Authy to Manage Google Authenticator Keys for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:83:\"http://ithemes.com/2014/05/28/use-authy-wordpress-manage-google-authenticator-keys/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"http://ithemes.com/2014/05/28/use-authy-wordpress-manage-google-authenticator-keys/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 28 May 2014 15:20:40 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:16:\"iThemes Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:18:\"WordPress Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"http://ithemes.com/?p=23791\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:366:\"If you&#8217;re adding two-factor authentication protection to your WordPress site with iThemes Security Pro, you have two ways to manage your login keys — directly through the Google Authenticator app or with Authy, an app that also manages your Google Authenticator keys. The Benefits of Using Authy to Manage Your Google Authenticator Keys Authy makes [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Kristen Wright\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:6103:\"<p>If you&#8217;re adding two-factor authentication protection to your WordPress site with <a href=\"http://ithemes.com/security\">iThemes Security Pro</a>, you have two ways to manage your login keys — directly through the Google Authenticator app or with <a href=\"http://blog.authy.com/authenticator\">Authy, an app that also manages your Google Authenticator keys</a>.</p>\n<h2>The Benefits of Using Authy to Manage Your Google Authenticator Keys</h2>\n<p>Authy makes managing your Google Authenticator keys easier by offering these Authy-only features:</p>\n<ul>\n<li><strong>Enable backups to avoid being locked out if you upgrade or lose your phone - </strong>Authy will encrypt (inside your phone) your Google Authenticator accounts to securely store them on their servers. Read more on <a href=\"http://blog.authy.com/backups\">how Authy handles encrypted backups</a>.</li>\n<li><strong>Share keys between multiple devices or your computer &#8211; </strong>Authy allows multi-device verification with <a href=\"https://www.authy.com/thefuture\">apps for your mobile devices</a> and <a href=\"http://blog.authy.com/authy-for-pc\">even your personal computer</a>. With their multi-device platform, you can have multiple devices enrolled at the same time, so you can quickly get back to work if one is lost.</li>\n<li><strong>Protected pins &#8211; </strong>Authy also includes the ability to add protection pins to your accounts or the entire app. That&#8217;s another added layer of security.</li>\n</ul>\n<h2>Getting Started with Authy</h2>\n<p>1. To get started with Authy, you&#8217;ll need to download the Authy app. They have apps available for <a href=\"https://itunes.apple.com/us/app/authy/id494168017\">iOS</a>, <a href=\"https://play.google.com/store/apps/details?id=com.authy.authy\">Andriod</a>, <a href=\"https://chrome.google.com/webstore/detail/authy/gaedmjdfmmahhbjefcbgaolhhanlaolb\">Mac</a>, <a href=\"https://chrome.google.com/webstore/detail/authy/gaedmjdfmmahhbjefcbgaolhhanlaolb\">Windows</a> and <a href=\"https://chrome.google.com/webstore/detail/authy/gaedmjdfmmahhbjefcbgaolhhanlaolb\">Linux.</a></p>\n<p>2. Follow the instructions included in this post on <a href=\"http://ithemes.com/2014/05/28/set-two-factor-authentication-wordpress-site-google-authenticator\">how to activate two-factor authentication for your WordPress site with iThemes Security Pro</a>. After you&#8217;ve activated two-factor authentication on your site, you&#8217;ll want to <strong>navigate to your WordPress User Profile page</strong> so you can use the QR code provided on your profile.</p>\n<p><img class=\"alignnone size-large wp-image-23759\" alt=\"enable-two-factor-authentication-wordpress\" src=\"http://ithemes.com/wp-content/uploads/2014/05/enable-two-factor-authentication-wordpress-1024x731.png\" width=\"1024\" height=\"731\" /></p>\n<p>3. Open the Authy app and follow the Setup instructions. You&#8217;ll be prompted to enter your cellphone number to turn your device into a secure token.</p>\n<p><img class=\"alignnone size-full wp-image-23830\" alt=\"set-up-authy\" src=\"http://ithemes.com/wp-content/uploads/2014/05/set-up-authy.png\" width=\"600\" height=\"508\" /></p>\n<p>4. After you enter your cellphone number, you can select to get your account verification via phone call or SMS.</p>\n<p><img class=\"alignnone size-full wp-image-23831\" alt=\"authy-verify-account\" src=\"http://ithemes.com/wp-content/uploads/2014/05/authy-verify-account.png\" width=\"600\" height=\"508\" /></p>\n<p>5. If you choose SMS (the quickest way to get your verification code), you&#8217;ll immediately receive at text message with your code. You can click the link to register directly from the text message or manually copy the code to enter in the app.</p>\n<p><img class=\"alignnone size-full wp-image-23835\" alt=\"authy-verify-code\" src=\"http://ithemes.com/wp-content/uploads/2014/05/authy-verify-code.png\" width=\"600\" height=\"508\" /></p>\n<p>6. Authy will register your account and then you&#8217;re all set. On the next screen, click<strong> Start Adding Accounts Now</strong>.</p>\n<p><img class=\"alignnone size-full wp-image-23804\" alt=\"authy-add-account\" src=\"http://ithemes.com/wp-content/uploads/2014/05/authy-add-account.png\" width=\"600\" height=\"508\" /></p>\n<p>7. On the next screen, scan the QR code provided by iThemes Security Pro on your WordPress User Profile page.</p>\n<p><img class=\"alignnone size-full wp-image-23817\" alt=\"authy-QR-code-scanner\" src=\"http://ithemes.com/wp-content/uploads/2014/05/authy-QR-code-scanner.png\" width=\"600\" height=\"508\" /></p>\n<p>8. Authy will automatically configure the account and generate your login token.</p>\n<p><img class=\"alignnone size-full wp-image-23820\" alt=\"authy-two-factor-wordpress\" src=\"http://ithemes.com/wp-content/uploads/2014/05/authy-two-factor-wordpress.png\" width=\"600\" height=\"508\" /></p>\n<p>9. You&#8217;ll be able to log in to your WordPress site using this token in addition to your password.</p>\n<p><img class=\"alignnone size-full wp-image-23753\" alt=\"WordPress Two-Factor Authentication\" src=\"http://ithemes.com/wp-content/uploads/2014/05/WordPress-Two-Factor-Authentication.png\" width=\"1015\" height=\"709\" /></p>\n<h2>Enabling Backups</h2>\n<p>To enable backups for your tokens, visit the Accounts page from the app. From here, you can enable backups for your Authenticator accounts.</p>\n<p><img class=\"alignnone size-full wp-image-23844\" alt=\"authy-account-backups\" src=\"http://ithemes.com/wp-content/uploads/2014/05/authy-account-backups.png\" width=\"600\" height=\"508\" /></p>\n<h2>Get Two-Factor Authentication + 30 Other Ways to Secure Your WordPress Site</h2>\n<p>With <a href=\"http://ithemes.com/security/\">iThemes Security Pro</a>, our WordPress security plugin, you can lock down your WordPress site with two-factor authentication and <a href=\"http://ithemes.com/security/\">30+ other security settings</a> like brute force protection, file change detection and away mode — all important security measures you can take to secure your site.</p>\n<p style=\"text-align: center;\"><a class=\"btn blue\" href=\"http://ithemes.com/security\">Get iThemes Security Pro Today</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"http://ithemes.com/2014/05/28/use-authy-wordpress-manage-google-authenticator-keys/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"How to Set Up Two-Factor Authentication for Your WordPress Site with Google Authenticator\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"http://ithemes.com/2014/05/28/set-two-factor-authentication-wordpress-site-google-authenticator/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:105:\"http://ithemes.com/2014/05/28/set-two-factor-authentication-wordpress-site-google-authenticator/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 28 May 2014 15:13:23 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:16:\"iThemes Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:18:\"WordPress Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"http://ithemes.com/?p=23736\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:363:\"When it comes to protecting your WordPress site, two-factor authentication is one of the best things you can do to secure your site — but how do you implement it? In this post, we&#8217;ll cover how to set up two-factor authentication for your WordPress site with Google Authenticator and iThemes Security Pro. Why Use Two-Factor Authentication? The [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Kristen Wright\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:9952:\"<p>When it comes to protecting your WordPress site, two-factor authentication is one of the best things you can do to secure your site — but how do you implement it? In this post, we&#8217;ll cover how to set up two-factor authentication for your WordPress site with <a href=\"http://www.google.com/landing/2step/\">Google Authenticator</a> and <a href=\"http://ithemes.com/security\">iThemes Security Pro</a>.</p>\n<h2>Why Use Two-Factor Authentication? The Problem With Passwords</h2>\n<p>With major security breeches like <a href=\"http://ithemes.com/2014/04/09/web-taken-shot-heart-can-heartbleed/\">the recent Heartbleed bug</a> that compromised passwords for millions of users, passwords are becoming an increasingly risky way of allowing user access to admin accounts.</p>\n<p>Google&#8217;s spam guru, Matt Cutts, <a href=\"http://lifehacker.com/5932700/please-turn-on-two-factor-authentication\" data-ls-seen=\"1\">explained it best</a>:</p>\n<blockquote><p>Two-factor authentication is a simple feature that asks for more than just your password. It requires both &#8220;something you know&#8221; (like a password) and &#8220;something you have&#8221; (like your phone).</p></blockquote>\n<p>With two-factor authentication, users are required to enter both a password and a second code sent to a device. Both the password and the code are required to log in to a user account, adding an extra layer of security that verifies it&#8217;s actually you logging in and not someone who gained access (or even guessed) your password.</p>\n<h2>How Two-Factor Authentication Works with WordPress</h2>\n<p>To start using two-factor authentication, you&#8217;ll need to have <a href=\"http://www.google.com/landing/2step/\">Google Authenticator</a>, a free two-factor application, installed on your smart phone. To download the Google Authenticator app, visit the <a href=\"https://itunes.apple.com/us/app/google-authenticator/id388497605?mt=8\">App Store (for iOS devices)</a> or from the <a href=\"https://play.google.com/store/apps/details?id=com.google.android.apps.authenticator2\">Android App Store on Google Play</a>.</p>\n<p>Once the app is configured with your site using <a href=\"http://ithemes.com/security\">iThemes Security Pro</a>, your WordPress site will require both your password and a verification code generated with the Google Authenticator app.</p>\n<p><img class=\"alignnone size-full wp-image-23753\" alt=\"WordPress Two-Factor Authentication\" src=\"http://ithemes.com/wp-content/uploads/2014/05/WordPress-Two-Factor-Authentication.png\" width=\"1015\" height=\"709\" /></p>\n<p>Google Authenticator creates a token of 6 digits that is only good once and changes every 30 seconds.Once configured, you can get verification codes without the need of a network or cellular connection.</p>\n<p><img class=\"alignnone size-full wp-image-23754\" alt=\"google-authenticator-wordpress\" src=\"http://ithemes.com/wp-content/uploads/2014/05/google-authenticator-wordpress.png\" width=\"600\" height=\"430\" /></p>\n<h2>Getting Started: Setting Up Two-Factor Authentication on Your WordPress Site</h2>\n<p>To get started setting up two-factor authentication for your WordPress site, you&#8217;ll need the following:</p>\n<ul>\n<li><a href=\"http://ithemes.com/security\">iThemes Security Pro</a> — our WordPress Security plugin — installed on your self-hosted WordPress site</li>\n<li>The Google Authenticator App — for <a href=\"https://itunes.apple.com/us/app/google-authenticator/id388497605?mt=8\">iOS </a>or <a href=\"https://play.google.com/store/apps/details?id=com.google.android.apps.authenticator2\">Android</a> — installed on your mobile device</li>\n</ul>\n<h3>Configuring in iThemes Security Pro</h3>\n<p>1. Once you&#8217;ve installed iThemes Security Pro on your WordPress site, navigate to <strong>Security &gt; Pro</strong> from the left-hand navigation menu. Click <strong>Enable Two Factor authentication</strong>.</p>\n<p><img class=\"alignnone size-full wp-image-23758\" alt=\"Two-Factor Authentication-iThemes Security\" src=\"http://ithemes.com/wp-content/uploads/2014/05/Two-Factor-Authentication-iThemes-Security.png\" width=\"1235\" height=\"857\" /></p>\n<p>2. Next, you can set the <strong>lowest role</strong>  — or the the minimum user role at which a user can use two-factor authentication. This is helpful if you don’t want to risk users like subscribers losing their phone.</p>\n<p>Click <strong>Save All Changes</strong>.</p>\n<p>3. Once two-factor authentication has been activated within iThemes Security Pro, any applicable user can then activate the feature for their own account by<strong> editing their profile</strong>.</p>\n<h3>Activating from Your WordPress User Profile</h3>\n<p>1. From the WordPress dashboard, visit <strong>Users &gt; Your Profile</strong>. Scroll to the <strong>Google Authenticator Settings</strong> section and click <strong>Enable</strong>.</p>\n<p><img class=\"alignnone size-full wp-image-23759\" alt=\"enable-two-factor-authentication-wordpress\" src=\"http://ithemes.com/wp-content/uploads/2014/05/enable-two-factor-authentication-wordpress.png\" width=\"1176\" height=\"840\" /></p>\n<p>2. Add a <strong>description label</strong> to identify the site in your Google authenticator app.</p>\n<p>3. The <strong>Key </strong>and<strong> QR Code </strong>included here will be used to set up your site in the Google Authenticator app.</p>\n<h3>Adding Your WordPress Site to the Google Authenticator App</h3>\n<p>1. Open the Google Authenticator App on your mobile device.</p>\n<p><img class=\"alignnone size-full wp-image-23760\" alt=\"google-authenticator-iphone\" src=\"http://ithemes.com/wp-content/uploads/2014/05/google-authenticator-iphone.png\" width=\"600\" height=\"508\" /></p>\n<p>2. The app will walk you through the setup. Click <strong>Begin Setup</strong>.</p>\n<p><img class=\"alignnone size-full wp-image-23761\" alt=\"google-authenticator-setup\" src=\"http://ithemes.com/wp-content/uploads/2014/05/google-authenticator-setup.png\" width=\"600\" height=\"508\" /></p>\n<p>3. On the next screen, you&#8217;re given two ways to add a new site to your Google Authenticator app. Select <strong>Scan Barcode</strong> or <strong>Manual Entry</strong>.</p>\n<p><img class=\"alignnone size-full wp-image-23762\" alt=\"google-authenticator-scan-barcode\" src=\"http://ithemes.com/wp-content/uploads/2014/05/google-authenticator-scan-barcode.png\" width=\"600\" height=\"508\" /></p>\n<p>4. For<strong> scan barcode</strong>, a QR code scanner will appear for you to scan the QR code included on your WordPress User profile page. Scan this QR code by pointing your phone camera at the screen (yep, this works.)</p>\n<p><img class=\"alignnone size-full wp-image-23767\" alt=\"google-authenticator-barcode-scanner\" src=\"http://ithemes.com/wp-content/uploads/2014/05/google-authenticator-barcode-scanner.png\" width=\"600\" height=\"508\" /></p>\n<p>5. For the <strong>manual entry </strong>method<strong>, </strong>use the key provided above the QR code on your WordPress User Profile page.</p>\n<p><img class=\"alignnone size-full wp-image-23768\" alt=\"manual-entry-google-authenticator\" src=\"http://ithemes.com/wp-content/uploads/2014/05/manual-entry-google-authenticator.png\" width=\"600\" height=\"508\" /></p>\n<p>6. Once Google Authenticator has recognized your QR code or key, a new site will be added to the app.</p>\n<p><img class=\"alignnone size-full wp-image-23769\" alt=\"google-authenticator-code\" src=\"http://ithemes.com/wp-content/uploads/2014/05/google-authenticator-code.png\" width=\"600\" height=\"508\" /></p>\n<p>7. Now you can use the 6-digit code generated by the app to log in to your WordPress site (just note this code refreshes every 30 seconds).</p>\n<p><img class=\"alignnone size-full wp-image-23753\" alt=\"WordPress Two-Factor Authentication\" src=\"http://ithemes.com/wp-content/uploads/2014/05/WordPress-Two-Factor-Authentication.png\" width=\"1015\" height=\"709\" /></p>\n<h2>What Happens if I Lose My phone? Disabling Two-Factor Authentication</h2>\n<p>If you lose your phone, two-factor authentication can be disabled. Any administrator on your WordPress site can override and disable the feature by turning it off on the user’s profile. Just note that admins can only <em>disable</em> it for a user, not enable it.</p>\n<h2>Using Authy to Manage Your Google Authenticator Keys</h2>\n<p>If you’re adding two-factor authentication protection to your WordPress site with <a href=\"http://ithemes.com/security\">iThemes Security Pro</a>, you can also manage your Google Authenticator keys with the <a href=\"https://www.authy.com/\">Authy app</a>.</p>\n<p>Authy has several features not included in the Google Authenticator app, including encrypted key backups, the ability to share keys between multiple devices or your computer and protected pins.</p>\n<p><a href=\"http://ithemes.com/2014/05/28/use-authy-wordpress-manage-google-authenticator-keys/\">Read more on how to manage your Google Authenticator Keys with Authy</a>.</p>\n<h2>Get Two-Factor Authentication + 30 Other Ways to Secure Your WordPress Site</h2>\n<p>With <a href=\"http://ithemes.com/security/\">iThemes Security Pro</a>, you can lock down your WordPress site with two-factor authentication and <a href=\"http://ithemes.com/security/\">30+ other security settings</a> like brute force protection, file change detection and away mode — all important security measures you can take to secure your site.</p>\n<div class=\"coupon-callout\" style=\"text-align: center;\">Save 25% off any <a href=\"http://ithemes.com/security\">iThemes Security plan</a> purchase through June 13, 2014 with coupon code <a href=\"http://ithemes.com/security\">WPSECURE25 </a>or save 30% off the <a href=\"http://http://ithemes.com/plugin-suite/\">Plugin Suite</a> (includes iThemes Security + 15 other plugins) through June 14, 2014 with coupon code <a href=\"http://ithemes.com/plugin-suite/\">WPPLUGINS30</a>.</div>\n<p style=\"text-align: center;\"><a class=\"btn blue\" href=\"http://ithemes.com/security\">Get iThemes Security Pro Today</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"http://ithemes.com/2014/05/28/set-two-factor-authentication-wordpress-site-google-authenticator/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"7\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:48:\"\n		\n		\n		\n		\n		\n				\n		\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"Easily Add Two-Factor Authentication To All Your WordPress Sites\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"http://ithemes.com/2014/05/28/add-two-factor-authentication-to-all-you-wp-sites/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"http://ithemes.com/2014/05/28/add-two-factor-authentication-to-all-you-wp-sites/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 28 May 2014 15:04:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:3:{i:0;a:5:{s:4:\"data\";s:8:\"Homepage\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:16:\"iThemes Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:2;a:5:{s:4:\"data\";s:18:\"WordPress Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"http://ithemes.com/?p=23730\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:373:\"iThemes Security and iThemes Security Pro just got some awesome new features to make your WordPress sites even more secure. Two-factor Authentication (Pro) Two-factor authentication was one of the most requested features on our roadmap by you for iThemes Security Pro and we&#8217;re excited to release it today. Get the full tutorial on how to setup two-factor [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Ashley Hurney\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:6557:\"<p><img class=\"aligncenter size-medium wp-image-23846\" alt=\"two-factor-authentication-for-wordpress\" src=\"http://ithemes.com/wp-content/uploads/2014/05/two-factor-authentication-for-wordpress-540x375.png\" width=\"540\" height=\"375\" />iThemes Security and <a href=\"http://ithemes.com/security/\">iThemes Security Pro</a> just got some awesome new features to make your WordPress sites even more secure.</p>\n<h2>Two-factor Authentication (<a href=\"http://ithemes.com/security/\" target=\"_blank\">Pro</a>)<img class=\"alignright size-full wp-image-23832\" alt=\"google-authenticator-wordpress\" src=\"http://ithemes.com/wp-content/uploads/2014/05/google-authenticator-wordpress1.png\" width=\"207\" height=\"384\" /></h2>\n<p>Two-factor authentication was one of the <a href=\"https://trello.com/b/OG8BFXFY/ithemes-security-ithemes-security-pro-roadmap\" target=\"_blank\">most requested features</a> on our roadmap by you for iThemes Security Pro and we&#8217;re excited to release it today.</p>\n<p>Get the full tutorial on <a title=\"setting up two-factor authentication in wordpress\" href=\"http://ithemes.com/2014/05/28/set-two-factor-authentication-wordpress-site-google-authenticator\" target=\"_blank\">how to setup two-factor authentication in iThemes Security Pro here</a>.</p>\n<p>Passwords are an old technology based on restricting access to something a person “knows.”  The problem with this password-only approach is anyone else can know it or even guess it themselves. Two-factor authentication makes it tougher for someone to hack your login by adding an additional step or factor to the login process.</p>\n<p>With two-factor authentication setup, users are required to enter both a password AND a second code sent to a device like your Android smartphone or iPhone. Both the password and the code are required to log in to a user account, adding an extra layer of security that verifies it’s actually you logging in and not someone who gained access (or even guessed) your password.</p>\n<p>&#8220;I&#8217;ve been using two-factor authentication for my email for years now via Gmail. It&#8217;s been especially handy and helped me be more secure as, for instance, I was recently in Atlanta and printing boarding passes from a computer in a hotel&#8217;s business center. In order to get into my email, I had to include my password, which I always hate doing on public computers like that, but then to get into my email, I had to use the code sent to my iPhone to verify it was truly me,&#8221; said iThemes founder Cory Miller. &#8220;Now with iThemes Security Pro and Google Authenticator, I can have the same level of security and peace of mind with all my WordPress sites.&#8221;</p>\n<p>You can activate this feature on the Pro tab where you can also set the minimum role (in case you don’t want to risk users like subscribers losing their phone).</p>\n<p><img class=\"aligncenter size-full wp-image-23797\" alt=\"2FA\" src=\"http://ithemes.com/wp-content/uploads/2014/05/2FA.png\" width=\"918\" height=\"538\" /></p>\n<p>Once activated, any applicable user can then activate the feature for their own account by editing their profile. An administrator can later over-ride and disable the feature (in case they lost their phone) by turning it off on the user’s account once enabled <strong>(note: admin can only disable it for a user, not enable it).</strong></p>\n<p>Any user making use of this technology will need to have a 2-factor application on their phone such as the free Google Authenitcator app or using the Authy app.</p>\n<h2>User Action Logging (<a href=\"http://ithemes.com/security/\" target=\"_blank\">Pro</a>)</h2>\n<p>In iThemes Security Pro 1.3 we added “User Action Logging.” This feature  allows you to keep track of what WP users are doing on your sites, like user logins, logouts, and changes to content. You can activate the new feature under the Pro tab where you can also set the minimum role for logging (so you don’t have every Subscriber or other action in a site with a lot of users).</p>\n<p>If you&#8217;re managing multiple authors or users on a WordPress site, this feature can help you see who did what and, if an account was compromised you can quickly see which account it was.</p>\n<p>One non-security benefit of this feature is you can see if your client&#8217;s have even logged into their sites.</p>\n<p><img class=\"aligncenter size-full wp-image-23793\" alt=\"User Logging ITSEC PRO\" src=\"http://ithemes.com/wp-content/uploads/2014/05/User-Logging-ITSEC-PRO.png\" width=\"958\" height=\"457\" /></p>\n<h2>Don&#8217;t Lock Yourself Out (Free and <a href=\"http://ithemes.com/security/\" target=\"_blank\">Pro</a>)</h2>\n<p>Sometimes with the lockout detection features in iThemes Security, you can accidentally lock yourself out of your own site. Now with the new Temporary Whitelist feature, you don’t risk locking yourself out when developing or testing.</p>\n<p>In the opening screen of iThemes Security, you&#8217;ll see the &#8220;Don&#8217;t Lock Yourself Out&#8221; box and can click the button to temporarily whitelist your own IP for a 24-hour period.</p>\n<p><img class=\"aligncenter size-full wp-image-23802\" alt=\"Whitelist\" src=\"http://ithemes.com/wp-content/uploads/2014/05/Whitelist.png\" width=\"922\" height=\"520\" /></p>\n<p>Doing so will still generate lockout error messages but will not lock the IP out allowing the user to then be able to find out what is triggering the lockout.</p>\n<p><em>Please note: only 1 IP can be whitelisted in this manner per 24 hour period.</em></p>\n<h2>Get Two-Factor Authentication + 30 Other Ways to Secure Your WordPress Site</h2>\n<p>With <a href=\"http://ithemes.com/security/\">iThemes Security Pro</a>, you can lock down your WordPress site with two-factor authentication and <a href=\"http://ithemes.com/security/\">30+ other security settings</a> like brute force protection, file change detection and away mode — all important security measures you can take to secure your site.</p>\n<div class=\"coupon-callout\" style=\"text-align: center;\">Save 25% off any <a href=\"http://ithemes.com/security\">iThemes Security plan</a> purchase through June 13, 2014 with coupon code <a href=\"http://ithemes.com/security\">WPSECURE25 </a>or save 30% off the <a href=\"http://ithemes.com/plugin-suite/\">Plugin Suite</a> (includes iThemes Security + 15 other plugins) through June 14, 2014 with coupon code <a href=\"http://ithemes.com/plugin-suite/\">WPPLUGINS30</a>.</div>\n<p style=\"text-align: center;\"><a class=\"btn blue\" href=\"http://ithemes.com/security\">Get iThemes Security Pro Today</a></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"http://ithemes.com/2014/05/28/add-two-factor-authentication-to-all-you-wp-sites/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:24:\"http://ithemes.com/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:10:{s:4:\"date\";s:29:\"Mon, 09 Jun 2014 00:42:15 GMT\";s:6:\"server\";s:6:\"Apache\";s:4:\"vary\";s:6:\"Cookie\";s:10:\"x-pingback\";s:29:\"http://ithemes.com/xmlrpc.php\";s:13:\"last-modified\";s:29:\"Fri, 06 Jun 2014 17:18:21 GMT\";s:4:\"etag\";s:34:\"\"f0646024c2515a83797684d58defca2e\"\";s:10:\"set-cookie\";a:2:{i:0;s:57:\"FirstTimeVisitor=1; expires=Sun, 09-Jun-2024 00:42:16 GMT\";i:1;s:57:\"FirstTimeVisitor=1; expires=Sun, 09-Jun-2024 00:42:16 GMT\";}s:12:\"x-robots-tag\";s:14:\"noindex,follow\";s:10:\"connection\";s:5:\"close\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";}s:5:\"build\";s:14:\"20131111204433\";}', 'no');
INSERT INTO `wp_options` VALUES('7795', '_site_transient_timeout__prli_messages', '1402293323', 'yes');
INSERT INTO `wp_options` VALUES('7796', '_site_transient__prli_messages', 'a:1:{i:0;s:568:\"If you like Pretty Link and want to generate income from your WordPress website then you\'ll love our new plugin:<br/><a class=\"prli_message_image\" href=\"http://www.memberpress.com/supercleanse/payments-728\"><img src=\"http://www.memberpress.com/wp-content/uploads/2013/01/banner5.png\" /></a><script>jQuery(\'.prli_message_image\').parent().removeClass(\'updated\');jQuery(\'.prli_message_image\').parent().parent().css(\'border-color\',\'transparent\').css(\'background-color\',\'transparent\');jQuery(\'.prli_message_image img\').css(\'width\',\'100%\').css(\'max-width\',\'728px\');</script>\";}', 'yes');
INSERT INTO `wp_options` VALUES('7626', '_transient_timeout_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca', '1402317125', 'no');
INSERT INTO `wp_options` VALUES('7627', '_transient_feed_ac0b00fe65abe10e0c5b588f3ed8c7ca', 'a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:51:\"\n	\n	\n	\n	\n	\n	\n		\n		\n	\n	\n		\n		\n		\n		\n		\n		\n		\n		\n		\n	\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:3:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"http://wordpress.org/news\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"WordPress News\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:13:\"lastBuildDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 08 May 2014 18:40:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:5:\"en-US\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:9:\"generator\";a:1:{i:0;a:5:{s:4:\"data\";s:42:\"http://wordpress.org/?v=4.0-alpha-20140607\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:10:{i:0;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"WordPress 3.9.1 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2014/05/wordpress-3-9-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/news/2014/05/wordpress-3-9-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 08 May 2014 18:40:58 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3241\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:385:\"After three weeks and more than 9 million downloads of WordPress 3.9, we&#8217;re pleased to announce that WordPress 3.9.1 is now available. This maintenance release fixes 34 bugs in 3.9, including numerous fixes for multisite networks, customizing widgets while previewing themes, and the updated visual editor. We&#8217;ve also made some improvements to the new audio/video [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3077:\"<p>After three weeks and more than 9 million downloads of <a title=\"WordPress 3.9 “Smith”\" href=\"http://wordpress.org/news/2014/04/smith/\">WordPress 3.9</a>, we&#8217;re pleased to announce that WordPress 3.9.1 is now available.</p>\n<p>This maintenance release fixes 34 bugs in 3.9, including numerous fixes for multisite networks, customizing widgets while previewing themes, and the updated visual editor. We&#8217;ve also made some improvements to the new audio/video playlists feature and made some adjustments to improve performance. For a full list of changes, consult the <a href=\"https://core.trac.wordpress.org/query?milestone=3.9.1\">list of tickets</a> and the <a href=\"https://core.trac.wordpress.org/log/branches/3.9?rev=28353&amp;stop_rev=28154\">changelog</a>.</p>\n<p>If you are one of the millions already running WordPress 3.9, we&#8217;ve started rolling out automatic background updates for 3.9.1. For sites <a href=\"http://wordpress.org/plugins/background-update-tester/\">that support them</a>, of course.</p>\n<p><a href=\"http://wordpress.org/download/\">Download WordPress 3.9.1</a> or venture over to <strong>Dashboard → Updates</strong> and simply click &#8220;Update Now.&#8221;</p>\n<p>Thanks to all of these fine individuals for contributing to 3.9.1: <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/rzen\">Brian Richards</a>, <a href=\"http://profiles.wordpress.org/ehg\">Chris Blower</a>, <a href=\"http://profiles.wordpress.org/jupiterwise\">Corey McKrill</a>, <a href=\"http://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"http://profiles.wordpress.org/feedmeastraycat\">feedmeastraycat</a>, <a href=\"http://profiles.wordpress.org/gcorne\">Gregory Cornelius</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandi</a>, <a href=\"http://profiles.wordpress.org/imath\">imath</a>, <a href=\"http://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/m_i_n\">m_i_n</a>, <a href=\"http://profiles.wordpress.org/clorith\">Marius Jensen</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/dimadin\">Milan Dinić</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/SergeyBiryukov\">Sergey Biryukov</a>, and <a href=\"http://profiles.wordpress.org/westonruter\">Weston Ruter</a>.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/05/wordpress-3-9-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:25:\"WordPress 3.9 “Smith”\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:40:\"http://wordpress.org/news/2014/04/smith/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:49:\"http://wordpress.org/news/2014/04/smith/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 16 Apr 2014 18:33:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3154\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:411:\"Version 3.9 of WordPress, named &#8220;Smith&#8221; in honor of jazz organist Jimmy Smith, is available for download or update in your WordPress dashboard. This release features a number of refinements that we hope you&#8217;ll love. A smoother media editing experience Improved visual editing The updated visual editor has improved speed, accessibility, and mobile support. You can paste into the [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:23291:\"<p>Version 3.9 of WordPress, named &#8220;Smith&#8221; in honor of jazz organist <a href=\"http://en.wikipedia.org/wiki/Jimmy_Smith_(musician)\">Jimmy Smith</a>, is available <a href=\"http://wordpress.org/download/\">for download</a> or update in your WordPress dashboard. This release features a number of refinements that we hope you&#8217;ll love.</p>\n<embed src=\"//v0.wordpress.com/player.swf?v=1.03\" type=\"application/x-shockwave-flash\" width=\"640\" height=\"360\" wmode=\"direct\" seamlesstabbing=\"true\" allowfullscreen=\"true\" allowscriptaccess=\"always\" overstretch=\"true\" flashvars=\"guid=sAiXhCfV&amp;isDynamicSeeking=true\" title=\"\"></embed>\n<h2 class=\"about-headline-callout\" style=\"text-align: center\">A smoother media editing experience</h2>\n<div>\n<p><img class=\"alignright wp-image-3168\" src=\"//wordpress.org/news/files/2014/04/editor1-300x233.jpg\" alt=\"editor\" width=\"228\" height=\"177\" /></p>\n<h3>Improved visual editing</h3>\n<p>The updated visual editor has improved speed, accessibility, and mobile support. You can paste into the visual editor from your word processor without wasting time to clean up messy styling. (Yeah, we’re talking about you, Microsoft Word.)</p>\n</div>\n<div style=\"clear: both\"></div>\n<div>\n<p><img class=\"alignright wp-image-3170\" src=\"//wordpress.org/news/files/2014/04/image1-300x233.jpg\" alt=\"image\" width=\"228\" height=\"178\" /></p>\n<h3>Edit images easily</h3>\n<p>With quicker access to crop and rotation tools, it’s now much easier to edit your images while editing posts. You can also scale images directly in the editor to find just the right fit.</p>\n</div>\n<div style=\"clear: both\"></div>\n<div>\n<p><img class=\"alignright wp-image-3187\" src=\"//wordpress.org/news/files/2014/04/dragdrop1-300x233.jpg\" alt=\"dragdrop\" width=\"228\" height=\"178\" /></p>\n<h3>Drag and drop your images</h3>\n<p>Uploading your images is easier than ever. Just grab them from your desktop and drop them in the editor.</p>\n</div>\n<div style=\"clear: both\"></div>\n<hr />\n<h2 style=\"text-align: center\">Gallery previews</h2>\n<p><img class=\"aligncenter size-full wp-image-3169\" src=\"//wordpress.org/news/files/2014/04/gallery1.jpg\" alt=\"gallery\" width=\"980\" height=\"550\" /></p>\n<p>Galleries display a beautiful grid of images right in the editor, just like they do in your published post.</p>\n<hr />\n<h2 style=\"text-align: center\">Do more with audio and video</h2>\n\n<a href=\'http://wordpress.org/news/files/2014/04/AintMisbehavin.mp3\'>Ain\'t Misbehavin\'</a>\n<a href=\'http://wordpress.org/news/files/2014/04/DavenportBlues.mp3\'>Davenport Blues</a>\n<a href=\'http://wordpress.org/news/files/2014/04/JellyRollMorton-BuddyBoldensBlues.mp3\'>Buddy Bolden\'s Blues</a>\n<a href=\'http://wordpress.org/news/files/2014/04/Johnny_Hodges_Orchestra-Squaty_Roo-1941.mp3\'>Squaty Roo</a>\n<a href=\'http://wordpress.org/news/files/2014/04/Louisiana_Five-Dixie_Blues-1919.mp3\'>Dixie Blues</a>\n<a href=\'http://wordpress.org/news/files/2014/04/WolverineBlues.mp3\'>Wolverine Blues</a>\n\n<p>Images have galleries; now we’ve added simple audio and video playlists, so you can showcase your music and clips.</p>\n<hr />\n<h2 style=\"text-align: center\">Live widget and header previews</h2>\n<div style=\"width: 692px; max-width: 100%;\" class=\"wp-video\"><!--[if lt IE 9]><script>document.createElement(\'video\');</script><![endif]-->\n<video class=\"wp-video-shortcode\" id=\"video-3154-1\" width=\"692\" height=\"448\" preload=\"metadata\" controls=\"controls\"><source type=\"video/mp4\" src=\"//wordpress.org/news/files/2014/04/widgets.mp4?_=1\" /><a href=\"//wordpress.org/news/files/2014/04/widgets.mp4\">//wordpress.org/news/files/2014/04/widgets.mp4</a></video></div>\n<p>Add, edit, and rearrange your site’s widgets right in the theme customizer. No “save and surprise” — preview your changes live and only save them when you’re ready.</p>\n<p>The improved header image tool also lets you upload, crop, and manage headers while customizing your theme.</p>\n<hr />\n<h2 style=\"text-align: center\">Stunning new theme browser</h2>\n<p><img class=\"aligncenter size-full wp-image-3172\" src=\"//wordpress.org/news/files/2014/04/theme1.jpg\" alt=\"theme\" width=\"1003\" height=\"558\" /><br />\nLooking for a new theme should be easy and fun. Lose yourself in the boundless supply of free WordPress.org themes with the beautiful new theme browser.</p>\n<hr />\n<h2 style=\"text-align: center\">The Crew</h2>\n<p>This release was led by <a href=\"http://nacin.com/\">Andrew Nacin</a> and <a href=\"http://www.getsource.net/\">Mike Schroder</a>, with the help of these fine individuals. There are 267 contributors with props in this release, a new high:</p>\n<p><a href=\"http://profiles.wordpress.org/aaroncampbell\">Aaron D. Campbell</a>, <a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/kawauso\">Adam Harley</a>, <a href=\"http://profiles.wordpress.org/adamsilverstein\">Adam Silverstein</a>, <a href=\"http://profiles.wordpress.org/adelval\">adelval</a>, <a href=\"http://profiles.wordpress.org/ajay\">Ajay</a>, <a href=\"http://profiles.wordpress.org/akeda\">Akeda Bagus</a>, <a href=\"http://profiles.wordpress.org/xknown\">Alex Concha</a>, <a href=\"http://profiles.wordpress.org/tellyworth\">Alex Shiels</a>, <a href=\"http://profiles.wordpress.org/aliso\">Alison Barrett</a>, <a href=\"http://profiles.wordpress.org/collinsinternet\">Allan Collins</a>, <a href=\"http://profiles.wordpress.org/sabreuse\">Amy Hendrix (sabreuse)</a>, <a href=\"http://profiles.wordpress.org/afercia\">Andrea Fercia</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/norcross\">Andrew Norcross</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/rarst\">Andrey \"Rarst\" Savchenko</a>, <a href=\"http://profiles.wordpress.org/andykeith\">Andy Keith</a>, <a href=\"http://profiles.wordpress.org/andy\">Andy Skelton</a>, <a href=\"http://profiles.wordpress.org/atimmer\">Anton Timmermans</a>, <a href=\"http://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"http://profiles.wordpress.org/barry\">Barry</a>, <a href=\"http://profiles.wordpress.org/toszcze\">Bartosz Romanowski</a>, <a href=\"http://profiles.wordpress.org/bassgang\">bassgang</a>, <a href=\"http://profiles.wordpress.org/bcworkz\">bcworkz</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"http://profiles.wordpress.org/neoxx\">Bernhard Riedl</a>, <a href=\"http://profiles.wordpress.org/bigdawggi\">bigdawggi</a>, <a href=\"http://profiles.wordpress.org/bobbravo2\">Bob Gregor</a>, <a href=\"http://profiles.wordpress.org/bobbingwide\">bobbingwide</a>, <a href=\"http://profiles.wordpress.org/bradt\">Brad Touesnard</a>, <a href=\"http://profiles.wordpress.org/bradparbs\">bradparbs</a>, <a href=\"http://profiles.wordpress.org/bramd\">bramd</a>, <a href=\"http://profiles.wordpress.org/kraftbj\">Brandon Kraft</a>, <a href=\"http://profiles.wordpress.org/brasofilo\">brasofilo</a>, <a href=\"http://profiles.wordpress.org/bravokeyl\">bravokeyl</a>, <a href=\"http://profiles.wordpress.org/bpetty\">Bryan Petty</a>, <a href=\"http://profiles.wordpress.org/cgaffga\">cgaffga</a>, <a href=\"http://profiles.wordpress.org/chiragswadia\">Chirag Swadia</a>, <a href=\"http://profiles.wordpress.org/chouby\">Chouby</a>, <a href=\"http://profiles.wordpress.org/ehg\">Chris Blower</a>, <a href=\"http://profiles.wordpress.org/cmmarslender\">Chris Marslender</a>, <a href=\"http://profiles.wordpress.org/c3mdigital\">Chris Olbekson</a>, <a href=\"http://profiles.wordpress.org/chrisscott\">Chris Scott</a>, <a href=\"http://profiles.wordpress.org/chriseverson\">chriseverson</a>, <a href=\"http://profiles.wordpress.org/chrisguitarguy\">chrisguitarguy</a>, <a href=\"http://profiles.wordpress.org/cfinke\">Christopher Finke</a>, <a href=\"http://profiles.wordpress.org/ciantic\">ciantic</a>, <a href=\"http://profiles.wordpress.org/antorome\">Comparativa de Bancos</a>, <a href=\"http://profiles.wordpress.org/cojennin\">Connor Jennings</a>, <a href=\"http://profiles.wordpress.org/corvannoorloos\">Cor van Noorloos</a>, <a href=\"http://profiles.wordpress.org/corphi\">Corphi</a>, <a href=\"http://profiles.wordpress.org/cramdesign\">cramdesign</a>, <a href=\"http://profiles.wordpress.org/danielbachhuber\">Daniel Bachhuber</a>, <a href=\"http://profiles.wordpress.org/redsweater\">Daniel Jalkut (Red Sweater)</a>, <a href=\"http://profiles.wordpress.org/dannydehaan\">Danny de Haan</a>, <a href=\"http://profiles.wordpress.org/koop\">Daryl Koopersmith</a>, <a href=\"http://profiles.wordpress.org/eightface\">Dave Kellam (eightface)</a>, <a href=\"http://profiles.wordpress.org/dpe415\">DaveE</a>, <a href=\"http://profiles.wordpress.org/davidakennedy\">David A. Kennedy</a>, <a href=\"http://profiles.wordpress.org/davidanderson\">David Anderson</a>, <a href=\"http://profiles.wordpress.org/davidmarichal\">David Marichal</a>, <a href=\"http://profiles.wordpress.org/denis-de-bernardy\">Denis de Bernardy</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"http://profiles.wordpress.org/dougwollison\">Doug Wollison</a>, <a href=\"http://profiles.wordpress.org/drewapicture\">Drew Jaynes</a>, <a href=\"http://profiles.wordpress.org/drprotocols\">DrProtocols</a>, <a href=\"http://profiles.wordpress.org/dustyf\">Dustin Filippini</a>, <a href=\"http://profiles.wordpress.org/eatingrules\">eatingrules</a>, <a href=\"http://profiles.wordpress.org/plocha\">edik</a>, <a href=\"http://profiles.wordpress.org/eliorivero\">Elio Rivero</a>, <a href=\"http://profiles.wordpress.org/enej\">enej</a>, <a href=\"http://profiles.wordpress.org/ericlewis\">Eric Andrew Lewis</a>, <a href=\"http://profiles.wordpress.org/ericmann\">Eric Mann</a>, <a href=\"http://profiles.wordpress.org/evarlese\">Erica Varlese</a>, <a href=\"http://profiles.wordpress.org/ethitter\">Erick Hitter</a>, <a href=\"http://profiles.wordpress.org/ejdanderson\">Evan Anderson</a>, <a href=\"http://profiles.wordpress.org/fahmiadib\">Fahmi Adib</a>, <a href=\"http://profiles.wordpress.org/fboender\">fboender</a>, <a href=\"http://profiles.wordpress.org/frank-klein\">Frank Klein</a>, <a href=\"http://profiles.wordpress.org/garyc40\">Gary Cao</a>, <a href=\"http://profiles.wordpress.org/garyj\">Gary Jones</a>, <a href=\"http://profiles.wordpress.org/pento\">Gary Pendergast</a>, <a href=\"http://profiles.wordpress.org/genkisan\">genkisan</a>, <a href=\"http://profiles.wordpress.org/soulseekah\">Gennady Kovshenin</a>, <a href=\"http://profiles.wordpress.org/georgestephanis\">George Stephanis</a>, <a href=\"http://profiles.wordpress.org/grahamarmfield\">Graham Armfield</a>, <a href=\"http://profiles.wordpress.org/vancoder\">Grant Mangham</a>, <a href=\"http://profiles.wordpress.org/gcorne\">Gregory Cornelius</a>, <a href=\"http://profiles.wordpress.org/tivnet\">Gregory Karpinsky (@tivnet)</a>, <a href=\"http://profiles.wordpress.org/hakre\">hakre</a>, <a href=\"http://profiles.wordpress.org/hanni\">hanni</a>, <a href=\"http://profiles.wordpress.org/helen\">Helen Hou-Sandí</a>, <a href=\"http://profiles.wordpress.org/ippetkov\">ippetkov</a>, <a href=\"http://profiles.wordpress.org/ipstenu\">Ipstenu (Mika Epstein)</a>, <a href=\"http://profiles.wordpress.org/jdgrimes\">J.D. Grimes</a>, <a href=\"http://profiles.wordpress.org/jackreichert\">Jack Reichert</a>, <a href=\"http://profiles.wordpress.org/_jameslee\">jameslee</a>, <a href=\"http://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"http://profiles.wordpress.org/janrenn\">janrenn</a>, <a href=\"http://profiles.wordpress.org/jaycc\">JayCC</a>, <a href=\"http://profiles.wordpress.org/jeffsebring\">Jeff Sebring</a>, <a href=\"http://profiles.wordpress.org/jenmylo\">Jen Mylo</a>, <a href=\"http://profiles.wordpress.org/jeremyfelt\">Jeremy Felt</a>, <a href=\"http://profiles.wordpress.org/jesin\">Jesin A</a>, <a href=\"http://profiles.wordpress.org/jayjdk\">Jesper Johansen (jayjdk)</a>, <a href=\"http://profiles.wordpress.org/jnielsendotnet\">jnielsendotnet</a>, <a href=\"http://profiles.wordpress.org/jartes\">Joan Artes</a>, <a href=\"http://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"http://profiles.wordpress.org/joehoyle\">Joe Hoyle</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"http://profiles.wordpress.org/johnjamesjacoby\">John James Jacoby</a>, <a href=\"http://profiles.wordpress.org/johnpbloch\">John P. Bloch</a>, <a href=\"http://profiles.wordpress.org/johnregan3\">John Regan</a>, <a href=\"http://profiles.wordpress.org/duck_\">Jon Cave</a>, <a href=\"http://profiles.wordpress.org/jond3r\">Jonas Bolinder (jond3r)</a>, <a href=\"http://profiles.wordpress.org/joostdevalk\">Joost de Valk</a>, <a href=\"http://profiles.wordpress.org/shelob9\">Josh Pollock</a>, <a href=\"http://profiles.wordpress.org/joshuaabenazer\">Joshua Abenazer</a>, <a href=\"http://profiles.wordpress.org/jstraitiff\">jstraitiff</a>, <a href=\"http://profiles.wordpress.org/juliobox\">Julio Potier</a>, <a href=\"http://profiles.wordpress.org/kopepasah\">Justin Kopepasah</a>, <a href=\"http://profiles.wordpress.org/justinsainton\">Justin Sainton</a>, <a href=\"http://profiles.wordpress.org/kadamwhite\">K.Adam White</a>, <a href=\"http://profiles.wordpress.org/trepmal\">Kailey (trepmal)</a>, <a href=\"http://profiles.wordpress.org/kasparsd\">Kaspars</a>, <a href=\"http://profiles.wordpress.org/ryelle\">Kelly Dwan</a>, <a href=\"http://profiles.wordpress.org/kerikae\">kerikae</a>, <a href=\"http://profiles.wordpress.org/kworthington\">Kevin Worthington</a>, <a href=\"http://profiles.wordpress.org/kpdesign\">Kim Parsell</a>, <a href=\"http://profiles.wordpress.org/kwight\">Kirk Wight</a>, <a href=\"http://profiles.wordpress.org/kitchin\">kitchin</a>, <a href=\"http://profiles.wordpress.org/klihelp\">klihelp</a>, <a href=\"http://profiles.wordpress.org/knutsp\">Knut Sparhell</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/obenland\">Konstantin Obenland</a>, <a href=\"http://profiles.wordpress.org/drozdz\">Krzysiek Drozdz</a>, <a href=\"http://profiles.wordpress.org/lancewillett\">Lance Willett</a>, <a href=\"http://profiles.wordpress.org/leewillis77\">Lee Willis</a>, <a href=\"http://profiles.wordpress.org/lkwdwrd\">lkwdwrd</a>, <a href=\"http://profiles.wordpress.org/lpointet\">lpointet</a>, <a href=\"http://profiles.wordpress.org/ldebrouwer\">Luc De Brouwer</a>, <a href=\"http://profiles.wordpress.org/spmlucas\">Lucas Karpiuk</a>, <a href=\"http://profiles.wordpress.org/mark8barnes\">Mark Barnes</a>, <a href=\"http://profiles.wordpress.org/markjaquith\">Mark Jaquith</a>, <a href=\"http://profiles.wordpress.org/markoheijnen\">Marko Heijnen</a>, <a href=\"http://profiles.wordpress.org/marventus\">Marventus</a>, <a href=\"http://profiles.wordpress.org/iammattthomas\">Matt (Thomas) Miklic</a>, <a href=\"http://profiles.wordpress.org/mjbanks\">Matt Banks</a>, <a href=\"http://profiles.wordpress.org/matt\">Matt Mullenweg</a>, <a href=\"http://profiles.wordpress.org/mboynes\">Matthew Boynes</a>, <a href=\"http://profiles.wordpress.org/mdbitz\">Matthew Denton</a>, <a href=\"http://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"http://profiles.wordpress.org/mattonomics\">mattonomics</a>, <a href=\"http://profiles.wordpress.org/mattyrob\">mattyrob</a>, <a href=\"http://profiles.wordpress.org/matveb\">Matías Ventura</a>, <a href=\"http://profiles.wordpress.org/maxcutler\">Max Cutler</a>, <a href=\"http://profiles.wordpress.org/mcadwell\">mcadwell</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/meloniq\">meloniq</a>, <a href=\"http://profiles.wordpress.org/michael-arestad\">Michael Arestad</a>, <a href=\"http://profiles.wordpress.org/michelwppi\">Michel - xiligroup dev</a>, <a href=\"http://profiles.wordpress.org/mcsf\">Miguel Fonseca</a>, <a href=\"http://profiles.wordpress.org/gradyetc\">Mike Burns</a>, <a href=\"http://profiles.wordpress.org/mikehansenme\">Mike Hansen</a>, <a href=\"http://profiles.wordpress.org/mikemanger\">Mike Manger</a>, <a href=\"http://profiles.wordpress.org/mikeschinkel\">Mike Schinkel</a>, <a href=\"http://profiles.wordpress.org/dh-shredder\">Mike Schroder</a>, <a href=\"http://profiles.wordpress.org/mikecorkum\">mikecorkum</a>, <a href=\"http://profiles.wordpress.org/mitchoyoshitaka\">mitcho (Michael Yoshitaka Erlewine)</a>, <a href=\"http://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"http://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"http://profiles.wordpress.org/mor10\">Morten Rand-Hendriksen</a>, <a href=\"http://profiles.wordpress.org/Nao\">Naoko Takano</a>, <a href=\"http://profiles.wordpress.org/alex-ye\">Nashwan Doaqan</a>, <a href=\"http://profiles.wordpress.org/nendeb55\">nendeb55</a>, <a href=\"http://profiles.wordpress.org/celloexpressions\">Nick Halsey</a>, <a href=\"http://profiles.wordpress.org/nicolealleyinteractivecom\">Nicole Arnold</a>, <a href=\"http://profiles.wordpress.org/nikv\">Nikhil Vimal (NikV)</a>, <a href=\"http://profiles.wordpress.org/nivijah\">Nivi Jah</a>, <a href=\"http://profiles.wordpress.org/nofearinc\">nofearinc</a>, <a href=\"http://profiles.wordpress.org/nunomorgadinho\">Nuno Morgadinho</a>, <a href=\"http://profiles.wordpress.org/olivm\">olivM</a>, <a href=\"http://profiles.wordpress.org/jbkkd\">Omer Korner</a>, <a href=\"http://profiles.wordpress.org/originalexe\">OriginalEXE</a>, <a href=\"http://profiles.wordpress.org/oso96_2000\">oso96_2000</a>, <a href=\"http://profiles.wordpress.org/patricknami\">patricknami</a>, <a href=\"http://profiles.wordpress.org/pbearne\">Paul Bearne</a>, <a href=\"http://profiles.wordpress.org/djpaul\">Paul Gibbs</a>, <a href=\"http://profiles.wordpress.org/paulwilde\">Paul Wilde</a>, <a href=\"http://profiles.wordpress.org/pavelevap\">pavelevap</a>, <a href=\"http://profiles.wordpress.org/westi\">Peter Westwood</a>, <a href=\"http://profiles.wordpress.org/philiparthurmoore\">Philip Arthur Moore</a>, <a href=\"http://profiles.wordpress.org/mordauk\">Pippin Williamson</a>, <a href=\"http://profiles.wordpress.org/nprasath002\">Prasath Nadarajah</a>, <a href=\"http://profiles.wordpress.org/prettyboymp\">prettyboymp</a>, <a href=\"http://profiles.wordpress.org/raamdev\">Raam Dev</a>, <a href=\"http://profiles.wordpress.org/rachelbaker\">rachelbaker</a>, <a href=\"http://profiles.wordpress.org/mauryaratan\">Ram Ratan Maurya</a>, <a href=\"http://profiles.wordpress.org/ramonchiara\">ramonchiara</a>, <a href=\"http://profiles.wordpress.org/ounziw\">Rescuework Support</a>, <a href=\"http://profiles.wordpress.org/rhyswynne\">Rhys Wynne</a>, <a href=\"http://profiles.wordpress.org/ricardocorreia\">Ricardo Correia</a>, <a href=\"http://profiles.wordpress.org/theorboman\">Richard Sweeney</a>, <a href=\"http://profiles.wordpress.org/iamfriendly\">Richard Tape</a>, <a href=\"http://profiles.wordpress.org/richard2222\">richard2222</a>, <a href=\"http://profiles.wordpress.org/rickalee\">Ricky Lee Whittemore</a>, <a href=\"http://profiles.wordpress.org/miqrogroove\">Robert Chapin</a>, <a href=\"http://profiles.wordpress.org/robmiller\">robmiller</a>, <a href=\"http://profiles.wordpress.org/rodrigosprimo\">Rodrigo Primo</a>, <a href=\"http://profiles.wordpress.org/romaimperator\">romaimperator</a>, <a href=\"http://profiles.wordpress.org/roothorick\">roothorick</a>, <a href=\"http://profiles.wordpress.org/ruudjoyo\">ruud@joyo</a>, <a href=\"http://profiles.wordpress.org/ryan\">Ryan Boren</a>, <a href=\"http://profiles.wordpress.org/rmccue\">Ryan McCue</a>, <a href=\"http://profiles.wordpress.org/salcode\">Sal Ferrarello</a>, <a href=\"http://profiles.wordpress.org/otto42\">Samuel Wood (Otto)</a>, <a href=\"http://profiles.wordpress.org/sandyr\">Sandeep</a>, <a href=\"http://profiles.wordpress.org/scottlee\">Scott Lee</a>, <a href=\"http://profiles.wordpress.org/coffee2code\">Scott Reilly</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/greglone\">ScreenfeedFr</a>, <a href=\"http://profiles.wordpress.org/scribu\">scribu</a>, <a href=\"http://profiles.wordpress.org/sdasse\">sdasse</a>, <a href=\"http://profiles.wordpress.org/bootsz\">Sean Butze</a>, <a href=\"http://profiles.wordpress.org/seanchayes\">Sean Hayes</a>, <a href=\"http://profiles.wordpress.org/nessworthy\">Sean Nessworthy</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/shahpranaf\">shahpranaf</a>, <a href=\"http://profiles.wordpress.org/shaunandrews\">Shaun Andrews</a>, <a href=\"http://profiles.wordpress.org/shinichin\">ShinichiN</a>, <a href=\"http://profiles.wordpress.org/pross\">Simon Prosser</a>, <a href=\"http://profiles.wordpress.org/simonwheatley\">Simon Wheatley</a>, <a href=\"http://profiles.wordpress.org/siobhan\">Siobhan</a>, <a href=\"http://profiles.wordpress.org/siobhyb\">Siobhan Bamber (siobhyb)</a>, <a href=\"http://profiles.wordpress.org/sirzooro\">sirzooro</a>, <a href=\"http://profiles.wordpress.org/solarissmoke\">solarissmoke</a>, <a href=\"http://profiles.wordpress.org/sonjanyc\">sonjanyc</a>, <a href=\"http://profiles.wordpress.org/spencerfinnell\">Spencer Finnell</a>, <a href=\"http://profiles.wordpress.org/piontkowski\">Spencer Piontkowski</a>, <a href=\"http://profiles.wordpress.org/stephcook22\">stephcook22</a>, <a href=\"http://profiles.wordpress.org/netweb\">Stephen Edgar</a>, <a href=\"http://profiles.wordpress.org/stephenharris\">Stephen Harris</a>, <a href=\"http://profiles.wordpress.org/sbruner\">Steve Bruner</a>, <a href=\"http://profiles.wordpress.org/stevenkword\">Steven Word</a>, <a href=\"http://profiles.wordpress.org/miyauchi\">Takayuki Miyauchi</a>, <a href=\"http://profiles.wordpress.org/tanner-m\">Tanner Moushey</a>, <a href=\"http://profiles.wordpress.org/tlovett1\">Taylor Lovett</a>, <a href=\"http://profiles.wordpress.org/tbrams\">tbrams</a>, <a href=\"http://profiles.wordpress.org/tobiasbg\">TobiasBg</a>, <a href=\"http://profiles.wordpress.org/tomauger\">Tom Auger</a>, <a href=\"http://profiles.wordpress.org/willmot\">Tom Willmot</a>, <a href=\"http://profiles.wordpress.org/topher1kenobe\">Topher</a>, <a href=\"http://profiles.wordpress.org/topquarky\">topquarky</a>, <a href=\"http://profiles.wordpress.org/zodiac1978\">Torsten Landsiedel</a>, <a href=\"http://profiles.wordpress.org/toru\">Toru</a>, <a href=\"http://profiles.wordpress.org/wpsmith\">Travis Smith</a>, <a href=\"http://profiles.wordpress.org/umeshsingla\">Umesh Kumar</a>, <a href=\"http://profiles.wordpress.org/undergroundnetwork\">undergroundnetwork</a>, <a href=\"http://profiles.wordpress.org/varunagw\">VarunAgw</a>, <a href=\"http://profiles.wordpress.org/wawco\">wawco</a>, <a href=\"http://profiles.wordpress.org/westonruter\">Weston Ruter</a>, <a href=\"http://profiles.wordpress.org/wokamoto\">wokamoto</a>, <a href=\"http://profiles.wordpress.org/xsonic\">xsonic</a>, <a href=\"http://profiles.wordpress.org/yoavf\">Yoav Farhi</a>, <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>, <a href=\"http://profiles.wordpress.org/zbtirrell\">Zach Tirrell</a>, and <a href=\"http://profiles.wordpress.org/vanillalounge\">Ze Fontainhas</a>. Also thanks to <a href=\"http://michaelpick.wordpress.com/\">Michael Pick</a> for producing the release video.</p>\n<p>If you want to follow along or help out, check out <a href=\"http://make.wordpress.org/\">Make WordPress</a> and our <a href=\"http://make.wordpress.org/core/\">core development blog</a>. Thanks for choosing WordPress. See you soon for version 4.0!</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:45:\"http://wordpress.org/news/2014/04/smith/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"WordPress 3.9 Release Candidate 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 15 Apr 2014 09:47:36 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3151\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:356:\"The second release candidate for WordPress 3.9 is now available for testing. If you haven&#8217;t tested 3.9 yet, you&#8217;re running out of time! We made about five dozen changes since the first release candidate, and those changes are all helpfully summarized in our weekly post on the development blog. Probably the biggest fixes are to live [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2273:\"<p>The second release candidate for WordPress 3.9 is now available for testing.</p>\n<p>If you haven&#8217;t tested 3.9 yet, you&#8217;re running out of time! We made about five dozen changes since the <a title=\"WordPress 3.9 Release Candidate\" href=\"//wordpress.org/news/2014/04/wordpress-3-9-release-candidate/\">first release candidate</a>, and those changes are all helpfully summarized <a href=\"//make.wordpress.org/core/?p=10237\">in our weekly post</a> on the development blog. Probably the biggest fixes are to live widget previews and the new theme browser, along with some extra TinyMCE compatibility and some RTL fixes.</p>\n<p><strong>Plugin authors:</strong> Could you test your plugins against 3.9, and if they&#8217;re compatible, make sure they are marked as tested up to 3.9? It only takes a few minutes and this really helps make launch easier. Be sure to follow along the core development blog; we&#8217;ve been posting <a href=\"//make.wordpress.org/core/tag/3-9-dev-notes/\">notes for developers for 3.9</a>. (For example: <a href=\"//make.wordpress.org/core/2014/04/15/html5-galleries-captions-in-wordpress-3-9/\">HTML5</a>, <a href=\"//make.wordpress.org/core/2014/04/14/symlinked-plugins-in-wordpress-3-9/\">symlinks</a>, <a href=\"//make.wordpress.org/core/2014/04/07/mysql-in-wordpress-3-9/\">MySQL</a>, <a href=\"//make.wordpress.org/core/2014/04/11/plupload-2-x-in-wordpress-3-9/\">Plupload</a>.)</p>\n<p>To test WordPress 3.9 RC2, try the <a href=\"//wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"//wordpress.org/wordpress-3.9-RC2.zip\">download the release candidate here</a> (zip). If you’d like to learn more about what’s new in WordPress 3.9, visit the nearly complete About screen in your dashboard (<strong><img src=\"//i0.wp.com/core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png?w=692\" alt=\"\" width=\"16\" height=\"16\" /> → About</strong> in the toolbar) and also check out <a title=\"WordPress 3.9 Beta 1\" href=\"//wordpress.org/news/2014/03/wordpress-3-9-beta-1/\">the Beta 1 post</a>.</p>\n<p><em>This is for testing,</em><br />\n<em>so not recommended for<br />\nproduction sites—yet.</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"WordPress 3.8.3 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2014/04/wordpress-3-8-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/news/2014/04/wordpress-3-8-3/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 14 Apr 2014 19:29:13 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3145\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:338:\"WordPress 3.8.3 is now available to fix a small but unfortunate bug in the WordPress 3.8.2 security release. The &#8220;Quick Draft&#8221; tool on the dashboard screen was broken in the 3.8.2 update. If you tried to use it, your draft would disappear and it wouldn&#8217;t save. While we doubt anyone was writing a novella using [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2339:\"<p>WordPress 3.8.3 is now available to fix a small but unfortunate bug in the <a title=\"WordPress 3.8.2 Security Release\" href=\"http://wordpress.org/news/2014/04/wordpress-3-8-2/\">WordPress 3.8.2 security release</a>.</p>\n<p>The &#8220;Quick Draft&#8221; tool on the dashboard screen was broken in the 3.8.2 update. If you tried to use it, your draft would disappear and it wouldn&#8217;t save. While we doubt anyone was writing a novella using this tool, <em>any</em> loss of content is unacceptable to us.</p>\n<p>We recognize how much trust you place in us to safeguard your content, and we take this responsibility very seriously. We&#8217;re sorry we let you down.</p>\n<p>We&#8217;ve all lost words we&#8217;ve written before, like an email thanks to a cat on the keyboard or a term paper to a blue screen of death. Over the last few WordPress releases, we&#8217;ve made a number of improvements to features like autosaves and revisions. With revisions, an old edit can always be restored. We&#8217;re trying our hardest to save your content somewhere even if your power goes out or your browser crashes. We even monitor your internet connection and prevent you from hitting that &#8220;Publish&#8221; button at the exact moment the coffee shop Wi-Fi has a hiccup.</p>\n<p>It&#8217;s <em>possible</em> that the quick draft you lost last week is still in the database, and just hidden from view. As an added complication, these &#8220;discarded drafts&#8221; normally get deleted after seven days, and it&#8217;s already been six days since the release. If we were able to rescue your draft, you&#8217;ll see it on the &#8220;All Posts&#8221; screen after you update to 3.8.3. (We&#8217;ll also be pushing 3.8.3 out as a background update, so you may just see a draft appear.)</p>\n<p>So, if you tried to jot down a quick idea last week, I hope WordPress has recovered it for you. Maybe it&#8217;ll turn into that novella.</p>\n<p><a href=\"http://wordpress.org/download/\">Download WordPress 3.8.3</a> or click &#8220;Update Now&#8221; on Dashboard → Updates.</p>\n<p><em>This affected version 3.7.2 as well, so we&#8217;re pushing a 3.7.3 to these installs, but we&#8217;d encourage you to update to the latest and greatest.</em></p>\n<hr />\n<p><em>Now for some good news:<br />\nWordPress 3.9 is near.<br />\nExpect it this week</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/04/wordpress-3-8-3/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"WordPress 3.9 Release Candidate\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 08 Apr 2014 21:05:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3129\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:338:\"As teased earlier, the first release candidate for WordPress 3.9 is now available for testing! We hope to ship WordPress 3.9 next week, but we need your help to get there. If you haven’t tested 3.9 yet, there’s no time like the present. (Please, not on a production site, unless you’re adventurous.) To test WordPress 3.9 [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2967:\"<p><a href=\"//wordpress.org/news/2014/04/wordpress-3-8-2/\">As teased earlier</a>, the first release candidate for WordPress 3.9 is now available for testing!</p>\n<p>We hope to ship WordPress 3.9 <em>next week</em>, but we need your help to get there. If you haven’t tested 3.9 yet, there’s no time like the present. (Please, not on a production site, unless you’re adventurous.)</p>\n<p>To test WordPress 3.9 RC1, try the <a href=\"//wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"//wordpress.org/wordpress-3.9-RC1.zip\">download the release candidate here</a> (zip). If you’d like to learn more about what’s new in WordPress 3.9, visit the work-in-progress About screen in your dashboard (<strong><img src=\"//i0.wp.com/core.svn.wordpress.org/branches/3.6/wp-content/themes/twentyten/images/wordpress.png?w=692\" alt=\"\" width=\"16\" height=\"16\" /> → About</strong> in the toolbar) and check out <a title=\"WordPress 3.9 Beta 1\" href=\"//wordpress.org/news/2014/03/wordpress-3-9-beta-1/\">the Beta 1 post</a>.</p>\n<p><strong>Think you’ve found a bug? </strong>Please post to the <a href=\"//wordpress.org/support/forum/alphabeta/\">Alpha/Beta area in the support forums</a>. If any known issues come up, you’ll be able to <a href=\"//core.trac.wordpress.org/report/5\">find them here</a>.</p>\n<p><strong>If you&#8217;re a plugin author</strong>, there are two important changes in particular to be aware of:</p>\n<ul>\n<li>TinyMCE received a major update, to version 4.0. Any editor plugins written for TinyMCE 3.x might require some updates. (If things broke, we&#8217;d like to hear about them so we can make adjustments.) For more, see TinyMCE&#8217;s <a href=\"http://www.tinymce.com/wiki.php/Tutorial:Migration_guide_from_3.x\">migration guide</a> and <a href=\"http://www.tinymce.com/wiki.php/api4:index\">API documentation</a>, and the notes on the <a href=\"//make.wordpress.org/core/2014/01/18/tinymce-4-0-is-in-core/\">core development blog</a>.</li>\n<li>WordPress 3.9 now uses the MySQLi Improved extension for sites running PHP 5.5. Any plugins that made direct calls to <code>mysql_*</code> functions will experience some problems on these sites. For more information, see the notes on the <a href=\"//make.wordpress.org/core/2014/04/07/mysql-in-wordpress-3-9/\">core development blog</a>.</li>\n</ul>\n<p>Be sure to follow along the core development blog, where we will be continuing to post <a href=\"//make.wordpress.org/core/tag/3-9-dev-notes/\">notes for developers for 3.9</a>. (For example, read <a href=\"//make.wordpress.org/core/2014/03/27/masonry-in-wordpress-3-9/\">this</a> if you are using Masonry in your theme.) And please, please update your plugin&#8217;s <em>Tested up to</em> version in the readme to 3.9 before April 16.</p>\n<p><em>Release candidate<br />\nThis haiku&#8217;s the easy one<br />\n3.9 is near</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:71:\"http://wordpress.org/news/2014/04/wordpress-3-9-release-candidate/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"WordPress 3.8.2 Security Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2014/04/wordpress-3-8-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/news/2014/04/wordpress-3-8-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 08 Apr 2014 19:04:44 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Security\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3124\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:355:\"WordPress 3.8.2 is now available. This is an important security release for all previous versions and we strongly encourage you to update your sites immediately. This releases fixes a weakness that could let an attacker force their way into your site by forging authentication cookies. This was discovered and fixed by Jon Cave of the WordPress [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2272:\"<p>WordPress 3.8.2 is now available. This is an important security release for all previous versions and we strongly encourage you to update your sites immediately.</p>\n<p>This releases fixes a weakness that could let an attacker force their way into your site by forging authentication cookies. This was discovered and fixed by <a href=\"http://joncave.co.uk/\">Jon Cave</a> of the WordPress security team.</p>\n<p>It also contains a fix to prevent a user with the Contributor role from improperly publishing posts. Reported by <a href=\"http://edik.ch/\">edik</a>.</p>\n<p>This release also fixes nine bugs and contains three other security hardening changes:</p>\n<ul>\n<li>Pass along additional information when processing pingbacks to help hosts identify potentially abusive requests.</li>\n<li>Fix a low-impact SQL injection by trusted users. Reported by <a href=\"http://www.dxw.com/\">Tom Adams</a> of dxw.</li>\n<li>Prevent possible cross-domain scripting through Plupload, the third-party library WordPress uses for uploading files. Reported by <a href=\"http://szgru.website.pl/\">Szymon Gruszecki</a>.</li>\n</ul>\n<p>We appreciated <a href=\"http://codex.wordpress.org/FAQ_Security\">responsible disclosure</a> of these security issues directly to our security team. For more information on all of the changes, see the <a href=\"http://codex.wordpress.org/Version_3.8.2\">release notes</a> or consult <a href=\"https://core.trac.wordpress.org/log/branches/3.8?rev=28057&amp;stop_rev=27024\">the list of changes</a>.</p>\n<p><a href=\"http://wordpress.org/download/\">Download WordPress 3.8.2</a> or venture over to <strong>Dashboard → Updates</strong> and simply click &#8220;Update Now.&#8221;</p>\n<p>Sites that support automatic background updates will be updated to WordPress 3.8.2 within 12 hours. If you are still on WordPress 3.7.1, you will be updated to 3.7.2, which contains the same security fixes as 3.8.2. We don&#8217;t support older versions, so please update to 3.8.2 for the latest and greatest.</p>\n<p>Already testing WordPress 3.9? The first release candidate is <a href=\"https://wordpress.org/wordpress-3.9-RC1.zip\">now available</a> (zip) and it contains these security fixes. Look for a full announcement later today; we expect to release 3.9 next week.</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/04/wordpress-3-8-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.9 Beta 3\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-3/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-3/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 29 Mar 2014 13:15:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3106\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:373:\"The third (and maybe last) beta of WordPress 3.9 is now available for download. Beta 3 includes more than 200 changes, including: New features like live widget previews and the new theme installer are now more ready for prime time, so check &#8216;em out. UI refinements when editing images and when working with media in the editor. We&#8217;ve also brought [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:2668:\"<p>The third (and maybe last) beta of WordPress 3.9 is now available for download.</p>\n<p>Beta 3 includes more than 200 <a href=\"https://core.trac.wordpress.org/log?rev=27850&amp;stop_rev=27639&amp;limit=300\">changes</a>, including:</p>\n<ul>\n<li>New features like live widget previews and the new theme installer are now more ready for prime time, so check &#8216;em out.</li>\n<li>UI refinements when editing images and when working with media in the editor. We&#8217;ve also brought back some of the advanced display settings for images.</li>\n<li>If you want to test out audio and video playlists, the links will appear in the media manager once you&#8217;ve uploaded an audio or video file.</li>\n<li>For theme developers, we&#8217;ve added HTML5 caption support (<a class=\"reopened ticket\" title=\"task (blessed): HTML5 captions (reopened)\" href=\"https://core.trac.wordpress.org/ticket/26642\">#26642</a>) to match the new gallery support (<a class=\"closed ticket\" title=\"enhancement: HTML5 Galleries (closed: fixed)\" href=\"https://core.trac.wordpress.org/ticket/26697\">#26697</a>).</li>\n<li>The formatting function that turns straight quotes into smart quotes (among other things) underwent some changes to drastically speed it up, so let us know if you see anything weird.</li>\n</ul>\n<p><strong>We need your help</strong>. We&#8217;re still aiming for an April release, which means the next week will be critical for identifying and squashing bugs. If you&#8217;re just joining us, please see <a href=\"https://wordpress.org/news/2014/03/wordpress-3-9-beta-1/\">the Beta 1 announcement post</a> for what to look out for.</p>\n<p><strong>If you think you’ve found a bug</strong>, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums, where friendly moderators are standing by. <b>Plugin developers</b><strong>,</strong> if you haven&#8217;t tested WordPress 3.9 yet, now is the time — and be sure to update the &#8220;tested up to&#8221; version for your plugins so they&#8217;re listed as compatible with 3.9.</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 3.9, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.9-beta3.zip\">download the beta here</a> (zip).</p>\n<p><em>WordPress 3.9<br />\nLet&#8217;s make the date official<br />\nIt&#8217;s April 16</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-3/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.9 Beta 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-2/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 20 Mar 2014 05:01:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3101\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:309:\"WordPress 3.9 Beta 2 is now available for testing! We&#8217;ve made more than a hundred changes since Beta 1, but we still need your help if we&#8217;re going to hit our goal of an April release. For what to look out for, please head on over to the Beta 1 announcement post. Some of the changes in [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:1901:\"<p>WordPress 3.9 Beta 2 is now available for testing!</p>\n<p>We&#8217;ve made more than a hundred <a href=\"https://core.trac.wordpress.org/log?rev=27639&amp;stop_rev=27500&amp;limit=200\">changes</a> since Beta 1, but we still need your help if we&#8217;re going to hit our goal of an April release. For what to look out for, please head on over to <a href=\"https://wordpress.org/news/2014/03/wordpress-3-9-beta-1/\">the Beta 1 announcement post</a>. Some of the changes in Beta 2 include:</p>\n<ul>\n<li>Rendering of embedded audio and video players directly in the visual editor.</li>\n<li>Visual and functional improvements to the editor, the media manager, and theme installer.</li>\n<li>Various bug fixes to TinyMCE, the software behind the visual editor.</li>\n<li>Lots of fixes to widget management in the theme customizer.</li>\n</ul>\n<p>As always,<strong> if you think you’ve found a bug</strong>, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. Or, if you’re comfortable writing a reproducible bug report, <a href=\"https://make.wordpress.org/core/reports/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/tickets/major\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.9\">everything we’ve fixed</a> so far.</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 3.9, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.9-beta2.zip\">download the beta here</a> (zip).</p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-2/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:45:\"\n		\n		\n		\n		\n		\n				\n		\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:20:\"WordPress 3.9 Beta 1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:64:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 11 Mar 2014 13:42:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:2:{i:0;a:5:{s:4:\"data\";s:11:\"Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}i:1;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3083\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:329:\"I&#8217;m excited to announce that the first beta of WordPress 3.9 is now available for testing. WordPress 3.9 is due out next month &#8212; but in order to hit that goal, we need your help testing all of the goodies we&#8217;ve added: We updated TinyMCE, the software powering the visual editor, to the latest version. [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:6065:\"<p>I&#8217;m excited to announce that the <strong>first beta of WordPress 3.9</strong> is now available for testing.</p>\n<p>WordPress 3.9 is due out next month &#8212; but in order to hit that goal, <strong>we need your help</strong> testing all of the goodies we&#8217;ve added:</p>\n<ul>\n<li>We updated TinyMCE, the software powering the visual editor, to the latest version. Be on the lookout for cleaner markup. Also try the new paste handling &#8212; if you paste in a block of text from Microsoft Word, for example, it will no longer come out terrible. (The &#8220;Paste from Word&#8221; button you probably never noticed has been removed.) It&#8217;s possible some plugins that added stuff to the visual editor (like a new toolbar button) no longer work, so we&#8217;d like to hear about them (<a href=\"https://core.trac.wordpress.org/ticket/24067\">#24067</a>). (And be sure to <a href=\"http://wordpress.org/support/\">open a support thread</a> for the plugin author.)</li>\n<li>We&#8217;ve added <strong>widget management to live previews</strong> (the customizer). Please test editing, adding, and rearranging widgets! (<a href=\"https://core.trac.wordpress.org/ticket/27112\">#27112</a>) We&#8217;ve also added the ability to upload, crop, and manage header images, without needing to leave the preview. (<a href=\"https://core.trac.wordpress.org/ticket/21785\">#21785</a>)</li>\n<li>We brought 3.8&#8242;s beautiful new theme browsing experience to the <strong>theme installer</strong>. Check it out! (<a title=\"View ticket\" href=\"https://core.trac.wordpress.org/ticket/27055\">#27055</a>)</li>\n<li><strong>Galleries</strong> now receive a live preview in the editor. Upload some photos and insert a gallery to see this in action. (<a href=\"https://core.trac.wordpress.org/ticket/26959\">#26959</a>)</li>\n<li>You can now <strong>drag-and-drop</strong> images directly onto the editor to upload them. It can be a bit finicky, so try it and help us work out the kinks. (<a href=\"https://core.trac.wordpress.org/ticket/19845\">#19845</a>)</li>\n<li>Some things got improved around <strong>editing images</strong>. It&#8217;s a lot easier to make changes to an image after you insert it into a post (<a class=\"closed\" title=\"View ticket\" href=\"https://core.trac.wordpress.org/ticket/24409\">#24409</a>) and you no longer get kicked to a new window when you need to crop or rotate an image (<a href=\"https://core.trac.wordpress.org/ticket/21811\">#21811</a>).</li>\n<li>New <strong>audio/video playlists</strong>. Upload a few audio or video files to test these. (<a href=\"https://core.trac.wordpress.org/ticket/26631\">#26631</a>)</li>\n</ul>\n<p><strong>If you think you’ve found a bug</strong>, you can post to the <a href=\"http://wordpress.org/support/forum/alphabeta\">Alpha/Beta area</a> in the support forums. We&#8217;d love to hear from you! If you’re comfortable writing a reproducible bug report, <a href=\"https://make.wordpress.org/core/reports/\">file one on the WordPress Trac</a>. There, you can also find <a href=\"http://core.trac.wordpress.org/tickets/major\">a list of known bugs</a> and <a href=\"http://core.trac.wordpress.org/query?status=closed&amp;group=component&amp;milestone=3.9\">everything we’ve fixed</a> so far.</p>\n<p><strong>This software is still in development,</strong> so we don’t recommend you run it on a production site. Consider setting up a test site just to play with the new version. To test WordPress 3.9, try the <a href=\"http://wordpress.org/extend/plugins/wordpress-beta-tester/\">WordPress Beta Tester</a> plugin (you’ll want “bleeding edge nightlies”). Or you can <a href=\"http://wordpress.org/wordpress-3.9-beta1.zip\">download the beta here</a> (zip).</p>\n<hr />\n<p><strong>DEVELOPERS!</strong> Hello! There&#8217;s lots for you, too.</p>\n<p><strong>Please test your plugins and themes!</strong> There&#8217;s a lot of great stuff under the hood in 3.9 and we hope to blog a bit about them in the coming days. If you haven&#8217;t been reading the awesome <a href=\"http://make.wordpress.org/core/tag/week-in-core/\">weekly summaries</a> on the <a href=\"http://make.wordpress.org/core/\">main core development blog</a>, that&#8217;s a great place to start. (You should definitely follow that blog.) For now, here are some things to watch out for when testing:</p>\n<ul>\n<li>The <strong>load process in multisite</strong> got rewritten. If you notice any issues with your network, see <a href=\"https://core.trac.wordpress.org/ticket/27003\">#27003</a>.</li>\n<li>We now use the <strong>MySQL Improved (mysqli) database extension</strong> if you&#8217;re running a recent version of PHP (<a href=\"https://core.trac.wordpress.org/ticket/21663\">#21663</a>). Please test your plugins and see that everything works well, and please make sure you&#8217;re not calling <code>mysql_*</code> functions directly.</li>\n<li><strong>Autosave</strong> was refactored, so if you see any issues related to autosaving, heartbeat, etc., let us know (<a href=\"https://core.trac.wordpress.org/ticket/25272\">#25272</a>).</li>\n<li>Library updates, in particular Backbone 1.1 and Underscore 1.6 (<a href=\"https://core.trac.wordpress.org/ticket/26799\">#26799</a>). Also Masonry 3 (<a href=\"https://core.trac.wordpress.org/ticket/25351\">#25351</a>), PHPMailer (<a href=\"https://core.trac.wordpress.org/ticket/25560\">#25560</a>), Plupload (<a href=\"https://core.trac.wordpress.org/ticket/25663\">#25663</a>), and TinyMCE (<a href=\"https://core.trac.wordpress.org/ticket/24067\">#24067</a>).</li>\n<li>TinyMCE 4.0 is a <em>major</em> update. Please see TinyMCE&#8217;s <a href=\"http://www.tinymce.com/wiki.php/Tutorial:Migration_guide_from_3.x\">upgrade guide</a> and our <a href=\"https://core.trac.wordpress.org/ticket/24067\">implementation ticket</a> for more. If you have any questions or problems, please <a href=\"http://wordpress.org/support/forum/alphabeta\">open a thread in the support forums</a>.</li>\n</ul>\n<p>Happy testing!</p>\n<p><em><em>Lots of improvements<br />\nLittle things go a long way</em><br />\nPlease test beta one<br />\n</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"http://wordpress.org/news/2014/03/wordpress-3-9-beta-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:42:\"\n		\n		\n		\n		\n		\n				\n\n		\n		\n				\n			\n		\n		\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:5:{s:0:\"\";a:7:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:35:\"WordPress 3.8.1 Maintenance Release\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:50:\"http://wordpress.org/news/2014/01/wordpress-3-8-1/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:59:\"http://wordpress.org/news/2014/01/wordpress-3-8-1/#comments\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 23 Jan 2014 20:37:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"category\";a:1:{i:0;a:5:{s:4:\"data\";s:8:\"Releases\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:33:\"http://wordpress.org/news/?p=3063\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:11:\"isPermaLink\";s:5:\"false\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:358:\"After six weeks and more than 9.3 million downloads of WordPress 3.8, we&#8217;re pleased to announce WordPress 3.8.1 is now available. Version 3.8.1 is a maintenance releases that addresses 31 bugs in 3.8, including various fixes and improvements for the new dashboard design and new themes admin screen. An issue with taxonomy queries in WP_Query [&#8230;]\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"Andrew Nacin\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:40:\"http://purl.org/rss/1.0/modules/content/\";a:1:{s:7:\"encoded\";a:1:{i:0;a:5:{s:4:\"data\";s:3809:\"<p>After six weeks and more than <a href=\"http://wordpress.org/download/counter/\">9.3 million downloads</a> of WordPress 3.8, we&#8217;re pleased to announce WordPress 3.8.1 is now available.</p>\n<p>Version 3.8.1 is a maintenance releases that addresses 31 bugs in 3.8, including various fixes and improvements for the new dashboard design and new themes admin screen. An issue with taxonomy queries in WP_Query was resolved. And if you&#8217;ve been frustrated by submit buttons that won&#8217;t do anything when you click on them (or thought you were going crazy, like some of us), we&#8217;ve found and fixed this &#8220;dead zone&#8221; on submit buttons.</p>\n<p>It also contains a fix for <strong>embedding tweets</strong> (by placing the URL to the tweet on its own line), which was broken due to a recent Twitter API change. (For more on Embeds, see <a href=\"http://codex.wordpress.org/Embeds\">the Codex</a>.)</p>\n<p>For a full list of changes, consult the <a href=\"http://core.trac.wordpress.org/query?milestone=3.8.1\">list of tickets</a> and <a href=\"https://core.trac.wordpress.org/log/branches/3.8?rev=27018&amp;stop_rev=26862\">the changelog</a>. There&#8217;s also a <a href=\"http://make.wordpress.org/core/2014/01/22/wordpress-3-8-1-release-candidate/\">detailed summary</a> for developers on the development blog.</p>\n<p>If you are one of the millions already running WordPress 3.8, we will start rolling out automatic background updates for WordPress 3.8.1 in the next few hours. For sites <a href=\"http://wordpress.org/plugins/background-update-tester/\">that support them</a>, of course.</p>\n<p><a href=\"http://wordpress.org/download/\">Download WordPress 3.8.1</a> or venture over to <strong>Dashboard → Updates</strong> and simply click &#8220;Update Now.&#8221;</p>\n<p>Thanks to all of these fine individuals for contributing to 3.8.1:</p>\n<p><a href=\"http://profiles.wordpress.org/jorbin\">Aaron Jorbin</a>, <a href=\"http://profiles.wordpress.org/collinsinternet\">Allan Collins</a>, <a href=\"http://profiles.wordpress.org/nacin\">Andrew Nacin</a>, <a href=\"http://profiles.wordpress.org/azaozz\">Andrew Ozz</a>, <a href=\"http://profiles.wordpress.org/aubreypwd\">Aubrey Portwood</a>, <a href=\"http://profiles.wordpress.org/empireoflight\">Ben Dunkle</a>, <a href=\"http://profiles.wordpress.org/cojennin\">Connor Jennings</a>, <a href=\"http://profiles.wordpress.org/dd32\">Dion Hulse</a>, <a href=\"http://profiles.wordpress.org/ocean90\">Dominik Schilling</a>, <a href=\"http://profiles.wordpress.org/fboender\">fboender</a>, <a href=\"http://profiles.wordpress.org/avryl\">Janneke Van Dorpe</a>, <a href=\"http://profiles.wordpress.org/janrenn\">janrenn</a>, <a href=\"http://profiles.wordpress.org/joedolson\">Joe Dolson</a>, <a href=\"http://profiles.wordpress.org/johnbillion\">John Blackbourn</a>, <a href=\"#\">José Pino</a>, <a href=\"http://profiles.wordpress.org/kovshenin\">Konstantin Kovshenin</a>, <a href=\"http://profiles.wordpress.org/matveb\">Matias Ventura</a>, <a href=\"http://profiles.wordpress.org/mattheu\">Matthew Haines-Young</a>, <a href=\"http://profiles.wordpress.org/iammattthomas\">Matt Thomas</a>, <a href=\"http://profiles.wordpress.org/melchoyce\">Mel Choyce</a>, <a href=\"http://profiles.wordpress.org/batmoo\">Mohammad Jangda</a>, <a href=\"http://profiles.wordpress.org/morganestes\">Morgan Estes</a>, <a href=\"http://profiles.wordpress.org/nivijah\">nivijah</a>, <a href=\"http://profiles.wordpress.org/wonderboymusic\">Scott Taylor</a>, <a href=\"http://profiles.wordpress.org/sergeybiryukov\">Sergey Biryukov</a>, <a href=\"http://profiles.wordpress.org/undergroundnetwork\">undergroundnetwork</a>, and <a href=\"http://profiles.wordpress.org/yurivictor\">Yuri Victor</a>.</p>\n<p><em>WordPress three eight one<br />\nWe heard you didn&#8217;t like bugs<br />\nSo we took them out</em></p>\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:36:\"http://wellformedweb.org/CommentAPI/\";a:1:{s:10:\"commentRss\";a:1:{i:0;a:5:{s:4:\"data\";s:55:\"http://wordpress.org/news/2014/01/wordpress-3-8-1/feed/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:38:\"http://purl.org/rss/1.0/modules/slash/\";a:1:{s:8:\"comments\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}s:27:\"http://www.w3.org/2005/Atom\";a:1:{s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:0:\"\";s:7:\"attribs\";a:1:{s:0:\"\";a:3:{s:4:\"href\";s:31:\"http://wordpress.org/news/feed/\";s:3:\"rel\";s:4:\"self\";s:4:\"type\";s:19:\"application/rss+xml\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:44:\"http://purl.org/rss/1.0/modules/syndication/\";a:2:{s:12:\"updatePeriod\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"hourly\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:15:\"updateFrequency\";a:1:{i:0;a:5:{s:4:\"data\";s:1:\"1\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:8:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Mon, 09 Jun 2014 00:32:05 GMT\";s:12:\"content-type\";s:23:\"text/xml; charset=UTF-8\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:10:\"x-pingback\";s:36:\"http://wordpress.org/news/xmlrpc.php\";s:13:\"last-modified\";s:29:\"Thu, 08 May 2014 18:40:58 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 249\";}s:5:\"build\";s:14:\"20131111204433\";}', 'no');
INSERT INTO `wp_options` VALUES('7628', '_transient_timeout_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca', '1402317125', 'no');
INSERT INTO `wp_options` VALUES('7629', '_transient_feed_mod_ac0b00fe65abe10e0c5b588f3ed8c7ca', '1402273925', 'no');
INSERT INTO `wp_options` VALUES('7631', '_transient_timeout_feed_867bd5c64f85878d03a060509cd2f92c', '1402317126', 'no');
INSERT INTO `wp_options` VALUES('7632', '_transient_feed_867bd5c64f85878d03a060509cd2f92c', 'a:4:{s:5:\"child\";a:1:{s:0:\"\";a:1:{s:3:\"rss\";a:1:{i:0;a:6:{s:4:\"data\";s:3:\"\n\n\n\";s:7:\"attribs\";a:1:{s:0:\"\";a:1:{s:7:\"version\";s:3:\"2.0\";}}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:1:{s:7:\"channel\";a:1:{i:0;a:6:{s:4:\"data\";s:61:\"\n	\n	\n	\n	\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:1:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:16:\"WordPress Planet\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:8:\"language\";a:1:{i:0;a:5:{s:4:\"data\";s:2:\"en\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress Planet - http://planet.wordpress.org/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"item\";a:50:{i:0;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:68:\"WordPress.tv: Eric Mann: Ten Lessons on Customer-centric Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=35261\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"http://wordpress.tv/2014/06/08/eric-mann-ten-lessons-on-customer-centric-development/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:691:\"<div id=\"v-CRbbhJVm-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/35261/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/35261/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=35261&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/08/eric-mann-ten-lessons-on-customer-centric-development/\"><img alt=\"Eric Mann: Ten Lessons on Customer-centric Development\" src=\"http://videos.videopress.com/CRbbhJVm/video-14af328cda_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 08 Jun 2014 18:56:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:1;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"WordPress.tv: Clinton Warren: An Accidental Career In WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=35319\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"http://wordpress.tv/2014/06/08/clinton-warren-an-accidental-career-in-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:681:\"<div id=\"v-bNd7Oif6-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/35319/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/35319/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=35319&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/08/clinton-warren-an-accidental-career-in-wordpress/\"><img alt=\"Clinton Warren: An Accidental Career In WordPress\" src=\"http://videos.videopress.com/bNd7Oif6/video-baca84f43e_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 08 Jun 2014 18:49:26 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:2;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"WordPress.tv: Helen Hou-Sandi: How I Convinced My Boss to Let Me Work on WordPress Full-time\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=35404\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:109:\"http://wordpress.tv/2014/06/08/helen-hou-sandi-how-i-convinced-my-boss-to-let-me-work-on-wordpress-full-time/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:739:\"<div id=\"v-fWQ4N99p-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/35404/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/35404/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=35404&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/08/helen-hou-sandi-how-i-convinced-my-boss-to-let-me-work-on-wordpress-full-time/\"><img alt=\"Helen Hou-Sandi: How I Convinced My Boss to Let Me Work on WordPress Full-time\" src=\"http://videos.videopress.com/fWQ4N99p/video-5802861622_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 08 Jun 2014 18:04:48 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:3;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:57:\"WordPress.tv: Chris Lema: Getting The Most From Your Blog\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=35585\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:74:\"http://wordpress.tv/2014/06/07/chris-lema-getting-the-most-from-your-blog/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:663:\"<div id=\"v-E24Ef0Qi-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/35585/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/35585/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=35585&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/07/chris-lema-getting-the-most-from-your-blog/\"><img alt=\"Chris Lema: Getting The Most From Your Blog\" src=\"http://videos.videopress.com/E24Ef0Qi/video-f6e527e6e8_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 07 Jun 2014 23:25:09 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:4;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"Alex King: Here’s Crowd Favorite’s own Brandon Dove at the …\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://alexking.org/?p=20175\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:41:\"http://alexking.org/blog/2014/06/07/20175\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:257:\"<div>\n<p>Here&#8217;s <a href=\"http://crowdfavorite.com\">Crowd Favorite</a>&#8216;s own <a href=\"http://brandondove.com/\">Brandon Dove</a> at the <a href=\"http://2014.oc.wordcamp.org/\">WordCamp Orange County</a> golf tournament yesterday.</p>\n<p></p>\n</div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 07 Jun 2014 17:45:55 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:4:\"Alex\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:5;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"WordPress.tv: James Laws: Ninja Forms: A Case Study Of The Freemium Plugin Model\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=35104\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:96:\"http://wordpress.tv/2014/06/07/james-laws-ninja-forms-a-case-study-of-the-freemium-plugin-model/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:714:\"<div id=\"v-G6Qclaje-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/35104/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/35104/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=35104&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/07/james-laws-ninja-forms-a-case-study-of-the-freemium-plugin-model/\"><img alt=\"James Laws: Ninja Forms: A Case Study Of The Freemium Plugin Model\" src=\"http://videos.videopress.com/G6Qclaje/video-3088daedcd_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 07 Jun 2014 09:00:37 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Michael\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:6;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:56:\"WordPress.tv: Andrew Nacin: WordCamp Connecticut Keynote\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=35467\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:73:\"http://wordpress.tv/2014/06/07/andrew-nacin-wordcamp-connecticut-keynote/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:661:\"<div id=\"v-yt8XUtjj-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/35467/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/35467/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=35467&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/07/andrew-nacin-wordcamp-connecticut-keynote/\"><img alt=\"STANFORD WP KEYNOTE Andrew Nacin.mp4\" src=\"http://videos.videopress.com/yt8XUtjj/video-a857e0bf7e_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 07 Jun 2014 08:00:50 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:7;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WordPress.tv: José Esteban Mucientes Manso: Un tema para cada necesidad\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=32504\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:88:\"http://wordpress.tv/2014/06/07/jose-esteban-mucientes-manso-un-tema-para-cada-necesidad/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:698:\"<div id=\"v-UCTGa87i-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/32504/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/32504/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=32504&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/07/jose-esteban-mucientes-manso-un-tema-para-cada-necesidad/\"><img alt=\"José Esteban Mucientes Manso: Un tema para cada necesidad\" src=\"http://videos.videopress.com/UCTGa87i/video-3cbd171905_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 07 Jun 2014 07:15:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:8;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"WPTavern: bbPress 2.5.4 Security Release Available: Immediate Update Recommended\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=24326\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:202:\"http://wptavern.com/bbpress-2-5-4-security-release-available-immediate-update-recommended?utm_source=rss&utm_medium=rss&utm_campaign=bbpress-2-5-4-security-release-available-immediate-update-recommended\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:1965:\"<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/bbpress.png\" rel=\"prettyphoto[24326]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/bbpress.png?resize=1025%2C378\" alt=\"bbpress\" class=\"aligncenter size-full wp-image-24338\" /></a></p>\n<p>If you have a WordPress site with a bbPress-powered forum, you may want to set aside a few minutes this weekend to perform updates. bbPress 2.5.4 was <a href=\"http://bbpress.org/blog/2014/06/bbpress-2-5-4-security-bugfix-release/\" target=\"_blank\">released</a> today with five bug fixes, including an important fix for a security vulnerability.</p>\n<p>bbPress project lead John James Jacoby announced the release, crediting IT Security Reaseacher<a href=\"https://hackerone.com/mazengamal\" target=\"_blank\"> Mazen Gamal Mesbah</a> for identifying and responsibly disclosing the displayed user field security issue. Mesbah has been instrumental in helping to identify multiple security bugs for Yahoo, Automattic, Mailchimp, Sony, Eventbrite, and was most recently honored in Microsoft&#8217;s security <a href=\"http://technet.microsoft.com/en-us/security/cc308589.aspx\" target=\"_blank\">hall of fame</a>.</p>\n<p>The security <a href=\"https://bbpress.trac.wordpress.org/ticket/2610\" target=\"_blank\">fix</a> in bbPress 2.5.4 adds proper escaping for displayed user fields and data when editing a user. Should you spend time updating over the weekend? Yes, if at all possible. The bbPress team recommends that you update your sites as soon as you can.  While the update wasn&#8217;t announced as critical, bbPress contributors found the important enough to fix within 24 hours of being notified, a feat which Jacoby notes is quite impressive for an all-volunteer team.</p>\n<p>The bbPress 2.6 release date has been pushed back to the end of June to allow contributors some more time to enjoy the summer. In the meantime, take a few minutes this weekend to update your bbPress sites to 2.5.4.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 07 Jun 2014 04:22:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:9;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"WPTavern: New Plugin Adds Syntax Highlighting to the WordPress Plugin and Theme Editors\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=24286\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:218:\"http://wptavern.com/new-plugin-adds-syntax-highlighting-to-the-wordpress-plugin-and-theme-editors?utm_source=rss&utm_medium=rss&utm_campaign=new-plugin-adds-syntax-highlighting-to-the-wordpress-plugin-and-theme-editors\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3862:\"<p>The WordPress plugin and theme editors have a basic, bare bones implementation of a text editor. They function well but are rather plain and limited in features. This may be due in part to the fact that many WordPress contributors cannot agree on whether or not the admin plugin and theme editors should be included in core.</p>\n<p>This hotly debated topic was reignited on the Tavern last year when we featured the controversial <a href=\"http://wptavern.com/should-code-revisions-be-added-to-the-wordpress-core\" target=\"_blank\">Code Revisions project</a>, which added native revisions to the admin theme and plugin editors. The project was part of Google Summer of Code in 2013 and there was some discussion about the possibility of adding it to core.</p>\n<p>Whether or not you agree on having the admin editors in core, there are many plugin developers who are happy to extend the feature for those who use it. <a href=\"http://wordpress.org/plugins/syntax-highlight/\" target=\"_blank\">Syntax Highlight</a> is a new plugin that adds syntax highlighting and a few other handy bits to the editors by incorporating the open source <a href=\"http://ace.c9.io/\" target=\"_blank\">Ace Editor</a>.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/syntax-highlighter.jpg\" rel=\"prettyphoto[24286]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/syntax-highlighter.jpg?resize=1025%2C548\" alt=\"syntax-highlighter\" class=\"aligncenter size-full wp-image-24288\" /></a></p>\n<p>The plugin adds AJAX saving through CTRL+S and has support for keyboard shortcuts (keybindings: Vim, Emacs and <a href=\"https://github.com/ajaxorg/ace/wiki/Default-Keyboard-Shortcuts\" target=\"_blank\">Default</a>). If you make edits and attempt to leave the page, the plugin will ask you whether or not you want to leave when there are unsaved changes.</p>\n<p>Syntax Highlight enables editors to launch in fullscreen mode (CTRL+Enter) for an experience similar to the distraction free writing mode:</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/fullscreen.jpg\" rel=\"prettyphoto[24286]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/fullscreen.jpg?resize=1025%2C548\" alt=\"fullscreen\" class=\"aligncenter size-full wp-image-24300\" /></a></p>\n<p>It also includes a lighter theme which can be turned on via the plugin&#8217;s settings page:</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/06/lighter-theme.jpg\" rel=\"prettyphoto[24286]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/06/lighter-theme.jpg?resize=1025%2C546\" alt=\"lighter-theme\" class=\"aligncenter size-full wp-image-24299\" /></a></p>\n<p>The settings panel gives you the option to set the default tab size, use soft tabs, turn on word wrap, use line numbers, set key bindings and enable full line selection.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/06/settings.jpg\" rel=\"prettyphoto[24286]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/06/settings.jpg?resize=1025%2C546\" alt=\"settings\" class=\"aligncenter size-full wp-image-24303\" /></a></p>\n<p>The plugin enables search and replace with regular expressions (CTRL+F, CTRL+H). It also supports all the other features included in the <a href=\"http://ace.c9.io/\" target=\"_blank\">Ace Editor</a>, including drag and drop text using the mouse, automatic indenting, live syntax checking (currently JavaScript/CoffeeScript/CSS/XQuery), and more.</p>\n<p>If you frequently use the admin plugin and theme editors and want to beef them up with syntax highlighting, this plugin is a decent option. At the very least, it makes the code more readable if you only use the editors for reference. You can download <a href=\"http://wordpress.org/plugins/syntax-highlight/\" target=\"_blank\">Syntax Highlight</a> from WordPress.org.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Jun 2014 23:20:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:10;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"WPTavern: WordPress for Android 2.9 Debuts Blog Discovery Feature\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=24259\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:174:\"http://wptavern.com/wordpress-for-android-2-9-debuts-blog-discovery-feature?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-for-android-2-9-debuts-blog-discovery-feature\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2990:\"<p>Version 2.9 of the WordPress for Android app was <a href=\"http://android.wordpress.org/2014/06/06/version-2-9-of-wordpress-for-android/\" target=\"_blank\">released</a> today, debuting its Blog Discovery feature as a new part of the Reader. Blog Discovery can be found by clicking the tag icon in the top right corner of the Reader. This feature helps users find new blogs to read, based on recommendations, and allows you to preview a blog&#8217;s posts before electing to follow it.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/blog-discovery-feature.gif\" rel=\"prettyphoto[24259]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/blog-discovery-feature.gif?resize=540%2C847\" alt=\"blog-discovery-feature\" class=\"aligncenter size-full wp-image-24264\" /></a></p>\n<p>The Reader has been updated to allow users to easily manage tags and blog subscriptions within the mobile app. You&#8217;ll notice that the reblogging interface is also sporting a new design.</p>\n<h3>Improved Publish Icon Button</h3>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/draft-save.png\" rel=\"prettyphoto[24259]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/draft-save.png?resize=300%2C500\" alt=\"draft-save\" class=\"alignright size-large wp-image-24273\" /></a>The 2.9 release solves a long-standing issue with the ambiguous UI of the save/publish button. In the past, it was unclear whether or not you were saving a draft or publishing a post, which discouraged some users from using the app to save drafts on the go.</p>\n<p>Version 2.9 clarifies the UI by replacing the publish icon button with a contextual text button. The new button displays the action it initiates, based on the current task, ie. saving a draft, publishing, scheduling, or updating a post. This is now more in line with how a user might expect WordPress to work based on the desktop experience.</p>\n<h3>UI Enhancements: Notifications Powered by Simperium, App Now Supports Pull-to-Refresh Gesture</h3>\n<p>Notifications now use <a href=\"https://simperium.com/\" target=\"_blank\">Simperium</a> technology for faster syncing. Stats also refresh faster and version 2.9 reintroduces the refresh button for all refreshable views. It makes use of Android&#8217;s native pull-to-refresh gesture. Posts will be auto-saved when you close the &#8220;edit post&#8221; view, so the save dialog has been removed entirely for simplification.</p>\n<p>Version 2.9 adds Hebrew and Basque to its available translations. It also introduces <a href=\"http://en.wikipedia.org/wiki/Server_Name_Indication\" target=\"_blank\">SNI (Server Name Indication) </a>support.</p>\n<p>Support for Gingerbread (Android 2.3) was dropped, as <a href=\"http://wptavern.com/wordpress-for-android-will-no-longer-support-gingerbread\" target=\"_blank\">announced</a> last month. If you&#8217;re upgrading to WordPress for Android 2.9, you&#8217;ll need to be running Android 4.0 or later on your device.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Jun 2014 19:34:02 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:11;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"WordPress.tv: Francisco Javier Carazo Gil: WordPress como plataforma de desarrollo\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=25609\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:99:\"http://wordpress.tv/2014/06/06/francisco-javier-carazo-gil-wordpress-como-plataforma-de-desarrollo/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:719:\"<div id=\"v-u20E7Fpe-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/25609/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/25609/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=25609&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/06/francisco-javier-carazo-gil-wordpress-como-plataforma-de-desarrollo/\"><img alt=\"Francisco Javier Carazo Gil: WordPress como plataforma de desarrollo\" src=\"http://videos.videopress.com/u20E7Fpe/video-d6104776da_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Jun 2014 09:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:12;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"WP Android: Version 2.9 of WordPress for Android\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:36:\"http://android.wordpress.org/?p=1065\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://android.wordpress.org/2014/06/06/version-2-9-of-wordpress-for-android/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4519:\"<p>The WordPress for Android 2.9 release is now available in the Google Play Store. This release includes some exciting new features, enhancements, and bug fixes.</p>\n<h2>Blog Discovery</h2>\n<p>Blog discovery is a new feature in the Reader that lets you:</p>\n<ul>\n<li>Find new blogs (based on recommendations).</li>\n<li>Preview a blog and read posts before following it.</li>\n<li>Manage your tags and blog subscriptions.</li>\n</ul>\n<p><a href=\"http://wpandroid.files.wordpress.com/2014/06/blog-discovery-feature.gif\"><img class=\"aligncenter size-full wp-image-1059\" src=\"http://wpandroid.files.wordpress.com/2014/06/blog-discovery-feature.gif?w=840\" alt=\"blog-discovery-feature\" /></a></p>\n<h2>Publish Icon Button</h2>\n<p>We replaced the publish icon button with a contextual text button. Whether you&#8217;re saving a draft, publishing or scheduling a post, or updating one, this new button will display your action, depending on your current task.</p>\n\n<a href=\"http://android.wordpress.org/?attachment_id=1063\"><img width=\"90\" height=\"150\" src=\"http://wpandroid.files.wordpress.com/2014/06/screencap-2014-06-04t17-47-230800.png?w=90&h=150\" class=\"attachment-thumbnail\" alt=\"\" /></a>\n<a href=\"http://android.wordpress.org/?attachment_id=1060\"><img width=\"90\" height=\"150\" src=\"http://wpandroid.files.wordpress.com/2014/06/screencap-2014-06-04t17-46-510800.png?w=90&h=150\" class=\"attachment-thumbnail\" alt=\"\" /></a>\n<a href=\"http://android.wordpress.org/?attachment_id=1061\"><img width=\"90\" height=\"150\" src=\"http://wpandroid.files.wordpress.com/2014/06/screencap-2014-06-04t17-46-570800.png?w=90&h=150\" class=\"attachment-thumbnail\" alt=\"\" /></a>\n<a href=\"http://android.wordpress.org/?attachment_id=1062\"><img width=\"90\" height=\"150\" src=\"http://wpandroid.files.wordpress.com/2014/06/screencap-2014-06-04t17-47-060800.png?w=90&h=150\" class=\"attachment-thumbnail\" alt=\"\" /></a>\n<a href=\"http://android.wordpress.org/?attachment_id=1064\"><img width=\"90\" height=\"150\" src=\"http://wpandroid.files.wordpress.com/2014/06/screencap-2014-06-04t18-42-390800.png?w=90&h=150\" class=\"attachment-thumbnail\" alt=\"\" /></a>\n\n<h2>Faster Notifications and Stats Refresh</h2>\n<p>We updated the Notifications feature to use <a href=\"https://simperium.com/\">Simperium</a> technology, which will sync your notifications quickly and efficiently.</p>\n<p>We also know you love viewing your Stats, so we improved them to refresh faster than ever before.</p>\n<h2>Interface Improvements</h2>\n<ul>\n<li>Reintroduction of the refresh button in all refreshable views, along with the pull-to-refresh gesture.</li>\n<li>Pull-to-refresh tip bar has been replaced by a less aggressive, self-hiding message.</li>\n<li>Save dialog has been removed, and all posts are now auto-saved when you close the edit post view.</li>\n<li>Reblogging interface redesign in the Reader.</li>\n<li>Sharing image, video, text, or link via WordPress for Android now remembers the previous choice.</li>\n</ul>\n<h2>General Changes</h2>\n<ul>\n<li>Posts and pages auto-save feature has been improved.</li>\n<li>Fixed bugs related to statistics (only affecting Jetpack users) and image handling.</li>\n<li>Reader improvements to fill gaps in time between two syncs.</li>\n<li>As <a href=\"http://android.wordpress.org/2014/05/16/wordpress-for-android-no-longer-paying-the-gingerbread-tax/\">we announced earlier</a>, we dropped Android 2.3 support. Current (2.9) and later versions need Android 4.0 or later.</li>\n<li>New translations: Hebrew and Basque.</li>\n<li>SNI (Server Name Indication) support.</li>\n<li>Minor bug fixes.</li>\n</ul>\n<h2>What’s Next?</h2>\n<p>A big thanks to all of the contributors who worked on this release: <a href=\"https://github.com/beaucollins\">@beaucollins</a>, <a href=\"https://github.com/daniloercoli\">@daniloercoli</a>, <a href=\"https://github.com/maxme\">@maxme</a>, <a href=\"https://github.com/nbradbury\">@nbradbury</a>, <a href=\"https://github.com/roundhill\">@roundhill</a>, and <a href=\"https://github.com/sendhil\">@sendhil</a>! You can keep up with the development progress at <a href=\"http://make.wordpress.org/mobile\">http://make.wordpress.org/mobile</a> and can also follow the app on Twitter <a href=\"http://twitter.com/wpandroid\">@WPAndroid</a>. If you need support or want to send us suggestions, please visit <a href=\"http://android.forums.wordpress.org/\">our forums</a>.</p><img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=android.wordpress.org&blog=9426921&post=1065&subd=wpandroid&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Jun 2014 08:34:22 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:6:\"Maxime\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:13;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:124:\"WordPress.tv: Fran Moreno: Themes premium desde la perspectiva del creador de contenidos, del diseñador y del desarrollador\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=25604\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:139:\"http://wordpress.tv/2014/06/06/fran-moreno-themes-premium-desde-la-perspectiva-del-creador-de-contenidos-del-disenador-y-del-desarrollador/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:701:\"<div id=\"v-iRjlQwSY-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/25604/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/25604/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=25604&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/06/fran-moreno-themes-premium-desde-la-perspectiva-del-creador-de-contenidos-del-disenador-y-del-desarrollador/\"><img alt=\"themes.mp4\" src=\"http://videos.videopress.com/iRjlQwSY/video-3bd011e887_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Jun 2014 08:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:14;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:79:\"WordPress.tv: Rafael Poveda: Trabajando en Comunidad – WordPress desde dentro\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=25241\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"http://wordpress.tv/2014/06/06/rafael-poveda-trabajando-en-comunidad-wordpress-desde-dentro/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:713:\"<div id=\"v-U8CvZNdU-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/25241/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/25241/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=25241&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/06/rafael-poveda-trabajando-en-comunidad-wordpress-desde-dentro/\"><img alt=\"Rafael Poveda: Trabajando en Comunidad &#8211; WordPress desde dentro\" src=\"http://videos.videopress.com/U8CvZNdU/video-735f74913e_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Jun 2014 07:15:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:15;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:95:\"WPTavern: Preview the “Press This” Bookmarklet Redesign, Alpha Plugin Now Ready for Testing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=24209\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:220:\"http://wptavern.com/preview-the-press-this-bookmarklet-redesign-alpha-plugin-now-ready-for-testing?utm_source=rss&utm_medium=rss&utm_campaign=preview-the-press-this-bookmarklet-redesign-alpha-plugin-now-ready-for-testing\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3821:\"<p>The &#8220;<a href=\"http://codex.wordpress.org/Press_This\" target=\"_blank\">Press This</a>&#8221; browser bookmarklet in WordPress is on its way to a <a href=\"http://make.wordpress.org/ui/2014/06/04/press-this/\" target=\"_blank\">complete redesign</a> via the <a href=\"http://make.wordpress.org/core/features-as-plugins/\" target=\"_blank\">features-as-plugins</a> development path. If you&#8217;ve never used it before, the feature allows you to make quick posts to your WordPress site from anywhere on the web. It&#8217;s actually a pretty smart tool for posting and can automatically detect media and grab the proper embed codes.</p>\n<p>The redesign project, led by <a href=\"http://profiles.wordpress.org/michael-arestad\" target=\"_blank\">Michael Arestad</a>, is currently in the design stage, but an ultra alpha public release of the <a href=\"http://wordpress.org/plugins/press-this/\" target=\"_blank\">Press This</a> plugin is now available for testing. Here&#8217;s a sneak peak of the redesign progress thus far:</p>\n<div id=\"attachment_24222\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/press-this.png\" rel=\"prettyphoto[24209]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/press-this.png?resize=1025%2C653\" alt=\"Press This redesign progress\" class=\"size-full wp-image-24222\" /></a><p class=\"wp-caption-text\">Press This redesign progress</p></div>\n<p>Parts of the design are still in flux (placement and behavior of WYSIWYG, modal pop-out, embeds, etc), as the bookmarklet is being completely rebuilt with a focus on automation and speed. Arestad posted a 30-second video demo that walks you through posting with the redesigned bookmarklet:<br />\n<div class=\"wp-video\"><!--[if lt IE 9]><script>document.createElement(\'video\');</script><![endif]-->\n<a href=\"http://wptavern.com/wp-content/uploads/2014/06/press-this-progress.mp4\">http://wptavern.com/wp-content/uploads/2014/06/press-this-progress.mp4</a></div><div class=\"media-shortcode-extend\"><div class=\"media-info video-info\"><ul class=\"media-meta\"><li><span class=\"prep\">Run Time</span> <span class=\"data\">0:29</span></li><li><span class=\"prep\">Dimensions</span> <span class=\"data\">1,280 &#215; 800</span></li><li><span class=\"prep\">File Name</span> <span class=\"data\"><a href=\"http://wptavern.com/wp-content/uploads/2014/06/press-this-progress.mp4\">press-this-progress.mp4</a></span></li><li><span class=\"prep\">File Size</span> <span class=\"data\">4.63 MB</span></li><li><span class=\"prep\">File Type</span> <span class=\"data\">MP4</span></li><li><span class=\"prep\">Mime Type</span> <span class=\"data\">video/quicktime</span></li></ul></div><a class=\"media-info-toggle\">Video Info</a></div></p>\n<p>This iteration of Press This is currently powered by AJAX, but Arestad reports that it&#8217;s ready to be switched to use the <a href=\"http://wptavern.com/json-rest-api-slated-for-wordpress-4-1-release\" target=\"_blank\">WP-API</a> endpoints as they become available. It&#8217;s also backward compatible with the old bookmarklet but is built to override /wp-admin/press-this.php and the bookmarklet JS code in /wp-admin/tools.php with the new behavior.</p>\n<p>The complete overhaul of the bookmarklet, with its speedy 2-step publishing capabilities, is bound to win the feature some new users. The contributors working on it are aiming for &#8220;lightning fast posting&#8221; and the progress so far looks promising.</p>\n<p>When testing the <a href=\"http://wordpress.org/plugins/press-this/\" target=\"_blank\">alpha plugin</a>, be advised that it&#8217;s currently undergoing heavy development and will undoubtedly have some bugs. If you want to join in the discussion, feel free to jump in on the <a href=\"http://corepressthis.wordpress.com\" target=\"_blank\">Press This Working Group blog</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Fri, 06 Jun 2014 02:35:25 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:16;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"WPTavern: Semicolon is Possibly the Cleanest Free Magazine Theme for WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=23953\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:200:\"http://wptavern.com/semicolon-is-possibly-the-cleanest-free-magazine-theme-for-wordpress?utm_source=rss&utm_medium=rss&utm_campaign=semicolon-is-possibly-the-cleanest-free-magazine-theme-for-wordpress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3105:\"<p>WordPress magazine themes are notorious for being packed to the gills with content, widgets, post meta, and advertising. Many have a chaotic feel as a byproduct of trying to pack as much content as possible into the homepage.</p>\n<p><a href=\"http://wordpress.org/themes/semicolon\" target=\"_blank\">Semicolon</a> is a shining exception among free WordPress magazine themes in that it features a super minimalist design with an emphasis on large, readable typography.</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/06/semicolon.png\" rel=\"prettyphoto[23953]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/06/semicolon.png?resize=880%2C660\" alt=\"semicolon\" class=\"aligncenter size-full wp-image-24147\" /></a></p>\n<p>Semicolon was created by <a href=\"http://kovshenin.com/\" target=\"_blank\">Konstantin Kovshenin</a>, a WordPress plugin and theme developer who is currently a code wrangler at Automattic.  It is based on the <a href=\"http://underscores.me/\" target=\"_blank\">Underscores</a> starter theme. The unique grid layout is 100% responsive and works beautifully on mobile devices.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/semicolon-mobile.png\" rel=\"prettyphoto[23953]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/semicolon-mobile.png?resize=281%2C500\" alt=\"semicolon-mobile\" class=\"alignright size-large wp-image-24193\" /></a>You can further personalize the theme by adding your own background image or setting the background color with the WordPress customizer. It also supports two menus: a primary navigation menu and a social menu than utilizes the <a href=\"http://genericons.com/\" target=\"_blank\">Genericons</a> vector icon webfont.</p>\n<p>Check out a live demo of Semicolon in action at <a href=\"http://semicolon.kovshenin.com/\" target=\"_blank\">semicolon.kovshenin.com</a>.</p>\n<p>Semicolon manages featured posts using Jetpack&#8217;s Featured Content module, so you&#8217;ll need to have that plugin installed in order to take advantage of this feature. You can then assign a unique tag for your featured posts via the customizer.</p>\n<p>Single posts are followed by an author bio section that can be updated via Users → Your Profile in the admin. A list of related posts is also shown below the content. It&#8217;s generated by a simple algorithm that fetches recent posts in the same category.</p>\n<p>The theme includes four widget areas. Unlike many other WordPress magazine themes, the widget areas are not used to determine the layout for the main content area. The primary, secondary and tertiary widgets are all located in the sidebar. The primary one is highlighted with a blue background and works best for a notice or information you want to feature. The fourth widget area is for the footer, where any widgets added will be stacked horizontally up to a maximum of three.</p>\n<p>Want to test Semicolon on your site? <a href=\"http://wordpress.org/themes/semicolon\" target=\"_blank\">Download</a> it for free from WordPress.org or install it directly via the themes browser in the admin.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 05 Jun 2014 20:29:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:17;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"WordPress.tv: Brad Parbs: Writing Extensible Plugins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=35263\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"http://wordpress.tv/2014/06/05/brad-parbs-writing-extensible-plugins/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:659:\"<div id=\"v-hrL5ccBA-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/35263/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/35263/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=35263&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/05/brad-parbs-writing-extensible-plugins/\"><img alt=\"Brad Parbs: Writing Extensible Plugins\" src=\"http://videos.videopress.com/hrL5ccBA/video-e797f9a98d_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 05 Jun 2014 18:26:33 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:18;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:102:\"WPTavern: WordPress.com to Implement SSL for All Subdomains, Joins the Fight Against Mass Surveillance\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=24161\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:246:\"http://wptavern.com/wordpress-com-to-implement-ssl-for-all-subdomains-joins-the-fight-against-mass-surveillance?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-com-to-implement-ssl-for-all-subdomains-joins-the-fight-against-mass-surveillance\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2381:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/reset-the-net.png\" rel=\"prettyphoto[24161]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/reset-the-net.png?resize=1025%2C453\" alt=\"reset-the-net\" class=\"aligncenter size-full wp-image-24163\" /></a></p>\n<p>Today Automattic joins Google, Mozilla, Twitter, Reddit, and other companies across the web in announcing its support for <a href=\"https://www.resetthenet.org/\" target=\"_blank\">Reset the Net</a> campaign against mass surveillance, which takes place on the internet today.</p>\n<p>Because the NSA continues to exploit weak links in internet security in order to spy on the world, the only way for companies to fight back is to build better security into their products. The campaign encourages citizens to commit to using apps that protect their devices from prying government eyes.</p>\n<p>In an effort that goes far beyond simply displaying a banner, Automattic <a href=\"http://en.blog.wordpress.com/2014/06/05/reset-the-net/\" target=\"_blank\">announced</a> that it will be implementing SSL for all *.wordpress.com subdomains by the end of the year. Paul Sieminski, General Counsel for Automattic, reaffirmed the company&#8217;s commitment to secure the connection between users and WordPress.com websites:</p>\n<blockquote><p>If we’ve learned anything over the past year, it’s that encryption, when done correctly, works. If we properly encrypt our sites and devices, we can make mass surveillance much more difficult.</p></blockquote>\n<p>As of May this year, 409 million people view more than 14.5 billion pages each month on the WordPress.com network, which includes Jetpack-enabled self-hosted sites. By the end of the year, SSL will be in place for anyone viewing a site hosted on WordPress.com. It&#8217;s important to note that SSL is already forced for WordPress.com admin areas.</p>\n<p>If you want to join in this historic push to secure the web, visit<a href=\"https://www.resetthenet.org/\" target=\"_blank\"> Reset the Net</a> to learn about specific ways that you can protect yourself and others to make mass government surveillance more difficult. Self-hosted WordPress sites can join in the campaign with the <a href=\"http://wordpress.org/plugins/reset-the-net-splash-screen/\" target=\"_blank\">Reset the Net splash screen</a> plugin, available for free on WordPress.org.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 05 Jun 2014 17:26:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:19;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"WordPress.tv: Scott Offord: Creating and Promoting Compelling Content Through Blogging\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=34789\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"http://wordpress.tv/2014/06/05/scott-offord-creating-and-promoting-compelling-content-through-blogging/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:727:\"<div id=\"v-mWiu88t0-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/34789/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/34789/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=34789&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/05/scott-offord-creating-and-promoting-compelling-content-through-blogging/\"><img alt=\"Scott Offord: Creating And Promoting Compelling Content Through Blogging\" src=\"http://videos.videopress.com/mWiu88t0/video-066f69c912_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 05 Jun 2014 08:00:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:20;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WordPress.tv: Adrian Zumbrunnen: On distraction-free reading experiences\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=35490\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:89:\"http://wordpress.tv/2014/06/05/adrian-zumbrunnen-on-distraction-free-reading-experiences/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:701:\"<div id=\"v-kthC8PH3-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/35490/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/35490/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=35490&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/05/adrian-zumbrunnen-on-distraction-free-reading-experiences/\"><img alt=\"Adrian Zumbrunnen: On distraction free reading experiences\" src=\"http://videos.videopress.com/kthC8PH3/adrian-zumbrunnen-wcch14_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 05 Jun 2014 07:00:07 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:21;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:27:\"Matt: iOS 8 Embedded WebKit\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=43835\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:43:\"http://ma.tt/2014/06/ios-8-embedded-webkit/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:606:\"<p><a href=\"http://9to5mac.com/2014/06/03/ios-8-webkit-changes-finally-allow-all-apps-to-have-the-same-performance-as-safari/\">iOS 8 WebKit changes finally allow all apps to have the same performance as Safari</a>. I was just asked about the future of the mobile web at last night&#8217;s WP talk in Singapore. (Which had about 300 people there, great turnout!) There are still a lot of issues for the open web in a closed mobile world, but things like this are a great step in the right direction. Another reason I can&#8217;t wait for iOS 8. Hat tip: <a href=\"http://bummyti.me/\">Matt Bumgardner</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Thu, 05 Jun 2014 06:01:49 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:22;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:54:\"WPTavern: WordPress in Vietnamese: Now 100% Translated\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=24119\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"http://wptavern.com/wordpress-in-vietnamese-now-100-translated?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-in-vietnamese-now-100-translated\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3909:\"<div id=\"attachment_24140\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/06/vietnamese-flag.jpg\" rel=\"prettyphoto[24119]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/06/vietnamese-flag.jpg?resize=1024%2C492\" alt=\"photo credit: patrikmloeff - cc\" class=\"size-full wp-image-24140\" /></a><p class=\"wp-caption-text\">photo credit: <a href=\"http://www.flickr.com/photos/bupia/807902145/\">patrikmloeff</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc-nd/2.0/\">cc</a></p></div>\n<p>This month marks a big milestone for WordPress in Vietnamese. It is now 100% translated, thanks in large part to the folks at <a href=\"http://foobla.com/\" target=\"_blank\">foobla</a> who volunteered a great deal of time and effort on the final push to finish translating the software into Vietnamese.</p>\n<p>New WordPress translations don&#8217;t magically happen &#8211; they actually take quite a bit of manual work. It requires having a nuanced understanding of both languages in addition to a decent level of WordPress expertise for context. You forget how many words are in WordPress until you see pages and pages of strings in need of translation:</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/translate-strings.jpg\" rel=\"prettyphoto[24119]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/translate-strings.jpg?resize=984%2C525\" alt=\"translate-strings\" class=\"aligncenter size-full wp-image-24128\" /></a></p>\n<p>Back in December 2013, the <a href=\"http://wpvi.wordpress.com/2013/12/13/current-state-of-vietnamese-translations-for-wordpress-org/\" target=\"_blank\">progress of the Vietnamese translation</a> was slow and it was nowhere near finished. Coverage was sparse with /trunk/ strings at 69% complete, WordPress admin strings at 46% and network admin for multisite at just 6%. The three most recent default themes were all 0% translated.</p>\n<p>Today&#8217;s <a href=\"http://wpvi.wordpress.com/2014/06/04/wordpress-now-100-translated-into-vietnamese/\" target=\"_blank\">announcement</a> of the fully complete translation is a huge victory for anyone wanting to use WordPress in Vietnamese. <a href=\"https://twitter.com/philip_arthur\" target=\"_blank\">Philip Arthur Moore</a>, who has been heavily involved in this effort, said that contributors will now change their focus to the Vietnamese WordPress.org site:</p>\n<blockquote><p>Our next steps are to update <a href=\"http://vi.wordpress.org/\" target=\"_blank\">vi.wordpress.org</a> with the updated language packages, and make sure that when WordPress users in Vietnam to go vi.wordpress.org, they know how to begin using WordPress.</p></blockquote>\n<p>Translations are an often overlooked area of WordPress contribution, but are a necessary part of expanding the software&#8217;s use to non-English speaking parts of the world. Internationalization stats on <a href=\"http://wpcentral.io/internationalization/\" target=\"_blank\">WP Central</a> show that only 41 locals are up to date on WordPress package translations and 22 locales are behind by two or more major versions. 60 locales do not yet have a package available.</p>\n<p>More completed translations and better support for installing WordPress in any language may be the catalyst to pushing global WordPress usage stats over the 25% mark. Andrew Nacin recently set out an ambitious <a href=\"http://wptavern.com/major-internationalization-improvements-planned-for-wordpress-4-0\" target=\"_blank\">plan to improve internationalization</a> across the board for WordPress core and is aiming at getting these updates into the 4.0 release.</p>\n<p>With the planned changes in place, WordPress core will have more elegant ways to get people on track to using the software in their own languages. 2014 is shaping up to be an important year for making WordPress friendlier for its users across the globe.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Jun 2014 21:05:15 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:23;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:104:\"WPTavern: WordPress.com VIP Releases Presentation Documents and Resources Under Creative Commons License\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=24081\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:252:\"http://wptavern.com/wordpress-com-vip-releases-presentation-documents-and-resources-under-creative-commons-license?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-com-vip-releases-presentation-documents-and-resources-under-creative-commons-license\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4319:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/documattic.jpg\" rel=\"prettyphoto[24081]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/documattic.jpg?resize=992%2C453\" alt=\"documattic\" class=\"aligncenter size-full wp-image-24107\" /></a></p>\n<p><a href=\"http://vip.wordpress.com/\" target=\"_blank\">WordPress.com VIP</a> announced <a href=\"https://github.com/Automattic/Documattic\" target=\"_blank\">Documattic</a> today, a new GitHub repository to house presentations and resources shared with the community. The VIP team is regularly engaged in the task of educating new clients on the strengths and features of the WordPress platform. Sara Rosso explained in the <a href=\"http://vip.wordpress.com/2014/06/04/documattic-wordpress-com-vip-presentations-resources-on-github/\" target=\"_blank\">announcement</a> why they decided to share the relevant documents:</p>\n<blockquote><p>We spend a lot of time explaining the great features of WordPress to client IT, security, and editorial teams, and work with partners and agencies to provide up-to-date information about WordPress software and its vast community of developers, designers, content creators, and site owners.</p></blockquote>\n<p>The VIP team plans to share documents that will focus mainly on technical specifications, capabilities, features, and other information with a marketing, project or educational purpose.</p>\n<p>Documattic currently contains three high quality resources. One is a recent presentation on <a href=\"https://github.com/Automattic/Documattic/tree/master/Presentations/Trends_in_Enterprise_WP_Content\" target=\"_blank\">Trends in Enterprise WordPress Content</a> by Sara Rosso. It&#8217;s available in both PDF and RevealJS slide formats.</p>\n<p><a href=\"https://github.com/Automattic/Documattic/tree/master/Presentations/Trends_in_Enterprise_WP_Content\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/trends-in-enterprise-content.jpg?resize=1024%2C768\" alt=\"trends-in-enterprise-content\" class=\"aligncenter size-full wp-image-24090\" /></a></p>\n<p>The repository also includes a document highlighting FAQs regarding <a href=\"https://github.com/Automattic/Documattic/tree/master/Security\" target=\"_blank\">WordPress security</a>. It&#8217;s basically a Q&amp;A style document filled with questions that are commonly fielded by most WordPress development agencies when speaking with clients who are new to the platform.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/wp-security.jpg\" rel=\"prettyphoto[24081]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/wp-security.jpg?resize=632%2C374\" alt=\"wp-security\" class=\"aligncenter size-full wp-image-24095\" /></a></p>\n<p>The third resource is a <a href=\"https://github.com/Automattic/Documattic/tree/master/WordPress_for_Government\" target=\"_blank\">WordPress in Government FAQ</a>, which answers questions such as:</p>\n<ul>\n<li>How is WordPress being used in government?</li>\n<li>Who uses WordPress in government?</li>\n<li>Why would a government agency use WordPress over other CMS / custom-built solutions?</li>\n<li>How big is the WordPress developer ecosystem?</li>\n</ul>\n<p>These documents can be useful to any WordPress agency looking to attract more enterprise clients, as they provide an excellent starting point for articulating the strengths and capabilities of the platform.</p>\n<p>The WordPress.com VIP team invites other agencies to contribute to the repository and they plan to continue curating it and building it up to be a collaborative resource open to the community.</p>\n<p>Earlier this year Automattic added a <a href=\"https://github.com/Automattic/legalmattic\" target=\"_blank\">Legalmattic</a> repository to share its legal documents under a similar Creative Commons license. The repository contains legal documents used on WordPress.com including its Terms of Service. There&#8217;s no doubt some will find these documents useful, although the <a href=\"https://github.com/Automattic/Documattic\" target=\"_blank\">Documattic</a> repository is likely to have a broader appeal.</p>\n<p>Anyone is welcome to reuse and edit these documents as necessary, provided you link back to the original source, as specified in the Creative Commons license applicable to the shared document.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Jun 2014 17:37:30 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:24;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:72:\"WordPress.tv: José Antonio Maroto Fernández: Tu WordPress 100% legal\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=32517\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"http://wordpress.tv/2014/06/04/jose-antonio-maroto-fernandez-tu-wordpress-100-legal/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:694:\"<div id=\"v-lSryyHXj-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/32517/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/32517/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=32517&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/04/jose-antonio-maroto-fernandez-tu-wordpress-100-legal/\"><img alt=\"José Antonio Maroto Fernández: Tu WordPress 100% legal\" src=\"http://videos.videopress.com/lSryyHXj/video-9d0fc4cac3_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Jun 2014 09:00:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:25;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:66:\"WordPress.tv: Enrique Rodríguez Vallejo: Ya éramos responsables\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=32512\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:80:\"http://wordpress.tv/2014/06/04/enrique-rodriguez-vallejo-ya-eramos-responsables/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:684:\"<div id=\"v-2IohVD3o-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/32512/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/32512/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=32512&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/04/enrique-rodriguez-vallejo-ya-eramos-responsables/\"><img alt=\"Enrique Rodríguez Vallejo: Ya éramos responsables\" src=\"http://videos.videopress.com/2IohVD3o/video-eae210ae03_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Jun 2014 08:00:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:26;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:149:\"WordPress.tv: Ricardo Prieto Antúnez, David Borrallo Rodríguez, Verónica Valenzuela Jiménez: WordPress y la personalización en el ecommerce\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=32507\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:107:\"http://wordpress.tv/2014/06/04/jose-esteban-mucientes-manso-wordpress-y-la-personalizacion-en-el-ecommerce/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:794:\"<div id=\"v-vhmWfYwU-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/32507/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/32507/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=32507&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/04/jose-esteban-mucientes-manso-wordpress-y-la-personalizacion-en-el-ecommerce/\"><img alt=\"Ricardo Prieto Antúnez, David Borrallo Rodríguez, Verónica Valenzuela Jiménez: WordPress y la personalización en el ecommerce\" src=\"http://videos.videopress.com/vhmWfYwU/video-eff73e9174_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Jun 2014 07:00:55 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:27;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"WPTavern: New Plugin Batch Deletes WordPress Comment Spam Without Killing Your Server\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=24057\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:214:\"http://wptavern.com/new-plugin-batch-deletes-wordpress-comment-spam-without-killing-your-server?utm_source=rss&utm_medium=rss&utm_campaign=new-plugin-batch-deletes-wordpress-comment-spam-without-killing-your-server\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2630:\"<p>Once in awhile a WordPress site gets left to the wolves and becomes overrun by spam comments. Perhaps you set up an installation and forgot to install Akismet or some other spam-blocking plugin. If you neglected your site for a significant length of time, it&#8217;s likely that you&#8217;ll return to hundreds, if not thousands, of spam comments.</p>\n<p>The problem is that servers tend to crap out on you when you attempt to batch delete that many WordPress comments at once. Pippin Williamson just released a new plugin that helps to tackle this problem.</p>\n<p><a href=\"http://wordpress.org/plugins/batch-comment-spam-deletion/\" target=\"_blank\">Batch Comment Spam Deletion</a> works by modifying the the &#8220;Empty Spam&#8221; action in WordPress to process the spam deletion in batches instead of all at once.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/empty-spam.png\" rel=\"prettyphoto[24057]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/empty-spam.png?resize=900%2C446\" alt=\"empty-spam\" class=\"aligncenter size-full wp-image-24071\" /></a></p>\n<p>With this plugin in place, you&#8217;ll be able to delete hundreds of thousands of spam comments at once without killing your server. The plugin keeps you in the loop with status updates as it processes batches of spam:</p>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/06/processing-spam.png\" rel=\"prettyphoto[24057]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/06/processing-spam.png?resize=1025%2C480\" alt=\"processing-spam\" class=\"aligncenter size-full wp-image-24072\" /></a></p>\n<p>I tested Batch Comment Spam Deletion and it breezed through deleting nearly 800 spam comments with no issues. Another user reports having deleted 18,500 spam comments on the first run. Although this is a relatively new plugin, you can bet that it&#8217;s rock solid. Its creator, Pippin Williamson, is also the author of the popular <a href=\"http://wordpress.org/plugins/easy-digital-downloads/\" target=\"_blank\">Easy Digital Downloads</a> plugin and <a href=\"http://profiles.wordpress.org/mordauk/\" target=\"_blank\">54 other free plugins</a> hosted on WordPress.org.</p>\n<p>If you need to do some serious housekeeping in your comments, install <a href=\"http://wordpress.org/plugins/batch-comment-spam-deletion/\" target=\"_blank\">Batch Comment Spam Deletion</a> before eradicating your spam problem. Your server will thank you. You can set the clean-up process to run and come back later to zero spam comments. This beats spending hours trying to manually process thousands of batches of spam.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Wed, 04 Jun 2014 03:56:54 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:28;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:61:\"WPTavern: Press75 Acquired by Westwerk for Undisclosed Amount\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=23994\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:166:\"http://wptavern.com/press75-acquired-by-westwerk-for-undisclosed-amount?utm_source=rss&utm_medium=rss&utm_campaign=press75-acquired-by-westwerk-for-undisclosed-amount\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4797:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/press75-feature.png\" rel=\"prettyphoto[23994]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/press75-feature.png?resize=907%2C436\" alt=\"press75-feature\" class=\"aligncenter size-full wp-image-24045\" /></a></p>\n<p><a href=\"http://press75.com/\" target=\"_blank\">Press75</a>, established by <a href=\"http://jason.sc/\" target=\"_blank\">Jason Schuller</a> in 2008, is one of the longest running successful WordPress theme shops. Schuller carved out his own niche creating video-centric WordPress themes and created a strong, well-respected brand. He gradually became more involved with creating <a href=\"http://dropplets.com/\" target=\"_blank\">Dropplets</a>, an alternative publishing platform, and experimenting with <a href=\"https://leeflets.com/\" target=\"_blank\">Leeflets</a>, and his <a href=\"https://cinemati.co/\" target=\"_blank\">Cinematico</a> project.</p>\n<p>In April, Schuller decided to put Press75 up for auction on <a href=\"https://flippa.com/3056892-pr-6-site-with-13-621-uniques-mo-making-5-268-mo-selling-wordpress-themes\" target=\"_blank\">Flippa</a>, where the site pulled in bids as high as $45,000. He announced today that Press75 has been acquired by Westwerk, parent company of <a href=\"http://werkpress.com/\" target=\"_blank\">WerkPress</a>, a WordPress design and development agency.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/revenue-press75.png\" rel=\"prettyphoto[23994]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/revenue-press75.png?resize=260%2C220\" alt=\"revenue-press75\" class=\"alignright size-full wp-image-24035\" /></a>Although Westwerk is not at liberty to disclose the final sale price of Press75, the site&#8217;s revenue was public on Flippa. At one time, Press75 brought in more than $30,000 per month but had experienced a sharp decline over the past year.</p>\n<p>I spoke with Amy Abt, account executive at WerkPress, who said that their team will be working to bring the site&#8217;s revenue back up from the current $5k/month where it plateaued:</p>\n<blockquote><p>The site’s revenue had declined in recent months, as Jason began transitioning his focus to other projects. As of recent, average monthly revenue hovered around $5K. We are looking forward to bringing this up to historical averages and beyond!</p></blockquote>\n<p>Abt said that they will not attempt to rebrand Press75 and noted that the site already sports a mint green color palette similar to its new parent company, <a href=\"http://westwerk.com/\" target=\"_blank\">Westwerk</a>.</p>\n<h3>What&#8217;s Next for Press75?</h3>\n<p>Press75 will continue supporting its current customers. The team, led by WerkPress director Travis Totz, is already busy creating new products.</p>\n<p><strong>&#8220;We will be focusing on a couple themes that are in the WordPress.com pipeline, and then shifting gears to updating a few older themes, and releasing new themes (and plugins) as well,&#8221;</strong> Abt said. &#8220;We’re shooting to have an update available by next month.&#8221;</p>\n<p>Press75 has a number of old, outdated themes among its collection, but Abt said the team hopes to revive them and create some more modern themes to add. &#8220;There are several that will remain archived,&#8221; she said. &#8220;However, we’d like to update and maintain as many relevant themes as possible, as well as release new themes, including several more responsive options.&#8221;</p>\n<p>Current Press75 subscribers will be glad to know that WerkPress has transitioned a couple lead developers to help with the immediate theme updates. In the future, they plan to add a dedicated support team (in addition to implementing community-based forums).</p>\n<p>It&#8217;s a bittersweet day in the history of commercial theme shops as Schuller officially makes his exit by handing over the keys to Press75&#8242;s new owners. Press75 came on the scene in the very early days around the same time as StudioPress, WooThemes and iThemes.  In a recent <a href=\"http://wptavern.com/interview-with-jason-schuller-founder-of-press75-com\" target=\"_blank\">interview</a> with the Tavern, Schuller shared with us his growing dissatisfaction with trying to make WordPress do what he wanted and needed.</p>\n<p><strong>&#8220;WordPress was a great stepping stone for getting started as an entrepreneur,&#8221; he said. &#8220;But I just know in my gut that in order to move forward I need to go and experiment on my own.&#8221;</strong></p>\n<p>Press75 is now in the hands of passionate people who will bring new energy to the site and its products. The folks at WestWerk believe strongly in the WordPress platform and plan to work diligently to make Press75 a successful product channel.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Jun 2014 20:25:19 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:29;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:90:\"WPTavern: Kirki: A Free Plugin to Style the WordPress Customizer and Add Advanced Controls\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=23987\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:222:\"http://wptavern.com/kirki-a-free-plugin-to-style-the-wordpress-customizer-and-add-advanced-controls?utm_source=rss&utm_medium=rss&utm_campaign=kirki-a-free-plugin-to-style-the-wordpress-customizer-and-add-advanced-controls\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:3924:\"<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/kirki.png\" rel=\"prettyphoto[23987]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/kirki.png?resize=772%2C250\" alt=\"kirki\" class=\"aligncenter size-full wp-image-23991\" /></a></p>\n<p>The <a href=\"http://codex.wordpress.org/Theme_Customization_API\" target=\"_blank\">customizer</a> is a powerful tool that allows users to make changes to WordPress themes and preview them live. Because it is native to WordPress, many theme authors are starting to employ the customizer exclusively, instead of creating their own option panels.</p>\n<p>Although the customizer is a frontend tool, it slides into view with a generic design that matches the backend of WordPress. Wouldn&#8217;t it be nice if you could style the customizer to be a more natural extension of your theme?</p>\n<h3>Kirki Plugin Lets You Theme the WordPress Customizer and Add Advanced Controls</h3>\n<p><a href=\"http://wordpress.org/plugins/kirki/\" target=\"_blank\">Kirki</a> is a new free plugin that adds advanced features to the WordPress customizer, including the ability to style it, add your own custom header, and include more advanced custom controls. It&#8217;s essentially a framework for the customizer.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/kirki-customizer.png\" rel=\"prettyphoto[23987]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/kirki-customizer.png?resize=1025%2C627\" alt=\"kirki-customizer\" class=\"aligncenter size-full wp-image-23996\" /></a></p>\n<p>While many theme option frameworks add a new panel to the admin, Kirki was designed to do one thing: extend the customizer. If you&#8217;re using a theme powered by Kirki, you won&#8217;t even know it&#8217;s there, because it doesn&#8217;t brand itself or add anything additional to the WordPress admin.</p>\n<p>Kirki packages more than a dozen different types of <a href=\"http://kirki.org/#fields\" target=\"_blank\">fields</a> that you can add to create advanced controls, such as multi-check checkboxes, sliders using the jQuery Slider UI, buttonsets, layout selection, and more.</p>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/background-properties.png\" rel=\"prettyphoto[23987]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/06/background-properties.png?resize=268%2C338\" alt=\"background-properties\" class=\"alignright size-full wp-image-24007\" /></a>There are two ways to incorporate the Kirki framework into your creations: You can use it as a plugin or embed it within a WordPress theme you are building. Theming the customizer is easy with just a few lines of code, and the documentation offers a <a href=\"https://gist.github.com/aristath/f5bb04a81b3036d54f03#file-example-config-php\" target=\"_blank\">sample array</a>.</p>\n<p>If you want to check out a demo of a bunch of Kirki-powered controls in action, you can install the <a href=\"https://github.com/wpmu/shoestrap\" target=\"_blank\">Shoestrap</a> theme, which doesn&#8217;t require the plugin. This will give you a feel of how the customizer can be themed and how various controls can be implemented. Full documentation for all of the fields is available on the <a href=\"http://kirki.org/\" target=\"_blank\">kirki.org</a> website.</p>\n<p>Kirki was created by WordPress developer <a href=\"http://aristeides.com/\" target=\"_blank\">Aristeides Stathopoulos</a>, author of the <a href=\"http://shoestrap.org/\" target=\"_blank\">Shoestrap</a> theme. He built it to help theme developers reduce the time spent writing custom controls so they can focus on creating beautiful, user-friendly themes.</p>\n<p>Kirki is free and open source. It&#8217;s available for <a href=\"http://wordpress.org/plugins/kirki/\" target=\"_blank\">download</a> from the WordPress Plugin Directory and can also be found on <a href=\"https://github.com/aristath/kirki\" target=\"_blank\">GitHub</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Jun 2014 17:54:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:30;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:67:\"WordPress.tv: Javier Casares: Escalando WordPress hasta el infinito\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=25602\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:84:\"http://wordpress.tv/2014/06/03/javier-casares-escalando-wordpress-hasta-el-infinito/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:689:\"<div id=\"v-IDW2ZKUA-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/25602/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/25602/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=25602&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/03/javier-casares-escalando-wordpress-hasta-el-infinito/\"><img alt=\"Javier Casares: Escalando WordPress hasta el infinito\" src=\"http://videos.videopress.com/IDW2ZKUA/video-5a6fa75e61_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Jun 2014 09:00:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:31;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:78:\"WordPress.tv: Daniel Frías: Éxitos y fracasos en el desarrollo con WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=25607\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:93:\"http://wordpress.tv/2014/06/03/daniel-frias-exitos-y-fracasos-en-el-desarrollo-con-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:709:\"<div id=\"v-62spXAXw-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/25607/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/25607/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=25607&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/03/daniel-frias-exitos-y-fracasos-en-el-desarrollo-con-wordpress/\"><img alt=\"Daniel Frías: Éxitos y fracasos en el desarrollo con WordPress\" src=\"http://videos.videopress.com/62spXAXw/video-644eb41302_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Jun 2014 08:00:03 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:32;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:92:\"WordPress.tv: Javier Santos: Hacer de WordPress un CMS más sencillo: consejos y WP Wizard 2\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=25612\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:107:\"http://wordpress.tv/2014/06/03/javier-santos-hacer-de-wordpress-un-cms-mas-sencillo-consejos-y-wp-wizard-2/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:737:\"<div id=\"v-HtlXmkj7-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/25612/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/25612/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=25612&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/03/javier-santos-hacer-de-wordpress-un-cms-mas-sencillo-consejos-y-wp-wizard-2/\"><img alt=\"Javier Santos: Hacer de WordPress un CMS más sencillo: consejos y WP Wizard 2\" src=\"http://videos.videopress.com/HtlXmkj7/video-c622c4081c_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Jun 2014 07:00:01 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:33;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:75:\"WPTavern: Major Internationalization Improvements Planned for WordPress 4.0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=23951\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:194:\"http://wptavern.com/major-internationalization-improvements-planned-for-wordpress-4-0?utm_source=rss&utm_medium=rss&utm_campaign=major-internationalization-improvements-planned-for-wordpress-4-0\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4532:\"<div id=\"attachment_23969\" class=\"wp-caption aligncenter\"><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/globe.jpg\" rel=\"prettyphoto[23951]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/globe.jpg?resize=800%2C368\" alt=\"photo credit: Sarah Elizabeth Altendorf - cc\" class=\"size-full wp-image-23969\" /></a><p class=\"wp-caption-text\">photo credit: <a href=\"http://www.flickr.com/photos/sarah_elizabeth_simpson/6263928301/\">Sarah Elizabeth Altendorf</a> &#8211; <a href=\"http://creativecommons.org/licenses/by-nc/2.0/\">cc</a></p></div>\n<p>Many native English speakers take WordPress&#8217; <a href=\"http://codex.wordpress.org/Installing_WordPress#Famous_5-Minute_Install\" target=\"_blank\">famous 5-minute installation</a> process for granted. Have you every wondered how much of a hurdle it might be to try to install the software when English is not your first language?</p>\n<p>Andrew Nacin recently published an extensive <a href=\"http://make.wordpress.org/core/2014/05/21/internationalization-goals-for-4-0/\" target=\"_blank\">plan</a> to tackle this problem and a host of others with internationalization improvements for WordPress 4.0. He outlined five major goals for the next release. The first, and perhaps one of the most important, is that you should be able to choose a language before embarking on installation.</p>\n<h3>Choosing a Langue Before Installing WordPress</h3>\n<p>Given that many applications allow you to select the language before installing, this improvement to WordPress seems like it might be a trivial thing to accomplish. However, Nacin identified some unique technical challenges, depending on how the user is attempting to install WordPress:</p>\n<blockquote><p>If the user’s first step is setup-config.php, we don’t actually have WordPress fully loaded at this point, which makes actually installing a language pack more difficult. The install step has WordPress loaded in full, just without database tables. We should look into making setup-config.php load “all” of WordPress to make these environments easier to code.</p></blockquote>\n<p>He proposed two solutions, which include downloading the language files as soon as the user selects a language or bundling barebones language files for use on the installation screen. Both create their own set of new problems to solve, especially given that users install WordPress using several different methods.</p>\n<p>The next step after accomplishing this goal would be to make it possible for users to choose/switch a language from the general settings screen. This involves fetching the available languages from WordPress.org so that a new pack can be downloaded after it is selected.</p>\n<h3>Searching the Admin for Plugins and Themes Available in Your Language</h3>\n<p>Another one of the major goals Nacin identified is to allow users to search via the admin for extensions available in their selected language. Of course, this would also include the ability to expand the search to include extensions from any available language. All of this would require having &#8220;localized&#8221; plugin and theme directories on the translated WordPress.org sites.</p>\n<p>The ability to search extensions by language will also rely on the final two goals, which are interdependent:</p>\n<ul>\n<li>All localized packages should be able to be automatically generated and made available immediately as part of the core release process.</li>\n<li>Localized packages should only be used for initial downloads from WordPress.org. Instead, language packs should be transparently used for updates.</li>\n</ul>\n<p>Nacin outlined a list of WordPress.org/API work and core work that will need to be done in order to accomplish these goals. It&#8217;s a major undertaking and will require a group of highly motivated contributors to make this happen for 4.0.</p>\n<p>Hopefully these changes will serve to reduce the burden of trying to install and use WordPress in different languages. The software already powers a fairly large chunk of the web (22%), but if its rapid growth is to continue, contributors will need to keep internationalization as a top priority. Andrew Nacin&#8217;s outline is right on track for improving the experience of using WordPress in your own language. If you want to contribute, make sure to read the full outline for more in-depth details on WordPress&#8217; <a href=\"http://make.wordpress.org/core/2014/05/21/internationalization-goals-for-4-0/\" target=\"_blank\">internationalization goals for 4.0</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Tue, 03 Jun 2014 02:45:41 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:34;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:32:\"Matt: Internet With A Human Face\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=43831\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:48:\"http://ma.tt/2014/06/internet-with-a-human-face/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:384:\"<blockquote><p>&#8220;These big collections of personal data are like radioactive waste. [...] Surveillance limits our ability to be creative with technology. It&#8217;s like a tax we all have to pay on innovation.&#8221;</p></blockquote>\n<p>Maciej Ceg&#0322;owski gave a great talk he later wrote out in <a href=\"http://idlewords.com/bt14.htm\">The Internet With A Human Face</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Jun 2014 20:39:42 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:35;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"WPTavern: New Plugin Syncs WordPress Content With a GitHub Repository\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=23921\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:182:\"http://wptavern.com/new-plugin-syncs-wordpress-content-with-a-github-repository?utm_source=rss&utm_medium=rss&utm_campaign=new-plugin-syncs-wordpress-content-with-a-github-repository\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4498:\"<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/01/wpvsgithub.jpg\" rel=\"prettyphoto[23921]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/01/wpvsgithub.jpg?resize=1025%2C381\" alt=\"WordPress Versus Github\" class=\"aligncenter size-full wp-image-15216\" /></a></p>\n<p>WordPress is excellent for writing posts privately by yourself and can be extended to allow collaborative writing with other registered authors. But what if you could open up your posts and revisions to even more contributors without requiring them to register to your site or even use WordPress?</p>\n<p><a href=\"https://github.com/benbalter/wordpress-github-sync\" target=\"_blank\">WordPress <--> GitHub Sync</a> is a new plugin that enables collaborative writing. It was created by <a href=\"https://twitter.com/BenBalter\" target=\"_blank\">Ben Balter</a>, who has fully embraced this practice and hosts his <a href=\"http://ben.balter.com/\" target=\"_blank\">blog</a> on GitHub pages where you can view all of his drafts and revisions. Balter is also the creator of the first working prototype of what later became version 0.1 of the <a href=\"http://wptavern.com/introducing-wordpress-post-forking-version-control-for-writers\" target=\"_blank\">Post Forking</a> plugin, which offers version control for writers working in WordPress.</p>\n<h3>Collaborative Writing with WordPress and GitHub</h3>\n<p><a href=\"https://github.com/benbalter/wordpress-github-sync\" target=\"_blank\">WordPress <--> GitHub Sync</a> makes it possible for you to accept pull requests to your WordPress posts. Additionally, if you are blogging with <a href=\"http://jekyllrb.com/\" target=\"_blank\">Jekyll</a>, the plugin enables you to author your Jekyll site with WordPress&#8217; user-friendly web interface.</p>\n<p>Balter outlines the three major benefits of WordPress <--> GitHub Sync:</p>\n<ul>\n<li>Allows content publishers to version their content in GitHub, exposing &#8220;who made what change when&#8221; to readers</li>\n<li>Allows readers to submit proposed improvements to WordPress-served content via GitHub&#8217;s Pull Request model</li>\n<li>Allows non-technical writers to draft and edit a Jekyll site in WordPress&#8217;s best-of-breed editing interface</li>\n</ul>\n<p>Whenever WordPress&#8217; save_post hook is called, the plugin will fire a sync in response and will push the content to GitHub. In turn, GitHub&#8217;s push webhook will trigger a sync of all changed files back to WordPress.</p>\n<p>When you install the plugin, you&#8217;ll need to enter your GitHub hostname and specify a repository to commit to. You&#8217;ll also need to enter your Oauth Token and Webhook Secret.  At the bottom of the settings page, you&#8217;ll find bulk actions for exporting to GitHub and importing from GitHub, so it doesn&#8217;t necessarily have to be started on a brand new blog.</p>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/wp-github-sync-settings.jpg\" rel=\"prettyphoto[23921]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/06/wp-github-sync-settings.jpg?resize=867%2C657\" alt=\"wp-github-sync-settings\" class=\"aligncenter size-full wp-image-23927\" /></a></p>\n<p>In the future, Balter says the plugin may allow you to do even more, such as sync the content of two different WordPress installations via GitHub. It could also be adapted to allow you to stage and preview content before &#8220;deploying&#8221; to your production server.</p>\n<p>For many writers the <a href=\"https://konklone.com/post/writing-in-public-syncing-with-github\" target=\"_blank\">idea of writing</a> in public may seem a bit daunting, but the practice and benefits are very much akin to writing open source code. Public revisions and incorporation of improvements bring a new transparency to the writer&#8217;s process and transforms the work into a shared community document. Publications that embrace collaborative writing have the potential to bring a whole new level of community participation to online journalism.</p>\n<p>If you&#8217;re interested in experimenting with collaborative writing, Balter&#8217;s <a href=\"https://github.com/benbalter/wordpress-github-sync\" target=\"_blank\">WordPress <--> GitHub Sync</a> is a good starting point. Be advised that it&#8217;s still a work in progress. If you&#8217;d like to help make it better, please refer to the <a href=\"https://github.com/benbalter/wordpress-github-sync/blob/master/CONTRIBUTING.md\" target=\"_blank\">contributing documentation</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Jun 2014 17:52:47 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:36;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:85:\"WordPress.tv: Benjamin Caubère: Crear un plugin con el modelo Freemium en WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=32798\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"http://wordpress.tv/2014/06/02/benjamin-caubere-crear-un-plugin-con-el-modelo-freemium-en-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:723:\"<div id=\"v-oVd0Ul78-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/32798/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/32798/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=32798&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/02/benjamin-caubere-crear-un-plugin-con-el-modelo-freemium-en-wordpress/\"><img alt=\"Benjamin Caubère: Crear un plugin con el modelo Freemium en WordPress\" src=\"http://videos.videopress.com/oVd0Ul78/video-8036b88a1d_scruberthumbnail_2.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Jun 2014 09:00:52 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:37;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"WPTavern: 10 New Free WordPress Themes From May 2014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=23866\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:148:\"http://wptavern.com/10-new-free-wordpress-themes-from-may-2014?utm_source=rss&utm_medium=rss&utm_campaign=10-new-free-wordpress-themes-from-may-2014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:8191:\"<p>May was an excellent month for free WordPress themes landing in the official Themes Directory. Several dozen were approved and added to the directory last week in one sweep. We&#8217;ve hand-picked some of the best themes released in the month of May, all of which have undergone the rigorous review process conducted by the Theme Review Team. Grab a coffee or tea and start bookmarking your favorites.</p>\n<h3>Themify Base</h3>\n<p><a href=\"http://wordpress.org/themes/themify-base\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/05/themify.png?resize=1025%2C769\" alt=\"themify\" class=\"aligncenter size-full wp-image-23868\" /></a></p>\n<p>Themify Base is a minimalist style blog theme from the folks at <a href=\"http://themify.me/\" target=\"_blank\">Themify</a>. It&#8217;s translation ready, includes one custom menu, a sidebar, and three footer widget areas. The theme options contain six different skins and multiple layouts for the index, archives, pages, and posts.</p>\n<p><strong><a href=\"http://themify.me/demo/themes/base/\" target=\"_blank\">Demo</a> | <a href=\"http://wordpress.org/themes/themify-base\" target=\"_blank\">Download</a></strong></p>\n<h3>Tracks</h3>\n<p><a href=\"http://wordpress.org/themes/tracks\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/05/tracks.jpg?resize=1000%2C600\" alt=\"tracks\" class=\"aligncenter size-full wp-image-23832\" /></a></p>\n<p>Tracks is a bold, beautiful theme designed for use on personal blogs. Making your site look just like the demo takes no time, as it features just a handful of options in the WordPress customizer. The theme looks its best with large, panoramic featured images in place for each post. It also includes a customized author section that will display social links and a bio for each author at the bottom of posts.</p>\n<p><strong><a href=\"http://www.competethemes.com/tracks-live-demo\" target=\"_blank\">Demo</a> | <a href=\"http://wordpress.org/themes/tracks\" target=\"_blank\">Download</a></strong></p>\n<h3>Link</h3>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/05/link.png\" rel=\"prettyphoto[23866]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/05/link.png?resize=880%2C660\" alt=\"link\" class=\"aligncenter size-full wp-image-23874\" /></a></p>\n<p>Link based on Bootstrap and is an adaptation of the &#8220;Link&#8221; theme by Blacktie.co. It features big full-width images and full-width colored sections. The theme is actually a child theme of the <a href=\"http://wordpress.org/themes/flat-bootstrap\" target=\"_blank\">Flat Bootstrap</a> theme created by Tim Nicholson. Link includes support for customer header images, multiple widget areas, and Font Awesome icons.</p>\n<p><strong><a href=\"http://wordpress.org/themes/link\" target=\"_blank\">Demo</a> | <a href=\"http://wordpress.org/themes/link\" target=\"_blank\">Download</a></strong></p>\n<h3>tdPersona</h3>\n<p><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/05/tdpersona.png\" rel=\"prettyphoto[23866]\"><img src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/05/tdpersona.png?resize=880%2C660\" alt=\"tdpersona\" class=\"aligncenter size-full wp-image-23875\" /></a></p>\n<p>tdPersona is a beautiful theme with a clean, simple design. This minimal style theme has support for all of the standard post formats and includes a unique header menu for navigating them. A hidden sidebar widget area slides out when activated by an unobtrusive icon in the top menu.</p>\n<p><strong><a href=\"http://demo.tdwp.us/tdpersona/\" target=\"_blank\">Demo</a> | <a href=\"http://wordpress.org/themes/tdpersona\" target=\"_blank\">Download</a></strong></p>\n<h3>Forceful Lite</h3>\n<p><a href=\"http://wordpress.org/themes/forceful-lite\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/05/forceful-lite.png?resize=600%2C450\" alt=\"forceful-lite\" class=\"aligncenter size-full wp-image-23876\" /></a></p>\n<p>Forceful Lite is a free theme suited to magazines, blogs and news sites. It includes multiple widget areas as well as the ability to create your own unique sidebars and assign them to individual posts/pages. The theme is packaged with 14 custom widgets for customizing the display of recent content, advertising, social links, and more.</p>\n<p><strong><a href=\"http://kopatheme.com/demo/forceful-magazine-wordpress-theme-light-version/\" target=\"_blank\">Demo</a> | <a href=\"http://wordpress.org/themes/forceful-lite\" target=\"_blank\">Download</a></strong></p>\n<h3>Carrot Lite</h3>\n<p><a href=\"http://wordpress.org/themes/carrot-lite\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/05/carrot-lite.png?resize=880%2C660\" alt=\"carrot-lite\" class=\"aligncenter size-full wp-image-23877\" /></a></p>\n<p>The Carrot Lite homepage sports a magazine-style design with a large welcome message that can be easily edited in the customizer. The theme includes footer and sidebar widget areas and support for Font Awesome icons.</p>\n<p><strong><a href=\"http://wordpress.org/themes/carrot-lite\" target=\"_blank\">Demo</a> | <a href=\"http://wordpress.org/themes/carrot-lite\" target=\"_blank\">Download</a></strong></p>\n<h3>Fictive</h3>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/05/fictive.png\" rel=\"prettyphoto[23866]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/05/fictive.png?resize=880%2C660\" alt=\"fictive\" class=\"aligncenter size-full wp-image-23878\" /></a></p>\n<p>Fictive is a beautiful free theme from Automattic, designed for bloggers. It can be customized with your own header, Gravatar and social links in the sidebar, which can be set to fixed or scroll. Fictive features post formats with different colors and icons for each.</p>\n<p><strong><a href=\"http://fictivedemo.wordpress.com/\" target=\"_blank\">Demo</a> | <a href=\"http://wordpress.org/themes/fictive\" target=\"_blank\">Download</a></strong></p>\n<h3>Make</h3>\n<p><a href=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/05/make.png\" rel=\"prettyphoto[23866]\"><img src=\"http://i1.wp.com/wptavern.com/wp-content/uploads/2014/05/make.png?resize=880%2C660\" alt=\"make\" class=\"aligncenter size-full wp-image-23250\" /></a></p>\n<p>Make is Theme Foundry&#8217;s first free WordPress theme. It includes a unique drag and drop page builder that makes it easy for anyone to customize the layout. The design can be further customized with your own background, fonts, colors, and logo. Make can be used as a base for nearly any kind of website, including portfolios, blogs, businesses, e-commerce, or magazine sites.</p>\n<p><strong><a href=\"https://thethemefoundry.com/wordpress-themes/make/\" target=\"_blank\">Demo</a> | <a href=\"http://wordpress.org/themes/make\" target=\"_blank\">Download</a></strong></p>\n<h3>Pictorico</h3>\n<p><a href=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/05/pictorico.png\" rel=\"prettyphoto[23866]\"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/05/pictorico.png?resize=880%2C660\" alt=\"pictorico\" class=\"aligncenter size-full wp-image-22830\" /></a></p>\n<p>Pictorico is a single-column, grid-based portfolio theme created by the folks at Automattic. It&#8217;s well-suited to photoblogging or portfolio sites that feature large images. The theme can be customized with your own background and header. Pictorico also includes a post slider and support for post formats and sticky posts.</p>\n<p><strong><a href=\"http://pictoricodemo.wordpress.com/\" target=\"_blank\">Demo</a> | <a href=\"http://wordpress.org/themes/pictorico\" target=\"_blank\">Download</a></strong></p>\n<h3>Quality</h3>\n<p><a href=\"http://wordpress.org/themes/quality \"><img src=\"http://i0.wp.com/wptavern.com/wp-content/uploads/2014/05/quality.png?resize=880%2C660\" alt=\"quality\" class=\"aligncenter size-full wp-image-23870\" /></a></p>\n<p>Quality is a business theme with a custom blog and homepage template. The options include the ability to upload your own logo and header image. Quality supports Font Awesome icons which are featured in the homepage services section and can be easily edited in the theme&#8217;s options.</p>\n<p><strong><a href=\"http://wordpress.org/themes/quality\" target=\"_blank\">Demo</a> | <a href=\"http://wordpress.org/themes/quality\" target=\"_blank\">Download</a></strong></p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Jun 2014 08:11:28 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Sarah Gooding\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:38;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"WordPress.tv: Mercedes Romero: AlbertoContador.org – WordPress multisitio, multiidioma y red social\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=32795\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:113:\"http://wordpress.tv/2014/06/02/mercedes-romero-albertocontador-org-wordpress-multisitio-multiidioma-y-red-social/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:752:\"<div id=\"v-07Liu1Wd-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/32795/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/32795/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=32795&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/02/mercedes-romero-albertocontador-org-wordpress-multisitio-multiidioma-y-red-social/\"><img alt=\"Mercedes Romero: AlbertoContador.org – WordPress multisitio, multiidioma y red social\" src=\"http://videos.videopress.com/07Liu1Wd/video-91f834ca2a_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Jun 2014 08:00:10 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:39;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:111:\"WordPress.tv: Rafael Poveda: 30 cosas que no sabías que se podían hacer con un WordPress recién instalado\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=32500\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:122:\"http://wordpress.tv/2014/06/02/rafael-poveda-30-cosas-que-no-sabias-que-se-podian-hacer-con-un-wordpress-recien-instalado/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:771:\"<div id=\"v-Y3vXBBC9-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/32500/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/32500/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=32500&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/02/rafael-poveda-30-cosas-que-no-sabias-que-se-podian-hacer-con-un-wordpress-recien-instalado/\"><img alt=\"Rafael Poveda: 30 cosas que no sabías que se podían hacer con un WordPress recién instalado\" src=\"http://videos.videopress.com/Y3vXBBC9/video-f935c26916_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Jun 2014 07:00:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:40;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:100:\"WordPress.tv: Syed Balkhi: KidsCamp Atlanta – Fundamental Decisions regarding your WordPress setup\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=35275\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:113:\"http://wordpress.tv/2014/06/02/syed-balkhi-kidscamp-atlanta-fundamental-decisions-regarding-your-wordpress-setup/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:755:\"<div id=\"v-Zw4VDHcJ-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/35275/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/35275/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=35275&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/02/syed-balkhi-kidscamp-atlanta-fundamental-decisions-regarding-your-wordpress-setup/\"><img alt=\"Syed Balkhi: KidsCamp Atlanta &#8211; Fundamental Decisions regarding your WordPress setup\" src=\"http://videos.videopress.com/Zw4VDHcJ/video-9637bcec11_scruberthumbnail_2.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Mon, 02 Jun 2014 07:00:00 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:41;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:22:\"Matt: Laundry-App Race\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:21:\"http://ma.tt/?p=43829\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:38:\"http://ma.tt/2014/06/laundry-app-race/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:188:\"<p>Jessica Pressler in New York Magazine has an unintentionally funny look at <a href=\"http://nymag.com/news/features/laundry-apps-2014-5/\">Silicon Valley&#8217;s Laundry-App Race</a>.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 01 Jun 2014 20:22:21 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:14:\"Matt Mullenweg\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:42;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:86:\"WordPress.tv: Cliff Seal: Get Started in Professional WordPress Design and Development\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=35255\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:103:\"http://wordpress.tv/2014/06/01/cliff-seal-get-started-in-professional-wordpress-design-and-development/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:721:\"<div id=\"v-Gb3K8ynt-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/35255/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/35255/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=35255&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/01/cliff-seal-get-started-in-professional-wordpress-design-and-development/\"><img alt=\"Cliff Seal: Get Started in Professional WordPress Design and Development\" src=\"http://videos.videopress.com/Gb3K8ynt/video-d7ccd33426_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 01 Jun 2014 18:37:51 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:43;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:65:\"WordPress.tv: Bryan Petty: Finding the Perfect Themes and Plugins\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=35243\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:82:\"http://wordpress.tv/2014/06/01/bryan-petty-finding-the-perfect-themes-and-plugins/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:679:\"<div id=\"v-233NQZiw-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/35243/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/35243/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=35243&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/01/bryan-petty-finding-the-perfect-themes-and-plugins/\"><img alt=\"Bryan Petty: Finding the Perfect Themes and Plugins\" src=\"http://videos.videopress.com/233NQZiw/video-67347b08b9_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 01 Jun 2014 18:34:31 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:44;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:60:\"WordPress.tv: David Laietta: Web Development Trends For 2014\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=35241\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:77:\"http://wordpress.tv/2014/06/01/david-laietta-web-development-trends-for-2014/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:669:\"<div id=\"v-F5Ynj9Ql-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/35241/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/35241/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=35241&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/06/01/david-laietta-web-development-trends-for-2014/\"><img alt=\"David Laietta: Web Development Trends For 2014\" src=\"http://videos.videopress.com/F5Ynj9Ql/video-ccdb65be9b_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 01 Jun 2014 18:31:06 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:45;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:26:\"Akismet: May Stats Roundup\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"http://blog.akismet.com/?p=1505\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:53:\"http://blog.akismet.com/2014/06/01/may-stats-roundup/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:4480:\"<p>Welcome to the second post in a series of monthly articles summarizing some stats and figures from the Akismet universe. You can find April&#8217;s post <a href=\"http://blog.akismet.com/2014/05/01/april-stats-roundup/\">here</a>.</p>\n<div id=\"attachment_1507\" class=\"wp-caption alignright\"><a href=\"http://akismet.files.wordpress.com/2014/06/8116030061_cd2098f723_o.jpg\"><img class=\"wp-image-1507 size-medium\" src=\"http://akismet.files.wordpress.com/2014/06/8116030061_cd2098f723_o.jpg?w=300&h=200\" alt=\"Atos Olympic Games male swimmers diving two London 2012 by Atos on Flickr\" width=\"300\" height=\"200\" /></a><p class=\"wp-caption-text\">This image is a derivative of &#8216;<a href=\"https://www.flickr.com/photos/atosorigin/8116030061/\">Atos Olympic Games male swimmers diving two London 2012</a>&#8216; by Atos. Used under <a href=\"https://creativecommons.org/licenses/by-sa/2.0/\">CC BY-SA</a></p></div>\n<p>In May, Akismet caught a total of <strong>6,562,229,410</strong> pieces of spam &#8211; including comments, forum posts, contact form submissions, etc. To visualize this number, <strong>picture each piece of spam as a sugar cube</strong> &#8211; that&#8217;d be enough sugar cubes to fill about 6 and a fifth Olympic swimming pools.</p>\n<p>The amount of spam we caught in May is up 4% from last month, and up 269% from May 2012. Here&#8217;s a breakdown of the spam and ham we detected each day:</p>\n<p><a href=\"https://akismet.files.wordpress.com/2014/06/akismet-ham-stats-may-20141.png\"><img src=\"http://akismet.files.wordpress.com/2014/06/akismet-ham-stats-may-20141.png?w=640&h=400\" alt=\"Akismet Spam and Ham Stats, May 2014\" width=\"640\" height=\"400\" class=\"alignnone size-large wp-image-1529\" /></a></p>\n<p>There weren&#8217;t any big dips or highs during the month of May. The busiest day of the month was May 8, with just over <strong>230 million</strong> spam messages detected. The slowest day was May 25, with &#8216;only&#8217; about 178 million pieces of spam caught. You may have seen similar ups and downs in the spam activity on your own site.</p>\n<p>We had no service interruptions this month, so any fluctuations in spam numbers we attribute to the natural way spam is posted. If you want to hear about any service interruptions you can subscribe to this blog, or follow <a href=\"https://twitter.com/akismet\">us on Twitter</a>.</p>\n<p>As usual, there&#8217;s much more spam going around than real comments (which we call ham). You can see this by looking at the purple bars in the graph.</p>\n<p>Akismet detected a total of 294,312,590 real messages in May. If each real comment were a sugar cube, they&#8217;d only enough be enough to fill about 10% of one Olympic swimming pool.</p>\n<p>In May, we missed only about 1 in every 7,404 spam messages. If you&#8217;ve seeing lots of missed spam comments on your own site, we are happy to help with that, so feel free to <a href=\"http://akismet.com/contact/\">contact us</a> about it, and please include your website &amp; your API key in your message.</p>\n<p>\n<strong>Some reads from the month that we recommend:</strong><br />\nThis month, we rather enjoyed reading <a href=\"http://www.theatlantic.com/technology/archive/2014/05/spam-always-finds-a-way/371194/\">this piece</a> by Adrienne LaFrance about the history of spam (going back to snail mail!), and how it affects us nowadays. We also liked Seth Godin&#8217;s <a href=\"http://sethgodin.typepad.com/seths_blog/2014/04/what-is-spam.html\">sage advice</a> (as always) on how not to spam people as a business, but still get business. In fact, in July <a href=\"http://blogs.windsorstar.com/2014/05/26/new-anti-spam-regulations-feature-tight-restrictions-hefty-fines/\">Canada&#8217;s Anti-Spam legislation will come into effect</a> (<a href=\"http://www.techvibes.com/blog/a-guide-to-canadas-anti-spam-law-2014-05-20\">similar to CAN-SPAM</a>), making the suggestions Seth Godin recommends, and even stricter rules around emailing, into law, which should make Canadians much happier with their inboxes <span class=\"wp-smiley emoji emoji-smile\" title=\":)\">:)</span>. We like where this is going!</p><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/akismet.wordpress.com/1505/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/akismet.wordpress.com/1505/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=blog.akismet.com&blog=116920&post=1505&subd=akismet&ref=&feed=1\" width=\"1\" height=\"1\" />\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 01 Jun 2014 06:00:05 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:7:\"Valerie\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:46;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:76:\"WPTavern: WordPress Plugin All In One SEO Releases Important Security Update\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wptavern.com/?p=23880\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:196:\"http://wptavern.com/wordpress-plugin-all-in-one-seo-releases-important-security-update?utm_source=rss&utm_medium=rss&utm_campaign=wordpress-plugin-all-in-one-seo-releases-important-security-update\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:2024:\"<p>The popular <a title=\"http://wordpress.org/plugins/all-in-one-seo-pack/\" href=\"http://wordpress.org/plugins/all-in-one-seo-pack/\">All In One SEO Plugin</a> for WordPress has <a title=\"http://semperfiwebdesign.com/blog/all-in-one-seo-pack/all-in-one-seo-pack-release-history/\" href=\"http://semperfiwebdesign.com/blog/all-in-one-seo-pack/all-in-one-seo-pack-release-history/\">released an update</a> addressing two security issues <a title=\"http://blog.sucuri.net/2014/05/vulnerability-found-in-the-all-in-one-seo-pack-wordpress-plugin.html\" href=\"http://blog.sucuri.net/2014/05/vulnerability-found-in-the-all-in-one-seo-pack-wordpress-plugin.html\">discovered by Sucuri </a>during a security audit. According to Sucuri, one of the vulnerabilities can be used to escalate privileges while the other deals with Cross Site Scripting attacks.</p>\n<div id=\"attachment_23882\" class=\"wp-caption aligncenter\"><a href=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/05/AllInOneSEOFeaturedImage.png\" rel=\"prettyphoto[23880]\"><img class=\"size-full wp-image-23882\" src=\"http://i2.wp.com/wptavern.com/wp-content/uploads/2014/05/AllInOneSEOFeaturedImage.png?resize=730%2C269\" alt=\"All In One SEO Plugin Header Image\" /></a><p class=\"wp-caption-text\">All In One SEO Plugin Header Image</p></div>\n<p>A logged-in user who doesn&#8217;t have administrative capabilities is able to modify certain parameters of the plugin such as the <strong>post&#8217;s SEO title, description, and meta tags</strong>. These changes could cause long-term negative effects to search engine rankings.</p>\n<p>Unfortunately, this bug can also be used to execute malicious code on an administrator&#8217;s control panel. Sucuri says &#8220;this means that an attacker could potentially inject any JavaScript code and do things like change the admin’s account password to leaving some backdoor in your website’s files in order to conduct even more “evil” activities later.&#8221;</p>\n<p>Sucuri recommends upgrading the plugin as soon as possible.</p>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sun, 01 Jun 2014 02:34:46 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:13:\"Jeff Chandler\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:47;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:87:\"WordPress.tv: Ignacio de Miguel: La unión hace la fuerza: PHP, WordPress y creatividad\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=25348\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:101:\"http://wordpress.tv/2014/05/31/ignacio-de-miguel-la-union-hace-la-fuerza-php-wordpress-y-creatividad/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:720:\"<div id=\"v-ahcdnnUU-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/25348/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/25348/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=25348&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/05/31/ignacio-de-miguel-la-union-hace-la-fuerza-php-wordpress-y-creatividad/\"><img alt=\"Ignacio de Miguel: La unión hace la fuerza: PHP, WordPress y creatividad\" src=\"http://videos.videopress.com/ahcdnnUU/video-86eea2dfe6_std.original.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 31 May 2014 09:00:57 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:48;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:47:\"WordPress.tv: Andy García: WordPress vs Drupal\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=25195\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:63:\"http://wordpress.tv/2014/05/31/andy-garcia-wordpress-vs-drupal/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:648:\"<div id=\"v-tNhCssxb-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/25195/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/25195/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=25195&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/05/31/andy-garcia-wordpress-vs-drupal/\"><img alt=\"Andy García: WordPress vs Drupal\" src=\"http://videos.videopress.com/tNhCssxb/video-1efcaf2516_scruberthumbnail_1.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 31 May 2014 08:00:43 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}i:49;a:6:{s:4:\"data\";s:13:\"\n	\n	\n	\n	\n	\n	\n\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";s:5:\"child\";a:2:{s:0:\"\";a:5:{s:5:\"title\";a:1:{i:0;a:5:{s:4:\"data\";s:52:\"WordPress.tv: Jorge Coronado: Hardening en WordPress\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"guid\";a:1:{i:0;a:5:{s:4:\"data\";s:28:\"http://wordpress.tv/?p=25250\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:4:\"link\";a:1:{i:0;a:5:{s:4:\"data\";s:69:\"http://wordpress.tv/2014/05/31/jorge-coronado-hardening-en-wordpress/\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:11:\"description\";a:1:{i:0;a:5:{s:4:\"data\";s:659:\"<div id=\"v-79g7dalR-1\" class=\"video-player\">\n</div><br />  <a rel=\"nofollow\" href=\"http://feeds.wordpress.com/1.0/gocomments/wptv.wordpress.com/25250/\"><img alt=\"\" border=\"0\" src=\"http://feeds.wordpress.com/1.0/comments/wptv.wordpress.com/25250/\" /></a> <img alt=\"\" border=\"0\" src=\"http://stats.wordpress.com/b.gif?host=wordpress.tv&blog=5089392&post=25250&subd=wptv&ref=&feed=1\" width=\"1\" height=\"1\" /><div><a href=\"http://wordpress.tv/2014/05/31/jorge-coronado-hardening-en-wordpress/\"><img alt=\"Jorge Coronado: Hardening en WordPress\" src=\"http://videos.videopress.com/79g7dalR/video-1b851666f8_scruberthumbnail_0.jpg\" width=\"160\" height=\"120\" /></a></div>\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}s:7:\"pubDate\";a:1:{i:0;a:5:{s:4:\"data\";s:31:\"Sat, 31 May 2014 07:00:34 +0000\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}s:32:\"http://purl.org/dc/elements/1.1/\";a:1:{s:7:\"creator\";a:1:{i:0;a:5:{s:4:\"data\";s:12:\"WordPress.tv\";s:7:\"attribs\";a:0:{}s:8:\"xml_base\";s:0:\"\";s:17:\"xml_base_explicit\";b:0;s:8:\"xml_lang\";s:0:\"\";}}}}}}}}}}}}}}}}s:4:\"type\";i:128;s:7:\"headers\";a:9:{s:6:\"server\";s:5:\"nginx\";s:4:\"date\";s:29:\"Mon, 09 Jun 2014 00:32:05 GMT\";s:12:\"content-type\";s:8:\"text/xml\";s:14:\"content-length\";s:6:\"127939\";s:10:\"connection\";s:5:\"close\";s:4:\"vary\";s:15:\"Accept-Encoding\";s:13:\"last-modified\";s:29:\"Mon, 09 Jun 2014 00:15:14 GMT\";s:4:\"x-nc\";s:11:\"HIT lax 249\";s:13:\"accept-ranges\";s:5:\"bytes\";}s:5:\"build\";s:14:\"20131111204433\";}', 'no');
INSERT INTO `wp_options` VALUES('6039', 'auto_core_update_notified', 'a:4:{s:4:\"type\";s:7:\"success\";s:5:\"email\";s:23:\"youremail@youremail.com\";s:7:\"version\";s:5:\"3.8.3\";s:9:\"timestamp\";i:1397679365;}', 'yes');
INSERT INTO `wp_options` VALUES('7652', '_transient_timeout_feed_mod_94bc6e7dd050c2a74ce39668c35643cd', '1402317736', 'no');
INSERT INTO `wp_options` VALUES('7653', '_transient_feed_mod_94bc6e7dd050c2a74ce39668c35643cd', '1402274536', 'no');
INSERT INTO `wp_options` VALUES('7785', '_transient_timeout_94bc6e7dd050c2a74ce39668c35643cd', '1402283627', 'no');
INSERT INTO `wp_options` VALUES('7786', '_transient_94bc6e7dd050c2a74ce39668c35643cd', '<li>- <a href=\"http://ithemes.com/2014/06/05/use-unbranded-wordpress-tutorials-train-clients-use-wordpress/\">How to Use Our Unbranded WordPre ...</a></li><li>- <a href=\"http://ithemes.com/2014/06/04/new-wordpress-101-tutorials/\">New WordPress 101 Tutorials</a></li><li>- <a href=\"http://ithemes.com/2014/06/04/easy-canadian-sales-taxes-add-ithemes-exchange/\">New! Easy Canadian Sales Taxes A ...</a></li><li>- <a href=\"http://ithemes.com/2014/06/04/bulk-install-wordpress-themes-plugins-in-seconds-ithemes-sync/\">Bulk Install Plugins &amp; Theme ...</a></li><li>- <a href=\"http://ithemes.com/2014/06/02/change-default-customer-login-registration-pages-ithemes-exchange/\">Change Default Customer Login &a ...</a></li>', 'no');
INSERT INTO `wp_options` VALUES('7666', '_transient_aioseop_oauth_current', '1', 'no');
INSERT INTO `wp_options` VALUES('7698', '_transient_timeout_vye_type_d_t8mN4mMtc', '1402366230', 'no');
INSERT INTO `wp_options` VALUES('7699', '_transient_vye_type_d_t8mN4mMtc', 'v', 'no');
INSERT INTO `wp_options` VALUES('7700', '_transient_timeout_vye_title_d_t8mN4mMtc', '1402366230', 'no');
INSERT INTO `wp_options` VALUES('7701', '_transient_vye_title_d_t8mN4mMtc', 'Fibromyalgia &amp; Pain Management : Cures for Chronic Fatigue Syndrome', 'no');
INSERT INTO `wp_options` VALUES('7702', '_transient_timeout_vye_video_047e6a8735bdd3cbe4bf4fdeefcd5495', '1402283430', 'no');
INSERT INTO `wp_options` VALUES('7703', '_transient_vye_video_047e6a8735bdd3cbe4bf4fdeefcd5495', '\n<!-- Vixy YouTube Embed v3.2 -->\n<span itemscope=\"itemscope\" xmlns:media=\"http://search.yahoo.com/searchmonkey/media/\" xmlns:dc=\"http://purl.org/dc/terms/\">\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/d_t8mN4mMtc?enablejsapi=1&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;wmode=opaque\" ></iframe>\n<link itemprop=\"media:video\" rel=\"alternate\" href=\"http://www.youtube.com/v/d_t8mN4mMtc\"/>\n<link itemprop=\"media:thumbnail\" rel=\"icon\" href=\"http://i.ytimg.com/vi/d_t8mN4mMtc/hqdefault.jpg\"/>\n<link itemprop=\"media:thumbnail\" rel=\"icon\" href=\"http://i.ytimg.com/vi/d_t8mN4mMtc/default.jpg\"/>\n<meta itemprop=\"media:title\" content=\"Fibromyalgia &amp;amp; Pain Management : Cures for Chronic Fatigue Syndrome\"/>\n<meta itemprop=\"media:width\" content=\"570\"/>\n<meta itemprop=\"media:height\" content=\"390\"/>\n	</span>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('7704', '_transient_timeout_vye_type_0iboZWCPzsE', '1402366230', 'no');
INSERT INTO `wp_options` VALUES('7705', '_transient_vye_type_0iboZWCPzsE', 'v', 'no');
INSERT INTO `wp_options` VALUES('7706', '_transient_timeout_vye_title_0iboZWCPzsE', '1402366230', 'no');
INSERT INTO `wp_options` VALUES('7707', '_transient_vye_title_0iboZWCPzsE', 'Medical Conditions &amp; Symptoms : Chronic Fatigue Syndrome Symptoms', 'no');
INSERT INTO `wp_options` VALUES('7708', '_transient_timeout_vye_video_52f2761ffde704a694ef9308cb961b8a', '1402283430', 'no');
INSERT INTO `wp_options` VALUES('7709', '_transient_vye_video_52f2761ffde704a694ef9308cb961b8a', '\n<!-- Vixy YouTube Embed v3.2 -->\n<span itemscope=\"itemscope\" xmlns:media=\"http://search.yahoo.com/searchmonkey/media/\" xmlns:dc=\"http://purl.org/dc/terms/\">\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/0iboZWCPzsE?enablejsapi=1&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;wmode=opaque\" ></iframe>\n<link itemprop=\"media:video\" rel=\"alternate\" href=\"http://www.youtube.com/v/0iboZWCPzsE\"/>\n<link itemprop=\"media:thumbnail\" rel=\"icon\" href=\"http://i.ytimg.com/vi/0iboZWCPzsE/hqdefault.jpg\"/>\n<link itemprop=\"media:thumbnail\" rel=\"icon\" href=\"http://i.ytimg.com/vi/0iboZWCPzsE/default.jpg\"/>\n<meta itemprop=\"media:title\" content=\"Medical Conditions &amp;amp; Symptoms : Chronic Fatigue Syndrome Symptoms\"/>\n<meta itemprop=\"media:width\" content=\"570\"/>\n<meta itemprop=\"media:height\" content=\"390\"/>\n	</span>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('7710', '_transient_timeout_vye_type_HhB8tzWpJqI', '1402366230', 'no');
INSERT INTO `wp_options` VALUES('7711', '_transient_vye_type_HhB8tzWpJqI', 'v', 'no');
INSERT INTO `wp_options` VALUES('7712', '_transient_timeout_vye_title_HhB8tzWpJqI', '1402366230', 'no');
INSERT INTO `wp_options` VALUES('7713', '_transient_vye_title_HhB8tzWpJqI', 'Fibromyalgia &amp; Pain Management : Chronic Fatigue Symptoms', 'no');
INSERT INTO `wp_options` VALUES('7714', '_transient_timeout_vye_video_7d17dc41066550b3b885fae32d1a7466', '1402283430', 'no');
INSERT INTO `wp_options` VALUES('7715', '_transient_vye_video_7d17dc41066550b3b885fae32d1a7466', '\n<!-- Vixy YouTube Embed v3.2 -->\n<span itemscope=\"itemscope\" xmlns:media=\"http://search.yahoo.com/searchmonkey/media/\" xmlns:dc=\"http://purl.org/dc/terms/\">\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/HhB8tzWpJqI?enablejsapi=1&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;wmode=opaque\" ></iframe>\n<link itemprop=\"media:video\" rel=\"alternate\" href=\"http://www.youtube.com/v/HhB8tzWpJqI\"/>\n<link itemprop=\"media:thumbnail\" rel=\"icon\" href=\"http://i.ytimg.com/vi/HhB8tzWpJqI/hqdefault.jpg\"/>\n<link itemprop=\"media:thumbnail\" rel=\"icon\" href=\"http://i.ytimg.com/vi/HhB8tzWpJqI/default.jpg\"/>\n<meta itemprop=\"media:title\" content=\"Fibromyalgia &amp;amp; Pain Management : Chronic Fatigue Symptoms\"/>\n<meta itemprop=\"media:width\" content=\"570\"/>\n<meta itemprop=\"media:height\" content=\"390\"/>\n	</span>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('7716', '_transient_timeout_vye_type_51dvhUl2U2g', '1402366230', 'no');
INSERT INTO `wp_options` VALUES('7717', '_transient_vye_type_51dvhUl2U2g', 'v', 'no');
INSERT INTO `wp_options` VALUES('7718', '_transient_timeout_vye_title_51dvhUl2U2g', '1402366230', 'no');
INSERT INTO `wp_options` VALUES('7719', '_transient_vye_title_51dvhUl2U2g', 'How to Treat Chronic Fatigue : Treating Chronic Fatigue', 'no');
INSERT INTO `wp_options` VALUES('7720', '_transient_timeout_vye_video_aa52b70cefb8869381ed422a6910bbd9', '1402283430', 'no');
INSERT INTO `wp_options` VALUES('7721', '_transient_vye_video_aa52b70cefb8869381ed422a6910bbd9', '\n<!-- Vixy YouTube Embed v3.2 -->\n<span itemscope=\"itemscope\" xmlns:media=\"http://search.yahoo.com/searchmonkey/media/\" xmlns:dc=\"http://purl.org/dc/terms/\">\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/51dvhUl2U2g?enablejsapi=1&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;wmode=opaque\" ></iframe>\n<link itemprop=\"media:video\" rel=\"alternate\" href=\"http://www.youtube.com/v/51dvhUl2U2g\"/>\n<link itemprop=\"media:thumbnail\" rel=\"icon\" href=\"http://i.ytimg.com/vi/51dvhUl2U2g/hqdefault.jpg\"/>\n<link itemprop=\"media:thumbnail\" rel=\"icon\" href=\"http://i.ytimg.com/vi/51dvhUl2U2g/default.jpg\"/>\n<meta itemprop=\"media:title\" content=\"How to Treat Chronic Fatigue : Treating Chronic Fatigue\"/>\n<meta itemprop=\"media:width\" content=\"570\"/>\n<meta itemprop=\"media:height\" content=\"390\"/>\n	</span>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('7886', '_transient_timeout_vye_video_f123abe89f67f81dddce964c4b9a4b47', '1402363145', 'no');
INSERT INTO `wp_options` VALUES('7887', '_transient_vye_video_f123abe89f67f81dddce964c4b9a4b47', '\n<!-- Vixy YouTube Embed v3.2 -->\n<span itemscope=\"itemscope\" xmlns:media=\"http://search.yahoo.com/searchmonkey/media/\" xmlns:dc=\"http://purl.org/dc/terms/\">\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/eeBzqhLlJ8s?enablejsapi=1&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;wmode=opaque\" ></iframe>\n<link itemprop=\"media:video\" rel=\"alternate\" href=\"http://www.youtube.com/v/eeBzqhLlJ8s\"/>\n<link itemprop=\"media:thumbnail\" rel=\"icon\" href=\"http://i.ytimg.com/vi/eeBzqhLlJ8s/hqdefault.jpg\"/>\n<link itemprop=\"media:thumbnail\" rel=\"icon\" href=\"http://i.ytimg.com/vi/eeBzqhLlJ8s/default.jpg\"/>\n<meta itemprop=\"media:title\" content=\"How To Restore Your Vision To 20 20 Restore My Vision Today Guide Restore My Vision Today Review\"/>\n<meta itemprop=\"media:width\" content=\"570\"/>\n<meta itemprop=\"media:height\" content=\"390\"/>\n	</span>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('7800', '_site_transient_timeout_poptags_40cd750bba9870f18aada2478b24840a', '1402304642', 'yes');
INSERT INTO `wp_options` VALUES('7801', '_site_transient_poptags_40cd750bba9870f18aada2478b24840a', 'a:40:{s:6:\"widget\";a:3:{s:4:\"name\";s:6:\"widget\";s:4:\"slug\";s:6:\"widget\";s:5:\"count\";s:4:\"4463\";}s:4:\"post\";a:3:{s:4:\"name\";s:4:\"Post\";s:4:\"slug\";s:4:\"post\";s:5:\"count\";s:4:\"2778\";}s:6:\"plugin\";a:3:{s:4:\"name\";s:6:\"plugin\";s:4:\"slug\";s:6:\"plugin\";s:5:\"count\";s:4:\"2683\";}s:5:\"admin\";a:3:{s:4:\"name\";s:5:\"admin\";s:4:\"slug\";s:5:\"admin\";s:5:\"count\";s:4:\"2196\";}s:5:\"posts\";a:3:{s:4:\"name\";s:5:\"posts\";s:4:\"slug\";s:5:\"posts\";s:5:\"count\";s:4:\"2110\";}s:7:\"sidebar\";a:3:{s:4:\"name\";s:7:\"sidebar\";s:4:\"slug\";s:7:\"sidebar\";s:5:\"count\";s:4:\"1756\";}s:6:\"google\";a:3:{s:4:\"name\";s:6:\"google\";s:4:\"slug\";s:6:\"google\";s:5:\"count\";s:4:\"1553\";}s:7:\"twitter\";a:3:{s:4:\"name\";s:7:\"twitter\";s:4:\"slug\";s:7:\"twitter\";s:5:\"count\";s:4:\"1513\";}s:8:\"comments\";a:3:{s:4:\"name\";s:8:\"comments\";s:4:\"slug\";s:8:\"comments\";s:5:\"count\";s:4:\"1465\";}s:6:\"images\";a:3:{s:4:\"name\";s:6:\"images\";s:4:\"slug\";s:6:\"images\";s:5:\"count\";s:4:\"1449\";}s:4:\"page\";a:3:{s:4:\"name\";s:4:\"page\";s:4:\"slug\";s:4:\"page\";s:5:\"count\";s:4:\"1401\";}s:9:\"shortcode\";a:3:{s:4:\"name\";s:9:\"shortcode\";s:4:\"slug\";s:9:\"shortcode\";s:5:\"count\";s:4:\"1340\";}s:5:\"image\";a:3:{s:4:\"name\";s:5:\"image\";s:4:\"slug\";s:5:\"image\";s:5:\"count\";s:4:\"1308\";}s:8:\"facebook\";a:3:{s:4:\"name\";s:8:\"Facebook\";s:4:\"slug\";s:8:\"facebook\";s:5:\"count\";s:4:\"1157\";}s:3:\"seo\";a:3:{s:4:\"name\";s:3:\"seo\";s:4:\"slug\";s:3:\"seo\";s:5:\"count\";s:4:\"1116\";}s:5:\"links\";a:3:{s:4:\"name\";s:5:\"links\";s:4:\"slug\";s:5:\"links\";s:5:\"count\";s:4:\"1096\";}s:9:\"wordpress\";a:3:{s:4:\"name\";s:9:\"wordpress\";s:4:\"slug\";s:9:\"wordpress\";s:5:\"count\";s:3:\"999\";}s:7:\"gallery\";a:3:{s:4:\"name\";s:7:\"gallery\";s:4:\"slug\";s:7:\"gallery\";s:5:\"count\";s:3:\"955\";}s:6:\"social\";a:3:{s:4:\"name\";s:6:\"social\";s:4:\"slug\";s:6:\"social\";s:5:\"count\";s:3:\"955\";}s:7:\"widgets\";a:3:{s:4:\"name\";s:7:\"widgets\";s:4:\"slug\";s:7:\"widgets\";s:5:\"count\";s:3:\"789\";}s:3:\"rss\";a:3:{s:4:\"name\";s:3:\"rss\";s:4:\"slug\";s:3:\"rss\";s:5:\"count\";s:3:\"782\";}s:5:\"pages\";a:3:{s:4:\"name\";s:5:\"pages\";s:4:\"slug\";s:5:\"pages\";s:5:\"count\";s:3:\"781\";}s:6:\"jquery\";a:3:{s:4:\"name\";s:6:\"jquery\";s:4:\"slug\";s:6:\"jquery\";s:5:\"count\";s:3:\"769\";}s:5:\"email\";a:3:{s:4:\"name\";s:5:\"email\";s:4:\"slug\";s:5:\"email\";s:5:\"count\";s:3:\"766\";}s:5:\"media\";a:3:{s:4:\"name\";s:5:\"media\";s:4:\"slug\";s:5:\"media\";s:5:\"count\";s:3:\"703\";}s:4:\"ajax\";a:3:{s:4:\"name\";s:4:\"AJAX\";s:4:\"slug\";s:4:\"ajax\";s:5:\"count\";s:3:\"678\";}s:5:\"video\";a:3:{s:4:\"name\";s:5:\"video\";s:4:\"slug\";s:5:\"video\";s:5:\"count\";s:3:\"662\";}s:10:\"javascript\";a:3:{s:4:\"name\";s:10:\"javascript\";s:4:\"slug\";s:10:\"javascript\";s:5:\"count\";s:3:\"651\";}s:7:\"content\";a:3:{s:4:\"name\";s:7:\"content\";s:4:\"slug\";s:7:\"content\";s:5:\"count\";s:3:\"619\";}s:10:\"buddypress\";a:3:{s:4:\"name\";s:10:\"buddypress\";s:4:\"slug\";s:10:\"buddypress\";s:5:\"count\";s:3:\"610\";}s:5:\"photo\";a:3:{s:4:\"name\";s:5:\"photo\";s:4:\"slug\";s:5:\"photo\";s:5:\"count\";s:3:\"592\";}s:4:\"link\";a:3:{s:4:\"name\";s:4:\"link\";s:4:\"slug\";s:4:\"link\";s:5:\"count\";s:3:\"583\";}s:4:\"feed\";a:3:{s:4:\"name\";s:4:\"feed\";s:4:\"slug\";s:4:\"feed\";s:5:\"count\";s:3:\"579\";}s:5:\"login\";a:3:{s:4:\"name\";s:5:\"login\";s:4:\"slug\";s:5:\"login\";s:5:\"count\";s:3:\"579\";}s:6:\"photos\";a:3:{s:4:\"name\";s:6:\"photos\";s:4:\"slug\";s:6:\"photos\";s:5:\"count\";s:3:\"568\";}s:8:\"category\";a:3:{s:4:\"name\";s:8:\"category\";s:4:\"slug\";s:8:\"category\";s:5:\"count\";s:3:\"532\";}s:7:\"youtube\";a:3:{s:4:\"name\";s:7:\"youtube\";s:4:\"slug\";s:7:\"youtube\";s:5:\"count\";s:3:\"525\";}s:4:\"spam\";a:3:{s:4:\"name\";s:4:\"spam\";s:4:\"slug\";s:4:\"spam\";s:5:\"count\";s:3:\"524\";}s:8:\"security\";a:3:{s:4:\"name\";s:8:\"security\";s:4:\"slug\";s:8:\"security\";s:5:\"count\";s:3:\"510\";}s:5:\"share\";a:3:{s:4:\"name\";s:5:\"Share\";s:4:\"slug\";s:5:\"share\";s:5:\"count\";s:3:\"507\";}}', 'yes');
INSERT INTO `wp_options` VALUES('7807', '_site_transient_update_plugins', 'O:8:\"stdClass\":4:{s:12:\"last_checked\";i:1402359570;s:7:\"checked\";a:27:{s:26:\"secure-wordpress/index.php\";s:5:\"3.0.1\";s:35:\"ad-codez-widget/ad-codes-widget.php\";s:6:\"110709\";s:39:\"ad-squares-widget/ad-squares-widget.php\";s:6:\"110709\";s:43:\"all-in-one-seo-pack/all_in_one_seo_pack.php\";s:5:\"2.1.6\";s:27:\"backupbuddy/backupbuddy.php\";s:6:\"2.2.33\";s:39:\"bad-behavior/bad-behavior-wordpress.php\";s:6:\"2.2.15\";s:36:\"contact-form-7/wp-contact-form-7.php\";s:5:\"3.8.1\";s:46:\"custom-post-template/custom-post-templates.php\";s:3:\"1.5\";s:39:\"sitemap-generator/sitemap-generator.php\";s:4:\"3.15\";s:23:\"digg-digg/digg-digg.php\";s:5:\"5.3.6\";s:43:\"easy-privacy-policy/easy-privacy-policy.php\";s:4:\"1.02\";s:36:\"google-sitemap-generator/sitemap.php\";s:5:\"4.0.6\";s:9:\"hello.php\";s:3:\"1.6\";s:32:\"login-lockdown/loginlockdown.php\";s:6:\"v1.6.1\";s:22:\"obox-mobile/mobile.php\";s:5:\"1.1.7\";s:27:\"pretty-link/pretty-link.php\";s:5:\"1.6.5\";s:31:\"quick-adsense/quick-adsense.php\";s:5:\"1.9.2\";s:35:\"simply-show-ids/simply-show-ids.php\";s:5:\"1.3.3\";s:23:\"slideshow/slideshow.php\";s:6:\"1.0.45\";s:30:\"smart-youtube/smartyoutube.php\";s:5:\"4.2.4\";s:25:\"sucuri-scanner/sucuri.php\";s:5:\"1.6.0\";s:65:\"timthumb-vulnerability-scanner/timthumb-vulnerability-scanner.php\";s:4:\"1.53\";s:31:\"youtube-embed/youtube-embed.php\";s:3:\"3.2\";s:25:\"wp-cumulus/wp-cumulus.php\";s:4:\"1.23\";s:27:\"wp-pagenavi/wp-pagenavi.php\";s:4:\"2.85\";s:37:\"wp-content-magic/wp-content-magic.php\";s:3:\"1.2\";s:49:\"wp-graphix-magic-light/wp-graphix-magic-light.php\";s:5:\"1.6.3\";}s:8:\"response\";a:0:{}s:12:\"translations\";a:0:{}}', 'yes');
INSERT INTO `wp_options` VALUES('7884', '_transient_timeout_vye_video_3eb9afcf32a1618bba53bb970e3f0a9d', '1402363145', 'no');
INSERT INTO `wp_options` VALUES('7885', '_transient_vye_video_3eb9afcf32a1618bba53bb970e3f0a9d', '\n<!-- Vixy YouTube Embed v3.2 -->\n<span itemscope=\"itemscope\" xmlns:media=\"http://search.yahoo.com/searchmonkey/media/\" xmlns:dc=\"http://purl.org/dc/terms/\">\n<iframe frameborder=\"0\" style=\"border: 0;\" class=\"youtube-player\" width=\"570\" height=\"390\" src=\"http://www.youtube.com/embed/wnt4KP4B_V8?enablejsapi=1&amp;modestbranding=1&amp;fs=0&amp;rel=0&amp;wmode=opaque\" ></iframe>\n<link itemprop=\"media:video\" rel=\"alternate\" href=\"http://www.youtube.com/v/wnt4KP4B_V8\"/>\n<link itemprop=\"media:thumbnail\" rel=\"icon\" href=\"http://i.ytimg.com/vi/wnt4KP4B_V8/hqdefault.jpg\"/>\n<link itemprop=\"media:thumbnail\" rel=\"icon\" href=\"http://i.ytimg.com/vi/wnt4KP4B_V8/default.jpg\"/>\n<meta itemprop=\"media:title\" content=\"Restore Your Eyesight Naturally With Simple Exercise\"/>\n<meta itemprop=\"media:width\" content=\"570\"/>\n<meta itemprop=\"media:height\" content=\"390\"/>\n	</span>\n<!-- End of YouTube Embed code -->\n', 'no');
INSERT INTO `wp_options` VALUES('7868', '_transient_timeout_vye_type_eeBzqhLlJ8s', '1402435883', 'no');
INSERT INTO `wp_options` VALUES('7869', '_transient_vye_type_eeBzqhLlJ8s', 'v', 'no');
INSERT INTO `wp_options` VALUES('7870', '_transient_timeout_vye_title_eeBzqhLlJ8s', '1402435883', 'no');
INSERT INTO `wp_options` VALUES('7871', '_transient_vye_title_eeBzqhLlJ8s', 'How To Restore Your Vision To 20 20 Restore My Vision Today Guide Restore My Vision Today Review', 'no');
CREATE TABLE `wp_postmeta` (  `meta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `post_id` bigint(20) unsigned NOT NULL DEFAULT '0',  `meta_key` varchar(255) DEFAULT NULL,  `meta_value` longtext,  PRIMARY KEY (`meta_id`),  KEY `post_id` (`post_id`),  KEY `meta_key` (`meta_key`)) ENGINE=MyISAM AUTO_INCREMENT=1659 DEFAULT CHARSET=utf8;
INSERT INTO `wp_postmeta` VALUES('1', '2', '_wp_page_template', 'default');
INSERT INTO `wp_postmeta` VALUES('657', '4', '_mail', 'a:7:{s:7:\"subject\";s:14:\"[your-subject]\";s:6:\"sender\";s:26:\"[your-name] <[your-email]>\";s:4:\"body\";s:193:\"From: [your-name] <[your-email]>\r\nSubject: [your-subject]\r\n\r\nMessage Body:\r\n[your-message]\r\n\r\n--\r\nThis mail is sent via contact form on Blood Pressure Help http://www.plrblogs.com/restorevision\";s:9:\"recipient\";s:23:\"youremail@youremail.com\";s:18:\"additional_headers\";s:0:\"\";s:11:\"attachments\";s:0:\"\";s:8:\"use_html\";s:0:\"\";}');
INSERT INTO `wp_postmeta` VALUES('658', '4', '_mail_2', 'a:8:{s:6:\"active\";s:0:\"\";s:7:\"subject\";s:14:\"[your-subject]\";s:6:\"sender\";s:26:\"[your-name] <[your-email]>\";s:4:\"body\";s:132:\"Message body:\r\n[your-message]\r\n\r\n--\r\nThis mail is sent via contact form on Blood Pressure Help http://www.plrblogs.com/restorevision\";s:9:\"recipient\";s:12:\"[your-email]\";s:18:\"additional_headers\";s:0:\"\";s:11:\"attachments\";s:0:\"\";s:8:\"use_html\";s:0:\"\";}');
INSERT INTO `wp_postmeta` VALUES('659', '4', '_messages', 'a:13:{s:12:\"mail_sent_ok\";s:43:\"Your message was sent successfully. Thanks.\";s:12:\"mail_sent_ng\";s:93:\"Failed to send your message. Please try later or contact the administrator by another method.\";s:16:\"validation_error\";s:74:\"Validation errors occurred. Please confirm the fields and submit it again.\";s:12:\"accept_terms\";s:35:\"Please accept the terms to proceed.\";s:13:\"invalid_email\";s:28:\"Email address seems invalid.\";s:16:\"invalid_required\";s:31:\"Please fill the required field.\";s:17:\"akismet_says_spam\";s:93:\"Failed to send your message. Please try later or contact the administrator by another method.\";s:17:\"captcha_not_match\";s:31:\"Your entered code is incorrect.\";s:13:\"upload_failed\";s:22:\"Failed to upload file.\";s:24:\"upload_file_type_invalid\";s:30:\"This file type is not allowed.\";s:21:\"upload_file_too_large\";s:23:\"This file is too large.\";s:23:\"upload_failed_php_error\";s:38:\"Failed to upload file. Error occurred.\";s:23:\"quiz_answer_not_correct\";s:27:\"Your answer is not correct.\";}');
INSERT INTO `wp_postmeta` VALUES('660', '4', '_additional_settings', '');
INSERT INTO `wp_postmeta` VALUES('7', '2', '_edit_lock', '1353922025:24');
INSERT INTO `wp_postmeta` VALUES('8', '2', '_edit_last', '24');
INSERT INTO `wp_postmeta` VALUES('9', '2', 'image', '');
INSERT INTO `wp_postmeta` VALUES('10', '2', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('11', '2', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('12', '16', '_edit_last', '24');
INSERT INTO `wp_postmeta` VALUES('13', '16', '_edit_lock', '1353922037:24');
INSERT INTO `wp_postmeta` VALUES('14', '16', '_wp_page_template', 'default');
INSERT INTO `wp_postmeta` VALUES('15', '16', 'image', '');
INSERT INTO `wp_postmeta` VALUES('16', '16', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('17', '16', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('18', '19', '_edit_last', '24');
INSERT INTO `wp_postmeta` VALUES('19', '19', '_edit_lock', '1353922065:24');
INSERT INTO `wp_postmeta` VALUES('20', '19', '_wp_page_template', 'default');
INSERT INTO `wp_postmeta` VALUES('21', '19', 'image', '');
INSERT INTO `wp_postmeta` VALUES('22', '19', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('23', '19', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('24', '21', '_edit_last', '28');
INSERT INTO `wp_postmeta` VALUES('25', '21', '_edit_lock', '1402349371:28');
INSERT INTO `wp_postmeta` VALUES('26', '21', '_wp_page_template', 'default');
INSERT INTO `wp_postmeta` VALUES('27', '21', 'image', '');
INSERT INTO `wp_postmeta` VALUES('28', '21', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('29', '21', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('500', '388', 'image', '');
INSERT INTO `wp_postmeta` VALUES('498', '388', '_edit_lock', '1353922044:24');
INSERT INTO `wp_postmeta` VALUES('162', '194', '_wp_attachment_metadata', 'a:6:{s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"250\";s:14:\"hwstring_small\";s:23:\"height=\'96\' width=\'115\'\";s:4:\"file\";s:26:\"2011/12/banner-example.jpg\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:26:\"banner-example-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('161', '194', '_wp_attached_file', '2011/12/banner-example.jpg');
INSERT INTO `wp_postmeta` VALUES('158', '189', '_wp_attachment_metadata', 'a:6:{s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"250\";s:14:\"hwstring_small\";s:23:\"height=\'96\' width=\'115\'\";s:4:\"file\";s:27:\"2011/12/banner-example2.jpg\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:27:\"banner-example2-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('140', '83', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('139', '83', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('138', '83', 'image', '');
INSERT INTO `wp_postmeta` VALUES('135', '83', '_edit_last', '24');
INSERT INTO `wp_postmeta` VALUES('136', '83', '_edit_lock', '1353922058:24');
INSERT INTO `wp_postmeta` VALUES('137', '83', '_wp_page_template', 'sales-page-no-header.php');
INSERT INTO `wp_postmeta` VALUES('157', '189', '_wp_attached_file', '2011/12/banner-example2.jpg');
INSERT INTO `wp_postmeta` VALUES('159', '190', '_wp_attached_file', '2011/12/banner-example3.jpg');
INSERT INTO `wp_postmeta` VALUES('160', '190', '_wp_attachment_metadata', 'a:6:{s:5:\"width\";s:3:\"300\";s:6:\"height\";s:3:\"250\";s:14:\"hwstring_small\";s:23:\"height=\'96\' width=\'115\'\";s:4:\"file\";s:27:\"2011/12/banner-example3.jpg\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:3:{s:4:\"file\";s:27:\"banner-example3-150x150.jpg\";s:5:\"width\";s:3:\"150\";s:6:\"height\";s:3:\"150\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";s:1:\"0\";s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";s:1:\"0\";s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";s:1:\"0\";s:3:\"iso\";s:1:\"0\";s:13:\"shutter_speed\";s:1:\"0\";s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('502', '388', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('501', '388', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('499', '388', '_wp_page_template', 'default');
INSERT INTO `wp_postmeta` VALUES('497', '388', '_edit_last', '24');
INSERT INTO `wp_postmeta` VALUES('778', '18', '_edit_last', '24');
INSERT INTO `wp_postmeta` VALUES('779', '18', '_wp_page_template', 'default');
INSERT INTO `wp_postmeta` VALUES('780', '18', '_edit_lock', '1353922050:24');
INSERT INTO `wp_postmeta` VALUES('656', '4', '_form', '<p>Your Name (required)<br />\r\n    [text* your-name] </p>\r\n\r\n<p>Your Email (required)<br />\r\n    [email* your-email] </p>\r\n\r\n<p>Subject<br />\r\n    [text your-subject] </p>\r\n\r\n<p>Your Message<br />\r\n    [textarea your-message] </p>\r\n\r\n<p>[submit \"Send\"]</p>');
INSERT INTO `wp_postmeta` VALUES('1569', '915', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:300;s:6:\"height\";i:250;s:4:\"file\";s:24:\"2011/12/300x250-S-10.jpg\";s:5:\"sizes\";a:1:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:24:\"300x250-S-10-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1568', '915', '_wp_attached_file', '2011/12/300x250-S-10.jpg');
INSERT INTO `wp_postmeta` VALUES('1570', '915', '_wp_attachment_image_alt', 'Restore My Vision Today');
INSERT INTO `wp_postmeta` VALUES('1571', '916', '_wp_attached_file', '2011/12/468x60-3.jpg');
INSERT INTO `wp_postmeta` VALUES('1572', '916', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:468;s:6:\"height\";i:60;s:4:\"file\";s:20:\"2011/12/468x60-3.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:19:\"468x60-3-150x60.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:60;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:19:\"468x60-3-300x38.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:38;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1573', '916', '_wp_attachment_image_alt', 'Restore My Vision Today');
INSERT INTO `wp_postmeta` VALUES('1574', '917', '_wp_attached_file', '2011/12/468x60-31.jpg');
INSERT INTO `wp_postmeta` VALUES('1575', '917', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:468;s:6:\"height\";i:60;s:4:\"file\";s:21:\"2011/12/468x60-31.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:20:\"468x60-31-150x60.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:60;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:20:\"468x60-31-300x38.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:38;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1576', '917', '_wp_attachment_image_alt', 'Restore My Vision Today');
INSERT INTO `wp_postmeta` VALUES('1595', '926', '_edit_lock', '1402361479:28');
INSERT INTO `wp_postmeta` VALUES('1596', '925', '_edit_last', '28');
INSERT INTO `wp_postmeta` VALUES('1592', '927', '_edit_lock', '1402361478:28');
INSERT INTO `wp_postmeta` VALUES('1593', '926', '_edit_last', '28');
INSERT INTO `wp_postmeta` VALUES('1589', '928', '_edit_lock', '1402361476:28');
INSERT INTO `wp_postmeta` VALUES('1590', '927', '_edit_last', '28');
INSERT INTO `wp_postmeta` VALUES('1587', '928', '_edit_last', '28');
INSERT INTO `wp_postmeta` VALUES('1599', '924', '_edit_last', '28');
INSERT INTO `wp_postmeta` VALUES('1598', '925', '_edit_lock', '1402361480:28');
INSERT INTO `wp_postmeta` VALUES('1602', '923', '_edit_last', '28');
INSERT INTO `wp_postmeta` VALUES('1601', '924', '_edit_lock', '1402361483:28');
INSERT INTO `wp_postmeta` VALUES('1606', '922', '_edit_last', '28');
INSERT INTO `wp_postmeta` VALUES('1604', '923', '_edit_lock', '1402359806:28');
INSERT INTO `wp_postmeta` VALUES('1609', '921', '_edit_last', '28');
INSERT INTO `wp_postmeta` VALUES('1608', '922', '_edit_lock', '1402359828:28');
INSERT INTO `wp_postmeta` VALUES('1612', '920', '_edit_last', '28');
INSERT INTO `wp_postmeta` VALUES('1611', '921', '_edit_lock', '1402359843:28');
INSERT INTO `wp_postmeta` VALUES('1615', '919', '_edit_last', '28');
INSERT INTO `wp_postmeta` VALUES('1614', '920', '_edit_lock', '1402359866:28');
INSERT INTO `wp_postmeta` VALUES('1618', '939', '_wp_attached_file', '2014/06/restore-vision-slider1.jpg');
INSERT INTO `wp_postmeta` VALUES('1617', '919', '_edit_lock', '1402359879:28');
INSERT INTO `wp_postmeta` VALUES('1619', '939', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:580;s:6:\"height\";i:300;s:4:\"file\";s:34:\"2014/06/restore-vision-slider1.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:34:\"restore-vision-slider1-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:34:\"restore-vision-slider1-300x155.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:155;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1620', '940', '_wp_attached_file', '2014/06/restore-vision-slider2.jpg');
INSERT INTO `wp_postmeta` VALUES('1621', '940', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:580;s:6:\"height\";i:300;s:4:\"file\";s:34:\"2014/06/restore-vision-slider2.jpg\";s:5:\"sizes\";a:2:{s:9:\"thumbnail\";a:4:{s:4:\"file\";s:34:\"restore-vision-slider2-150x150.jpg\";s:5:\"width\";i:150;s:6:\"height\";i:150;s:9:\"mime-type\";s:10:\"image/jpeg\";}s:6:\"medium\";a:4:{s:4:\"file\";s:34:\"restore-vision-slider2-300x155.jpg\";s:5:\"width\";i:300;s:6:\"height\";i:155;s:9:\"mime-type\";s:10:\"image/jpeg\";}}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1622', '941', '_wp_attached_file', '2014/06/restore-vision-thumb1.jpg');
INSERT INTO `wp_postmeta` VALUES('1623', '941', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:150;s:6:\"height\";i:150;s:4:\"file\";s:33:\"2014/06/restore-vision-thumb1.jpg\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1624', '942', '_wp_attached_file', '2014/06/restore-vision-thumb2.jpg');
INSERT INTO `wp_postmeta` VALUES('1625', '942', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:150;s:6:\"height\";i:150;s:4:\"file\";s:33:\"2014/06/restore-vision-thumb2.jpg\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1626', '943', '_wp_attached_file', '2014/06/restore-vision-thumb3.jpg');
INSERT INTO `wp_postmeta` VALUES('1627', '943', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:150;s:6:\"height\";i:150;s:4:\"file\";s:33:\"2014/06/restore-vision-thumb3.jpg\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1628', '939', '_edit_lock', '1402361653:28');
INSERT INTO `wp_postmeta` VALUES('1629', '944', '_wp_attached_file', '2014/06/restore-vision-thumb4.jpg');
INSERT INTO `wp_postmeta` VALUES('1630', '944', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:150;s:6:\"height\";i:150;s:4:\"file\";s:33:\"2014/06/restore-vision-thumb4.jpg\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1631', '940', '_edit_lock', '1402361660:28');
INSERT INTO `wp_postmeta` VALUES('1632', '941', '_edit_lock', '1402361398:28');
INSERT INTO `wp_postmeta` VALUES('1633', '945', '_wp_attached_file', '2014/06/restore-vision-thumb5.jpg');
INSERT INTO `wp_postmeta` VALUES('1634', '945', '_wp_attachment_metadata', 'a:5:{s:5:\"width\";i:150;s:6:\"height\";i:150;s:4:\"file\";s:33:\"2014/06/restore-vision-thumb5.jpg\";s:5:\"sizes\";a:0:{}s:10:\"image_meta\";a:10:{s:8:\"aperture\";i:0;s:6:\"credit\";s:0:\"\";s:6:\"camera\";s:0:\"\";s:7:\"caption\";s:0:\"\";s:17:\"created_timestamp\";i:0;s:9:\"copyright\";s:0:\"\";s:12:\"focal_length\";i:0;s:3:\"iso\";i:0;s:13:\"shutter_speed\";i:0;s:5:\"title\";s:0:\"\";}}');
INSERT INTO `wp_postmeta` VALUES('1655', '939', '_wp_attachment_image_alt', 'Discover The Techniques To Get Your Perfect Eyesight Without Surgery!');
INSERT INTO `wp_postmeta` VALUES('1636', '928', 'image', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2014/06/restore-vision-thumb1.jpg');
INSERT INTO `wp_postmeta` VALUES('1637', '928', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('1638', '928', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('1640', '927', 'image', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2014/06/restore-vision-thumb2.jpg');
INSERT INTO `wp_postmeta` VALUES('1641', '927', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('1642', '927', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('1644', '926', 'image', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2014/06/restore-vision-thumb3.jpg');
INSERT INTO `wp_postmeta` VALUES('1645', '926', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('1646', '926', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('1648', '925', 'image', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2014/06/restore-vision-thumb4.jpg');
INSERT INTO `wp_postmeta` VALUES('1649', '925', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('1650', '925', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('1652', '924', 'image', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2014/06/restore-vision-thumb5.jpg');
INSERT INTO `wp_postmeta` VALUES('1653', '924', 'seo_follow', 'false');
INSERT INTO `wp_postmeta` VALUES('1654', '924', 'seo_noindex', 'false');
INSERT INTO `wp_postmeta` VALUES('1656', '939', '_edit_last', '28');
INSERT INTO `wp_postmeta` VALUES('1657', '940', '_wp_attachment_image_alt', 'You Can Improve Your Eyesight Without Prescription Drugs Or Glasses!');
INSERT INTO `wp_postmeta` VALUES('1658', '940', '_edit_last', '28');
CREATE TABLE `wp_posts` (  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `post_author` bigint(20) unsigned NOT NULL DEFAULT '0',  `post_date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `post_date_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `post_content` longtext NOT NULL,  `post_title` text NOT NULL,  `post_excerpt` text NOT NULL,  `post_status` varchar(20) NOT NULL DEFAULT 'publish',  `comment_status` varchar(20) NOT NULL DEFAULT 'open',  `ping_status` varchar(20) NOT NULL DEFAULT 'open',  `post_password` varchar(20) NOT NULL DEFAULT '',  `post_name` varchar(200) NOT NULL DEFAULT '',  `to_ping` text NOT NULL,  `pinged` text NOT NULL,  `post_modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `post_modified_gmt` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `post_content_filtered` longtext NOT NULL,  `post_parent` bigint(20) unsigned NOT NULL DEFAULT '0',  `guid` varchar(255) NOT NULL DEFAULT '',  `menu_order` int(11) NOT NULL DEFAULT '0',  `post_type` varchar(20) NOT NULL DEFAULT 'post',  `post_mime_type` varchar(100) NOT NULL DEFAULT '',  `comment_count` bigint(20) NOT NULL DEFAULT '0',  PRIMARY KEY (`ID`),  KEY `post_name` (`post_name`),  KEY `type_status_date` (`post_type`,`post_status`,`post_date`,`ID`),  KEY `post_parent` (`post_parent`),  KEY `post_author` (`post_author`)) ENGINE=MyISAM AUTO_INCREMENT=946 DEFAULT CHARSET=utf8;
INSERT INTO `wp_posts` VALUES('2', '28', '2012-11-08 04:18:50', '2012-11-08 04:18:50', 'This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors.', 'About', '', 'publish', 'open', 'closed', '', 'about', '', '', '2012-11-26 09:27:05', '2012-11-26 09:27:05', '', '0', 'http://www.plrblogs.com/bloodpressure/?page_id=2', '0', 'page', '', '0');
INSERT INTO `wp_posts` VALUES('16', '28', '2012-11-08 21:22:43', '2012-11-08 21:22:43', '[contact-form-7 id=\"4\" title=\"Contact form 1\"]', 'Contact', '', 'publish', 'open', 'closed', '', 'contact', '', '', '2012-11-26 09:27:17', '2012-11-26 09:27:17', '', '0', 'http://www.plrblogs.com/bloodpressure/?page_id=16', '0', 'page', '', '0');
INSERT INTO `wp_posts` VALUES('17', '28', '2011-12-08 21:22:38', '2011-12-08 21:22:38', '', 'Contact', '', 'inherit', 'open', 'open', '', '16-revision', '', '', '2011-12-08 21:22:38', '2011-12-08 21:22:38', '', '16', 'http://www.plrblogs.com/bloodpressure/uncategorized/16-revision', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('18', '28', '2012-11-08 21:23:31', '2012-11-08 21:23:31', '<strong>Your Privacy</strong><br/>Your privacy is important to us. To better protect your privacy we provide this notice explaining our online information practices and the choices you can make about the way your information is collected and used. To make this notice easy to find, we make it available on our homepage and at every point where personally identifiable information may be requested.<p/><strong>Google Adsense and the DoubleClick DART Cookie</strong><br/>Google, as a third party advertisement vendor, uses cookies to serve ads on this site. The use of DART cookies by Google enables them to serve adverts to visitors that are based on their visits to this website as well as other sites on the internet.\r\n\r\nTo opt out of the DART cookies you may visit the Google ad and content network privacy policy at the following url <a href=\"http://www.google.com/privacy_ads.html\">http://www.google.com/privacy_ads.html</a> Tracking of users through the DART cookie mechanisms are subject to Google\'s own privacy policies.\r\n\r\nOther Third Party ad servers or ad networks may also use cookies to track users activities on this website to measure advertisement effectiveness and other reasons that will be provided in their own privacy policies,  has no access or control over these cookies that may be used by third party advertisers.<p/><strong>Collection of Personal Information</strong><br/>When visiting , the IP address used to access the site will be logged along with the dates and times of access. This information is purely used to analyze trends, administer the site, track users movement and gather broad demographic information for internal use. Most importantly, any recorded IP addresses are not linked to personally identifiable information.\r\n<p/><strong>Links to third party Websites</strong><br/>We have included links on this site for your use and reference. We are not responsible for the privacy policies on these websites. You should be aware that the privacy policies of these sites may differ from our own. \r\n<p/><strong>Changes to this Privacy Statement</strong><br/>The contents of this statement may be altered at any time, at our discretion. \r\n\r\nIf you have any questions regarding the privacy policy of  then you may contact us at <p/>', 'Privacy Policy', '', 'publish', 'closed', 'closed', '', 'privacy-policy', '', '', '2012-11-26 09:27:30', '2012-11-26 09:27:30', '', '0', 'http://www.plrblogs.com/bloodpressure/privacy-policy', '0', 'page', '', '0');
INSERT INTO `wp_posts` VALUES('4', '28', '2011-12-08 20:59:30', '2011-12-08 20:59:30', '', 'Contact form 1', '', 'publish', 'closed', 'open', '', 'contact-form-1', '', '', '2011-12-08 20:59:30', '2011-12-08 20:59:30', '', '0', 'http://www.plrblogs.com/bloodpressure/?wpcf7_contact_form=contact-form-1', '0', 'wpcf7_contact_form', '', '0');
INSERT INTO `wp_posts` VALUES('5', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Logo', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_logo', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=5', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('6', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Custom Favicon', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_custom_favicon', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=6', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('7', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Aff1 Banner Url 1', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_aff1_banner_url_1', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=7', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('8', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Aff1 Banner Url 2', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_aff1_banner_url_2', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=8', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('9', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Aff1 Banner Url 3', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_aff1_banner_url_3', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=9', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('10', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Aff2 Banner Url 1', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_aff2_banner_url_1', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=10', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('11', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Aff2 Banner Url 2', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_aff2_banner_url_2', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=11', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('12', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Aff2 Banner Url 3', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_aff2_banner_url_3', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=12', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('13', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Ad Top Image', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_ad_top_image', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=13', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('14', '28', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', 'Woo Ad Content Image', '', 'draft', 'closed', 'closed', '', 'woo-wf-woo_ad_content_image', '', '', '2011-12-08 07:08:15', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/bloodpressure/?post_type=wooframework&p=14', '0', 'wooframework', '', '0');
INSERT INTO `wp_posts` VALUES('15', '28', '2011-12-08 04:18:50', '2011-12-08 04:18:50', 'This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors. It might say something like this:\n\n<blockquote>Hi there! I\'m a bike messenger by day, aspiring actor by night, and this is my blog. I live in Los Angeles, have a great dog named Jack, and I like pi&#241;a coladas. (And gettin\' caught in the rain.)</blockquote>\n\n...or something like this:\n\n<blockquote>The XYZ Doohickey Company was founded in 1971, and has been providing quality doohickies to the public ever since. Located in Gotham City, XYZ employs over 2,000 people and does all kinds of awesome things for the Gotham community.</blockquote>\n\nAs a new WordPress user, you should go to <a href=\"http://www.plrblogs.com/restorevision/wp-admin/\">your dashboard</a> to delete this page and create new pages for your content. Have fun!', 'Sample Page', '', 'inherit', 'open', 'open', '', '2-revision', '', '', '2011-12-08 04:18:50', '2011-12-08 04:18:50', '', '2', 'http://www.plrblogs.com/bloodpressure/?p=15', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('19', '28', '2012-11-08 21:24:17', '2012-11-08 21:24:17', '<!-- ddsitemapgen -->', 'Sitemap', '', 'publish', 'open', 'closed', '', 'sitemap', '', '', '2012-11-26 09:27:45', '2012-11-26 09:27:45', '', '0', 'http://www.plrblogs.com/bloodpressure/?page_id=19', '0', 'page', '', '0');
INSERT INTO `wp_posts` VALUES('20', '28', '2011-12-08 21:23:55', '2011-12-08 21:23:55', '', 'Sitemap', '', 'inherit', 'open', 'open', '', '19-revision', '', '', '2011-12-08 21:23:55', '2011-12-08 21:23:55', '', '19', 'http://www.plrblogs.com/bloodpressure/uncategorized/19-revision', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('21', '28', '2013-10-08 21:25:50', '2013-10-08 21:25:50', '[youtube width=570 height=390]IK0w7mfqMSc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]wnt4KP4B_V8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]eeBzqhLlJ8s[/youtube]', 'Restore Your Vision Videos', '', 'publish', 'open', 'closed', '', 'restore-your-vision-videos', '', '', '2014-06-09 21:31:14', '2014-06-09 21:31:14', '', '0', 'http://www.plrblogs.com/bloodpressure/?page_id=21', '0', 'page', '', '0');
INSERT INTO `wp_posts` VALUES('913', '28', '2014-06-09 02:12:25', '2014-06-09 02:12:25', '[youtube width=570 height=390][/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390][/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390][/youtube]', 'Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2014-06-09 02:12:25', '2014-06-09 02:12:25', '', '21', 'http://www.plrblogs.com/deckplans/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('912', '28', '2014-06-09 02:12:03', '2014-06-09 02:12:03', '[youtube width=570 height=390]d_t8mN4mMtc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]0iboZWCPzsE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]HhB8tzWpJqI[/youtube]', 'Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2014-06-09 02:12:03', '2014-06-09 02:12:03', '', '21', 'http://www.plrblogs.com/deckplans/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('869', '28', '2013-11-11 20:49:16', '2013-11-11 20:49:16', '<ul>\r\n[youtube width=570 height=390][/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390][/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390][/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390][/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-11-11 20:49:16', '2013-11-11 20:49:16', '', '21', 'http://www.plrblogs.com/aviarybirdhouseplans/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('22', '28', '2011-12-08 21:25:20', '2011-12-08 21:25:20', '', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:25:20', '2011-12-08 21:25:20', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('23', '28', '2011-12-08 21:25:50', '2011-12-08 21:25:50', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]J2C_7QLwsnc[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=270 height=200]IBbEBFsfheU[/youtube]</span>[youtube width=270 height=200]I3BxvHhz4XQ[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=270 height=200]h_FZMRZ1_Xg[/youtube]</span>[youtube width=270 height=200]UFSc3rrAYLQ[/youtube]', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:25:50', '2011-12-08 21:25:50', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision-2', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('24', '28', '2011-12-08 21:26:50', '2011-12-08 21:26:50', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]nrfj4LM5qj8[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=270 height=200]ONytpf8Rihs[/youtube]</span>[youtube width=270 height=200]ztYRWoKGBnY[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=270 height=200]vWK6vWGeSMQ[/youtube]</span>[youtube width=270 height=200]i03mt72s5QU[/youtube]', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:26:50', '2011-12-08 21:26:50', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision-3', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('25', '28', '2011-12-08 21:27:16', '2011-12-08 21:27:16', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]nrfj4LM5qj8[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=260 height=200]ONytpf8Rihs[/youtube]</span>[youtube width=260 height=200]ztYRWoKGBnY[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=260 height=200]vWK6vWGeSMQ[/youtube]</span>[youtube width=260 height=200]i03mt72s5QU[/youtube]', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:27:16', '2011-12-08 21:27:16', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision-4', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('26', '28', '2011-12-08 21:27:38', '2011-12-08 21:27:38', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]nrfj4LM5qj8[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=250 height=200]ONytpf8Rihs[/youtube]</span>[youtube width=250 height=200]ztYRWoKGBnY[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=250 height=200]vWK6vWGeSMQ[/youtube]</span>[youtube width=250 height=200]i03mt72s5QU[/youtube]', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:27:38', '2011-12-08 21:27:38', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision-5', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('27', '28', '2011-12-08 21:29:07', '2011-12-08 21:29:07', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]nrfj4LM5qj8[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=200 height=200]ONytpf8Rihs[/youtube]</span>[youtube width=200 height=200]ztYRWoKGBnY[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=250 height=200]vWK6vWGeSMQ[/youtube]</span>[youtube width=250 height=200]i03mt72s5QU[/youtube]', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:29:07', '2011-12-08 21:29:07', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision-6', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('28', '28', '2011-12-08 21:45:04', '2011-12-08 21:45:04', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]nrfj4LM5qj8[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0; display:inline-block;\">[youtube width=200 height=200]ONytpf8Rihs[/youtube]</span>[youtube width=200 height=200]ztYRWoKGBnY[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0;\">[youtube width=250 height=200]vWK6vWGeSMQ[/youtube]</span>[youtube width=250 height=200]i03mt72s5QU[/youtube]', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:45:04', '2011-12-08 21:45:04', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision-7', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('29', '28', '2014-06-09 21:30:57', '2014-06-09 21:30:57', '[youtube width=570 height=390]IK0w7mfqMSc[/youtube]\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\n[youtube width=570 height=390][/youtube]\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\n[youtube width=570 height=390][/youtube]', 'Restore Your Vision Videos', '', 'inherit', 'open', 'open', '', '21-autosave-v1', '', '', '2014-06-09 21:30:57', '2014-06-09 21:30:57', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-autosave', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('918', '28', '2014-06-09 21:31:14', '2014-06-09 21:31:14', '[youtube width=570 height=390]IK0w7mfqMSc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]wnt4KP4B_V8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]eeBzqhLlJ8s[/youtube]', 'Restore Your Vision Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2014-06-09 21:31:14', '2014-06-09 21:31:14', '', '21', 'http://www.plrblogs.com/restorevision/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('743', '28', '2013-07-05 13:31:56', '2013-07-05 13:31:56', 'Beer Brewing Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]Kw8wV5NkOf4[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]otxFTHi1bKY[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]Ay2_RpC7JRw[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]5WGHkNPqCS8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]6f1jJ_K8hhk[/youtube]', 'Angular Cheilitis Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-07-05 13:31:56', '2013-07-05 13:31:56', '', '21', 'http://www.plrblogs.com/angularcheilitis/uncategorized/21-revision-26', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('82', '28', '2011-12-09 06:10:24', '2011-12-09 06:10:24', 'This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors.', 'About', '', 'inherit', 'open', 'open', '', '2-autosave', '', '', '2011-12-09 06:10:24', '2011-12-09 06:10:24', '', '2', 'http://www.plrblogs.com/bloodpressure/uncategorized/2-autosave', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('30', '28', '2011-12-08 21:45:41', '2011-12-08 21:45:41', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]nrfj4LM5qj8[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0; display:inline-block;\">[youtube width=200 height=200]ONytpf8Rihs[/youtube]</span>[youtube width=200 height=200]ztYRWoKGBnY[/youtube]</span>\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n<span style=\"padding: 10px 15px 10px 0; display:inline-block;\">[youtube width=250 height=200]vWK6vWGeSMQ[/youtube]</span>[youtube width=250 height=200]i03mt72s5QU[/youtube]</span>', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:45:41', '2011-12-08 21:45:41', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision-8', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('31', '28', '2011-12-08 21:47:28', '2011-12-08 21:47:28', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]nrfj4LM5qj8[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n[youtube width=570 height=390]ONytpf8Rihs[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n[youtube width=570 height=390]ztYRWoKGBnY[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n[youtube width=570 height=390]vWK6vWGeSMQ[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"Zygor World of Warcraft Guides\" href=\"http://46fdail846o5-c3prt-qsj6rc3.hop.clickbank.net/\" target=\"_blank\"><img src=\"http://www.zygorguides.com/affiliates/ads/levelingbanner1.jpg\" alt=\"Zygor World of Warcraft Guides\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n[youtube width=570 height=390]i03mt72s5QU[/youtube]', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:47:28', '2011-12-08 21:47:28', '', '21', 'http://www.plrblogs.com/bloodpressure/uncategorized/21-revision-9', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('385', '28', '2012-04-24 08:57:26', '2012-04-24 08:57:26', 'Acne Scar Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]uCtUI6Ot_ns[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]1AQBZYUltq8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]CrvBApGYEYw[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]qiIZJJ9l5ZU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]g4j1BMWAGAs[/youtube]', 'Acne Scar Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-04-24 08:57:26', '2012-04-24 08:57:26', '', '21', 'http://www.plrblogs.com/acnescars/uncategorized/21-revision-16', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('389', '28', '2012-04-25 12:31:06', '2012-04-25 12:31:06', '', 'Disclosure Policy', '', 'inherit', 'open', 'open', '', '388-revision', '', '', '2012-04-25 12:31:06', '2012-04-25 12:31:06', '', '388', 'http://www.plrblogs.com/acnescars/uncategorized/388-revision', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('294', '28', '2011-12-08 21:49:13', '2011-12-08 21:49:13', 'Blood Pressure Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]nrfj4LM5qj8[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n[youtube width=570 height=390]ONytpf8Rihs[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n[youtube width=570 height=390]ztYRWoKGBnY[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n[youtube width=570 height=390]vWK6vWGeSMQ[/youtube]\r\n\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n\r\n[youtube width=570 height=390]i03mt72s5QU[/youtube]', 'Blood Pressure Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2011-12-08 21:49:13', '2011-12-08 21:49:13', '', '21', 'http://www.plrblogs.com/wartremoval/uncategorized/21-revision-10', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('380', '28', '2012-02-16 14:50:50', '2012-02-16 14:50:50', 'Wart Removal Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]eIRmCGwurmE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]im5RzdwrhcU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]xsNOZdwWk5Q[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]g1g3DzM7rz8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]HiooHVe2Cdw[/youtube]', 'Wart Removal Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-02-16 14:50:50', '2012-02-16 14:50:50', '', '21', 'http://www.plrblogs.com/acnescars/uncategorized/21-revision-11', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('381', '28', '2012-04-24 05:59:17', '2012-04-24 05:59:17', 'Wart Removal Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]eIRmCGwurmE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]im5RzdwrhcU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]xsNOZdwWk5Q[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]g1g3DzM7rz8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]HiooHVe2Cdw[/youtube]', 'Acne Scar Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-04-24 05:59:17', '2012-04-24 05:59:17', '', '21', 'http://www.plrblogs.com/acnescars/uncategorized/21-revision-12', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('382', '28', '2012-04-24 05:59:24', '2012-04-24 05:59:24', 'Wart Removal Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]eIRmCGwurmE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]im5RzdwrhcU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]xsNOZdwWk5Q[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]g1g3DzM7rz8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]HiooHVe2Cdw[/youtube]', 'Acne Scar Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-04-24 05:59:24', '2012-04-24 05:59:24', '', '21', 'http://www.plrblogs.com/acnescars/uncategorized/21-revision-13', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('383', '28', '2012-04-24 05:59:30', '2012-04-24 05:59:30', 'Wart Removal Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]eIRmCGwurmE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]im5RzdwrhcU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]xsNOZdwWk5Q[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]g1g3DzM7rz8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]HiooHVe2Cdw[/youtube]', 'Acne Scar Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-04-24 05:59:30', '2012-04-24 05:59:30', '', '21', 'http://www.plrblogs.com/acnescars/uncategorized/21-revision-14', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('384', '28', '2012-04-24 08:56:28', '2012-04-24 08:56:28', 'Wart Removal Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]uCtUI6Ot_ns[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]1AQBZYUltq8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]CrvBApGYEYw[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]qiIZJJ9l5ZU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]g4j1BMWAGAs[/youtube]', 'Acne Scar Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-04-24 08:56:28', '2012-04-24 08:56:28', '', '21', 'http://www.plrblogs.com/acnescars/uncategorized/21-revision-15', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('194', '28', '2011-12-11 20:36:21', '2011-12-11 20:36:21', '', 'banner-example', '', 'inherit', 'open', 'open', '', 'banner-example', '', '', '2011-12-11 20:36:21', '2011-12-11 20:36:21', '', '0', 'http://www.plrblogs.com/bloodpressure/wp-content/uploads/2011/12/banner-example.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('392', '28', '2012-04-25 12:41:42', '2012-04-25 12:41:42', 'While it is a good practice for the visitor of any review site to treat every product recommendation with a healthy degree of skepticism, it would be a mistake to assume that every review is invalid just because there may be a commission paid to the reviewer. Here are some of the readers protections we attempt to build into our reviews:\r\n\r\n1. Many of the reviews contain lots of factual information that is easily verifiable. We always try to provide an honest and accurate assessment.\r\n\r\n2. The review includes a section that is a subjective summary. This is based on the personal experience of the reviewer.\r\n\r\n3. Attempts are made to establish the general consensus in relation to specific products by reading reviews of those products on other sites, along with user testimonials and we attempt to portray this overall perception in our reviews.\r\n\r\n4. We always provide links to the manufacturers\' website to provide additional information that is not available in our reviews. Some of this information can include customer testimonials, more specific product details, sales information, free newsletters and even samples.\r\n\r\nThese are good rules of practice. It is important for you as a consumer to understand the relationship between a person reviewing the product and the manufacturer.\r\n\r\nIf you do not see a disclosure policy on a review site, that reviewer may be committing an offense.\r\n\r\nI hope that you have a useful and meaningful experience as a direct result of our detailed reviews and articles. We welcome any feedback that may help us to improve your experience when visiting this website.\r\n\r\nOur website makes no representations, warranties, or assurances as to the accuracy, currency or completeness of the content contain on this website or any sites linked to this site.', 'Disclosure Policy', '', 'inherit', 'open', 'open', '', '388-revision-4', '', '', '2012-04-25 12:41:42', '2012-04-25 12:41:42', '', '388', 'http://www.plrblogs.com/acnescars/uncategorized/388-revision-4', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('460', '28', '2012-04-24 09:12:53', '2012-04-24 09:12:53', 'Acne Scar Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]uCtUI6Ot_ns[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]1AQBZYUltq8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]CrvBApGYEYw[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]qiIZJJ9l5ZU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]g4j1BMWAGAs[/youtube]', 'Acne Scar Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-04-24 09:12:53', '2012-04-24 09:12:53', '', '21', 'http://www.plrblogs.com/clickbank/uncategorized/21-revision-17', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('77', '28', '2011-12-09 03:04:10', '2011-12-09 03:04:10', '', 'Sitemap', '', 'inherit', 'open', 'open', '', '19-autosave', '', '', '2011-12-09 03:04:10', '2011-12-09 03:04:10', '', '19', 'http://www.plrblogs.com/bloodpressure/uncategorized/19-autosave', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('83', '28', '2012-10-09 13:33:36', '2012-10-09 13:33:36', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'draft', 'open', 'closed', '', 'sample-sales-page', '', '', '2012-11-26 09:27:38', '2012-11-26 09:27:38', '', '0', 'http://www.plrblogs.com/bloodpressure/?page_id=83', '0', 'page', '', '0');
INSERT INTO `wp_posts` VALUES('142', '28', '2011-12-09 18:41:51', '2011-12-09 18:41:51', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-58', '', '', '2011-12-09 18:41:51', '2011-12-09 18:41:51', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-58', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('126', '28', '2011-12-09 16:13:49', '2011-12-09 16:13:49', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]Mention about your Superb Guarantee Policy![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-42', '', '', '2011-12-09 16:13:49', '2011-12-09 16:13:49', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-42', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('85', '28', '2011-12-09 13:33:36', '2011-12-09 13:33:36', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" ]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" ]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-2', '', '', '2011-12-09 13:33:36', '2011-12-09 13:33:36', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-2', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('84', '28', '2011-12-09 13:32:38', '2011-12-09 13:32:38', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" ]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\n\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" ]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\n\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\n\nAdd Feature/Benefit Bullet Points Here!\n\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\n<ul>\n<li class=\"bullet\">Control background color, border color, and even border radius!</li>\n<li class=\"bullet\">Control width of page, padding (spacing) of inside page area!</li>\n<li class=\"bullet\">Comes with the FREE version of WP Graphix Magic, my newest plugin!</li>\n<li class=\"bullet\">Highlight text, add colored buttons, add badges, bullets, Buy Now Buttons!</li>\n<li class=\"bullet\">and much more!</li>\n</ul>\n[/wpgfxm_bullets]\n[/wpgfxm_contentbox]\n\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\n\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\n\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\n\n[wpgfxm_divider divider_image=\"divider-2\" ]\n\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\n\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\n\nHere is some text you can enter\n\n[wpgfxm_bullets bullet=\"green-arrow\"]\n<ul>\n<li class=\"bullet\">Enter List Info Enter List Info Enter List Info Enter List Info</li>\n<li class=\"bullet\">Enter List InfoEnter List Info Enter List Info Enter List Info Enter List Info</li>\n<li class=\"bullet\">Enter List InfoEnter List Info Enter List Info Enter List Info Enter List Info</li>\n</ul>\n[/wpgfxm_bullets]\n\n[/wpgfxm_contentbox]\n\n&nbsp;\n\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\n\n[/wpgfxm_salesboxes]\n\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\n\n[wpgfxm_bullets bullet=\"green-tick-3\"]\n<ul>\n<li class=\"bullet\">Enter List Info</li>\n<li class=\"bullet\">Enter List Info</li>\n<li class=\"bullet\">Enter List Info</li>\n</ul>\n[/wpgfxm_bullets]\n\n[wpgfxm_bullets bullet=\"green-arrow\"]\n<ul>\n<li class=\"bullet\">Enter List Info</li>\n<li class=\"bullet\">Enter List Info</li>\n<li class=\"bullet\">Enter List Info</li>\n</ul>\n[/wpgfxm_bullets]\n\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\n<ul>\n<li class=\"bullet\">Enter List Info</li>\n<li class=\"bullet\">Enter List Info</li>\n<li class=\"bullet\">Enter List Info</li>\n</ul>\n[/wpgfxm_bullets]\n\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\n\n[wpgfxm_divider divider_image=\"divider-1\" ]\n\n[wpgfxm_divider divider_image=\"divider-2\" ]\n\n[wpgfxm_divider divider_image=\"css\" ]\n\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\n\n&nbsp;\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\n\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\n\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\n\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\n\n&nbsp;\n\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\n\n&nbsp;\n\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\n\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\n\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\n\n&nbsp;\n\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\n\n&nbsp;\n\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\n\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\n\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision', '', '', '2011-12-09 13:32:38', '2011-12-09 13:32:38', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('86', '28', '2011-12-09 13:35:48', '2011-12-09 13:35:48', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" ]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" ]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-3', '', '', '2011-12-09 13:35:48', '2011-12-09 13:35:48', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-3', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('87', '28', '2011-12-09 13:36:25', '2011-12-09 13:36:25', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" ]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" ]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-4', '', '', '2011-12-09 13:36:25', '2011-12-09 13:36:25', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-4', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('88', '28', '2011-12-12 01:25:47', '2011-12-12 01:25:47', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\n\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\n\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\n\n&nbsp;\n\nFrom the desk of: John Smith\n\n<strong>Dear site visitor,</strong>\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\n\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\n\nAdd Feature/Benefit Bullet Points Here!\n\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\n<ul>\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\n</ul>\n[/wpgfxm_bullets]\n[/wpgfxm_contentbox]\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\n\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\n\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\n\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\n\nHere you mention about your superb money back, 100% satisfaction guarantee!\n\n&nbsp;\n\n[/wpgfxm_contentbox]\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\n\n[wpgfxm_divider divider_image=\"divider-1\"]\n\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\n\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\n\n[wpgfxm_divider divider_image=\"divider-2\" ]\n\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\n\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\n\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\n\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\n\nHere is some text you can enter\n\n[wpgfxm_bullets bullet=\"green-arrow\"]\n<ul>\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\n</ul>\n[/wpgfxm_bullets]\n\n[/wpgfxm_contentbox]\n\n&nbsp;\n\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\n\n[/wpgfxm_salesboxes]\n\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-autosave', '', '', '2011-12-12 01:25:47', '2011-12-12 01:25:47', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-autosave', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('125', '28', '2011-12-09 15:51:08', '2011-12-09 15:51:08', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-41', '', '', '2011-12-09 15:51:08', '2011-12-09 15:51:08', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-41', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('90', '28', '2011-12-09 13:46:33', '2011-12-09 13:46:33', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\" ]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" ]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-6', '', '', '2011-12-09 13:46:33', '2011-12-09 13:46:33', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-6', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('89', '28', '2011-12-09 13:37:00', '2011-12-09 13:37:00', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" ]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" ]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-5', '', '', '2011-12-09 13:37:00', '2011-12-09 13:37:00', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-5', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('91', '28', '2011-12-09 13:47:41', '2011-12-09 13:47:41', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\nIt\'s never been easier to create custom sales pages like this, all within seconds!\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-7', '', '', '2011-12-09 13:47:41', '2011-12-09 13:47:41', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-7', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('124', '28', '2011-12-09 15:50:36', '2011-12-09 15:50:36', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-40', '', '', '2011-12-09 15:50:36', '2011-12-09 15:50:36', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-40', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('92', '28', '2011-12-09 13:48:28', '2011-12-09 13:48:28', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-8', '', '', '2011-12-09 13:48:28', '2011-12-09 13:48:28', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-8', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('98', '28', '2011-12-09 13:51:01', '2011-12-09 13:51:01', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-14', '', '', '2011-12-09 13:51:01', '2011-12-09 13:51:01', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-14', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('93', '28', '2011-12-09 13:48:52', '2011-12-09 13:48:52', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-9', '', '', '2011-12-09 13:48:52', '2011-12-09 13:48:52', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-9', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('94', '28', '2011-12-09 13:49:07', '2011-12-09 13:49:07', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"150%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-10', '', '', '2011-12-09 13:49:07', '2011-12-09 13:49:07', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-10', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('95', '28', '2011-12-09 13:49:28', '2011-12-09 13:49:28', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-11', '', '', '2011-12-09 13:49:28', '2011-12-09 13:49:28', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-11', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('96', '28', '2011-12-09 13:49:39', '2011-12-09 13:49:39', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-12', '', '', '2011-12-09 13:49:39', '2011-12-09 13:49:39', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-12', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('97', '28', '2011-12-09 13:50:15', '2011-12-09 13:50:15', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-13', '', '', '2011-12-09 13:50:15', '2011-12-09 13:50:15', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-13', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('99', '28', '2011-12-09 13:51:25', '2011-12-09 13:51:25', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-15', '', '', '2011-12-09 13:51:25', '2011-12-09 13:51:25', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-15', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('100', '28', '2011-12-09 13:51:42', '2011-12-09 13:51:42', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-16', '', '', '2011-12-09 13:51:42', '2011-12-09 13:51:42', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-16', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('101', '28', '2011-12-09 13:52:05', '2011-12-09 13:52:05', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-17', '', '', '2011-12-09 13:52:05', '2011-12-09 13:52:05', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-17', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('102', '28', '2011-12-09 13:57:02', '2011-12-09 13:57:02', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"90%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-18', '', '', '2011-12-09 13:57:02', '2011-12-09 13:57:02', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-18', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('103', '28', '2011-12-09 13:57:18', '2011-12-09 13:57:18', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-19', '', '', '2011-12-09 13:57:18', '2011-12-09 13:57:18', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-19', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('105', '28', '2011-12-09 14:26:38', '2011-12-09 14:26:38', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-21', '', '', '2011-12-09 14:26:38', '2011-12-09 14:26:38', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-21', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('123', '28', '2011-12-09 15:07:02', '2011-12-09 15:07:02', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-39', '', '', '2011-12-09 15:07:02', '2011-12-09 15:07:02', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-39', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('104', '28', '2011-12-09 14:24:27', '2011-12-09 14:24:27', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"50%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-20', '', '', '2011-12-09 14:24:27', '2011-12-09 14:24:27', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-20', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('106', '28', '2011-12-09 14:27:07', '2011-12-09 14:27:07', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"50%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-22', '', '', '2011-12-09 14:27:07', '2011-12-09 14:27:07', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-22', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('107', '28', '2011-12-09 14:27:20', '2011-12-09 14:27:20', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"70%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-23', '', '', '2011-12-09 14:27:20', '2011-12-09 14:27:20', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-23', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('108', '28', '2011-12-09 14:27:31', '2011-12-09 14:27:31', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"80%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-24', '', '', '2011-12-09 14:27:31', '2011-12-09 14:27:31', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-24', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('109', '28', '2011-12-09 14:27:43', '2011-12-09 14:27:43', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"90%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-25', '', '', '2011-12-09 14:27:43', '2011-12-09 14:27:43', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-25', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('113', '28', '2011-12-09 14:41:17', '2011-12-09 14:41:17', '&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-29', '', '', '2011-12-09 14:41:17', '2011-12-09 14:41:17', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-29', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('110', '28', '2011-12-09 14:28:00', '2011-12-09 14:28:00', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"100%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-26', '', '', '2011-12-09 14:28:00', '2011-12-09 14:28:00', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-26', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('111', '28', '2011-12-09 14:28:21', '2011-12-09 14:28:21', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"200%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-27', '', '', '2011-12-09 14:28:21', '2011-12-09 14:28:21', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-27', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('112', '28', '2011-12-09 14:40:55', '2011-12-09 14:40:55', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"100%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-28', '', '', '2011-12-09 14:40:55', '2011-12-09 14:40:55', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-28', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('114', '28', '2011-12-09 14:41:38', '2011-12-09 14:41:38', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"50%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-30', '', '', '2011-12-09 14:41:38', '2011-12-09 14:41:38', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-30', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('115', '28', '2011-12-09 14:48:38', '2011-12-09 14:48:38', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"20%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-31', '', '', '2011-12-09 14:48:38', '2011-12-09 14:48:38', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-31', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('117', '28', '2011-12-09 15:01:46', '2011-12-09 15:01:46', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"50%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-33', '', '', '2011-12-09 15:01:46', '2011-12-09 15:01:46', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-33', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('116', '28', '2011-12-09 15:00:09', '2011-12-09 15:00:09', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"100%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-32', '', '', '2011-12-09 15:00:09', '2011-12-09 15:00:09', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-32', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('118', '28', '2011-12-09 15:02:06', '2011-12-09 15:02:06', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"30%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-34', '', '', '2011-12-09 15:02:06', '2011-12-09 15:02:06', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-34', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('119', '28', '2011-12-09 15:02:19', '2011-12-09 15:02:19', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"40%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-35', '', '', '2011-12-09 15:02:19', '2011-12-09 15:02:19', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-35', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('120', '28', '2011-12-09 15:02:48', '2011-12-09 15:02:48', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"60%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-36', '', '', '2011-12-09 15:02:48', '2011-12-09 15:02:48', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-36', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('121', '28', '2011-12-09 15:03:03', '2011-12-09 15:03:03', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"10%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-37', '', '', '2011-12-09 15:03:03', '2011-12-09 15:03:03', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-37', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('122', '28', '2011-12-09 15:03:15', '2011-12-09 15:03:15', '[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" resize=\"20%\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-38', '', '', '2011-12-09 15:03:15', '2011-12-09 15:03:15', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-38', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('127', '28', '2011-12-09 16:14:18', '2011-12-09 16:14:18', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]Mention about your Superb Guarantee Policy![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-43', '', '', '2011-12-09 16:14:18', '2011-12-09 16:14:18', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-43', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('128', '28', '2011-12-09 16:15:00', '2011-12-09 16:15:00', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]Mention about your Superb Guarantee Policy![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-44', '', '', '2011-12-09 16:15:00', '2011-12-09 16:15:00', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-44', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('129', '28', '2011-12-09 16:21:20', '2011-12-09 16:21:20', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]Mention about your Superb Guarantee Policy![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-45', '', '', '2011-12-09 16:21:20', '2011-12-09 16:21:20', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-45', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('132', '28', '2011-12-09 16:51:39', '2011-12-09 16:51:39', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]Your 30/60/90 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-48', '', '', '2011-12-09 16:51:39', '2011-12-09 16:51:39', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-48', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('131', '28', '2011-12-09 16:27:16', '2011-12-09 16:27:16', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]Mention about your Superb Guarantee Policy! Mention about your Superb Guarantee Policy! Mention about your Superb Guarantee Policy! Mention about your Superb Guarantee Policy![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-47', '', '', '2011-12-09 16:27:16', '2011-12-09 16:27:16', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-47', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('130', '28', '2011-12-09 16:24:15', '2011-12-09 16:24:15', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]Mention about your Superb Guarantee Policy! Mention about your Superb Guarantee Policy! Mention about your Superb Guarantee Policy! Mention about your Superb Guarantee Policy![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-46', '', '', '2011-12-09 16:24:15', '2011-12-09 16:24:15', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-46', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('141', '28', '2011-12-09 18:40:58', '2011-12-09 18:40:58', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-57', '', '', '2011-12-09 18:40:58', '2011-12-09 18:40:58', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-57', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('133', '28', '2011-12-09 16:52:25', '2011-12-09 16:52:25', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30/60/90 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-49', '', '', '2011-12-09 16:52:25', '2011-12-09 16:52:25', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-49', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('135', '28', '2011-12-09 16:56:41', '2011-12-09 16:56:41', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30/60/90 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-51', '', '', '2011-12-09 16:56:41', '2011-12-09 16:56:41', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-51', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('134', '28', '2011-12-09 16:52:47', '2011-12-09 16:52:47', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30/60/90 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-50', '', '', '2011-12-09 16:52:47', '2011-12-09 16:52:47', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-50', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('136', '28', '2011-12-09 16:57:17', '2011-12-09 16:57:17', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30/60/90 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-52', '', '', '2011-12-09 16:57:17', '2011-12-09 16:57:17', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-52', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('137', '28', '2011-12-09 16:57:56', '2011-12-09 16:57:56', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"18px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-53', '', '', '2011-12-09 16:57:56', '2011-12-09 16:57:56', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-53', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('138', '28', '2011-12-09 16:58:22', '2011-12-09 16:58:22', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-54', '', '', '2011-12-09 16:58:22', '2011-12-09 16:58:22', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-54', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('140', '28', '2011-12-09 17:04:28', '2011-12-09 17:04:28', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-56', '', '', '2011-12-09 17:04:28', '2011-12-09 17:04:28', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-56', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('139', '28', '2011-12-09 16:58:51', '2011-12-09 16:58:51', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ] [wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-55', '', '', '2011-12-09 16:58:51', '2011-12-09 16:58:51', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-55', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('143', '28', '2011-12-09 18:42:09', '2011-12-09 18:42:09', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-59', '', '', '2011-12-09 18:42:09', '2011-12-09 18:42:09', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-59', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('144', '28', '2011-12-09 18:44:06', '2011-12-09 18:44:06', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-60', '', '', '2011-12-09 18:44:06', '2011-12-09 18:44:06', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-60', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('145', '28', '2011-12-09 18:44:59', '2011-12-09 18:44:59', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=570 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-61', '', '', '2011-12-09 18:44:59', '2011-12-09 18:44:59', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-61', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('146', '28', '2011-12-09 18:45:15', '2011-12-09 18:45:15', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-62', '', '', '2011-12-09 18:45:15', '2011-12-09 18:45:15', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-62', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('147', '28', '2011-12-09 18:46:07', '2011-12-09 18:46:07', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\nDear site visitor,\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-63', '', '', '2011-12-09 18:46:07', '2011-12-09 18:46:07', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-63', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('148', '28', '2011-12-09 18:46:29', '2011-12-09 18:46:29', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\nDear site visitor,\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"100%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-64', '', '', '2011-12-09 18:46:29', '2011-12-09 18:46:29', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-64', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('149', '28', '2011-12-09 18:46:54', '2011-12-09 18:46:54', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\nDear site visitor,\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"100%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-65', '', '', '2011-12-09 18:46:54', '2011-12-09 18:46:54', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-65', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('150', '28', '2011-12-09 18:47:25', '2011-12-09 18:47:25', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\nDear site visitor,\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"100%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-66', '', '', '2011-12-09 18:47:25', '2011-12-09 18:47:25', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-66', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('152', '28', '2011-12-09 18:48:37', '2011-12-09 18:48:37', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"100%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-68', '', '', '2011-12-09 18:48:37', '2011-12-09 18:48:37', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-68', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('151', '28', '2011-12-09 18:48:07', '2011-12-09 18:48:07', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"16px\" color=\"#000000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]Dear site visitor,[/wpgfxm_headlines]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"100%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-67', '', '', '2011-12-09 18:48:07', '2011-12-09 18:48:07', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-67', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('154', '28', '2011-12-09 18:49:41', '2011-12-09 18:49:41', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"100%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-70', '', '', '2011-12-09 18:49:41', '2011-12-09 18:49:41', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-70', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('153', '28', '2011-12-09 18:49:15', '2011-12-09 18:49:15', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"100%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-69', '', '', '2011-12-09 18:49:15', '2011-12-09 18:49:15', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-69', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('159', '28', '2011-12-09 19:03:38', '2011-12-09 19:03:38', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-75', '', '', '2011-12-09 19:03:38', '2011-12-09 19:03:38', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-75', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('155', '28', '2011-12-09 18:58:49', '2011-12-09 18:58:49', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ][wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-71', '', '', '2011-12-09 18:58:49', '2011-12-09 18:58:49', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-71', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('156', '28', '2011-12-09 19:00:13', '2011-12-09 19:00:13', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-72', '', '', '2011-12-09 19:00:13', '2011-12-09 19:00:13', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-72', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('160', '28', '2011-12-09 19:06:23', '2011-12-09 19:06:23', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#E8E0BA\" b_color=\"#D4CC85\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"0px\" ]\r\n\r\nMaybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want!\r\n\r\n[/wpgfxm_contentbox]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-76', '', '', '2011-12-09 19:06:23', '2011-12-09 19:06:23', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-76', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('157', '28', '2011-12-09 19:02:13', '2011-12-09 19:02:13', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-73', '', '', '2011-12-09 19:02:13', '2011-12-09 19:02:13', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-73', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('158', '28', '2011-12-09 19:02:40', '2011-12-09 19:02:40', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-74', '', '', '2011-12-09 19:02:40', '2011-12-09 19:02:40', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-74', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('164', '28', '2011-12-09 19:14:49', '2011-12-09 19:14:49', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"90%\"]Maybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want![/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-80', '', '', '2011-12-09 19:14:49', '2011-12-09 19:14:49', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-80', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('163', '28', '2011-12-09 19:10:40', '2011-12-09 19:10:40', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#E8E0BA\" b_color=\"#D4CC85\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"0px\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"80%\"]Maybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-79', '', '', '2011-12-09 19:10:40', '2011-12-09 19:10:40', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-79', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('161', '28', '2011-12-09 19:07:35', '2011-12-09 19:07:35', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#E8E0BA\" b_color=\"#D4CC85\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"0px\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"800%\"]Maybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-77', '', '', '2011-12-09 19:07:35', '2011-12-09 19:07:35', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-77', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('162', '28', '2011-12-09 19:08:51', '2011-12-09 19:08:51', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#E8E0BA\" b_color=\"#D4CC85\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"0px\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"80%\"]Maybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want![/wpgfxm_headlines]\r\n\r\n[/wpgfxm_contentbox]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-78', '', '', '2011-12-09 19:08:51', '2011-12-09 19:08:51', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-78', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('169', '28', '2011-12-09 19:17:36', '2011-12-09 19:17:36', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\" ]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-85', '', '', '2011-12-09 19:17:36', '2011-12-09 19:17:36', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-85', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('165', '28', '2011-12-09 19:15:17', '2011-12-09 19:15:17', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"90%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#000000\" ]Maybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-81', '', '', '2011-12-09 19:15:17', '2011-12-09 19:15:17', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-81', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('166', '28', '2011-12-09 19:15:46', '2011-12-09 19:15:46', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"90%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\" ]Maybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-82', '', '', '2011-12-09 19:15:46', '2011-12-09 19:15:46', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-82', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('167', '28', '2011-12-09 19:16:15', '2011-12-09 19:16:15', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"90%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\" ]<strong>Disclaimer:</strong> Maybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-83', '', '', '2011-12-09 19:16:15', '2011-12-09 19:16:15', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-83', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('168', '28', '2011-12-09 19:16:33', '2011-12-09 19:16:33', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\" ]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\" ]<strong>Disclaimer:</strong> Maybe put some disclaimer text here! Mention that their purchase will be  paid with a secure online connection or whatever you want![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-84', '', '', '2011-12-09 19:16:33', '2011-12-09 19:16:33', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-84', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('170', '28', '2011-12-09 19:21:28', '2011-12-09 19:21:28', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-86', '', '', '2011-12-09 19:21:28', '2011-12-09 19:21:28', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-86', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('171', '28', '2011-12-09 19:21:48', '2011-12-09 19:21:48', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"9px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-87', '', '', '2011-12-09 19:21:48', '2011-12-09 19:21:48', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-87', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('172', '28', '2011-12-09 19:22:11', '2011-12-09 19:22:11', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"10px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-88', '', '', '2011-12-09 19:22:11', '2011-12-09 19:22:11', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-88', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('173', '28', '2011-12-09 20:13:12', '2011-12-09 20:13:12', '[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"10px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-89', '', '', '2011-12-09 20:13:12', '2011-12-09 20:13:12', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-89', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('174', '28', '2011-12-09 20:13:30', '2011-12-09 20:13:30', '[wpgfxm_headlines font=\"Impact\" size=\"50px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"10px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-90', '', '', '2011-12-09 20:13:30', '2011-12-09 20:13:30', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-90', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('175', '28', '2011-12-09 20:14:05', '2011-12-09 20:14:05', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]5LOcUkm8m9w[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"10px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-91', '', '', '2011-12-09 20:14:05', '2011-12-09 20:14:05', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-91', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('176', '28', '2011-12-09 20:16:09', '2011-12-09 20:16:09', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]GRmDGvdkg8E[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"10px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-92', '', '', '2011-12-09 20:16:09', '2011-12-09 20:16:09', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-92', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('177', '28', '2011-12-09 20:22:59', '2011-12-09 20:22:59', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"10px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-93', '', '', '2011-12-09 20:22:59', '2011-12-09 20:22:59', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-93', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('178', '28', '2011-12-09 20:23:54', '2011-12-09 20:23:54', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-94', '', '', '2011-12-09 20:23:54', '2011-12-09 20:23:54', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-94', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('189', '28', '2011-12-10 01:34:25', '2011-12-10 01:34:25', '', 'banner-example2', '', 'inherit', 'open', 'open', '', 'banner-example2', '', '', '2011-12-10 01:34:25', '2011-12-10 01:34:25', '', '0', 'http://www.plrblogs.com/bloodpressure/wp-content/uploads/2011/12/banner-example2.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('190', '28', '2011-12-10 01:34:26', '2011-12-10 01:34:26', '', 'banner-example3', '', 'inherit', 'open', 'open', '', 'banner-example3', '', '', '2011-12-10 01:34:26', '2011-12-10 01:34:26', '', '0', 'http://www.plrblogs.com/bloodpressure/wp-content/uploads/2011/12/banner-example3.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('183', '28', '2011-12-09 20:24:26', '2011-12-09 20:24:26', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-95', '', '', '2011-12-09 20:24:26', '2011-12-09 20:24:26', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-95', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('184', '28', '2011-12-09 22:11:20', '2011-12-09 22:11:20', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-96', '', '', '2011-12-09 22:11:20', '2011-12-09 22:11:20', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-96', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('192', '28', '2011-12-09 23:40:18', '2011-12-09 23:40:18', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-97', '', '', '2011-12-09 23:40:18', '2011-12-09 23:40:18', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-97', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('196', '28', '2011-12-11 19:38:17', '2011-12-11 19:38:17', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-98', '', '', '2011-12-11 19:38:17', '2011-12-11 19:38:17', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-98', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('197', '28', '2011-12-12 00:56:08', '2011-12-12 00:56:08', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-99', '', '', '2011-12-12 00:56:08', '2011-12-12 00:56:08', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-99', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('198', '28', '2011-12-12 01:00:24', '2011-12-12 01:00:24', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-100', '', '', '2011-12-12 01:00:24', '2011-12-12 01:00:24', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-100', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('199', '28', '2011-12-12 01:06:19', '2011-12-12 01:06:19', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-101', '', '', '2011-12-12 01:06:19', '2011-12-12 01:06:19', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-101', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('201', '28', '2011-12-12 01:07:45', '2011-12-12 01:07:45', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-103', '', '', '2011-12-12 01:07:45', '2011-12-12 01:07:45', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-103', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('200', '28', '2011-12-12 01:07:30', '2011-12-12 01:07:30', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-102', '', '', '2011-12-12 01:07:30', '2011-12-12 01:07:30', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-102', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('202', '28', '2011-12-12 01:08:36', '2011-12-12 01:08:36', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-104', '', '', '2011-12-12 01:08:36', '2011-12-12 01:08:36', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-104', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('205', '28', '2011-12-12 01:09:30', '2011-12-12 01:09:30', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-107', '', '', '2011-12-12 01:09:30', '2011-12-12 01:09:30', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-107', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('203', '28', '2011-12-12 01:08:55', '2011-12-12 01:08:55', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-105', '', '', '2011-12-12 01:08:55', '2011-12-12 01:08:55', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-105', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('204', '28', '2011-12-12 01:09:06', '2011-12-12 01:09:06', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee! Here you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-106', '', '', '2011-12-12 01:09:06', '2011-12-12 01:09:06', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-106', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('207', '28', '2011-12-12 01:10:06', '2011-12-12 01:10:06', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-109', '', '', '2011-12-12 01:10:06', '2011-12-12 01:10:06', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-109', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('206', '28', '2011-12-12 01:09:45', '2011-12-12 01:09:45', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-108', '', '', '2011-12-12 01:09:45', '2011-12-12 01:09:45', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-108', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('208', '28', '2011-12-12 01:10:36', '2011-12-12 01:10:36', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-110', '', '', '2011-12-12 01:10:36', '2011-12-12 01:10:36', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-110', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('209', '28', '2011-12-12 01:23:32', '2011-12-12 01:23:32', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-111', '', '', '2011-12-12 01:23:32', '2011-12-12 01:23:32', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-111', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('233', '28', '2011-12-12 01:24:41', '2011-12-12 01:24:41', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-112', '', '', '2011-12-12 01:24:41', '2011-12-12 01:24:41', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-112', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('235', '28', '2011-12-12 05:08:06', '2011-12-12 05:08:06', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n \r\n\r\nFrom the desk of: John Smith\r\n\r\nDear site visitor,\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n\r\nEnter Feature/Benefit Info\r\nEnter Feature/Benefit Info\r\nEnter Feature/Benefit Info\r\nEnter Feature/Benefit Info\r\nEnter Feature/Benefit Info\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n \r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n\r\nEnter Feature/Benefit Info\r\nEnter Feature/Benefit Info\r\nEnter Feature/Benefit Info\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n \r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]Disclaimer: Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-114', '', '', '2011-12-12 05:08:06', '2011-12-12 05:08:06', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-114', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('234', '28', '2011-12-12 05:07:28', '2011-12-12 05:07:28', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"2px\" ]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" ]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere are just a few of the options available:\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Control background color, border color, and even border radius!</li>\r\n	<li class=\"bullet\">Control width of page, padding (spacing) of inside page area!</li>\r\n	<li class=\"bullet\">Comes with the FREE version of WP Graphix Magic, my newest plugin!</li>\r\n	<li class=\"bullet\">Highlight text, add colored buttons, add badges, bullets, Buy Now Buttons!</li>\r\n	<li class=\"bullet\">and much more!</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]1. Add a Sales Box![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\" ]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info Enter List Info Enter List Info Enter List Info</li>\r\n	<li class=\"bullet\">Enter List InfoEnter List Info Enter List Info Enter List Info Enter List Info</li>\r\n	<li class=\"bullet\">Enter List InfoEnter List Info Enter List Info Enter List Info Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]2. Three Different Image Bullets![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_bullets bullet=\"green-tick-3\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n	<li class=\"bullet\">Enter List Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]3. Three Types of Dividers![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\" ]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_divider divider_image=\"css\" ]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]4. Text Highlights and 3 Badge Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#000000\" ]salutatus cotidieque duo[/wpgfxm_highlighter], ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis [wpgfxm_badge image=\"orange-badge-lg\" align=\"left\" ] salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_highlighter bg_color=\"#C90000\" text_color=\"#FFFFFF\" ]Lorem ipsum dolor sit amet[/wpgfxm_highlighter], in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, [wpgfxm_highlighter bg_color=\"#9124FF\" text_color=\"#FFFFFF\" ]ad mea delicata recteque argumentum[/wpgfxm_highlighter]. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]5. Create Content Boxes[/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\" ]Choose Border Styles[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"50%\" bg_color=\"#FBEBB7\" b_color=\"#D93232\" style=\"dashed\" top=\"5px\" right=\"5px\" bottom=\"5px\" left=\"5px\" radius=\"0px\" ]Change Width and Background Colors[/wpgfxm_contentbox]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#30B2D9\" style=\"solid\" top=\"1px\" right=\"1px\" bottom=\"1px\" left=\"1px\" radius=\"10px\" ]Change Border Radius! Works in modern browsers (ie Chrome, Firefox, Safari, Opera, IE9+) [/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]6. Twelve Colors - 2 Sizes![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"orange_yellow\" align=\"left\" new_window=\"_blank\" link=\"http://www.google.com\"]Hyperlink Your Buttons[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"large\" color=\"light_blue\" align=\"center\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Align Left, Right, or Center[/wpgfxm_button]\r\n\r\n[wpgfxm_button title_color=\"#FFFFFF\" size=\"medium\" color=\"dark_grey\" align=\"right\" new_window=\"_blank\" link=\"http://www.plrblogs.com\"]Add Your Own Text![/wpgfxm_button]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"40px\" color=\"#1C8A1F\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"1px\" ][wpgfxm_highlighter bg_color=\"#FFF76B\" text_color=\"#1C8A1F\" ]7. Three Pro Buttons![/wpgfxm_highlighter][/wpgfxm_headlines]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-add-to-cart\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-buy-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" link=\"http://www.google.com\"]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-113', '', '', '2011-12-12 05:07:28', '2011-12-12 05:07:28', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-113', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('244', '28', '2011-12-12 05:10:01', '2011-12-12 05:10:01', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-115', '', '', '2011-12-12 05:10:01', '2011-12-12 05:10:01', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-115', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('247', '28', '2011-12-12 09:17:27', '2011-12-12 09:17:27', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-116', '', '', '2011-12-12 09:17:27', '2011-12-12 09:17:27', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-116', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('248', '28', '2011-12-13 00:49:07', '2011-12-13 00:49:07', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-117', '', '', '2011-12-13 00:49:07', '2011-12-13 00:49:07', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-117', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('249', '28', '2011-12-13 00:49:36', '2011-12-13 00:49:36', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-118', '', '', '2011-12-13 00:49:36', '2011-12-13 00:49:36', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-118', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('250', '28', '2011-12-13 01:12:23', '2011-12-13 01:12:23', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-119', '', '', '2011-12-13 01:12:23', '2011-12-13 01:12:23', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-119', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('388', '28', '2012-10-25 12:31:11', '2012-10-25 12:31:11', 'While it is a good practice for the visitor of any review site to treat every product recommendation with a healthy degree of skepticism, it would be a mistake to assume that every review is invalid just because there may be a commission paid to the reviewer. Here are some of the readers protections we attempt to build into our reviews:\r\n\r\n1. Many of the reviews contain lots of factual information that is easily verifiable. We always try to provide an honest and accurate assessment.\r\n\r\n2. The review includes a section that is a subjective summary. This is based on the personal experience of the reviewer.\r\n\r\n3. Attempts are made to establish the general consensus in relation to specific products by reading reviews of those products on other sites, along with user testimonials and we attempt to portray this overall perception in our reviews.\r\n\r\n4. We always provide links to the manufacturers\' website to provide additional information that is not available in our reviews. Some of this information can include customer testimonials, more specific product details, sales information, free newsletters and even samples.\r\n\r\nThese are good rules of practice. It is important for you as a consumer to understand the relationship between a person reviewing the product and the manufacturer.\r\n\r\nIf you do not see a disclosure policy on a review site, that reviewer may be committing an offense.\r\n\r\nI hope that you have a useful and meaningful experience as a direct result of our detailed reviews and articles. We welcome any feedback that may help us to improve your experience when visiting this website.\r\n\r\nOur website makes no representations, warranties, or assurances as to the accuracy, currency or completeness of the content contain on this website or any sites linked to this site.', 'Disclosure Policy', '', 'publish', 'open', 'closed', '', 'disclosure-policy', '', '', '2012-11-26 09:27:24', '2012-11-26 09:27:24', '', '0', 'http://www.plrblogs.com/acnescars/?page_id=388', '0', 'page', '', '0');
INSERT INTO `wp_posts` VALUES('255', '28', '2011-12-13 01:12:48', '2011-12-13 01:12:48', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-120', '', '', '2011-12-13 01:12:48', '2011-12-13 01:12:48', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-120', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('256', '28', '2011-12-15 04:05:00', '2011-12-15 04:05:00', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-121', '', '', '2011-12-15 04:05:00', '2011-12-15 04:05:00', '', '83', 'http://www.plrblogs.com/bloodpressure/uncategorized/83-revision-121', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('390', '28', '2012-04-25 12:31:11', '2012-04-25 12:31:11', 'While it is a good practice for the visitor of any review site to treat every product recommendation with a healthy degree of skepticism, it would be a mistake to assume that every review is invalid just because there may be a commission paid to the reviewer. Here are some of the readers protections we attempt to build into our reviews:\r\n\r\n1. Many of the reviews contain lots of factual information that is easily verifiable. We always try to provide an honest and accurate assessment.\r\n\r\n2. The review includes a section that is a subjective summary. This is based on the personal experience of the reviewer.\r\n\r\n3. Attempts are made to establish the general consensus in relation to specific products by reading reviews of those products on other sites, along with user testimonials and we attempt to portray this overall perception in our reviews.\r\n\r\n4. We always provide links to the manufacturers’ website to provide additional information that is not available in our reviews. Some of this information can include customer testimonials, more specific product details, sales information, free newsletters and even samples.\r\n\r\nThese are good rules of practice. It is important for you as a consumer to understand the relationship between a person reviewing the product and the manufacturer.\r\n\r\nIf you do not see a disclosure policy on a review site, that reviewer may be committing an offense.\r\n\r\nI hope that you have a useful and meaningful experience as a direct result of our detailed reviews and articles. We welcome any feedback that may help us to improve your experience when visiting this website.\r\n\r\nOur website makes no representations, warranties, or assurances as to the accuracy, currency or completeness of the content contain on this website or any sites linked to this site.', 'Disclosure Policy', '', 'inherit', 'open', 'open', '', '388-revision-2', '', '', '2012-04-25 12:31:11', '2012-04-25 12:31:11', '', '388', 'http://www.plrblogs.com/acnescars/uncategorized/388-revision-2', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('391', '28', '2012-04-25 12:37:55', '2012-04-25 12:37:55', 'While it is a good practice for the visitor of any review site to treat every product recommendation with a healthy degree of skepticism, it would be a mistake to assume that every review is invalid just because there may be a commission paid to the reviewer. Here are some of the readers protections we attempt to build into our reviews:\r\n\r\n1. Many of the reviews contain lots of factual information that is easily verifiable. We always try to provide an honest and accurate assessment.\r\n\r\n2. The review includes a section that is a subjective summary. This is based on the personal experience of the reviewer.\r\n\r\n3. Attempts are made to establish the general consensus in relation to specific products by reading reviews of those products on other sites, along with user testimonials and we attempt to portray this overall perception in our reviews.\r\n\r\n4. We always provide links to the manufacturers\' website to provide additional information that is not available in our reviews. Some of this information can include customer testimonials, more specific product details, sales information, free newsletters and even samples.\r\n\r\nThese are good rules of practice. It is important for you as a consumer to understand the relationship between a person reviewing the product and the manufacturer.\r\n\r\nIf you do not see a disclosure policy on a review site, that reviewer may be committing an offense.\r\n\r\nI hope that you have a useful and meaningful experience as a direct result of our detailed reviews and articles. We welcome any feedback that may help us to improve your experience when visiting this website.\r\n\r\nOur website makes no representations, warranties, or assurances as to the accuracy, currency or completeness of the content contain on this website or any sites linked to this site.', 'Disclosure Policy', '', 'inherit', 'open', 'open', '', '388-revision-3', '', '', '2012-04-25 12:37:55', '2012-04-25 12:37:55', '', '388', 'http://www.plrblogs.com/acnescars/uncategorized/388-revision-3', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('536', '28', '2012-06-28 17:56:59', '2012-06-28 17:56:59', 'Clickbank Marketing Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]pGZHNqP8WnY[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]vAMRXJj5J_A[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]53Zx_n4hgK0[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]SAVV-ZrlWeI[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]cSUiqwcHKRw[/youtube]', 'Clickbank Marketing Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-06-28 17:56:59', '2012-06-28 17:56:59', '', '21', 'http://www.plrblogs.com/badbreath/uncategorized/21-revision-19', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('537', '28', '2012-11-22 19:51:35', '2012-11-22 19:51:35', 'Clickbank Marketing Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]pGZHNqP8WnY[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]vAMRXJj5J_A[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]53Zx_n4hgK0[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]SAVV-ZrlWeI[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]cSUiqwcHKRw[/youtube]', 'Bad Breath FAQs Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-11-22 19:51:35', '2012-11-22 19:51:35', '', '21', 'http://www.plrblogs.com/badbreath/uncategorized/21-revision-20', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('538', '28', '2011-12-08 21:20:39', '2011-12-08 21:20:39', 'This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors.', 'About', '', 'inherit', 'open', 'open', '', '2-revision-2', '', '', '2011-12-08 21:20:39', '2011-12-08 21:20:39', '', '2', 'http://www.plrblogs.com/badbreath/uncategorized/2-revision-2', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('539', '28', '2012-11-25 21:44:55', '2012-11-25 21:44:55', 'This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors.', 'About', '', 'inherit', 'open', 'open', '', '2-revision-3', '', '', '2012-11-25 21:44:55', '2012-11-25 21:44:55', '', '2', 'http://www.plrblogs.com/badbreath/uncategorized/2-revision-3', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('404', '28', '2012-06-17 02:21:03', '2012-06-17 02:21:03', 'While it is a good practice for the visitor of any review site to treat every product recommendation with a healthy degree of skepticism, it would be a mistake to assume that every review is invalid just because there may be a commission paid to the reviewer. Here are some of the readers protections we attempt to build into our reviews:\n\n1. Many of the reviews contain lots of factual information that is easily verifiable. We always try to provide an honest and accurate assessment.\n\n2. The review includes a section that is a subjective summary. This is based on the personal experience of the reviewer.\n\n3. Attempts are made to establish the general consensus in relation to specific products by reading reviews of those products on other sites, along with user testimonials and we attempt to portray this overall perception in our reviews.\n\n4. We always provide links to the manufacturers\' website to provide additional information that is not available in our reviews. Some of this information can include customer testimonials, more specific product details, sales information, free newsletters and even samples.\n\nThese are good rules of practice. It is important for you as a consumer to understand the relationship between a person reviewing the product and the manufacturer.\n\nIf you do not see a disclosure policy on a review site, that reviewer may be committing an offense.\n\nI hope that you have a useful and meaningful experience as a direct result of our detailed reviews and articles. We welcome any feedback that may help us to improve your experience when visiting this website.\n\nOur website makes no representations, warranties, or assurances as to the accuracy, currency or completeness of the content contain on this website or any sites linked to this site.', 'Disclosure Policy', '', 'inherit', 'open', 'open', '', '388-autosave', '', '', '2012-06-17 02:21:03', '2012-06-17 02:21:03', '', '388', 'http://www.plrblogs.com/acnescars/uncategorized/388-autosave', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('550', '28', '2012-11-25 21:45:02', '2012-11-25 21:45:02', 'This is an example page. It\'s different from a blog post because it will stay in one place and will show up in your site navigation (in most themes). Most people start with an About page that introduces them to potential site visitors.', 'About', '', 'inherit', 'open', 'open', '', '2-revision-4', '', '', '2012-11-25 21:45:02', '2012-11-25 21:45:02', '', '2', 'http://www.plrblogs.com/badbreath/uncategorized/2-revision-4', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('551', '28', '2012-11-22 19:52:32', '2012-11-22 19:52:32', 'Bad Breath FAQs Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]-1csrI4xO-I[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]lmi5SrcQaQQ[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]IOFyiepWykk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]qFrbPtbhMJ4[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]iUBjuXS4pAQ[/youtube]', 'Bad Breath FAQs Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-11-22 19:52:32', '2012-11-22 19:52:32', '', '21', 'http://www.plrblogs.com/badbreath/uncategorized/21-revision-21', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('552', '28', '2011-12-08 21:22:43', '2011-12-08 21:22:43', '[contact-form-7 id=\"4\" title=\"Contact form 1\"]', 'Contact', '', 'inherit', 'open', 'open', '', '16-revision-2', '', '', '2011-12-08 21:22:43', '2011-12-08 21:22:43', '', '16', 'http://www.plrblogs.com/badbreath/uncategorized/16-revision-2', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('553', '28', '2012-04-25 12:42:08', '2012-04-25 12:42:08', 'While it is a good practice for the visitor of any review site to treat every product recommendation with a healthy degree of skepticism, it would be a mistake to assume that every review is invalid just because there may be a commission paid to the reviewer. Here are some of the readers protections we attempt to build into our reviews:\r\n\r\n1. Many of the reviews contain lots of factual information that is easily verifiable. We always try to provide an honest and accurate assessment.\r\n\r\n2. The review includes a section that is a subjective summary. This is based on the personal experience of the reviewer.\r\n\r\n3. Attempts are made to establish the general consensus in relation to specific products by reading reviews of those products on other sites, along with user testimonials and we attempt to portray this overall perception in our reviews.\r\n\r\n4. We always provide links to the manufacturers\' website to provide additional information that is not available in our reviews. Some of this information can include customer testimonials, more specific product details, sales information, free newsletters and even samples.\r\n\r\nThese are good rules of practice. It is important for you as a consumer to understand the relationship between a person reviewing the product and the manufacturer.\r\n\r\nIf you do not see a disclosure policy on a review site, that reviewer may be committing an offense.\r\n\r\nI hope that you have a useful and meaningful experience as a direct result of our detailed reviews and articles. We welcome any feedback that may help us to improve your experience when visiting this website.\r\n\r\nOur website makes no representations, warranties, or assurances as to the accuracy, currency or completeness of the content contain on this website or any sites linked to this site.', 'Disclosure Policy', '', 'inherit', 'open', 'open', '', '388-revision-5', '', '', '2012-04-25 12:42:08', '2012-04-25 12:42:08', '', '388', 'http://www.plrblogs.com/badbreath/uncategorized/388-revision-5', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('554', '28', '2011-12-08 21:23:31', '2011-12-08 21:23:31', '<strong>Your Privacy</strong><br/>Your privacy is important to us. To better protect your privacy we provide this notice explaining our online information practices and the choices you can make about the way your information is collected and used. To make this notice easy to find, we make it available on our homepage and at every point where personally identifiable information may be requested.<p/><strong>Google Adsense and the DoubleClick DART Cookie</strong><br/>Google, as a third party advertisement vendor, uses cookies to serve ads on this site. The use of DART cookies by Google enables them to serve adverts to visitors that are based on their visits to this website as well as other sites on the internet.\r\n\r\nTo opt out of the DART cookies you may visit the Google ad and content network privacy policy at the following url <a href=\"http://www.google.com/privacy_ads.html\">http://www.google.com/privacy_ads.html</a> Tracking of users through the DART cookie mechanisms are subject to Google\'s own privacy policies.\r\n\r\nOther Third Party ad servers or ad networks may also use cookies to track users activities on this website to measure advertisement effectiveness and other reasons that will be provided in their own privacy policies,  has no access or control over these cookies that may be used by third party advertisers.<p/><strong>Collection of Personal Information</strong><br/>When visiting , the IP address used to access the site will be logged along with the dates and times of access. This information is purely used to analyze trends, administer the site, track users movement and gather broad demographic information for internal use. Most importantly, any recorded IP addresses are not linked to personally identifiable information.\r\n<p/><strong>Links to third party Websites</strong><br/>We have included links on this site for your use and reference. We are not responsible for the privacy policies on these websites. You should be aware that the privacy policies of these sites may differ from our own. \r\n<p/><strong>Changes to this Privacy Statement</strong><br/>The contents of this statement may be altered at any time, at our discretion. \r\n\r\nIf you have any questions regarding the privacy policy of  then you may contact us at <p/>', 'Privacy Policy', '', 'inherit', 'open', 'open', '', '18-revision', '', '', '2011-12-08 21:23:31', '2011-12-08 21:23:31', '', '18', 'http://www.plrblogs.com/badbreath/uncategorized/18-revision', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('555', '28', '2012-07-01 03:19:53', '2012-07-01 03:19:53', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-124', '', '', '2012-07-01 03:19:53', '2012-07-01 03:19:53', '', '83', 'http://www.plrblogs.com/badbreath/uncategorized/83-revision-124', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('556', '28', '2011-12-08 21:24:17', '2011-12-08 21:24:17', '<!-- ddsitemapgen -->', 'Sitemap', '', 'inherit', 'open', 'open', '', '19-revision-2', '', '', '2011-12-08 21:24:17', '2011-12-08 21:24:17', '', '19', 'http://www.plrblogs.com/badbreath/uncategorized/19-revision-2', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('480', '28', '2012-06-26 01:00:52', '2012-06-26 01:00:52', 'Clickbank Marketing Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]pGZHNqP8WnY[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]vAMRXJj5J_A[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]53Zx_n4hgK0[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]SAVV-ZrlWeI[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]cSUiqwcHKRw[/youtube]', 'Clickbank Marketing Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-06-26 01:00:52', '2012-06-26 01:00:52', '', '21', 'http://www.plrblogs.com/clickbank/uncategorized/21-revision-18', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('483', '28', '2011-12-15 04:07:56', '2011-12-15 04:07:56', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-122', '', '', '2011-12-15 04:07:56', '2011-12-15 04:07:56', '', '83', 'http://www.plrblogs.com/clickbank/uncategorized/83-revision-122', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('484', '28', '2012-07-01 03:17:54', '2012-07-01 03:17:54', '[wpgfxm_headlines font=\"Impact\" size=\"45px\" color=\"#1C8A1F\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"0px\" lineheight=\"120%\"]Welcome to the demo Custom Sales Page in Headlines Enhanced V3![/wpgfxm_headlines]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"24px\" color=\"#BF0202\" shadow=\"yes\" decor=\"none\" style=\"italic\" weight=\"bold\" align=\"center\" spacing=\"-1px\" lineheight=\"120%\"]It\'s never been easier to create custom sales pages like this, all within seconds![/wpgfxm_headlines]\r\n\r\n[youtube width=650 height=390]2jYJV9zHy04[/youtube]\r\n\r\n&nbsp;\r\n\r\nFrom the desk of: John Smith\r\n\r\n<strong>Dear site visitor,</strong>\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"60%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nAdd Feature/Benefit Bullet Points Here!\r\n\r\n[wpgfxm_bullets bullet=\"green-plus-sign\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_contentbox width=\"90%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\n[wpgfxm_badge image=\"orange-badge-sm\" align=\"left\"]\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"16px\" color=\"#DE0000\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"left\" spacing=\"normal\" lineheight=\"120%\"]30 Day 100% Money Back Guarantee[/wpgfxm_headlines]\r\n\r\nHere you mention about your superb money back, 100% satisfaction guarantee!\r\n\r\n&nbsp;\r\n\r\n[/wpgfxm_contentbox]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Lorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum.\r\n\r\n[wpgfxm_divider divider_image=\"divider-1\"]\r\n\r\n[wpgfxm_salesboxes salesbox_image=\"salesbox1\"]\r\n\r\n[wpgfxm_headlines font=\"Impact\" size=\"42px\" color=\"#bf0000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"normal\" ]100% Risk Free Guarantee![/wpgfxm_headlines]\r\n\r\n[wpgfxm_divider divider_image=\"divider-2\" ]\r\n\r\n[wpgfxm_badge image=\"orange-badge-med\" align=\"right\" ]\r\n\r\nLorem ipsum dolor sit amet, in errem principes est, no singulis salutatus cotidieque duo, ad mea delicata recteque argumentum. Ne mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\nNe mutat vivendo has. Justo movet deserunt ea qui. Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.Wisi tritani cu ius. Et eum graecis efficiendi, aperiam lucilius est no. Oporteat abhorreant cum no.\r\n\r\n[wpgfxm_headlines font=\"Arial Black\" size=\"26px\" color=\"#E00000\" shadow=\"yes\" decor=\"none\" style=\"normal\" weight=\"bold\" align=\"center\" spacing=\"-2px\"]You Can Put Smaller Headlines - Such As Mention Special Discounts![/wpgfxm_headlines]\r\n\r\n[wpgfxm_contentbox width=\"80%\" bg_color=\"#F1F8FB\" b_color=\"#C1D2D9\" style=\"solid\" top=\"1px\" right=\"none\" bottom=\"1px\" left=\"none\" radius=\"0px\"]\r\n\r\nHere is some text you can enter\r\n\r\n[wpgfxm_bullets bullet=\"green-arrow\"]\r\n<ul>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n	<li class=\"bullet\">Enter Feature/Benefit Info</li>\r\n</ul>\r\n[/wpgfxm_bullets]\r\n\r\n[/wpgfxm_contentbox]\r\n\r\n&nbsp;\r\n\r\n[wpgfxm_salesbuttons image=\"o-download-now\" align=\"center\" new_window=\"_blank\" alt=\"Download Now!\" link=\"http://www.google.com\"]\r\n\r\n[/wpgfxm_salesboxes]\r\n\r\n[wpgfxm_headlines font=\"Arial\" size=\"11px\" color=\"#A19777\" shadow=\"none\" decor=\"none\" style=\"normal\" weight=\"normal\" align=\"center\" spacing=\"normal\" lineheight=\"120%\"][wpgfxm_highlighter bg_color=\"#DBDBDB\" text_color=\"#8C8C8C\"]<strong>Disclaimer:</strong> Maybe put some disclaimer text here![/wpgfxm_highlighter][/wpgfxm_headlines]', 'Sample Sales Page', '', 'inherit', 'open', 'open', '', '83-revision-123', '', '', '2012-07-01 03:17:54', '2012-07-01 03:17:54', '', '83', 'http://www.plrblogs.com/clickbank/uncategorized/83-revision-123', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('651', '28', '2013-01-10 21:22:55', '2013-01-10 21:22:55', 'Kindle Publishing Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]V-T12_6HYGk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]xKE5fIfY2Lc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]ASEwXjEr2Oc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]2fVCKGP9lHk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]usNuEVGGZ10[/youtube]', 'Kindle Publishing Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-01-10 21:22:55', '2013-01-10 21:22:55', '', '21', 'http://www.plrblogs.com/beerbrewing/uncategorized/21-revision-24', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('822', '28', '2013-07-25 13:05:55', '2013-07-25 13:05:55', '[youtube width=570 height=390]1pnotCDM4KU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]YQNNEQzyhDE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]rgMhZKp2G7Y[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]B3YK9qDCLjQ[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-07-25 13:05:55', '2013-07-25 13:05:55', '', '21', 'http://www.plrblogs.com/airtravel/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('573', '28', '2012-11-26 09:27:10', '2012-11-26 09:27:10', 'Bad Breath FAQs Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]-1csrI4xO-I[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]lmi5SrcQaQQ[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]IOFyiepWykk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]qFrbPtbhMJ4[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]iUBjuXS4pAQ[/youtube]', 'Bad Breath FAQs Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2012-11-26 09:27:10', '2012-11-26 09:27:10', '', '21', 'http://www.plrblogs.com/kindle/uncategorized/21-revision-22', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('574', '28', '2013-01-10 21:09:44', '2013-01-10 21:09:44', 'Bad Breath FAQs Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]-1csrI4xO-I[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]lmi5SrcQaQQ[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]IOFyiepWykk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]qFrbPtbhMJ4[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" src=\"[aff1banner3]\" alt=\"[aff1tag]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]iUBjuXS4pAQ[/youtube]', 'Kindle Publishing Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-01-10 21:09:44', '2013-01-10 21:09:44', '', '21', 'http://www.plrblogs.com/kindle/uncategorized/21-revision-23', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('742', '28', '2013-05-18 09:11:02', '2013-05-18 09:11:02', 'Beer Brewing Videos - The Learning Center\r\n\r\n[youtube width=570 height=390]Kw8wV5NkOf4[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]otxFTHi1bKY[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]Ay2_RpC7JRw[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]5WGHkNPqCS8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]6f1jJ_K8hhk[/youtube]', 'Beer Brewing Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-05-18 09:11:02', '2013-05-18 09:11:02', '', '21', 'http://www.plrblogs.com/angularcheilitis/uncategorized/21-revision-25', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('744', '28', '2013-07-05 13:34:11', '2013-07-05 13:34:11', '[youtube width=570 height=390]fn-OZW4X8Sc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]rgMhZKp2G7Y[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]lNnQtyV_w94[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]YQNNEQzyhDE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Angular Cheilitis Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-07-05 13:34:11', '2013-07-05 13:34:11', '', '21', 'http://www.plrblogs.com/angularcheilitis/uncategorized/21-revision-27', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('808', '28', '2013-07-05 15:33:30', '2013-07-05 15:33:30', '[youtube width=570 height=390]1pnotCDM4KU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]YQNNEQzyhDE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]rgMhZKp2G7Y[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]B3YK9qDCLjQ[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Angular Cheilitis Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-07-05 15:33:30', '2013-07-05 15:33:30', '', '21', 'http://www.plrblogs.com/nailfungus/uncategorized/21-revision-28', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('823', '28', '2013-08-10 12:26:32', '2013-08-10 12:26:32', '[youtube width=570 height=390]5HlfVnzzKtc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]ZpZmxu_JucU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]XtEvlsqsxOk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]3yxIddcpI_8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-08-10 12:26:32', '2013-08-10 12:26:32', '', '21', 'http://www.plrblogs.com/conversationconfidence/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('824', '28', '2013-08-11 01:01:46', '2013-08-11 01:01:46', '[youtube width=570 height=390]5HlfVnzzKtc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]ZpZmxu_JucU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]XtEvlsqsxOk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]3yxIddcpI_8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Conversation Help Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-08-11 01:01:46', '2013-08-11 01:01:46', '', '21', 'http://www.plrblogs.com/conversationconfidence/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('868', '28', '2013-11-11 20:48:44', '2013-11-11 20:48:44', '[youtube width=570 height=390]5HlfVnzzKtc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]ZpZmxu_JucU[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]XtEvlsqsxOk[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]3yxIddcpI_8[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-11-11 20:48:44', '2013-11-11 20:48:44', '', '21', 'http://www.plrblogs.com/aviarybirdhouseplans/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('871', '28', '2013-11-12 04:09:22', '2013-11-12 04:09:22', '<ul>\r\n[youtube width=570 height=390]d_t8mN4mMtc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]0iboZWCPzsE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]HhB8tzWpJqI[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]51dvhUl2U2g[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Chronic Fatigue Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-11-12 04:09:22', '2013-11-12 04:09:22', '', '21', 'http://www.plrblogs.com/chronicfatigue/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('872', '28', '2013-11-13 04:53:18', '2013-11-13 04:53:18', '[youtube width=570 height=390]d_t8mN4mMtc[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]0iboZWCPzsE[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]HhB8tzWpJqI[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>\r\n[youtube width=570 height=390]51dvhUl2U2g[/youtube]\r\n<p style=\"margin: 40px 0 40px 35px;\"><a title=\"[aff1tag]\" href=\"[aff1link]\"><img title=\"[aff1tag]\" alt=\"[aff1tag]\" src=\"[aff1banner3]\" width=\"468\" height=\"60\" /></a></p>', 'Chronic Fatigue Videos', '', 'inherit', 'open', 'open', '', '21-revision-v1', '', '', '2013-11-13 04:53:18', '2013-11-13 04:53:18', '', '21', 'http://www.plrblogs.com/chronicfatigue/uncategorized/21-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('910', '28', '2014-06-09 00:31:55', '0000-00-00 00:00:00', '', 'Auto Draft', '', 'auto-draft', 'open', 'open', '', '', '', '', '2014-06-09 00:31:55', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/chronicfatigue/?p=910', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('911', '28', '2014-06-09 01:10:09', '0000-00-00 00:00:00', '', 'Auto Draft', '', 'auto-draft', 'open', 'open', '', '', '', '', '2014-06-09 01:10:09', '0000-00-00 00:00:00', '', '0', 'http://www.plrblogs.com/deckplans/?p=911', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('915', '28', '2014-06-09 21:28:10', '2014-06-09 21:28:10', '', 'Restore My Vision Today', '', 'inherit', 'open', 'open', '', '300x250-s-10', '', '', '2014-06-09 21:28:10', '2014-06-09 21:28:10', '', '7', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2011/12/300x250-S-10.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('916', '28', '2014-06-09 21:28:30', '2014-06-09 21:28:30', '', 'Restore My Vision Today', '', 'inherit', 'open', 'open', '', '468x60-3', '', '', '2014-06-09 21:28:30', '2014-06-09 21:28:30', '', '9', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2011/12/468x60-3.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('917', '28', '2014-06-09 21:29:15', '2014-06-09 21:29:15', '', 'Restore My Vision Today', '', 'inherit', 'open', 'open', '', '468x60-3-2', '', '', '2014-06-09 21:29:15', '2014-06-09 21:29:15', '', '13', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2011/12/468x60-31.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('919', '28', '2014-05-03 09:48:00', '2014-05-03 09:48:00', 'yes are the most essential part of the human body and we can only see the beauty or the very existence of earth because we are blessed with vision of eyes. Life is an irony who are blind or whose vision are diminished due to certain factors. The world will never be the same without eyes such is its importance. All human not only desire to have beautiful eyes but also cherish to maintain the eye power, sight, and enhanced vision for long time.\r\n\r\nHowever there are external developments of medical science which can correct your diminishing power of eye sight. This medical procedure includes non â\" surgical as well as surgical procedure. The processes are wearing of contact lenses, going for glasses to rectify the diminishing power, and sometime surgical procedure is also conducted to improve the eye vision by removing problems like cataract, glaucoma etc.\r\n\r\nBut no one question are there other modes which can help us to restore our vision naturally. However there is a method called Eye Exercises which is the best way to restore the vision without any non â\" surgical as well as surgical procedure. The exercises are powerful enough to give back 20 / 20 eyes sight. But its healing power has always been questioned but the 100 years research and development has made it possible to cure eye vision with exercises giving glasses and contact lenses market a stiff competition.\r\n\r\nEye sights are adversely affected by the daily routine works that we perform or go through. From watching television, to browsing computer, to unhealthy lifestyles, and overwork with rising stress has contributed to the vision of the eyes leading to low power or vision difficulty. However there are common as well as simple eye exercises that can be followed to improve the vision or restore the eye sights.\r\n\r\nOne of the common eye exercises is palming and is essential in curing many eye related as well as head related problems. Palming has been effective in curing migraine, eye pain, and head â\" ache leading to complete relaxation of the eyes. The exercise is very simple and requires just 10 â\" 15 minutes a day to apply it to your eyes and experience the wonder results. First step while following this exercise is to rub your hands with each other to warm and then in the second step cover them to eyes for 3 minutes. The points to remember is that no light should get in and make sure to visualize something interesting during this time and see how one of the fundamental exercise helps to improve the vision.', 'Eye Exercises to Restore Vision', '', 'publish', 'open', 'open', '', 'eye-exercises-to-restore-vision', '', '', '2014-06-10 00:24:39', '2014-06-10 00:24:39', '', '0', 'http://www.plrblogs.com/restorevision/improve-eyesight/eye-exercises-to-restore-vision', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('920', '28', '2014-05-05 12:06:45', '2014-05-05 12:06:45', 'Have you ever heard the term, \"eyes are the windows to the soul\"? Not only are they the windows to our soul, but they are also the windows to view the outside world. Our eyes help us see things, read, work and even communicate. They are a very delicate part of our body though and they also need plenty of rest.\r\n\r\nHave you ever thought that you could improve eyesight naturally? Were you aware that you can improve eyesight just by changing a few habits? We are much harder on our eyes then we think. If we were to take the time to learn and practice some relaxation exercises, we could start seeing more clearly. Some people think that just because they have worn glasses for years or have some type of eye disease that they can\'t learn to improve their eyesight naturally. It depends on how severe the eye disease is, but under normal circumstances, your eyesight can improve.\r\n\r\nThe main causes for poor eyesight are stress and strain. We are all born with relatively good eyesight. We start learning bad habits throughout our school years. Like sitting in a classroom staring at the blackboard, our books or papers. This causes strain on our eyes which leaves them tired and stressed. There is little to no time between classes where we can relax the eyes and give them the rest they require. Because we learn these habits at such a young age, they are carried over into our adult lives. From there we do the same things at work staring at our computers, working on paperwork or stressing over a deadline.\r\n\r\nAre you aware of the signals your body relays when you need rest? For instance when you spend too much time doing household chores and your back starts to hurt. The same goes for the eyes. Like when your head starts to hurt or your eyes start to burn. Those are the signals that it\'s time to take a break. If you are able, lie down and just relax for a few minutes. If you aren\'t able to lie down, find a quiet place to relax your mind and close your eyes. They need to be re-energized.\r\n\r\nWe can all prevent poor eyesight. If we take the steps today and develop the necessary habits that will improve our eyesight, we will be better off for the rest of our lives.', 'Improve Your Eyesight The Natural Way', '', 'publish', 'open', 'open', '', 'improve-your-eyesight-the-natural-way', '', '', '2014-06-10 00:24:26', '2014-06-10 00:24:26', '', '0', 'http://www.plrblogs.com/restorevision/improve-eyesight/improve-your-eyesight-the-natural-way', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('921', '28', '2014-05-08 01:42:06', '2014-05-08 01:42:06', 'Do you the feeling of getting up in the morning and everything is blurry?  Not be able to tie your shoo, get dressed, or even find the sink to wash your face.  The disappointment when your glasses break, in the most important moment. Always end your trip or some other fun activity. Entering a warm room on a cold day and wait 10 minutes for the fog to come off your glasses.  Not to mention the pressure wounds on your nose bridge and at the back of your ears.\r\n\r\nOne might think that contact lenses are the answer to his problem as I thought years ago.  I have checked contact lenses. But they scratches my eyes, switched to soft lenses which kept moving in my eyes and cause me several eye infections.  The worst part of wearing contact lenses is the any windy weather or even some dust hearts your eye.  In a nut shell I have had to give up on them as well.  Not to mention the enormous investment and maintenances you need to afford.\r\n\r\nThen I had to get back to my glasses, my self-confidence went down, and I could not go out or enjoy any water related or ball games.  I knew that I not will do the laser correction surgery I have a cousin who lost here vision in one eye and badly damaged her other eye.  I really want see for the rest of my life so I will have to give that up.    \r\n\r\nAt this point I have started my own investigation to find a cure to my eyes or simply improve eye vision.  I have found that my doctors kept me the same or worst as my eye prescription went up and all they did was giving a thicker lens.  I have found out that Astigmatism can be cured and that its not something I have to live with.  I have found out that I need to prepare my eyes for the coming day, consume nutrition, vitamins and minerals and relaxation which is one of the most important factors.\r\n\r\nThe thing that finally, along with all the relaxation and special food ingredients, helped me was exercising.\r\n   \r\nI have set my self to a schedule of exercising and relaxation and after three months I have began to see some real improvement in my vision.  Today, I have regained 90% of my original vision back, I do not see perfectly but I mange with out any help and I am very happy, I am looking forward to more improvement in the future.  \r\n\r\nThe exercises are very simple. Every one can perform them, and they take very short time too.  I perform three types of eye exercise and relax between them.  The relaxation is simply place my hands over my closed eyes.', 'Improved Eye Vision', '', 'publish', 'open', 'open', '', 'improved-eye-vision', '', '', '2014-06-10 00:24:03', '2014-06-10 00:24:03', '', '0', 'http://www.plrblogs.com/restorevision/improve-eyesight/improved-eye-vision', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('922', '28', '2014-05-11 12:40:17', '2014-05-11 12:40:17', 'Are you looking for ways to improve your eyesight and avoid having to wear glasses and contact lenses for the rest of your life. Unfortunately we are made to believe the only way to improve eyesight without glasses or contact lenses is to opt for expensive and risky eye surgery. Thankfully this is not the case! For over 120 years cultures from around the globe have been using eye exercises to correct their vision.\r\n\r\nDue to the stresses of modern life and the way we work and play our eyes are coping major stress on a daily basis without most of us taking anytime to consider the effects. Using a computer daily, watching television or playing video games forces our eyes into an unnatural state. Our eyes are not made to focus for long periods of time on computer screens or televisions. This results into many people suffering from eye strain and other ailments from the direct result of this unnatural practice such as headaches and migraines. Our eyes are trying to tell us something.\r\n\r\nThe first thing you need to understand is that corrective lenses are only a patch up, they do nothing to help correct your vision. In fact the sad truth about glasses and contacts is that they force your eyes to become lazy and overtime get weaker. The result? Stronger lenses after your next visit to the optometrist! Wearing glasses means that your eyes do not heal and correct themselves naturally as the corrective lenses simply let your eyesight get progressively worse in time.\r\n\r\nMany cultures around the world, especially class rooms in China make school kids perform daily eye exercises to improve the health of their eyes as well as correct most vision problems naturally. The most common eye sight problems such as being short or near sighted can be cured through daily exercise.\r\n\r\nThe optometry field is a billion dollar industry, it is not in their best interests to tell you about how these exercises can cure most vision problems. Think about the cost of your glasses or monthly costs of your contact lenses, these costs can add up to thousands of dollars over the course of your life.\r\n\r\nEye exercises are a perfectly safe and natural alternative to wearing glasses. You must understand that your eyes are like any other muscle in your body, with the correct exercises you can force them to become stronger and heal. Restoring 20/20 vision with these exercises is very common regardless of your age.\r\n\r\nWhile our eyesight will deteriorate in time due to age their is no reason why we can not keep them strong and healthy and improve our eyesight naturally even while we get into our years. These eye exercises were first spoken about in the late 1800\'s by Dr William Bates whose patients were made to do a series of eye exercises daily. Dr Bates found that his patients were not only able to improve their vision but in time restore perfect vision. The series of exercises not only helped with the most common vision problems but he found that certain conditions that were difficult to treat also improved.\r\n\r\nDr Bates was shunned by his peers as a result of going against the status quo and showing people who they could improve their eyesight without spending money on corrective lenses.', 'Its Possible To Improve Your Eyesight Naturally', '', 'publish', 'open', 'open', '', 'its-possible-to-improve-your-eyesight-naturally', '', '', '2014-06-10 00:23:48', '2014-06-10 00:23:48', '', '0', 'http://www.plrblogs.com/restorevision/improve-eyesight/its-possible-to-improve-your-eyesight-naturally', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('923', '28', '2014-05-14 01:50:20', '2014-05-14 01:50:20', 'Laser eye surgery is a medical procedure consisting of the use of laser for reshaping the surface of the cornea. It is used to improve shortsightedness, long sightedness or astigmatism. The first information on laser eye surgery dates back from over twenty years ago, and the FDA approved excimer laser eye surgery in 1995.\n\n\r\n\r\nDuring laser eye surgery, an excimer laser, controlled by a computer is used to remove tiny amounts of corneal tissue. The aim of the procedure is to restore normal vision, eliminating the need for glasses or contacts. Although laser surgery has risen in popularity in the past few years, only about 20% of ophthalmologists have been trained to use it.\n\n\r\n\r\nIn one type of laser eye surgery, the outer layer of the cornea, also called epithelium, is removed and an excimer laser is used to reshape underneath tissue. This procedure is called photorefractive keratectomy (PRK).\n\nIn a newer procedure, a microkeratome is used to cut a flap in the corneal tissue, which is then lifted and an excimer laser is used to reshape underlying tissue. In the end, the flap is put back to its place. This type of laser eye surgery is called laser-assisted in situ keratomileusis (LASIK). Nowadays, it is more commonly used than PRK.\n\n\r\n\r\nWhat Happens During Laser Eye Surgery Procedure\n\nThe surgery should take less than 30 minutes. You will lie on your back, reclining in a chair, or on a table. You may be given a sedative before the procedure, to help you relax.\n\nLocal anesthetic eye drops are used before the surgery. The procedure takes a few minutes per eye. The actual time when the laser is used for reshaping the corneal tissue is generally less than a minute. An instrument called a lid speculum will be used to hold your eyelids open. A ring is placed on your eye, and the cutting instrument is attached to the ring. A microkeratome, the cutting instrument, is used to cut a flap in your cornea. A laser is positioned over your eye, and you will be asked to stare at the light. \r\n\r\nThis light is to help you keep your eye fixed in one spot when the laser comes on.\n\nOnce your eye is in the correct position, the doctor will turn the laser on. Pulses of laser energy vaporize the corneal tissue, and then the flap is placed back into position\n\nYou will need to wear an eye shield for protection after the procedure. This will prevent you from rubbing your eyes, and protect your eye from being accidentally hit or poked until the flap has healed.\n\n\r\n\r\nAfter laser eye surgery, you should expect some minor discomfort. However, you should be able to see, although not very clearly. You won\'t be able to drive on your own, so you need to have someone drive you home or take a cab. You should see your doctor within the first 24 to 48 hours after surgery, and then at regular intervals for about six months. You will have to wait for up to two weeks before using make-up, creams or lotions, to prevent infection or irritation. You should also avoid swimming and hot tubs for about 6 weeks.\r\n\r\n\n\nAlthough you should see well the day after surgery, your vision will continue to improve over the next several months. As the eye heals, your vision will continue to improve. It is important to keep all your follow-up appointments with your doctor, to make sure that everything is going according to plan.', 'Learn More About Laser Eye Surgery', '', 'publish', 'open', 'open', '', 'learn-more-about-laser-eye-surgery', '', '', '2014-06-10 00:23:26', '2014-06-10 00:23:26', '', '0', 'http://www.plrblogs.com/restorevision/improve-eyesight/learn-more-about-laser-eye-surgery', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('924', '28', '2014-05-17 12:06:30', '2014-05-17 12:06:30', 'In today\'s very accelerated paced world we do not consume a appropriate diet all of the time. If you lead a active life and do not get decent vitamins for your body to operate decently then you should be correcting with natural vitamin supplements.\r\n\r\nHerbs or botanicals that have not yet been evaluated by the Food and Drug Administration are marketed as diet nutritional supplements if they claim to improve health, shape the body, improve immunity, improve vision, improve mental acuity, boost energy, or help prevent diseases.\r\n\r\nNaturally, the most visible benefit to adopting multi vitamin supplements is convenience. It is far quicker for a person to acquire one dosage of a multi vitamin supplement that incorporates each of the needed vitamins compared to adopting each one one by one. This is especially the case for children as it can be more laborious for them to acquire a large number of vitamin supplements but one dosage of a multi vitamin supplement is far more easygoing.\r\n\r\nOur bodies need adequate nutrition in order to operate properly. Our bodies need adequate necessary vitamins to habitually make it through the day and with our daily food ingestion not supplying each of the essential nutrients the demand for a vitamin supplement has never been bigger.\r\n\r\nThe ideal time to take supplements is with your meals. During this time, your body can absorb the nutrients better, as your digestive system will be stimulated with food. If you are using time released supplements, you should take them with food to ensure that they move through your body at the right pace and release the proper amount of nutrients and vitamins your body needs at the right time.\r\n\r\nIf you do not have any deficiency for a particular nutrient, your body will usually absorb only about 10 percent to 15 percent of the nutrients from vitamin and nutritional supplements. The remaining 85 percent is excreted in your urine. This means that for every $10.00 you spend on vitamin and nutritional supplements, $8.50 of it can be going down the toilet.\r\n\r\nTo make the decision smoother there are now a many of multi vitamin supplements made for particular people. For instance, there are multi vitamin supplements that are planned for children. These multi vitamin supplements carries the particular nutrients that children demand for them to grow and develop decently. Pregnant women have singular nutrient demands to guarantee that their baby gets the necessary nutrients and there are multi vitamin supplements prepared for pregnant women.\r\n\r\nIt is significant to consider the contents of any multi vitamin supplement prior ingesting too many. Many vitamins can be dangerous if too much is absorbed and this can occur more easily with multi vitamin supplements as a lot of the content may be neglected. The labeling of the actual percentage of the suggested daily allowance for each vitamin in a multi vitamin supplement should be clearly labeled and must be evaluated before a person acquires them. Always seek professional medical advice before acquiring any multi vitamin supplement if there is any doubt as to the benefits of the contents.', 'Maximize The Effects of Vitamins Supplements', '', 'publish', 'open', 'open', '', 'maximize-the-effects-of-vitamins-supplements', '', '', '2014-06-10 00:53:39', '2014-06-10 00:53:39', '', '0', 'http://www.plrblogs.com/restorevision/improve-eyesight/maximize-the-effects-of-vitamins-supplements', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('925', '28', '2014-05-19 04:46:32', '2014-05-19 04:46:32', 'Types of Eye Surgery\r\n\r\nEye surgery, also referred to as ophthalmic or ocular surgery, is a type of surgical procedure that is performed on the eye or the surrounding tissues. There are a number of different types of eye surgeries including refractive surgery, corneal surgery, glaucoma surgery, cataract surgery, and oculoplastic (cosmetic) surgery.\r\n\r\nRefractive surgery\r\n\r\nThe goal of refractive surgery is to improve a patients vision. An individual who is either nearsighted or farsighted has a refractive error in the interior of their eye. Light entering the eye does not properly focus on the retina, instead focusing in front of the retina in nearsighted individuals or behind the retina in farsighted individuals. \r\n\r\nThe result is that viewed images appear blurry and out of focus. Refractive surgery corrects this error, allowing light to focus directly on the retina, thereby improving vision and eliminating the need for corrective lenses. \r\nThere are numerous methods of refractive surgery, the most popular of which are LASIK (laser assisted in-situ keratomileusis), LASEK (laser assisted sub-epithelial keratomileusis) as known as Epi-LASIK, PRK (Photorefractive keratectomy), CK (conductive keratoplasty), and ICRs or Intacs (Intracorneal rings). \r\n\r\nCorneal surgery\r\n\r\nCorneal surgery is any surgery that involves manipulation of the cornea of the eye. \r\n\r\nThis encompasses nearly all types of refractive surgeries since the cornea is modified in order to improve the individuals vision. It also includes corneal transplant surgery, a procedure by which a damaged or diseased cornea is removed and replaced with a clear cornea from an organ donor. Other types of corneal surgery are PK (penetrating keratoplasty), PTK (phototherapeutic keratectomy), and Pterygium excession. \r\n\r\nGlaucoma surgery\r\n\r\nGlaucoma is a disease that attacks the optic nerve, resulting in loss of vision and a rise in intraocular pressure. Glaucoma surgeries assist in combating the disease by lowering intraocular pressure. \r\n\r\nThis may be accomplished by decreasing the amount of aqueous produced in the eye or by encouraging the release of excess aqueous humor from the eye.\r\n\r\nCataract surgery\r\n\r\nCataract extraction is the most common eye surgery performed. Age, illness, or trauma to the eye can sometimes cause the crystalline lens of the eye to become cloudy and opaque. This cloudiness, called a cataract, interferes with the eyes ability to focus a clear image on the retina, resulting in loss of vision. The presence of significant cataracts requires the removal and replacement of the lens through cataract surgery. \r\n\r\nAlthough there are a number of different types of cataract extraction, the two most popular procedures are called ICCE (intracapsular cataract extraction) and ECCE (extracapsular cataract extraction).\r\n\r\nOculoplastic surgery\r\n\r\nOculoplastic surgery is a type of eye surgery that concerns the reconstruction of the eye and its surrounding structures. Eyelid surgery, or blepharoplasty, removes excessive fat, muscle and skin from the eyelid to correct sagging or puffy eyes. Browplasty, often referred to as a brow lift, is the reconstruction of the forehead and brow bone. Oculoplastic surgery can also involve the removal of the eye itself. Enucleation involves the removal of the eye itself, leaving the muscles surrounding the eye and all orbital contents in place. \r\n\r\nEvisceration occurs when the eye and all of its contents are removed, leaving just the shell of the sclera in place. Finally, exenteration involves the removal of the entire orbital content. This includes the removal of the eye itself, any extraocular muscles, surrounding fat, and all connective tissues.', 'The Different Types Of Eye Sugery', '', 'publish', 'open', 'open', '', 'the-different-types-of-eye-sugery', '', '', '2014-06-10 00:53:32', '2014-06-10 00:53:32', '', '0', 'http://www.plrblogs.com/restorevision/improve-eyesight/the-different-types-of-eye-sugery', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('926', '28', '2014-05-22 08:28:31', '2014-05-22 08:28:31', 'Oftentimes, people are told in their childhood or teen years that their vision is going downhill, and at some point in their lifetime, millions of people around the globe are told their eyesight needs to be corrected in some fashion. There are some more traditional, commonly accepted corrective measures that you can take as ways to improve eyesight, but there are others that you may not be too familiar with, too. \r\n\r\nHere\'s what you need to know:\r\n\r\nTemporary Fixes\r\n\r\nPerhaps the most commonly accepted of ways to improve eyesight is through corrective eyewear. In fact, when you were diagnosed with vision troubles by your eye doctor, he or she likely wrote you a prescription for eyeglasses and contact lenses. In some vision centers, you can actually pick out your glasses and wear your contact lenses home that very first day you are diagnosed with your vision issues. These are, however, just temporary fixes for your vision issues. You have to take them off and put them on each day, so there are times each day when you will have to struggle with trying to make a blurry world clear by squinting.\r\n\r\nPermanent Solution\r\n\r\nThere are permanent ways to improve eyesight as well. More and more people today are turning to laser eye surgery as a means to correct their vision on a more permanent basis. While popular, this surgery is not suitable for everyone. For instance, if your vision is still changing and has not yet settled into a permanent state of fuzziness, your eye doctor will advise you to put the surgery on hold for a year or two until your vision has stopped changing. The cost of the surgery coupled with the fact that the surgery generally isn\'t covered by insurance makes it an undesirable option for many, too.\r\n\r\nNatural Remedies\r\n\r\nIf you are looking for ways to improve eyesight, you don\'t want to overlook the benefits of diet and exercise. Most people do not even consider how diet and exercise can affect vision, but the fact is that they do. Some foods truly do promote visual health while others can damage it over a long period of time. Furthermore, exercising your eye muscles can provide you with tremendous benefits to your eyesight. These eye muscles control your ability to focus, so strengthening these muscles helps you to better sharpen your focal ability. If you are tired of the hassles of glasses and contacts and are not willing or able to consider laser eye surgery, diet and exercise as a natural solution is a great way to improve your eyesight.', 'Top Ways to Improve Eyesight', '', 'publish', 'open', 'open', '', 'top-ways-to-improve-eyesight', '', '', '2014-06-10 00:53:16', '2014-06-10 00:53:16', '', '0', 'http://www.plrblogs.com/restorevision/improve-eyesight/top-ways-to-improve-eyesight', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('927', '28', '2014-05-25 06:12:54', '2014-05-25 06:12:54', 'Vision correction technology has advanced rapidly.  Laser eye surgery, lasik, and lens transplants are a few of the options available to you.\r\n\r\nBecoming a popular form of vision correction is laser eye surgery and lasik.  With the amazing advances in lasers and eye corrective technology, there is no doubt, why this type of procedure is the number one corrective eye surgery today.  Laser eye surgery is a safe and a successful form of vision correction. \r\n\r\nAnother option for vision correction is a lens transplant.  \r\n\r\nThis surgery is becoming more popular as an alternative to laser surgery.  As there are many people who feel uncomfortable with the idea of laser surgery.  Therefore, this is a great alternative for those people.  A lens transplant is a simple surgery and just as successful as laser surgery.  You have the opportunity to have the lens of your eye taken out and replaced with a lens that has the vision qualities you require. \r\n\r\nCorrective lenses and frames are of course the most popular type of vision correction.  Corrective lenses are a very affordable and effective way to compensate for your vision impairment no matter what type of impairment you may possess.  \r\n\r\nGlasses and contact lenses are now covered in a large variety of insurance companies which makes this form of vision correction that much more affordable.  There are also many great styles and fashions when it comes to the frames of your glasses.  This makes wearing corrective lenses that much easier if you are feeling uncomfortable wearing glasses.\r\n\r\nWith all the great types of vision corrective surgeries and alternatives, there are great opportunities to improve your sight.  No matter what type of eye impairment you have, it can be corrected!', 'Vision Correction - So Many Options', '', 'publish', 'open', 'open', '', 'vision-correction-so-many-options', '', '', '2014-06-10 00:53:06', '2014-06-10 00:53:06', '', '0', 'http://www.plrblogs.com/restorevision/improve-eyesight/vision-correction-so-many-options', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('928', '28', '2014-05-28 03:21:41', '2014-05-28 03:21:41', 'It\'s been said that Beauty lies in the eyes of the beholder\' but have you given any thought to those eyes which help you capture this beauty. By adopting various patterns of life we can give your eyes a much needed boost. Bringing changes in your lifestyle and in your eating habits will help you see your eyes in a new light.\r\n\r\nFood and Diet\r\n\r\n* Consuming good amount of apple and grapes helps in improving your eyesight.\r\n* Vitamin A is very good for enhancing your eyesight. Carrots have good quantity of vitamin A which proves to be one of the useful natural treatments.\r\n* Cucumber juice does wonders for your eyesight as it tries to improve it immensely.\r\n* Add spinach in your daily diet as Spinach contains iron, vitamin A, B and C. It purifies your blood, increases the hemoglobin and improves your eyesight.\r\n* You can find good source of vitamin A in turnip, milk cream, fresh milk, cheese, butter, tomatoes, lettuce, cabbage, soya beans, green peas, oranges and dates.\r\n* An ayurvedic medicine name Triphala is considered to work immensely in favor of your eyes.\r\n* Consuming blueberry juice also considered to be very useful for your eyes.\r\n\r\nExercises\r\n\r\n* Close both the eyes very tightly by shutting the lids firmly. Open them suddenly which allows you to feel the stretch. Once open arch your brows and stretch your face. Repeat this several times a day.\r\n\r\n* Look as far as possible and inhale then look down as far as possible and exhale. Blink your eyes more than dozen times. Do the same procedure by turning to your left and right then diagonally up to left, down to right, up to right and down to left followed by rapid blinking.\r\n\r\n* Rotate your eyes in all the directions. Slowly and steadily concentrate one eye at a time. Do this exercise more than dozen times and try doing this with your eyes shut.\r\n\r\n* By using palming which can be stated as a revised version of the thousand-year-old yoga tradition known was Hatha Yoga. It relieves strain and stress from your mind and eyes which needs the required break. For this you have to warm your hands by rubbing them together vigorously. Once its warm cover the eye without touching the eyelids. This relaxes the nerves and helps in blood circulation.\r\n\r\n* You can also try sunning which means to use sun\'s light for your eyes. Move your head from side to side for the heat to benefit the eyes. After a while try stretching the eyes to allow more sunlight to your eyes. Directly looking at the sun is never good. It is great method to reduce light sensitivity.\r\n\r\n* Perform Netra Basti which is bathing your eyes with clarified butter to reduce eye strain and to improve eyesight.\r\n\r\nWarning: The reader of this article should exercise all precautionary measures while following instructions on the home remedies from this article. Avoid using any of these products if you are allergic to it. The responsibility lies with the reader and not with the site or the writer.', 'Ways To Improve Your Eyesight', '', 'publish', 'open', 'open', '', 'ways-to-improve-your-eyesight', '', '', '2014-06-10 00:52:58', '2014-06-10 00:52:58', '', '0', 'http://www.plrblogs.com/restorevision/improve-eyesight/ways-to-improve-your-eyesight', '0', 'post', '', '0');
INSERT INTO `wp_posts` VALUES('929', '28', '2014-06-10 00:20:36', '2014-06-10 00:20:36', 'It\'s been said that Beauty lies in the eyes of the beholder\' but have you given any thought to those eyes which help you capture this beauty. By adopting various patterns of life we can give your eyes a much needed boost. Bringing changes in your lifestyle and in your eating habits will help you see your eyes in a new light.\r\n\r\n\n\nFood and Diet\n\n\r\n\r\n* Consuming good amount of apple and grapes helps in improving your eyesight.\r\n\n\n* Vitamin A is very good for enhancing your eyesight. Carrots have good quantity of vitamin A which proves to be one of the useful natural treatments.\r\n\n\n* Cucumber juice does wonders for your eyesight as it tries to improve it immensely.\n\n\r\n* Add spinach in your daily diet as Spinach contains iron, vitamin A, B and C. It purifies your blood, increases the hemoglobin and improves your eyesight.\n\n\r\n* You can find good source of vitamin A in turnip, milk cream, fresh milk, cheese, butter, tomatoes, lettuce, cabbage, soya beans, green peas, oranges and dates.\r\n\n\n* An ayurvedic medicine name Triphala is considered to work immensely in favor of your eyes.\r\n\n\n* Consuming blueberry juice also considered to be very useful for your eyes.\r\n\r\n\n\nExercises\n\n\r\n\r\n* Close both the eyes very tightly by shutting the lids firmly. Open them suddenly which allows you to feel the stretch. Once open arch your brows and stretch your face. Repeat this several times a day.\r\n\n\n* Look as far as possible and inhale then look down as far as possible and exhale. Blink your eyes more than dozen times. Do the same procedure by turning to your left and right then diagonally up to left, down to right, up to right and down to left followed by rapid blinking.\r\n\n\n* Rotate your eyes in all the directions. Slowly and steadily concentrate one eye at a time. Do this exercise more than dozen times and try doing this with your eyes shut.\r\n\n\n* By using palming which can be stated as a revised version of the thousand-year-old yoga tradition known was Hatha Yoga. It relieves strain and stress from your mind and eyes which needs the required break. For this you have to warm your hands by rubbing them together vigorously. Once its warm cover the eye without touching the eyelids. This relaxes the nerves and helps in blood circulation.\r\n\n\n* You can also try sunning which means to use sun\'s light for your eyes. Move your head from side to side for the heat to benefit the eyes. After a while try stretching the eyes to allow more sunlight to your eyes. Directly looking at the sun is never good. It is great method to reduce light sensitivity.\r\n\n\n* Perform Netra Basti which is bathing your eyes with clarified butter to reduce eye strain and to improve eyesight.\r\n\r\n\n\nWarning: The reader of this article should exercise all precautionary measures while following instructions on the home remedies from this article. Avoid using any of these products if you are allergic to it. The responsibility lies with the reader and not with the site or the writer.', 'Ways To Improve Your Eyesight', '', 'inherit', 'open', 'open', '', '928-revision-v1', '', '', '2014-06-10 00:20:36', '2014-06-10 00:20:36', '', '928', 'http://www.plrblogs.com/restorevision/uncategorized/928-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('930', '28', '2014-06-10 00:21:09', '2014-06-10 00:21:09', 'Vision correction technology has advanced rapidly.  Laser eye surgery, lasik, and lens transplants are a few of the options available to you.\n\nBecoming a popular form of vision correction is laser eye surgery and lasik.  With the amazing advances in lasers and eye corrective technology, there is no doubt, why this type of procedure is the number one corrective eye surgery today.  Laser eye surgery is a safe and a successful form of vision correction. \n\nAnother option for vision correction is a lens transplant.  \r\n\r\nThis surgery is becoming more popular as an alternative to laser surgery.  As there are many people who feel uncomfortable with the idea of laser surgery.  Therefore, this is a great alternative for those people.  A lens transplant is a simple surgery and just as successful as laser surgery.  You have the opportunity to have the lens of your eye taken out and replaced with a lens that has the vision qualities you require. \n\nCorrective lenses and frames are of course the most popular type of vision correction.  Corrective lenses are a very affordable and effective way to compensate for your vision impairment no matter what type of impairment you may possess.  \r\n\r\nGlasses and contact lenses are now covered in a large variety of insurance companies which makes this form of vision correction that much more affordable.  There are also many great styles and fashions when it comes to the frames of your glasses.  This makes wearing corrective lenses that much easier if you are feeling uncomfortable wearing glasses.\n\nWith all the great types of vision corrective surgeries and alternatives, there are great opportunities to improve your sight.  No matter what type of eye impairment you have, it can be corrected!', 'Vision Correction - So Many Options', '', 'inherit', 'open', 'open', '', '927-revision-v1', '', '', '2014-06-10 00:21:09', '2014-06-10 00:21:09', '', '927', 'http://www.plrblogs.com/restorevision/uncategorized/927-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('931', '28', '2014-06-10 00:21:23', '2014-06-10 00:21:23', 'Oftentimes, people are told in their childhood or teen years that their vision is going downhill, and at some point in their lifetime, millions of people around the globe are told their eyesight needs to be corrected in some fashion. There are some more traditional, commonly accepted corrective measures that you can take as ways to improve eyesight, but there are others that you may not be too familiar with, too. \r\n\r\nHere\'s what you need to know:\r\n\r\nTemporary Fixes\r\n\r\nPerhaps the most commonly accepted of ways to improve eyesight is through corrective eyewear. In fact, when you were diagnosed with vision troubles by your eye doctor, he or she likely wrote you a prescription for eyeglasses and contact lenses. In some vision centers, you can actually pick out your glasses and wear your contact lenses home that very first day you are diagnosed with your vision issues. These are, however, just temporary fixes for your vision issues. You have to take them off and put them on each day, so there are times each day when you will have to struggle with trying to make a blurry world clear by squinting.\r\n\r\nPermanent Solution\r\n\r\nThere are permanent ways to improve eyesight as well. More and more people today are turning to laser eye surgery as a means to correct their vision on a more permanent basis. While popular, this surgery is not suitable for everyone. For instance, if your vision is still changing and has not yet settled into a permanent state of fuzziness, your eye doctor will advise you to put the surgery on hold for a year or two until your vision has stopped changing. The cost of the surgery coupled with the fact that the surgery generally isn\'t covered by insurance makes it an undesirable option for many, too.\r\n\r\nNatural Remedies\r\n\r\nIf you are looking for ways to improve eyesight, you don\'t want to overlook the benefits of diet and exercise. Most people do not even consider how diet and exercise can affect vision, but the fact is that they do. Some foods truly do promote visual health while others can damage it over a long period of time. Furthermore, exercising your eye muscles can provide you with tremendous benefits to your eyesight. These eye muscles control your ability to focus, so strengthening these muscles helps you to better sharpen your focal ability. If you are tired of the hassles of glasses and contacts and are not willing or able to consider laser eye surgery, diet and exercise as a natural solution is a great way to improve your eyesight.', 'Top Ways to Improve Eyesight', '', 'inherit', 'open', 'open', '', '926-revision-v1', '', '', '2014-06-10 00:21:23', '2014-06-10 00:21:23', '', '926', 'http://www.plrblogs.com/restorevision/uncategorized/926-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('932', '28', '2014-06-10 00:21:37', '2014-06-10 00:21:37', 'Types of Eye Surgery\r\n\r\n\n\nEye surgery, also referred to as ophthalmic or ocular surgery, is a type of surgical procedure that is performed on the eye or the surrounding tissues. There are a number of different types of eye surgeries including refractive surgery, corneal surgery, glaucoma surgery, cataract surgery, and oculoplastic (cosmetic) surgery.\r\n\r\n\n\nRefractive surgery\n\nThe goal of refractive surgery is to improve a patients vision. An individual who is either nearsighted or farsighted has a refractive error in the interior of their eye. Light entering the eye does not properly focus on the retina, instead focusing in front of the retina in nearsighted individuals or behind the retina in farsighted individuals. \r\n\r\nThe result is that viewed images appear blurry and out of focus. Refractive surgery corrects this error, allowing light to focus directly on the retina, thereby improving vision and eliminating the need for corrective lenses. \nThere are numerous methods of refractive surgery, the most popular of which are LASIK (laser assisted in-situ keratomileusis), LASEK (laser assisted sub-epithelial keratomileusis) as known as Epi-LASIK, PRK (Photorefractive keratectomy), CK (conductive keratoplasty), and ICRs or Intacs (Intracorneal rings). \n\nCorneal surgery\n\nCorneal surgery is any surgery that involves manipulation of the cornea of the eye. \r\n\r\nThis encompasses nearly all types of refractive surgeries since the cornea is modified in order to improve the individuals vision. It also includes corneal transplant surgery, a procedure by which a damaged or diseased cornea is removed and replaced with a clear cornea from an organ donor. Other types of corneal surgery are PK (penetrating keratoplasty), PTK (phototherapeutic keratectomy), and Pterygium excession. \n\nGlaucoma surgery\n\nGlaucoma is a disease that attacks the optic nerve, resulting in loss of vision and a rise in intraocular pressure. Glaucoma surgeries assist in combating the disease by lowering intraocular pressure. \r\n\r\nThis may be accomplished by decreasing the amount of aqueous produced in the eye or by encouraging the release of excess aqueous humor from the eye.\n\nCataract surgery\n\nCataract extraction is the most common eye surgery performed. Age, illness, or trauma to the eye can sometimes cause the crystalline lens of the eye to become cloudy and opaque. This cloudiness, called a cataract, interferes with the eyes ability to focus a clear image on the retina, resulting in loss of vision. The presence of significant cataracts requires the removal and replacement of the lens through cataract surgery. \r\n\r\nAlthough there are a number of different types of cataract extraction, the two most popular procedures are called ICCE (intracapsular cataract extraction) and ECCE (extracapsular cataract extraction).\n\nOculoplastic surgery\n\nOculoplastic surgery is a type of eye surgery that concerns the reconstruction of the eye and its surrounding structures. Eyelid surgery, or blepharoplasty, removes excessive fat, muscle and skin from the eyelid to correct sagging or puffy eyes. Browplasty, often referred to as a brow lift, is the reconstruction of the forehead and brow bone. Oculoplastic surgery can also involve the removal of the eye itself. Enucleation involves the removal of the eye itself, leaving the muscles surrounding the eye and all orbital contents in place. \r\n\r\nEvisceration occurs when the eye and all of its contents are removed, leaving just the shell of the sclera in place. Finally, exenteration involves the removal of the entire orbital content. This includes the removal of the eye itself, any extraocular muscles, surrounding fat, and all connective tissues.', 'The Different Types Of Eye Sugery', '', 'inherit', 'open', 'open', '', '925-revision-v1', '', '', '2014-06-10 00:21:37', '2014-06-10 00:21:37', '', '925', 'http://www.plrblogs.com/restorevision/uncategorized/925-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('933', '28', '2014-06-10 00:23:05', '2014-06-10 00:23:05', 'In today\'s very accelerated paced world we do not consume a appropriate diet all of the time. If you lead a active life and do not get decent vitamins for your body to operate decently then you should be correcting with natural vitamin supplements.\r\n\r\nHerbs or botanicals that have not yet been evaluated by the Food and Drug Administration are marketed as diet nutritional supplements if they claim to improve health, shape the body, improve immunity, improve vision, improve mental acuity, boost energy, or help prevent diseases.\r\n\r\nNaturally, the most visible benefit to adopting multi vitamin supplements is convenience. It is far quicker for a person to acquire one dosage of a multi vitamin supplement that incorporates each of the needed vitamins compared to adopting each one one by one. This is especially the case for children as it can be more laborious for them to acquire a large number of vitamin supplements but one dosage of a multi vitamin supplement is far more easygoing.\r\n\r\nOur bodies need adequate nutrition in order to operate properly. Our bodies need adequate necessary vitamins to habitually make it through the day and with our daily food ingestion not supplying each of the essential nutrients the demand for a vitamin supplement has never been bigger.\r\n\r\nThe ideal time to take supplements is with your meals. During this time, your body can absorb the nutrients better, as your digestive system will be stimulated with food. If you are using time released supplements, you should take them with food to ensure that they move through your body at the right pace and release the proper amount of nutrients and vitamins your body needs at the right time.\r\n\r\nIf you do not have any deficiency for a particular nutrient, your body will usually absorb only about 10 percent to 15 percent of the nutrients from vitamin and nutritional supplements. The remaining 85 percent is excreted in your urine. This means that for every $10.00 you spend on vitamin and nutritional supplements, $8.50 of it can be going down the toilet.\r\n\r\nTo make the decision smoother there are now a many of multi vitamin supplements made for particular people. For instance, there are multi vitamin supplements that are planned for children. These multi vitamin supplements carries the particular nutrients that children demand for them to grow and develop decently. Pregnant women have singular nutrient demands to guarantee that their baby gets the necessary nutrients and there are multi vitamin supplements prepared for pregnant women.\r\n\r\nIt is significant to consider the contents of any multi vitamin supplement prior ingesting too many. Many vitamins can be dangerous if too much is absorbed and this can occur more easily with multi vitamin supplements as a lot of the content may be neglected. The labeling of the actual percentage of the suggested daily allowance for each vitamin in a multi vitamin supplement should be clearly labeled and must be evaluated before a person acquires them. Always seek professional medical advice before acquiring any multi vitamin supplement if there is any doubt as to the benefits of the contents.', 'Maximize The Effects of Vitamins Supplements', '', 'inherit', 'open', 'open', '', '924-revision-v1', '', '', '2014-06-10 00:23:05', '2014-06-10 00:23:05', '', '924', 'http://www.plrblogs.com/restorevision/uncategorized/924-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('934', '28', '2014-06-10 00:23:19', '2014-06-10 00:23:19', 'Laser eye surgery is a medical procedure consisting of the use of laser for reshaping the surface of the cornea. It is used to improve shortsightedness, long sightedness or astigmatism. The first information on laser eye surgery dates back from over twenty years ago, and the FDA approved excimer laser eye surgery in 1995.\n\n\r\n\r\nDuring laser eye surgery, an excimer laser, controlled by a computer is used to remove tiny amounts of corneal tissue. The aim of the procedure is to restore normal vision, eliminating the need for glasses or contacts. Although laser surgery has risen in popularity in the past few years, only about 20% of ophthalmologists have been trained to use it.\n\n\r\n\r\nIn one type of laser eye surgery, the outer layer of the cornea, also called epithelium, is removed and an excimer laser is used to reshape underneath tissue. This procedure is called photorefractive keratectomy (PRK).\n\nIn a newer procedure, a microkeratome is used to cut a flap in the corneal tissue, which is then lifted and an excimer laser is used to reshape underlying tissue. In the end, the flap is put back to its place. This type of laser eye surgery is called laser-assisted in situ keratomileusis (LASIK). Nowadays, it is more commonly used than PRK.\n\n\r\n\r\nWhat Happens During Laser Eye Surgery Procedure\n\nThe surgery should take less than 30 minutes. You will lie on your back, reclining in a chair, or on a table. You may be given a sedative before the procedure, to help you relax.\n\nLocal anesthetic eye drops are used before the surgery. The procedure takes a few minutes per eye. The actual time when the laser is used for reshaping the corneal tissue is generally less than a minute. An instrument called a lid speculum will be used to hold your eyelids open. A ring is placed on your eye, and the cutting instrument is attached to the ring. A microkeratome, the cutting instrument, is used to cut a flap in your cornea. A laser is positioned over your eye, and you will be asked to stare at the light. \r\n\r\nThis light is to help you keep your eye fixed in one spot when the laser comes on.\n\nOnce your eye is in the correct position, the doctor will turn the laser on. Pulses of laser energy vaporize the corneal tissue, and then the flap is placed back into position\n\nYou will need to wear an eye shield for protection after the procedure. This will prevent you from rubbing your eyes, and protect your eye from being accidentally hit or poked until the flap has healed.\n\n\r\n\r\nAfter laser eye surgery, you should expect some minor discomfort. However, you should be able to see, although not very clearly. You won\'t be able to drive on your own, so you need to have someone drive you home or take a cab. You should see your doctor within the first 24 to 48 hours after surgery, and then at regular intervals for about six months. You will have to wait for up to two weeks before using make-up, creams or lotions, to prevent infection or irritation. You should also avoid swimming and hot tubs for about 6 weeks.\r\n\r\n\n\nAlthough you should see well the day after surgery, your vision will continue to improve over the next several months. As the eye heals, your vision will continue to improve. It is important to keep all your follow-up appointments with your doctor, to make sure that everything is going according to plan.', 'Learn More About Laser Eye Surgery', '', 'inherit', 'open', 'open', '', '923-revision-v1', '', '', '2014-06-10 00:23:19', '2014-06-10 00:23:19', '', '923', 'http://www.plrblogs.com/restorevision/uncategorized/923-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('935', '28', '2014-06-10 00:23:48', '2014-06-10 00:23:48', 'Are you looking for ways to improve your eyesight and avoid having to wear glasses and contact lenses for the rest of your life. Unfortunately we are made to believe the only way to improve eyesight without glasses or contact lenses is to opt for expensive and risky eye surgery. Thankfully this is not the case! For over 120 years cultures from around the globe have been using eye exercises to correct their vision.\r\n\r\nDue to the stresses of modern life and the way we work and play our eyes are coping major stress on a daily basis without most of us taking anytime to consider the effects. Using a computer daily, watching television or playing video games forces our eyes into an unnatural state. Our eyes are not made to focus for long periods of time on computer screens or televisions. This results into many people suffering from eye strain and other ailments from the direct result of this unnatural practice such as headaches and migraines. Our eyes are trying to tell us something.\r\n\r\nThe first thing you need to understand is that corrective lenses are only a patch up, they do nothing to help correct your vision. In fact the sad truth about glasses and contacts is that they force your eyes to become lazy and overtime get weaker. The result? Stronger lenses after your next visit to the optometrist! Wearing glasses means that your eyes do not heal and correct themselves naturally as the corrective lenses simply let your eyesight get progressively worse in time.\r\n\r\nMany cultures around the world, especially class rooms in China make school kids perform daily eye exercises to improve the health of their eyes as well as correct most vision problems naturally. The most common eye sight problems such as being short or near sighted can be cured through daily exercise.\r\n\r\nThe optometry field is a billion dollar industry, it is not in their best interests to tell you about how these exercises can cure most vision problems. Think about the cost of your glasses or monthly costs of your contact lenses, these costs can add up to thousands of dollars over the course of your life.\r\n\r\nEye exercises are a perfectly safe and natural alternative to wearing glasses. You must understand that your eyes are like any other muscle in your body, with the correct exercises you can force them to become stronger and heal. Restoring 20/20 vision with these exercises is very common regardless of your age.\r\n\r\nWhile our eyesight will deteriorate in time due to age their is no reason why we can not keep them strong and healthy and improve our eyesight naturally even while we get into our years. These eye exercises were first spoken about in the late 1800\'s by Dr William Bates whose patients were made to do a series of eye exercises daily. Dr Bates found that his patients were not only able to improve their vision but in time restore perfect vision. The series of exercises not only helped with the most common vision problems but he found that certain conditions that were difficult to treat also improved.\r\n\r\nDr Bates was shunned by his peers as a result of going against the status quo and showing people who they could improve their eyesight without spending money on corrective lenses.', 'Its Possible To Improve Your Eyesight Naturally', '', 'inherit', 'open', 'open', '', '922-revision-v1', '', '', '2014-06-10 00:23:48', '2014-06-10 00:23:48', '', '922', 'http://www.plrblogs.com/restorevision/uncategorized/922-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('936', '28', '2014-06-10 00:24:03', '2014-06-10 00:24:03', 'Do you the feeling of getting up in the morning and everything is blurry?  Not be able to tie your shoo, get dressed, or even find the sink to wash your face.  The disappointment when your glasses break, in the most important moment. Always end your trip or some other fun activity. Entering a warm room on a cold day and wait 10 minutes for the fog to come off your glasses.  Not to mention the pressure wounds on your nose bridge and at the back of your ears.\r\n\r\nOne might think that contact lenses are the answer to his problem as I thought years ago.  I have checked contact lenses. But they scratches my eyes, switched to soft lenses which kept moving in my eyes and cause me several eye infections.  The worst part of wearing contact lenses is the any windy weather or even some dust hearts your eye.  In a nut shell I have had to give up on them as well.  Not to mention the enormous investment and maintenances you need to afford.\r\n\r\nThen I had to get back to my glasses, my self-confidence went down, and I could not go out or enjoy any water related or ball games.  I knew that I not will do the laser correction surgery I have a cousin who lost here vision in one eye and badly damaged her other eye.  I really want see for the rest of my life so I will have to give that up.    \r\n\r\nAt this point I have started my own investigation to find a cure to my eyes or simply improve eye vision.  I have found that my doctors kept me the same or worst as my eye prescription went up and all they did was giving a thicker lens.  I have found out that Astigmatism can be cured and that its not something I have to live with.  I have found out that I need to prepare my eyes for the coming day, consume nutrition, vitamins and minerals and relaxation which is one of the most important factors.\r\n\r\nThe thing that finally, along with all the relaxation and special food ingredients, helped me was exercising.\r\n   \r\nI have set my self to a schedule of exercising and relaxation and after three months I have began to see some real improvement in my vision.  Today, I have regained 90% of my original vision back, I do not see perfectly but I mange with out any help and I am very happy, I am looking forward to more improvement in the future.  \r\n\r\nThe exercises are very simple. Every one can perform them, and they take very short time too.  I perform three types of eye exercise and relax between them.  The relaxation is simply place my hands over my closed eyes.', 'Improved Eye Vision', '', 'inherit', 'open', 'open', '', '921-revision-v1', '', '', '2014-06-10 00:24:03', '2014-06-10 00:24:03', '', '921', 'http://www.plrblogs.com/restorevision/uncategorized/921-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('937', '28', '2014-06-10 00:24:26', '2014-06-10 00:24:26', 'Have you ever heard the term, \"eyes are the windows to the soul\"? Not only are they the windows to our soul, but they are also the windows to view the outside world. Our eyes help us see things, read, work and even communicate. They are a very delicate part of our body though and they also need plenty of rest.\r\n\r\nHave you ever thought that you could improve eyesight naturally? Were you aware that you can improve eyesight just by changing a few habits? We are much harder on our eyes then we think. If we were to take the time to learn and practice some relaxation exercises, we could start seeing more clearly. Some people think that just because they have worn glasses for years or have some type of eye disease that they can\'t learn to improve their eyesight naturally. It depends on how severe the eye disease is, but under normal circumstances, your eyesight can improve.\r\n\r\nThe main causes for poor eyesight are stress and strain. We are all born with relatively good eyesight. We start learning bad habits throughout our school years. Like sitting in a classroom staring at the blackboard, our books or papers. This causes strain on our eyes which leaves them tired and stressed. There is little to no time between classes where we can relax the eyes and give them the rest they require. Because we learn these habits at such a young age, they are carried over into our adult lives. From there we do the same things at work staring at our computers, working on paperwork or stressing over a deadline.\r\n\r\nAre you aware of the signals your body relays when you need rest? For instance when you spend too much time doing household chores and your back starts to hurt. The same goes for the eyes. Like when your head starts to hurt or your eyes start to burn. Those are the signals that it\'s time to take a break. If you are able, lie down and just relax for a few minutes. If you aren\'t able to lie down, find a quiet place to relax your mind and close your eyes. They need to be re-energized.\r\n\r\nWe can all prevent poor eyesight. If we take the steps today and develop the necessary habits that will improve our eyesight, we will be better off for the rest of our lives.', 'Improve Your Eyesight The Natural Way', '', 'inherit', 'open', 'open', '', '920-revision-v1', '', '', '2014-06-10 00:24:26', '2014-06-10 00:24:26', '', '920', 'http://www.plrblogs.com/restorevision/uncategorized/920-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('938', '28', '2014-06-10 00:24:39', '2014-06-10 00:24:39', 'yes are the most essential part of the human body and we can only see the beauty or the very existence of earth because we are blessed with vision of eyes. Life is an irony who are blind or whose vision are diminished due to certain factors. The world will never be the same without eyes such is its importance. All human not only desire to have beautiful eyes but also cherish to maintain the eye power, sight, and enhanced vision for long time.\r\n\r\nHowever there are external developments of medical science which can correct your diminishing power of eye sight. This medical procedure includes non â\" surgical as well as surgical procedure. The processes are wearing of contact lenses, going for glasses to rectify the diminishing power, and sometime surgical procedure is also conducted to improve the eye vision by removing problems like cataract, glaucoma etc.\r\n\r\nBut no one question are there other modes which can help us to restore our vision naturally. However there is a method called Eye Exercises which is the best way to restore the vision without any non â\" surgical as well as surgical procedure. The exercises are powerful enough to give back 20 / 20 eyes sight. But its healing power has always been questioned but the 100 years research and development has made it possible to cure eye vision with exercises giving glasses and contact lenses market a stiff competition.\r\n\r\nEye sights are adversely affected by the daily routine works that we perform or go through. From watching television, to browsing computer, to unhealthy lifestyles, and overwork with rising stress has contributed to the vision of the eyes leading to low power or vision difficulty. However there are common as well as simple eye exercises that can be followed to improve the vision or restore the eye sights.\r\n\r\nOne of the common eye exercises is palming and is essential in curing many eye related as well as head related problems. Palming has been effective in curing migraine, eye pain, and head â\" ache leading to complete relaxation of the eyes. The exercise is very simple and requires just 10 â\" 15 minutes a day to apply it to your eyes and experience the wonder results. First step while following this exercise is to rub your hands with each other to warm and then in the second step cover them to eyes for 3 minutes. The points to remember is that no light should get in and make sure to visualize something interesting during this time and see how one of the fundamental exercise helps to improve the vision.', 'Eye Exercises to Restore Vision', '', 'inherit', 'open', 'open', '', '919-revision-v1', '', '', '2014-06-10 00:24:39', '2014-06-10 00:24:39', '', '919', 'http://www.plrblogs.com/restorevision/uncategorized/919-revision-v1', '0', 'revision', '', '0');
INSERT INTO `wp_posts` VALUES('939', '28', '2014-06-10 00:52:03', '2014-06-10 00:52:03', '', 'Discover The Techniques To Get Your Perfect Eyesight Without Surgery!', 'Discover The Techniques To Get Your Perfect Eyesight Without Surgery!', 'inherit', 'open', 'open', '', 'restore-vision-slider1', '', '', '2014-06-10 00:52:03', '2014-06-10 00:52:03', '', '0', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2014/06/restore-vision-slider1.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('940', '28', '2014-06-10 00:52:05', '2014-06-10 00:52:05', '', 'You Can Improve Your Eyesight Without Prescription Drugs Or Glasses!', 'You Can Improve Your Eyesight Without Prescription Drugs Or Glasses!', 'inherit', 'open', 'open', '', 'restore-vision-slider2', '', '', '2014-06-10 00:52:05', '2014-06-10 00:52:05', '', '0', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2014/06/restore-vision-slider2.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('941', '28', '2014-06-10 00:52:07', '2014-06-10 00:52:07', '', 'restore-vision-thumb1', '', 'inherit', 'open', 'open', '', 'restore-vision-thumb1', '', '', '2014-06-10 00:52:07', '2014-06-10 00:52:07', '', '0', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2014/06/restore-vision-thumb1.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('942', '28', '2014-06-10 00:52:08', '2014-06-10 00:52:08', '', 'restore-vision-thumb2', '', 'inherit', 'open', 'open', '', 'restore-vision-thumb2', '', '', '2014-06-10 00:52:08', '2014-06-10 00:52:08', '', '0', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2014/06/restore-vision-thumb2.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('943', '28', '2014-06-10 00:52:09', '2014-06-10 00:52:09', '', 'restore-vision-thumb3', '', 'inherit', 'open', 'open', '', 'restore-vision-thumb3', '', '', '2014-06-10 00:52:09', '2014-06-10 00:52:09', '', '0', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2014/06/restore-vision-thumb3.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('944', '28', '2014-06-10 00:52:10', '2014-06-10 00:52:10', '', 'restore-vision-thumb4', '', 'inherit', 'open', 'open', '', 'restore-vision-thumb4', '', '', '2014-06-10 00:52:10', '2014-06-10 00:52:10', '', '0', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2014/06/restore-vision-thumb4.jpg', '0', 'attachment', 'image/jpeg', '0');
INSERT INTO `wp_posts` VALUES('945', '28', '2014-06-10 00:52:12', '2014-06-10 00:52:12', '', 'restore-vision-thumb5', '', 'inherit', 'open', 'open', '', 'restore-vision-thumb5', '', '', '2014-06-10 00:52:12', '2014-06-10 00:52:12', '', '0', 'http://www.plrblogs.com/restorevision/wp-content/uploads/2014/06/restore-vision-thumb5.jpg', '0', 'attachment', 'image/jpeg', '0');
CREATE TABLE `wp_prli_clicks` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `ip` varchar(255) DEFAULT NULL,  `browser` varchar(255) DEFAULT NULL,  `btype` varchar(255) DEFAULT NULL,  `bversion` varchar(255) DEFAULT NULL,  `os` varchar(255) DEFAULT NULL,  `referer` varchar(255) DEFAULT NULL,  `host` varchar(255) DEFAULT NULL,  `uri` varchar(255) DEFAULT NULL,  `robot` tinyint(4) DEFAULT '0',  `first_click` tinyint(4) DEFAULT '0',  `created_at` datetime NOT NULL,  `link_id` int(11) DEFAULT NULL,  `vuid` varchar(25) DEFAULT NULL,  PRIMARY KEY (`id`),  KEY `link_id` (`link_id`),  KEY `ip` (`ip`),  KEY `browser` (`browser`),  KEY `btype` (`btype`),  KEY `bversion` (`bversion`),  KEY `os` (`os`),  KEY `referer` (`referer`),  KEY `host` (`host`),  KEY `uri` (`uri`),  KEY `robot` (`robot`),  KEY `first_click` (`first_click`),  KEY `vuid` (`vuid`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `wp_prli_groups` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `name` varchar(255) DEFAULT NULL,  `description` text,  `created_at` datetime NOT NULL,  PRIMARY KEY (`id`),  KEY `name` (`name`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `wp_prli_link_metas` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `meta_key` varchar(255) DEFAULT NULL,  `meta_value` longtext,  `link_id` int(11) NOT NULL,  `created_at` datetime NOT NULL,  PRIMARY KEY (`id`),  KEY `meta_key` (`meta_key`),  KEY `link_id` (`link_id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `wp_prli_links` (  `id` int(11) NOT NULL AUTO_INCREMENT,  `name` varchar(255) DEFAULT NULL,  `description` text,  `url` text,  `slug` varchar(255) DEFAULT NULL,  `nofollow` tinyint(1) DEFAULT '0',  `track_me` tinyint(1) DEFAULT '1',  `param_forwarding` varchar(255) DEFAULT NULL,  `param_struct` varchar(255) DEFAULT NULL,  `redirect_type` varchar(255) DEFAULT '307',  `created_at` datetime NOT NULL,  `group_id` int(11) DEFAULT NULL,  PRIMARY KEY (`id`),  KEY `group_id` (`group_id`),  KEY `name` (`name`),  KEY `nofollow` (`nofollow`),  KEY `track_me` (`track_me`),  KEY `param_forwarding` (`param_forwarding`),  KEY `param_struct` (`param_struct`),  KEY `redirect_type` (`redirect_type`),  KEY `slug` (`slug`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;
CREATE TABLE `wp_term_relationships` (  `object_id` bigint(20) unsigned NOT NULL DEFAULT '0',  `term_taxonomy_id` bigint(20) unsigned NOT NULL DEFAULT '0',  `term_order` int(11) NOT NULL DEFAULT '0',  PRIMARY KEY (`object_id`,`term_taxonomy_id`),  KEY `term_taxonomy_id` (`term_taxonomy_id`)) ENGINE=MyISAM DEFAULT CHARSET=utf8;
INSERT INTO `wp_term_relationships` VALUES('1', '2', '0');
INSERT INTO `wp_term_relationships` VALUES('2', '2', '0');
INSERT INTO `wp_term_relationships` VALUES('3', '2', '0');
INSERT INTO `wp_term_relationships` VALUES('4', '2', '0');
INSERT INTO `wp_term_relationships` VALUES('5', '2', '0');
INSERT INTO `wp_term_relationships` VALUES('6', '2', '0');
INSERT INTO `wp_term_relationships` VALUES('7', '2', '0');
INSERT INTO `wp_term_relationships` VALUES('919', '344', '0');
INSERT INTO `wp_term_relationships` VALUES('920', '332', '0');
INSERT INTO `wp_term_relationships` VALUES('921', '355', '0');
INSERT INTO `wp_term_relationships` VALUES('922', '332', '0');
INSERT INTO `wp_term_relationships` VALUES('923', '345', '0');
INSERT INTO `wp_term_relationships` VALUES('924', '346', '0');
INSERT INTO `wp_term_relationships` VALUES('925', '342', '0');
INSERT INTO `wp_term_relationships` VALUES('926', '332', '0');
INSERT INTO `wp_term_relationships` VALUES('927', '338', '0');
INSERT INTO `wp_term_relationships` VALUES('928', '332', '0');
INSERT INTO `wp_term_relationships` VALUES('928', '335', '0');
INSERT INTO `wp_term_relationships` VALUES('928', '336', '0');
INSERT INTO `wp_term_relationships` VALUES('928', '337', '0');
INSERT INTO `wp_term_relationships` VALUES('927', '334', '0');
INSERT INTO `wp_term_relationships` VALUES('927', '339', '0');
INSERT INTO `wp_term_relationships` VALUES('927', '340', '0');
INSERT INTO `wp_term_relationships` VALUES('926', '341', '0');
INSERT INTO `wp_term_relationships` VALUES('926', '335', '0');
INSERT INTO `wp_term_relationships` VALUES('926', '336', '0');
INSERT INTO `wp_term_relationships` VALUES('926', '337', '0');
INSERT INTO `wp_term_relationships` VALUES('925', '333', '0');
INSERT INTO `wp_term_relationships` VALUES('925', '343', '0');
INSERT INTO `wp_term_relationships` VALUES('925', '344', '0');
INSERT INTO `wp_term_relationships` VALUES('925', '345', '0');
INSERT INTO `wp_term_relationships` VALUES('924', '333', '0');
INSERT INTO `wp_term_relationships` VALUES('924', '347', '0');
INSERT INTO `wp_term_relationships` VALUES('924', '348', '0');
INSERT INTO `wp_term_relationships` VALUES('924', '349', '0');
INSERT INTO `wp_term_relationships` VALUES('923', '350', '0');
INSERT INTO `wp_term_relationships` VALUES('923', '351', '0');
INSERT INTO `wp_term_relationships` VALUES('923', '344', '0');
INSERT INTO `wp_term_relationships` VALUES('922', '353', '0');
INSERT INTO `wp_term_relationships` VALUES('923', '334', '0');
INSERT INTO `wp_term_relationships` VALUES('922', '336', '0');
INSERT INTO `wp_term_relationships` VALUES('922', '337', '0');
INSERT INTO `wp_term_relationships` VALUES('922', '354', '0');
INSERT INTO `wp_term_relationships` VALUES('921', '333', '0');
INSERT INTO `wp_term_relationships` VALUES('921', '344', '0');
INSERT INTO `wp_term_relationships` VALUES('921', '338', '0');
INSERT INTO `wp_term_relationships` VALUES('920', '336', '0');
INSERT INTO `wp_term_relationships` VALUES('920', '337', '0');
INSERT INTO `wp_term_relationships` VALUES('920', '356', '0');
INSERT INTO `wp_term_relationships` VALUES('920', '357', '0');
INSERT INTO `wp_term_relationships` VALUES('919', '333', '0');
INSERT INTO `wp_term_relationships` VALUES('919', '358', '0');
INSERT INTO `wp_term_relationships` VALUES('919', '359', '0');
INSERT INTO `wp_term_relationships` VALUES('919', '338', '0');
CREATE TABLE `wp_term_taxonomy` (  `term_taxonomy_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `term_id` bigint(20) unsigned NOT NULL DEFAULT '0',  `taxonomy` varchar(32) NOT NULL DEFAULT '',  `description` longtext NOT NULL,  `parent` bigint(20) unsigned NOT NULL DEFAULT '0',  `count` bigint(20) NOT NULL DEFAULT '0',  PRIMARY KEY (`term_taxonomy_id`),  UNIQUE KEY `term_id_taxonomy` (`term_id`,`taxonomy`),  KEY `taxonomy` (`taxonomy`)) ENGINE=MyISAM AUTO_INCREMENT=360 DEFAULT CHARSET=utf8;
INSERT INTO `wp_term_taxonomy` VALUES('1', '1', 'category', '', '0', '0');
INSERT INTO `wp_term_taxonomy` VALUES('2', '2', 'link_category', '', '0', '7');
INSERT INTO `wp_term_taxonomy` VALUES('332', '332', 'category', '', '0', '4');
INSERT INTO `wp_term_taxonomy` VALUES('333', '333', 'category', '', '0', '4');
INSERT INTO `wp_term_taxonomy` VALUES('334', '334', 'category', '', '0', '2');
INSERT INTO `wp_term_taxonomy` VALUES('335', '335', 'post_tag', '', '0', '2');
INSERT INTO `wp_term_taxonomy` VALUES('336', '336', 'post_tag', '', '0', '4');
INSERT INTO `wp_term_taxonomy` VALUES('337', '337', 'post_tag', '', '0', '4');
INSERT INTO `wp_term_taxonomy` VALUES('338', '338', 'post_tag', '', '0', '3');
INSERT INTO `wp_term_taxonomy` VALUES('339', '339', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('340', '340', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('341', '341', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('342', '342', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('343', '343', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('344', '344', 'post_tag', '', '0', '4');
INSERT INTO `wp_term_taxonomy` VALUES('345', '345', 'post_tag', '', '0', '2');
INSERT INTO `wp_term_taxonomy` VALUES('346', '346', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('347', '347', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('348', '348', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('349', '349', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('350', '350', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('351', '351', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('352', '352', 'post_tag', '', '0', '0');
INSERT INTO `wp_term_taxonomy` VALUES('353', '353', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('354', '354', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('355', '355', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('356', '356', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('357', '357', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('358', '358', 'post_tag', '', '0', '1');
INSERT INTO `wp_term_taxonomy` VALUES('359', '359', 'post_tag', '', '0', '1');
CREATE TABLE `wp_terms` (  `term_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `name` varchar(200) NOT NULL DEFAULT '',  `slug` varchar(200) NOT NULL DEFAULT '',  `term_group` bigint(10) NOT NULL DEFAULT '0',  PRIMARY KEY (`term_id`),  UNIQUE KEY `slug` (`slug`),  KEY `name` (`name`)) ENGINE=MyISAM AUTO_INCREMENT=360 DEFAULT CHARSET=utf8;
INSERT INTO `wp_terms` VALUES('1', 'Uncategorized', 'uncategorized', '0');
INSERT INTO `wp_terms` VALUES('2', 'Blogroll', 'blogroll', '0');
INSERT INTO `wp_terms` VALUES('332', 'Improve Eyesight', 'improve-eyesight', '0');
INSERT INTO `wp_terms` VALUES('333', 'Vision Correction', 'vision-correction', '0');
INSERT INTO `wp_terms` VALUES('334', 'Eyesight Improvement FAQs', 'eyesight-improvement-faqs', '0');
INSERT INTO `wp_terms` VALUES('335', 'ways', 'ways', '0');
INSERT INTO `wp_terms` VALUES('336', 'improve', 'improve', '0');
INSERT INTO `wp_terms` VALUES('337', 'eyesight', 'eyesight', '0');
INSERT INTO `wp_terms` VALUES('338', 'vision', 'vision', '0');
INSERT INTO `wp_terms` VALUES('339', 'correction', 'correction', '0');
INSERT INTO `wp_terms` VALUES('340', 'options', 'options', '0');
INSERT INTO `wp_terms` VALUES('341', 'top', 'top', '0');
INSERT INTO `wp_terms` VALUES('342', 'different', 'different', '0');
INSERT INTO `wp_terms` VALUES('343', 'types', 'types', '0');
INSERT INTO `wp_terms` VALUES('344', 'eye', 'eye', '0');
INSERT INTO `wp_terms` VALUES('345', 'surgery', 'surgery', '0');
INSERT INTO `wp_terms` VALUES('346', 'maximize', 'maximize', '0');
INSERT INTO `wp_terms` VALUES('347', 'effects', 'effects', '0');
INSERT INTO `wp_terms` VALUES('348', 'vitamins', 'vitamins', '0');
INSERT INTO `wp_terms` VALUES('349', 'supplements', 'supplements', '0');
INSERT INTO `wp_terms` VALUES('350', 'learn', 'learn', '0');
INSERT INTO `wp_terms` VALUES('351', 'laser', 'laser', '0');
INSERT INTO `wp_terms` VALUES('352', 'surger', 'surger', '0');
INSERT INTO `wp_terms` VALUES('353', 'possible', 'possible', '0');
INSERT INTO `wp_terms` VALUES('354', 'naturally', 'naturally', '0');
INSERT INTO `wp_terms` VALUES('355', 'improved', 'improved', '0');
INSERT INTO `wp_terms` VALUES('356', 'natural', 'natural', '0');
INSERT INTO `wp_terms` VALUES('357', 'way', 'way', '0');
INSERT INTO `wp_terms` VALUES('358', 'exercises', 'exercises', '0');
INSERT INTO `wp_terms` VALUES('359', 'restore', 'restore', '0');
CREATE TABLE `wp_usermeta` (  `umeta_id` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `user_id` bigint(20) unsigned NOT NULL DEFAULT '0',  `meta_key` varchar(255) DEFAULT NULL,  `meta_value` longtext,  PRIMARY KEY (`umeta_id`),  KEY `user_id` (`user_id`),  KEY `meta_key` (`meta_key`)) ENGINE=MyISAM AUTO_INCREMENT=572 DEFAULT CHARSET=utf8;
INSERT INTO `wp_usermeta` VALUES('571', '28', 'wp_user-settings-time', '1402349377');
INSERT INTO `wp_usermeta` VALUES('570', '28', 'wp_user-settings', 'editor=html&imgsize=full');
INSERT INTO `wp_usermeta` VALUES('569', '28', 'show_welcome_panel', '0');
INSERT INTO `wp_usermeta` VALUES('568', '28', 'metaboxhidden_dashboard', 'a:5:{i:0;s:19:\"dashboard_right_now\";i:1;s:21:\"prli_dashboard_widget\";i:2;s:18:\"dashboard_activity\";i:3;s:14:\"pb_backupbuddy\";i:4;s:21:\"dashboard_quick_press\";}');
INSERT INTO `wp_usermeta` VALUES('564', '28', 'yim', '');
INSERT INTO `wp_usermeta` VALUES('565', '28', 'jabber', '');
INSERT INTO `wp_usermeta` VALUES('566', '28', 'googleplus', '');
INSERT INTO `wp_usermeta` VALUES('567', '28', 'closedpostboxes_dashboard', 'a:0:{}');
INSERT INTO `wp_usermeta` VALUES('563', '28', 'aim', '');
INSERT INTO `wp_usermeta` VALUES('550', '28', 'first_name', 'admin');
INSERT INTO `wp_usermeta` VALUES('551', '28', 'last_name', '');
INSERT INTO `wp_usermeta` VALUES('552', '28', 'nickname', 'admin');
INSERT INTO `wp_usermeta` VALUES('553', '28', 'description', '');
INSERT INTO `wp_usermeta` VALUES('554', '28', 'rich_editing', 'true');
INSERT INTO `wp_usermeta` VALUES('555', '28', 'comment_shortcuts', 'false');
INSERT INTO `wp_usermeta` VALUES('556', '28', 'admin_color', 'fresh');
INSERT INTO `wp_usermeta` VALUES('557', '28', 'use_ssl', '0');
INSERT INTO `wp_usermeta` VALUES('558', '28', 'show_admin_bar_front', 'false');
INSERT INTO `wp_usermeta` VALUES('559', '28', 'wp_capabilities', 'a:1:{s:13:\"administrator\";b:1;}');
INSERT INTO `wp_usermeta` VALUES('560', '28', 'wp_user_level', '10');
INSERT INTO `wp_usermeta` VALUES('561', '28', 'dismissed_wp_pointers', 'wp350_media,wp360_revisions,wp360_locks,wp390_widgets,aioseop_menu_211,aioseop_welcome_211');
INSERT INTO `wp_usermeta` VALUES('562', '28', 'wp_dashboard_quick_press_last_post_id', '911');
CREATE TABLE `wp_users` (  `ID` bigint(20) unsigned NOT NULL AUTO_INCREMENT,  `user_login` varchar(60) NOT NULL DEFAULT '',  `user_pass` varchar(64) NOT NULL DEFAULT '',  `user_nicename` varchar(50) NOT NULL DEFAULT '',  `user_email` varchar(100) NOT NULL DEFAULT '',  `user_url` varchar(100) NOT NULL DEFAULT '',  `user_registered` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',  `user_activation_key` varchar(60) NOT NULL DEFAULT '',  `user_status` int(11) NOT NULL DEFAULT '0',  `display_name` varchar(250) NOT NULL DEFAULT '',  PRIMARY KEY (`ID`),  KEY `user_login_key` (`user_login`),  KEY `user_nicename` (`user_nicename`)) ENGINE=MyISAM AUTO_INCREMENT=29 DEFAULT CHARSET=utf8;
INSERT INTO `wp_users` VALUES('28', 'admin', '$P$B/VNqAdVc9St8McguIkp1yX/D6fWTb/', 'admin', 'youremail@youremail.com', '', '2014-06-09 01:09:54', '', '0', 'admin');
